-- 网站信息表
DROP TABLE IF EXISTS `ds_site`;
CREATE TABLE `ds_site` (
  `name`			varchar(100)	,							-- 名称
  `host`			varchar(100)	,							-- 域名
  `appcode` 		varchar(100)	,							-- APP授权码
  `phone` 			varchar(50)		,							-- 联系电话
  `email` 			varchar(100)	,							-- 联系邮箱
  `qq` 				varchar(50)		,							-- 联系QQ
  `address`			varchar(50)		,							-- 联系地址
  `icp` 			varchar(50)		,							-- 网站ICP
  `tongji` 			text			,							-- 第三方统计
  `template` 		varchar(50)		DEFAULT 'default',			-- 模板 
  `version`			varchar(50)		,							-- 版本
  `key`				varchar(50)		,							-- key
  `insertdate` 		timestamp 		DEFAULT CURRENT_TIMESTAMP,	-- 安装时间
  `state` 			tinyint(4) 	DEFAULT '0'						-- 状态
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `ds_site` (`name`, `host`, `phone`, `email`, `qq`, `address`, `version`, `key`) VALUES ('DS文库系统', 'https://www.docswf.com', '0531-8888888', '50245077@qq.com', '50245077', '山东省济南市齐鲁软件F坐', '1.0', '12345678');

-- 导航栏表
DROP TABLE IF EXISTS `ds_navbar`;
CREATE TABLE `ds_navbar`(
	`id` 			int(11) 		AUTO_INCREMENT PRIMARY KEY,	-- ID
	`title` 		varchar(50) 	,							-- 名称
	`href` 			varchar(500)	,							-- 链接地址
	`blank` 		varchar(50)		,							-- 新窗口  [_self,_blank]
	`pc` 			tinyint(4)		,							-- 电脑端  0:未启用，1:启用
	`mobile` 		tinyint(4)		,							-- 手机端  0:未启用，1:启用
	`sort` 			tinyint(4)		,							-- 排序
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
INSERT INTO `ds_navbar` (`id`, `title`, `href`, `blank`, `pc`, `mobile`, `sort`) VALUES(1, '首页', '/', '_self', 1, 1, 1);
INSERT INTO `ds_navbar` (`id`, `title`, `href`, `blank`, `pc`, `mobile`, `sort`) VALUES(2, '分类', 'type.html', '_self', 0, 1, 2);
INSERT INTO `ds_navbar` (`id`, `title`, `href`, `blank`, `pc`, `mobile`, `sort`) VALUES(3, '文档', 'doc.html', '_self', 1, 1, 3);
INSERT INTO `ds_navbar` (`id`, `title`, `href`, `blank`, `pc`, `mobile`, `sort`) VALUES(4, '专题', 'topic.html', '_self', 1, 1, 4);
INSERT INTO `ds_navbar` (`id`, `title`, `href`, `blank`, `pc`, `mobile`, `sort`) VALUES(5, 'VIP文档', 'vip.html', '_self', 1, 1, 5);
INSERT INTO `ds_navbar` (`id`, `title`, `href`, `blank`, `pc`, `mobile`, `sort`) VALUES(6, '悬赏', 'reward.html', '_self', 1, 1, 6);
INSERT INTO `ds_navbar` (`id`, `title`, `href`, `blank`, `pc`, `mobile`, `sort`) VALUES(7, '文章', 'article.html', '_self', 1, 0,7);
INSERT INTO `ds_navbar` (`id`, `title`, `href`, `blank`, `pc`, `mobile`, `sort`) VALUES(8, '问答', 'ask.html', '_self', 1, 0, 8);
INSERT INTO `ds_navbar` (`id`, `title`, `href`, `blank`, `pc`, `mobile`, `sort`) VALUES(9, '帮助', 'help.html', '_self', 1, 0, 9);

-- Banner表
DROP TABLE IF EXISTS `ds_banner`;
CREATE TABLE `ds_banner`(
	`id` 			int(11) 		AUTO_INCREMENT PRIMARY KEY,	-- bannerID
	`name` 			varchar(50) 	,							-- banner名称
	`img` 			varchar(500)	,							-- banner图片	
	`src` 			varchar(500)	,							-- 链接地址
	`pc` 			tinyint(4)		,							-- 电脑端  0:未启用，1:启用
	`mobile` 		tinyint(4)		,							-- 手机端  0:未启用，1:启用
	`sort` 			tinyint(4)		,							-- 排序
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '1'					-- 状态
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
INSERT INTO `ds_banner` (`id`, `name`, `img`, `src`, `pc`, `mobile`,`sort`) VALUES(1, '幻灯1', 'data/img/banner01.jpg', '', 1, 1, 1);
INSERT INTO `ds_banner` (`id`, `name`, `img`, `src`, `pc`, `mobile`, `sort`) VALUES(2, '幻灯2', 'data/img/banner02.jpg', '', 1, 1, 2);
INSERT INTO `ds_banner` (`id`, `name`, `img`, `src`, `pc`, `mobile`, `sort`) VALUES(3, '幻灯3', 'data/img/banner03.jpg', '', 1, 1, 3);
INSERT INTO `ds_banner` (`id`, `name`, `img`, `src`, `pc`, `mobile`, `sort`) VALUES(4, '幻灯4', 'data/img/banner04.jpg', '', 1, 1, 4);
INSERT INTO `ds_banner` (`id`, `name`, `img`, `src`, `pc`, `mobile`, `sort`) VALUES(5, '幻灯5', 'data/img/banner05.jpg', '', 1, 1, 5);

-- Links表
DROP TABLE IF EXISTS `ds_links`;
CREATE TABLE `ds_links`(
	`id` 			int(11) 		AUTO_INCREMENT PRIMARY KEY,	-- linksID
	`name` 			varchar(50) 	,							-- links名称
	`img` 			varchar(500)	,							-- links图片	
	`src` 			varchar(500)	,							-- 链接地址 	
	`sort` 			tinyint(4)		,							-- 排序
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '1'					-- 状态 启用状态， 0:未启用，1:启用
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
INSERT INTO `ds_links` (`id`, `name`, `img`, `src`, `sort`) VALUES(1, '阿里云', 'data/img/l_aliyun.png', '#', 1);
INSERT INTO `ds_links` (`id`, `name`, `img`, `src`, `sort`) VALUES(2, '百度', 'data/img/l_baidu.png', '#', 2);
INSERT INTO `ds_links` (`id`, `name`, `img`, `src`, `sort`) VALUES(3, '亚马逊', 'data/img/l_aws.png', '#', 3);
INSERT INTO `ds_links` (`id`, `name`, `img`, `src`, `sort`) VALUES(4, '开放云', 'data/img/l_baiduyun.png', '#', 4);
INSERT INTO `ds_links` (`id`, `name`, `img`, `src`, `sort`) VALUES(5, '乐视云', 'data/img/l_letv.png', '#', 5);
INSERT INTO `ds_links` (`id`, `name`, `img`, `src`, `sort`) VALUES(6, 'Ucloud', 'data/img/l_ucloud.png', '#', 6);

-- Partner表
DROP TABLE IF EXISTS `ds_partner`;
CREATE TABLE `ds_partner`(
	`id` 			int(11) 		AUTO_INCREMENT PRIMARY KEY,	-- ID
	`name` 			varchar(50) 	,							-- 名称
	`img` 			varchar(500)	,							-- 图片	
	`src` 			varchar(500)	,							-- 链接地址 	
	`sort` 			tinyint(4)		,							-- 排序
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '1'					-- 状态 启用状态， 0:未启用，1:启用
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
INSERT INTO `ds_partner` (`id`, `name`, `img`, `src`, `sort`) VALUES(1, '阿里云', 'data/img/l_aliyun.png', '#', 1);
INSERT INTO `ds_partner` (`id`, `name`, `img`, `src`, `sort`) VALUES(2, '百度', 'data/img/l_baidu.png', '#', 2);
INSERT INTO `ds_partner` (`id`, `name`, `img`, `src`, `sort`) VALUES(3, '亚马逊', 'data/img/l_aws.png', '#', 3);
INSERT INTO `ds_partner` (`id`, `name`, `img`, `src`, `sort`) VALUES(4, '开放云', 'data/img/l_baiduyun.png', '#', 4);
INSERT INTO `ds_partner` (`id`, `name`, `img`, `src`, `sort`) VALUES(5, '乐视云', 'data/img/l_letv.png', '#', 5);
INSERT INTO `ds_partner` (`id`, `name`, `img`, `src`, `sort`) VALUES(6, 'Ucloud', 'data/img/l_ucloud.png', '#', 6);

-- 公告表
DROP TABLE IF EXISTS `ds_notice`;
CREATE TABLE `ds_notice`(
	`id` 			int(11) 		AUTO_INCREMENT PRIMARY KEY,	-- ID
	`title` 		varchar(50) 	,							-- 公告名称
	`body` 			text			,							-- 公告内容
	`import` 		int(11)		 	DEFAULT '0',				-- 重要公告	
	`pubdate` 		date	 	 	,							-- 公布日期
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '1'					-- 启用状态， 0:未启用，1:启用
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
INSERT INTO `ds_notice` (`id`, `title`, `body`, `import`, `pubdate`) VALUES(1, 'DS文库系统正式版发布', '今天，文库系统独立版就正式上线，独立版文库版系统支持N多特性。。。', '1', '2018-11-12');
INSERT INTO `ds_notice` (`id`, `title`, `body`, `import`, `pubdate`) VALUES(2, '新站建设中，敬请期待', '新版文库系统，正在紧张开发中...', '0', '2017-11-10');

-- 功能设置表
DROP TABLE IF EXISTS `ds_docset`;
CREATE TABLE `ds_docset`(
	`isnotice` 		tinyint(4) 		, 							-- 首页显示公告
	`isarticle` 	tinyint(4) 		, 							-- 首页显示文章
	`istui` 		tinyint(4) 		, 							-- 首页显示推荐模块
	`isnew` 		tinyint(4) 		, 							-- 首页显示最新模块
	`isfree` 		tinyint(4) 		, 							-- 首页显示免费模块
	`isvip` 		tinyint(4) 		, 							-- 首页显示VIP模块
	`isreward` 		tinyint(4) 		, 							-- 首页显示悬赏模块
	`isuser` 		tinyint(4) 		, 							-- 首页显示活跃用户
	`home_cache`	int(11)			,							-- 首页缓存时间，单位秒
	`list_cache`	int(11)			,							-- 列表页缓存时间，单位秒
	`doc_cache`		int(11)			,							-- 详细页缓存时间，单位秒
	`anonypay` 		tinyint(4) 		, 							-- 匿名下载
	`doc_num`		int(11)			,							-- 虚拟文档数据
	`ismd5` 		tinyint(4) 		, 							-- 是否可以上传重复文档，MD5验证
	`wordcount`		int(11)			,							-- 截取的简介字数
	`preview`		int(11)			,							-- 默认预览几页
	`readpay`		float			,							-- 默认阅读金币
	`downpay`		float			,							-- 默认下载金币
	`mintype` 		tinyint(4) 		, 							-- 选择到最小分类
	`minfilter` 	tinyint(4) 		, 							-- 选择到最小附加分类
	`iscopy` 		tinyint(4) 		, 							-- 是否可复制
	`iszip` 		tinyint(4) 		, 							-- 是否启用压缩
	`ish5` 			tinyint(4) 		, 							-- 是否启用H5方式阅读[无用]
	`isyun` 		tinyint(4) 		, 							-- 是否启用云转换
	`ypage` 		tinyint(4) 		, 							-- 云转换页数
	`isauth1` 		tinyint(4) 		, 							-- 认证用户才能上传
	`isauth2` 		tinyint(4) 		, 							-- 认证用户才能提现	
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
INSERT INTO `ds_docset` (`isnotice`,`isarticle`,`istui`,`isnew`,`isfree`,`isvip`,`isreward`,`isuser`,`home_cache`,`list_cache`,`doc_cache`,`doc_num`,`ismd5`,`wordcount`,`preview`,`readpay`,`downpay`,`iscopy`,`iszip`,`ish5`, `isyun`, `ypage`,`isauth1`,`isauth2`) VALUES(1,1,1,1,1,1,1,1,0,0,0,10000,1,1000,2,3,5,1,0,0,0,5,0,0);

-- 水印设置表
DROP TABLE IF EXISTS `ds_water`;
CREATE TABLE `ds_water`(
	`text` 			varchar(20) 	, 							-- 文字
	`font` 			varchar(20) 	, 							-- 字体
	`size` 			varchar(20) 	, 							-- 大小
	`x`				int(11)			,							-- X位置
	`y`				int(11)			,							-- Y位置
	`width`			int(11)			,							-- 宽度
	`height`		int(11)			,							-- 高度
	`rotate`		int(11)			,							-- 角度
	`fill`			varchar(20)	,								-- 颜色
	`watermark`		varchar(500)	,							-- 结果
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '1'					-- 0：关闭 1：开启
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
INSERT INTO `ds_water` (`text`,`font`,`size`,`x`,`y`,`width`,`height`,`rotate`,`fill`,`watermark`) VALUES('DS文库系统','宋体',16,20,15,100,100,30,'0,0,0,0.2','<defs><pattern id="pattern" x="0" y="0" width="150" height="150" patternUnits="userSpaceOnUse"><text x="20" y="15" font-size="16" font-family="宋体" transform="rotate(30)" fill="rgba(0,0,0,.2)">DS文库系统</text></pattern></defs><rect width="100%" height="100%" fill="url(#pattern)" />');

-- 交易规则表
DROP TABLE IF EXISTS `ds_tradeset`;
CREATE TABLE `ds_tradeset`(
	`glodname`		varchar(50) 	, 							-- 交易币名称/符号
	`glodunit`		varchar(50) 	, 							-- 交易币单位
	`toauth` 		tinyint(4) 		, 							-- 阅读和下载交易币是否给上传者 0：不给 1：给
	`toauth2` 		tinyint(4) 		, 							-- 扫码直接交易的交易币是否给上传者 0：不给 1：给	
	`rate` 			float		 	,							-- 如果阅读和下载交易币给上传者，是否扣除税率，0没有税率
	`paydue` 		int(11)		 	,							-- 几天后，再次下载或阅读需要重新付费，0永不过期
	`rewardtop` 	int(11)			,							-- 悬赏置顶价格
	`backrate` 		float			,							-- 悬赏失败,退回赏金折扣。0.9 则返回90%
	`glodin` 		int(11)			,							-- 最低充值金额
	`glodout` 		int(11)			,							-- 最低提现金额
	`glodrate`		float			,							-- 交易币对人民币兑换比例
	`pointout` 		int(11)			,							-- 最低兑换积分
	`pointrate`		float			,							-- 积分对交易币兑换比例
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
INSERT INTO `ds_tradeset` (`glodname`, `glodunit`, `toauth`, `toauth2`, `rate`, `paydue`, `rewardtop`, `backrate`,`glodin`,`glodout`,`glodrate`,`pointout`,`pointrate`) VALUES('¥','元',1,0,0.2,365,10,0.9,10,10,1,100,0.1);

-- 积分设置表，半固定表(pointid，pointname，cycle)
DROP TABLE IF EXISTS `ds_points`;
CREATE TABLE `ds_points`(
	`id` 			int(11) 		AUTO_INCREMENT PRIMARY KEY,	-- 积分ID
	`name` 			varchar(100) 	,							-- 积分名称
	`cycle` 		varchar(50) 	,							-- 周期
	`points` 		int(11)			,							-- 积分值
	`note`			varchar(250)	,							-- 积分描述
	`sort` 			tinyint(4)		,							-- 排序
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '1'					-- 状态 0:不启用 1：启用
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
INSERT INTO `ds_points` (`id`, `name`, `cycle`, `points`, `note`, `sort`) VALUES(1,'用户注册',						'一次', 10, '',1);
INSERT INTO `ds_points` (`id`, `name`, `cycle`, `points`, `note`, `sort`) VALUES(2,'每天登录',						'每天', 1, 	'',2);
INSERT INTO `ds_points` (`id`, `name`, `cycle`, `points`, `note`, `sort`) VALUES(3,'用户信息完善',					'一次', 1, 	'',2);
INSERT INTO `ds_points` (`id`, `name`, `cycle`, `points`, `note`, `sort`) VALUES(4,'上传的文档被管理员审核通过',	 '每篇', 2,	'',3);
INSERT INTO `ds_points` (`id`, `name`, `cycle`, `points`, `note`, `sort`) VALUES(5,'上传的文档被管理员设为推荐',	 '每篇', 5,	'',4);
INSERT INTO `ds_points` (`id`, `name`, `cycle`, `points`, `note`, `sort`) VALUES(6,'上传的文档被管理员设为VIP',		 '每篇', 10, '',5);
INSERT INTO `ds_points` (`id`, `name`, `cycle`, `points`, `note`, `sort`) VALUES(7,'访问推广',						'每次', 10, '',6);
INSERT INTO `ds_points` (`id`, `name`, `cycle`, `points`, `note`, `sort`) VALUES(8,'注册推广',						'每次', 20, '',7);
-- INSERT INTO `ds_points` (`id`, `name`, `cycle`, `points`, `note`, `sort`) VALUES(9,'微信分享',						'每次', 25, '',8);

-- SMTP表
DROP TABLE IF EXISTS `ds_smtp`;
CREATE TABLE `ds_smtp`(
	`email` 		varchar(50) 	,							-- 邮箱
	`username` 		varchar(50) 	,							-- 邮箱用户名
	`password` 		varchar(50) 	,							-- 邮箱密码
	`smtp` 			varchar(50)		,							-- SMTP	
	`port` 			varchar(10)		,							-- Port
	`email_from` 	varchar(50) 	,							-- 测试邮箱发件人
	`email_to` 		varchar(50) 	,							-- 测试邮箱收件人	
	`email_body` 	varchar(100)	,							-- 测试信息
	`insertdate` 	timestamp	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)		DEFAULT '0'					-- 状态
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `ds_smtp` (`email`, `username`, `password`, `smtp`, `port`, `email_to`, `email_body`) VALUES('admin@docswf.com', 'admin@docswf.com', 'SMTPserver1234', 'ssl://smtp.mxhichina.com', '465','50245077@qq.com','您的SMTP邮件服务已成功设置');

-- 协议表
DROP TABLE IF EXISTS `ds_protocol`;
CREATE TABLE `ds_protocol`(
	`type` 			varchar(50) 	PRIMARY KEY,				-- 协议分类
	`title` 		varchar(50) 	,							-- 协议标题
	`content` 		text 			,							-- 协议内容
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `ds_protocol` (`type`, `title`, `content`) VALUES ('agree', '文库注册协议', '协议内容');

-- 底部菜单分组
DROP TABLE IF EXISTS `ds_about_group`;
CREATE TABLE `ds_about_group`(
	`id` 			int(11) 		AUTO_INCREMENT PRIMARY KEY,	-- ID
	`title` 		varchar(50) 	,							-- 名称
	`sort` 			tinyint(4)		,							-- 排序
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
INSERT INTO `ds_about_group` (`id`, `title`, `sort`) VALUES (1, '关于我们', 1);
INSERT INTO `ds_about_group` (`id`, `title`, `sort`) VALUES (2, '版权声明', 2);
INSERT INTO `ds_about_group` (`id`, `title`, `sort`) VALUES (3, '商务合作', 3);
INSERT INTO `ds_about_group` (`id`, `title`, `sort`) VALUES (4, '使用帮助', 4);

-- 底部菜单
DROP TABLE IF EXISTS `ds_about`;
CREATE TABLE `ds_about`(
	`id` 			int(11) 		AUTO_INCREMENT PRIMARY KEY,	-- ID
	`title` 		varchar(50) 	,							-- 名称
	`link`	 		varchar(50) 	,							-- 名称
	`content` 		text 			,							-- 内容
	`groupid` 		int(11)		 	,							-- 分组	
	`sort` 			tinyint(4)		,							-- 排序
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '1'					-- 状态 启用状态， 0:未启用，1:启用
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
INSERT INTO `ds_about` (`title`, `link`, `content`, `groupid`, `sort`) VALUES ('关于我们', 'about.html', '关于我们', 1 ,11);
INSERT INTO `ds_about` (`title`, `link`, `content`, `groupid`, `sort`) VALUES ('网站协议', 'protocol.html', '网站协议', 1 ,12);
INSERT INTO `ds_about` (`title`, `link`, `content`, `groupid`, `sort`) VALUES ('意见反馈', 'feedback.html', '意见反馈', 1 ,13);
INSERT INTO `ds_about` (`title`, `link`, `content`, `groupid`, `sort`) VALUES ('免责声明', 'duty.html', '免责声明', 2 ,21);
INSERT INTO `ds_about` (`title`, `link`, `content`, `groupid`, `sort`) VALUES ('版权声明', 'right.html', '版权声明', 2 ,22);
INSERT INTO `ds_about` (`title`, `link`, `content`, `groupid`, `sort`) VALUES ('版权申诉', 'report.html', '版权申诉', 2 ,23);
INSERT INTO `ds_about` (`title`, `link`, `content`, `groupid`, `sort`) VALUES ('广告服务', 'adv.html', '广告服务', 3 ,31);
INSERT INTO `ds_about` (`title`, `link`, `content`, `groupid`, `sort`) VALUES ('友情链接', 'link.html', '友情链接', 3 ,32);
INSERT INTO `ds_about` (`title`, `link`, `content`, `groupid`, `sort`) VALUES ('商业合作', 'biz.html', '商业合作', 3 ,33);
INSERT INTO `ds_about` (`title`, `link`, `content`, `groupid`, `sort`) VALUES ('使用帮助', 'help.html', '使用帮助', 4 ,41);
INSERT INTO `ds_about` (`title`, `link`, `content`, `groupid`, `sort`) VALUES ('会员权益', 'member.html', '会员权益', 4 ,42);
INSERT INTO `ds_about` (`title`, `link`, `content`, `groupid`, `sort`) VALUES ('网站地图', 'sitemap.html', '自动跳转到网站地图，请勿修改url', 4 ,43);

CREATE OR REPLACE VIEW `ds_about_view` AS
SELECT `ds_about`.*,`ds_about_group`.`title` as `groupname`
FROM `ds_about` 
LEFT JOIN `ds_about_group` 
ON `ds_about`.`groupid` = `ds_about_group`.`id`;

-- 举报条目表
DROP TABLE IF EXISTS `ds_report_item`;
CREATE TABLE `ds_report_item`(
	`id` 			int(11) 		AUTO_INCREMENT PRIMARY KEY,	-- bannerID
	`title` 		varchar(50) 	,							-- banner名称	
	`sort` 			tinyint(4)		,							-- 排序
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '1'					-- 状态 启用状态， 0:未启用，1:启用
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
INSERT INTO `ds_report_item` (`id`, `title`, `sort`) VALUES(1, '侵权盗版文件', 1);
INSERT INTO `ds_report_item` (`id`, `title`, `sort`) VALUES(2, '侵犯个人隐私', 2);
INSERT INTO `ds_report_item` (`id`, `title`, `sort`) VALUES(3, '泄露商业机密', 3);
INSERT INTO `ds_report_item` (`id`, `title`, `sort`) VALUES(4, '广告垃圾信息', 4);
INSERT INTO `ds_report_item` (`id`, `title`, `sort`) VALUES(5, '其他违法信息', 5);

-- 热门搜索项目
DROP TABLE IF EXISTS `ds_hotkey`;
CREATE TABLE `ds_hotkey`(
	`id` 			int(11) 		AUTO_INCREMENT PRIMARY KEY,	-- ID
	`key` 			varchar(50) 	,							-- 关键字	
	`sort` 			tinyint(4)		,							-- 排序
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '1'					-- 状态 启用状态， 0:未启用，1:启用
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
INSERT INTO `ds_hotkey` (`key`, `sort`) VALUES('力的合成', 1);
INSERT INTO `ds_hotkey` (`key`, `sort`) VALUES('PPT模板', 2);
INSERT INTO `ds_hotkey` (`key`, `sort`) VALUES('物理课件', 3);
INSERT INTO `ds_hotkey` (`key`, `sort`) VALUES('物联网IOT', 4);
INSERT INTO `ds_hotkey` (`key`, `sort`) VALUES('2018高考答案', 5);
INSERT INTO `ds_hotkey` (`key`, `sort`) VALUES('数学答案', 6);
INSERT INTO `ds_hotkey` (`key`, `sort`) VALUES('英语', 7);

-- 过滤词
DROP TABLE IF EXISTS `ds_badword`;
CREATE TABLE `ds_badword`(
	`id` 			int(11) 		AUTO_INCREMENT PRIMARY KEY,	-- ID
	`word` 			varchar(50) 	,							-- 关键字
	`word2` 		varchar(50) 	,							-- To关键字	
	`sort` 			tinyint(4)		,							-- 排序
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '1'					-- 状态 启用状态， 0:未启用，1:启用
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;

-- Adv表
DROP TABLE IF EXISTS `ds_adv`;
CREATE TABLE `ds_adv`(
	`id` 			int(11) 		AUTO_INCREMENT PRIMARY KEY,	-- advID
	`name` 			varchar(50) 	,							-- adv名称
	`page` 			varchar(10)		,							-- 在哪一页 [home,list,doc,search]
	`pointid` 		int(11)			,							-- 在哪里ID
	`src` 			varchar(500)	,							-- 源码
	`sort` 			tinyint(4)		,							-- 排序
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
INSERT INTO `ds_adv` (`id`, `name`, `page`, `pointid`, `src`, `sort`) VALUES(1, '最新文档下方', 'home', '1', '<a href=""><img src="data/img/chang_a1.png" /></a>', 1);
INSERT INTO `ds_adv` (`id`, `name`, `page`, `pointid`, `src`, `sort`) VALUES(2, '合作伙伴上方', 'home', '2', '<a href=""><img src="data/img/chang_a1.png" /></a>', 2);
INSERT INTO `ds_adv` (`id`, `name`, `page`, `pointid`, `src`, `sort`) VALUES(3, '列表上方', 'list', '3', '<a href=""><img src="data/img/list_a1.png" style="width:100%" /></a>', 1);
INSERT INTO `ds_adv` (`id`, `name`, `page`, `pointid`, `src`, `sort`) VALUES(4, '分类下方', 'list', '4', '<a href=""><img src="data/img/fang_a1.png" /></a>', 2);
INSERT INTO `ds_adv` (`id`, `name`, `page`, `pointid`, `src`, `sort`) VALUES(5, '评论下方', 'doc', '5', '<a href=""><img src="data/img/fang_a1.png" /></a>', 1);
INSERT INTO `ds_adv` (`id`, `name`, `page`, `pointid`, `src`, `sort`) VALUES(6, '阅读页之间', 'doc', '6', '<a href=""><img src="data/img/chang_a1.png" /></a>', 2);
INSERT INTO `ds_adv` (`id`, `name`, `page`, `pointid`, `src`, `sort`) VALUES(7, '列表右侧', 'search', '7', '<a href=""><img src="data/img/fang_a1.png" /></a>', 1);
INSERT INTO `ds_adv` (`id`, `name`, `page`, `pointid`, `src`, `sort`) VALUES(8, '列表右侧', 'search', '7', '<a href=""><img src="data/img/fang_a1.png" /></a>', 2);
INSERT INTO `ds_adv` (`id`, `name`, `page`, `pointid`, `src`, `sort`) VALUES(9, '列表右侧', 'search', '7', '<a href=""><img src="data/img/fang_a1.png" /></a>', 3);
INSERT INTO `ds_adv` (`id`, `name`, `page`, `pointid`, `src`, `sort`) VALUES(10, '列表下方', 'search', '8', '<a href=""><img src="data/img/chang_a1.png" style="width:100%" /></a>', 4);

-- Adv 位置固定表
DROP TABLE IF EXISTS `ds_advpoint`;
CREATE TABLE `ds_advpoint`(
	`id` 			int(11) 		AUTO_INCREMENT PRIMARY KEY,	-- advpointID
	`page` 			varchar(10)		,							-- 哪一页 [home,list,doc,search]
	`point` 		varchar(50)		,							-- 哪里 [下方,上方]
	`sort` 			tinyint(4)		,							-- 排序
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
INSERT INTO `ds_advpoint` (`id`, `page`, `point`, `sort`) VALUES(1, 'home', '畅读榜下方', 1);
INSERT INTO `ds_advpoint` (`id`, `page`, `point`, `sort`) VALUES(2, 'home', '友情链接上方', 2);
INSERT INTO `ds_advpoint` (`id`, `page`, `point`, `sort`) VALUES(3, 'list', '列表上方', 1);
INSERT INTO `ds_advpoint` (`id`, `page`, `point`, `sort`) VALUES(4, 'list', '分类下方', 2);
INSERT INTO `ds_advpoint` (`id`, `page`, `point`, `sort`) VALUES(5, 'doc', '评论下方', 1);
INSERT INTO `ds_advpoint` (`id`, `page`, `point`, `sort`) VALUES(6, 'doc', '阅读页之间', 2);
INSERT INTO `ds_advpoint` (`id`, `page`, `point`, `sort`) VALUES(7, 'search', '列表右侧', 1);
INSERT INTO `ds_advpoint` (`id`, `page`, `point`, `sort`) VALUES(8, 'search', '列表下方', 2);

CREATE OR REPLACE VIEW `ds_advv` AS
SELECT `ds_adv`.*,`ds_advpoint`.`point`  
FROM `ds_adv` 
LEFT JOIN `ds_advpoint` 
ON `ds_adv`.`pointid` = `ds_advpoint`.`id`;

-- 用户组表,根据文档数量确定,0 限制 -1不限制。
DROP TABLE IF EXISTS `ds_group`;
CREATE TABLE `ds_group`(
	`groupid` 		int(11)			AUTO_INCREMENT PRIMARY KEY,	-- 用户组ID
	`groupname` 	varchar(50) 	,							-- 用户组名
	`groupicon` 	varchar(250)	,							-- 用户组图标
	`docnum`		int(11)			DEFAULT '0',				-- 所需用户文档数
	`isauth`		int(11)			DEFAULT '0',				-- 是否需要认证，建议处默认用户组，其他需要认证。
	`divide`		float 			DEFAULT '0',				-- 提现利率 提现金额=提现额*提现利率
	`invite`		varchar(50) 	DEFAULT '0',				-- 邀请奖 整数一次性分成 和 %被邀请人付费奖励
	`invitedays`	int(11) 		DEFAULT '0',				-- 多次奖励  时间限制 0：不限制 单位：天
	`uploadcount`	int(11)			DEFAULT '0',				-- 上传上限50篇，[-1 不限制 0不能上传]
	`uploadsize`	int(11)			DEFAULT '0',				-- 上传大小限制2M,单位M，[-1 不限制 0不能上传]
	`uploadexten`	varchar(250)	,							-- 上传大小类型限制，doc,docx,ppt,pptx,xls,xlsx,csv,epub,vsd,pot,pps,rtf,wps,et,dps,pdf,txt,zip
	`downcount`		int(11)			DEFAULT '0',				-- 下载上限50篇	，[-1 不限制 0不能上传]
	`rights`		varchar(500) 	,							-- 权限列表
	`sort` 			tinyint(4)		,							-- 排序
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
INSERT INTO `ds_group` (`groupid`, `groupname`, `groupicon`, `docnum`, `isauth`, `divide`, `uploadcount`, `uploadsize`, `uploadexten`, `downcount`, `rights`, `sort`) VALUES(-1, '游客', '', 0, 0, 0, 0, 0, 'doc,docx,ppt,pptx,xls,xlsx,csv,epub,vsd,pot,pps,rtf,wps,et,dps,pdf,txt,zip', 0,'1,10,40,50,60,70', 1); -- 不能删
INSERT INTO `ds_group` (`groupid`, `groupname`, `groupicon`, `docnum`, `isauth`, `divide`, `uploadcount`, `uploadsize`, `uploadexten`, `downcount`, `rights`, `sort`) VALUES(1, '管理员', '', 0, 0, 1, -1, -1, 'doc,docx,ppt,pptx,xls,xlsx,csv,epub,vsd,pot,pps,rtf,wps,et,dps,pdf,txt,zip', -1,'1,2,3,4,10,11,12,13,14,15,16,17,18,19,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79', 2);
INSERT INTO `ds_group` (`groupid`, `groupname`, `groupicon`, `docnum`, `isauth`, `divide`, `uploadcount`, `uploadsize`, `uploadexten`, `downcount`, `rights`, `sort`) VALUES(2, '审核员', '', 0, 0, 1, -1, -1, 'doc,docx,ppt,pptx,xls,xlsx,csv,epub,vsd,pot,pps,rtf,wps,et,dps,pdf,txt,zip', -1,'1,2,3,10,11,12,13,14,15,16,17,18,19,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79', 3);
INSERT INTO `ds_group` (`groupid`, `groupname`, `groupicon`, `docnum`, `isauth`, `divide`, `uploadcount`, `uploadsize`, `uploadexten`, `downcount`, `rights`, `sort`) VALUES(3, '注册会员', '', 0, 0, 0.5, 50, 10, 'doc,docx,ppt,pptx,xls,xlsx,csv,epub,vsd,pot,pps,rtf,wps,et,dps,pdf,txt,zip', 50,'1,2,10,11,12,13,14,15,16,17,18,19,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79', 4);
INSERT INTO `ds_group` (`groupid`, `groupname`, `groupicon`, `docnum`, `isauth`, `divide`, `uploadcount`, `uploadsize`, `uploadexten`, `downcount`, `rights`, `sort`) VALUES(4, '铜牌会员', '', 500, 1, 0.8, 200, 20, 'doc,docx,ppt,pptx,xls,xlsx,csv,epub,vsd,pot,pps,rtf,wps,et,dps,pdf,txt,zip', 200,'1,2,10,11,12,13,14,15,16,17,18,19,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79', 5);
INSERT INTO `ds_group` (`groupid`, `groupname`, `groupicon`, `docnum`, `isauth`, `divide`, `uploadcount`, `uploadsize`, `uploadexten`, `downcount`, `rights`, `sort`) VALUES(5, '银牌会员', '', 1000, 1, 0.85, 300, 30, 'doc,docx,ppt,pptx,xls,xlsx,csv,epub,vsd,pot,pps,rtf,wps,et,dps,pdf,txt,zip', 300,'1,2,10,11,12,13,14,15,16,17,18,19,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79', 6);
INSERT INTO `ds_group` (`groupid`, `groupname`, `groupicon`, `docnum`, `isauth`, `divide`, `uploadcount`, `uploadsize`, `uploadexten`, `downcount`, `rights`, `sort`) VALUES(6, '金牌会员', '', 5000, 1, 0.9, 400, 40, 'doc,docx,ppt,pptx,xls,xlsx,csv,epub,vsd,pot,pps,rtf,wps,et,dps,pdf,txt,zip', 400,'1,2,10,11,12,13,14,15,16,17,18,19,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79', 7);
INSERT INTO `ds_group` (`groupid`, `groupname`, `groupicon`, `docnum`, `isauth`, `divide`, `uploadcount`, `uploadsize`, `uploadexten`, `downcount`, `rights`, `sort`) VALUES(7, '钻石会员', '', 10000, 1, 0.95, 500, 50, 'doc,docx,ppt,pptx,xls,xlsx,csv,epub,vsd,pot,pps,rtf,wps,et,dps,pdf,txt,zip', 500,'1,2,10,11,12,13,14,15,16,17,18,19,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79', 8);
UPDATE `ds_group` SET `groupid` = '0' WHERE `ds_group`.`groupid` = -1;

-- VIP用户组表
DROP TABLE IF EXISTS `ds_vgroup`;
CREATE TABLE `ds_vgroup`(
	`vgroupid` 		int(11)			AUTO_INCREMENT PRIMARY KEY,	-- 用户组ID
	`vgroupname` 	varchar(50) 	,							-- 用户组名
	`vgroupicon` 	varchar(250)	,							-- 用户组图标
	`vipdays`		int(11)			,							-- VIP开通时长,单位天
	`discount`		float 			,							-- VIP折扣(read) 0.9
	`discount2`		float 			,							-- VIP折扣(down) 0.9
	`downcount`		int(11)			,							-- 日下载上限+50篇
	`downcount2`		int(11)			,						-- 总下载量 -1 不限制
	`docmoney`		float			,							-- 免费下载文档价格上限
	`cash` 			varchar(20)		,							-- 原价
	`cash2` 		varchar(20)		,							-- 优惠价
	`suggest` 		int(11)		 	DEFAULT '0',				-- 推荐
	`sort` 			tinyint(4)		,							-- 排序
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态 0：未启用 1：启用
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
INSERT INTO `ds_vgroup` (`vgroupid`, `vgroupname`, `vgroupicon`, `vipdays`, `discount`, `discount2`,`downcount`, `downcount2`,`cash`, `cash2`, `suggest`, `sort`, `state`) VALUES(1, 'VIP(月)', '',  30,  0.95, 0.95, 50,  5000, 20,   20,  0, 1, 1);
INSERT INTO `ds_vgroup` (`vgroupid`, `vgroupname`, `vgroupicon`, `vipdays`, `discount`, `discount2`,`downcount`, `downcount2`,`cash`, `cash2`, `suggest`, `sort`, `state`) VALUES(2, 'VIP(季)', '',  90,  0.9,  0.9,  100, 1000, 60,   55,  0, 2, 1);
INSERT INTO `ds_vgroup` (`vgroupid`, `vgroupname`, `vgroupicon`, `vipdays`, `discount`, `discount2`,`downcount`, `downcount2`,`cash`, `cash2`, `suggest`, `sort`, `state`) VALUES(3, 'VIP(年)', '',  365, 0.85, 0.85, 150, 1500, 240,  200, 0, 3, 1);
INSERT INTO `ds_vgroup` (`vgroupid`, `vgroupname`, `vgroupicon`, `vipdays`, `discount`, `discount2`,`downcount`, `downcount2`,`cash`, `cash2`, `suggest`, `sort`, `state`) VALUES(4, 'SVIP(月)', '', 30,  0.8,  0.8,  200, 2000, 30,   30,  0, 4, 1);
INSERT INTO `ds_vgroup` (`vgroupid`, `vgroupname`, `vgroupicon`, `vipdays`, `discount`, `discount2`,`downcount`, `downcount2`,`cash`, `cash2`, `suggest`, `sort`, `state`) VALUES(5, 'SVIP(季)', '', 90,  0.75, 0.75, 250, 2500, 90,   80,  0, 5, 1);
INSERT INTO `ds_vgroup` (`vgroupid`, `vgroupname`, `vgroupicon`, `vipdays`, `discount`, `discount2`,`downcount`, `downcount2`,`cash`, `cash2`, `suggest`, `sort`, `state`) VALUES(6, 'SVIP(年)', '', 365, 0.7,  0.7,  300, -1,   360 , 300, 1, 6, 1);

-- 权限表，固定表
DROP TABLE IF EXISTS `ds_right`;
CREATE TABLE `ds_right`(
	`rightid` 		int(11) 		PRIMARY KEY,				-- 权限标识
	`rightname` 	varchar(50) 	,							-- 权限名
	`righticon` 	varchar(250)	,							-- 权限图标
	`note`			varchar(250)	,							-- 权限描述
	`model`			int(11)			,							-- 模块	
	`sort` 			tinyint(4)		,							-- 排序
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(1, '访问网站', '不勾选则用户组不能访问网站', 0, 1);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(2, '金币提现', '赚取的金币可以进行提现操作', 0, 2);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(3, '审核管理', '可登录系统后台文档管理页面，进行文档审核，编辑，删除操作', 0, 3);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(4, '系统管理', '可登录系统后台，进行系统配置', 0, 4);

INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(10, '阅读文档', '可以在线阅读文档', 1, 0);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(11, '下载文档', '可以下载文档', 1, 1);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(12, '上传文档', '可以上传文档', 1, 2);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(13, '文档免审', '上传文档无需审核', 1, 3);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(14, '编辑文档', '可以编辑自己上传的文档', 1, 4);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(15, '删除文档', '可以删除自己上传的文档', 1, 5);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(16, '文档评论', '可以在文档阅读页面发表评论', 1, 6);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(17, '评论免审', '发表文档评论无需审核', 1, 7);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(18, '编辑评论', '可以编辑自己发表的文档评论', 1, 8);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(19, '删除评论', '可以删除自己发表的文档评论', 1, 9);

INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(20, '阅读书籍', '可以在线阅读书籍', 2, 0);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(21, '下载书籍', '可以下载书籍', 2, 1);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(22, '上传书籍', '可以上传书籍', 2, 2);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(23, '书籍免审', '上传书籍无需审核', 2, 3);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(24, '编辑书籍', '可以编辑自己上传的书籍', 2, 4);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(25, '删除书籍', '可以删除自己上传的书籍', 2, 5);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(26, '书籍评论', '可以在书籍阅读页面发表评论', 2, 6);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(27, '评论免审', '发表书籍评论无需审核', 2, 7);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(28, '编辑评论', '可以编辑自己发表的书籍评论', 2, 8);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(29, '删除评论', '可以删除自己发表的书籍评论', 2, 9);

INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(30, '观看视频', '可以在线观看视频', 3, 0);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(31, '下载视频', '可以下载视频', 3, 1);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(32, '上传视频', '可以上传视频', 3, 2);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(33, '视频免审', '上传视频无需审核', 3, 3);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(34, '编辑视频', '可以编辑自己的上传视频', 3, 4);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(35, '删除视频', '可以删除自己的上传视频', 3, 5);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(36, '视频评论', '可以在观看视频页面发表评论', 3, 6);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(37, '评论免审', '发表视频评论无需审核', 3, 7);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(38, '编辑评论', '可以编辑自己发表的视频评论', 3, 8);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(39, '删除评论', '可以删除自己发表的视频评论', 3, 9);

INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(40, '浏览专题', '可以预览专题模块的专题', 4, 0);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(41, '下载专题', '可以下载专题', 4, 1);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(42, '创建专题', '可以创建专题', 4, 1);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(43, '专题免审', '创建专题无需审核', 4, 2);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(44, '编辑专题', '可以编辑自己创建的专题', 4, 3);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(45, '删除专题', '可以删除自己创建的专题', 4, 4);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(46, '专题评论', '可以在专题详细页面评论专题', 4, 5);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(47, '评论免审', '发表专题评论无需审核', 4, 6);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(48, '编辑评论', '可以编辑自己发表的的专题评论', 4, 7);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(49, '删除评论', '可以删除自己发表的的专题评论', 4, 8);

INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(50, '浏览悬赏', '可以浏览悬赏模块的悬赏任务', 5, 0);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(52, '发布悬赏', '可以发布悬赏任务', 5, 2);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(53, '悬赏免审', '发布悬赏无需审核', 5, 3);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(54, '编辑悬赏', '可以编辑自己的发布的悬赏', 5, 4);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(55, '删除悬赏', '可以删除自己发布悬赏', 5, 5);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(56, '悬赏投稿', '可以进行悬赏投稿', 5, 6);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(57, '投稿免审', '发布投稿无需审核', 5, 7);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(58, '编辑投稿', '可以编辑自己的投稿', 5, 8);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(59, '删除投稿', '可以删除自己的投稿', 5, 9);

INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(60, '浏览文章', '可以浏览文章模块的文章', 6, 0);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(62, '发表文章', '可以发表文章', 6, 2);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(63, '文章免审', '发表文章无需审核', 6, 3);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(64, '编辑文章', '可以编辑自己发表的文章', 6, 4);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(65, '删除文章', '可以删除自己发表的文章', 6, 5);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(66, '评论文章', '可以在文章详细页面评论文章', 6, 6);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(67, '评论免审', '评论文章无需审核', 6, 7);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(68, '编辑评论', '可以编辑自己发表的的文章评论', 6, 8);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(69, '删除评论', '可以删除自己发表的的文章评论', 6, 9);

INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(70, '浏览问答', '可以浏览问答模块的问答', 7, 0);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(72, '提问问题', '可以提问问题', 7, 2);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(73, '问题免审', '提问问题无需审核', 7, 3);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(74, '编辑问题', '可以编辑自己提问的问题', 7, 4);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(75, '删除问题', '可以删除自己提问的问题', 7, 5);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(76, '回答问题', '可以在问答页面回答问题', 7, 6);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(77, '回答免审', '回答问题无需审核', 7, 7);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(78, '编辑回答', '可以编辑自己回答的的问题回答', 7, 8);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(79, '删除回答', '可以删除自己回答的的问题回答', 7, 9);

INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(80, '积分商城', '可以打开积分商城', 8, 0);
INSERT INTO `ds_right` (`rightid`, `rightname`, `note`, `model`, `sort`) VALUES(81, '积分兑换', '可以在积分商城进行兑换', 8, 1);

-- 用户表
DROP TABLE IF EXISTS `ds_user`;
CREATE TABLE `ds_user`(
	`userid` 		int(11)			AUTO_INCREMENT PRIMARY KEY,	-- 用户ID
	`username` 		varchar(50) 	,							-- 用户名，用Email注册
	`password` 		varchar(50) 	,							-- 密码
	`nickname` 		varchar(20) 	,							-- 昵称，设置昵称，用户名显示昵称
	`photo` 		varchar(250) 	,							-- 头像
	`sex` 			char(1) 		,							-- 性别：[男,女]
	`phone` 		varchar(20) 	,							-- 电话号码	
	`address` 		varchar(250) 	,							-- 地址
	`isauth`		tinyint(4)		DEFAULT '0',				-- 认证：[1是,0否]
	`points`		int(11)			DEFAULT '0',				-- 积分，用于兑换
	`glods`			float			DEFAULT '0',				-- 总金币，[交易+充值]
	`groupid`		int(11)			,							-- 用户组,必有
	`vgroupid`		int(11)			DEFAULT '0',				-- VIP用户组
	`vipdate`		datetime		,							-- VIP日期,决定是否过期
	`finvicode`		varchar(20) 	,							-- 来自哪个邀请码
	`iinvicode`		varchar(20) 	,							-- 我的邀请码
	`regfrom`		tinyint(4) 		DEFAULT '0',				-- 来自那里：[1:email 2:phone 3:QQ 4:weixin 5:支付宝 6：discuz]
	`openqq`		varchar(50) 	,							-- 来自那里：第三方登录QQ
	`openwx`		varchar(50) 	,							-- 来自那里：第三方登录WX
	`openali`		varchar(50) 	,							-- 来自那里：第三方登录Ali
	`regip` 		varchar(20) 	,							-- 注册IP
	`regdate` 		datetime 		,							-- 注册时间
	`loginip` 		varchar(20) 	,							-- 最后登陆IP
	`logindate` 	datetime 		,							-- 最后登陆时间
	`insertdate` 	timestamp	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state`			tinyint(4)	 	DEFAULT '1'					-- 状态：[0：禁止 1：正常]
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
INSERT INTO `ds_user` (`userid`, `username`, `password`, `nickname`, `groupid`) VALUES(1, 'admin@docswf.com', 'e10adc3949ba59abbe56e057f20f883e', '小库', 1);
INSERT INTO `ds_user` (`userid`, `username`, `password`, `nickname`, `groupid`) VALUES(2, '50245077@qq.com', 'e10adc3949ba59abbe56e057f20f883e', '冰川', 2);

CREATE OR REPLACE VIEW `ds_user_view` AS 
SELECT `ds_user`.*,`ds_group`.`groupname`,ifnull(`ds_vgroup`.`vgroupname`,'-') as 'vgroupname',(`ds_user`.`vipdate` > now()) as vipuser
FROM `ds_user` 
LEFT JOIN `ds_group` 
ON `ds_user`.`groupid` = `ds_group`.`groupid`
LEFT JOIN `ds_vgroup` 
ON `ds_user`.`vgroupid` = `ds_vgroup`.`vgroupid`;

-- 用户认证
DROP TABLE IF EXISTS `ds_auth`;
CREATE TABLE `ds_auth`(
	`userid` 		int(11) 		PRIMARY KEY,				-- UserID
	`comname` 		varchar(50)		,							-- 企业名称
	`comaddress` 	varchar(50) 	,							-- 企业地址
	`comcode` 		varchar(50)		,							-- 统一社会信用代码
	`realname` 		varchar(50)		,							-- 姓名
	`cardid` 		varchar(50)		,							-- 身份证号
	`phone` 		varchar(50)		,							-- 手机号码
	`email` 		varchar(50)		,							-- 电子邮箱
	`note` 			MEDIUMTEXT		,							-- 其他信息
	`authpic1` 		MEDIUMTEXT		,							-- pic1
	`authpic2` 		MEDIUMTEXT		,							-- pic2
	`authpic3` 		MEDIUMTEXT		,							-- pic3
	`authpic4` 		MEDIUMTEXT		,							-- pic4
	`authpic5` 		MEDIUMTEXT		,							-- pic5
	`authpic6` 		MEDIUMTEXT		,							-- pic6
	`authpic7` 		MEDIUMTEXT		,							-- pic7				
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`model` 		tinyint(4)	 	DEFAULT '0',				-- 状态  0：个人 1：企业	
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态  0：未审核 -1：不过 1：审核通过
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE OR REPLACE VIEW `ds_auth_view` AS 
SELECT `ds_auth`.*,`ds_user`.`username`,`ds_user`.`nickname`
FROM `ds_auth`  
LEFT JOIN `ds_user` 
ON `ds_auth`.`userid` = `ds_user`.`userid`;

-- 文档分类
DROP TABLE IF EXISTS `ds_type`;
CREATE TABLE `ds_type`(
	`typeid` 		int(11) 		AUTO_INCREMENT PRIMARY KEY, -- 分类ID
	`ptypeid` 		int(11)			,							-- 父分类ID
	`typename` 		varchar(50) 	,							-- 类型名称
	`seotitle` 		varchar(100) 	,							-- SEO标题
	`filter`		varchar(50)		DEFAULT '-1',				-- 相关筛选分类1,2,3,4,默认值为-1，防止不设时显示筛选标题
	`sort` 			tinyint(4)		,							-- 排序
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
INSERT INTO `ds_type` (`typeid`, `ptypeid`, `typename`, `filter`, `sort`) VALUES (1, 0, '小学教育', '1,2,3', 1),(2, 0, '中学教育', '1,2,3', 2),(3, 0, '大学教育', '23,24,25', 3),(4, 0, '通信技术', '23,24,25', 4),(5, 0, '程序开发', '23,24,25', 5),(6, 0, '语言', '23,24,25', 6),(7, 0, 'IT计算机', '23,24,25', 7),(8, 1, '语文', '1,2,3', 1),(9, 1, '数学', '1,2,3', 2),(10, 1, '英语', '1,2,3', 3),(11, 1, '其他课程', '1,2,3', 4),(12, 2, '语文', '1,2,3', 1),(13, 2, '英语', '1,2,3', 2),(14, 2, '数学', '1,2,3', 3),(15, 2, '物理', '1,2,3', 4),(16, 2, '化学', '1,2,3', 5),(17, 3, '大学英语', '23,24,25', 1),(18, 3, '高等数学', '23,24,25', 2),(19, 3, '数字电路', '23,24,25', 3),(20, 3, '模拟电路', '23,24,25', 4),(21, 4, ' 电话通信', '23,24,25', 1),(22, 4, '数据通信', '23,24,25', 2),(23, 4, '基带传输j', '23,24,25', 3),(24, 4, '调制传输', '23,24,25', 4),(25, 4, '光纤通信技术', '23,24,25', 5),(26, 5, 'Android开发', '23,24,25', 1),(27, 5, 'IOS开发', '23,24,25', 2),(28, 5, 'Web开发', '23,24,25', 3),(29, 5, '应用程序开发', '23,24,25', 4),(30, 5, '人工智能', '23,24,25', 5),(31, 5, '底层驱动', '23,24,25', 6),(32, 6, 'C语言', '23,24,25', 1),(33, 6, 'C++语言', '23,24,25', 2),(34, 6, 'C#语言', '23,24,25', 3),(35, 6, 'Java语言', '23,24,25', 4),(36, 6, 'PHP语言', '23,24,25', 5),(37, 6, 'Perl语言', '23,24,25', 6),(38, 8, '一年级语文', '1,2,3', 1),(39, 8, '二年级语文', '1,2,3', 2),(40, 8, '三年级语文', '1,2,3', 3),(41, 8, '四年级语文', '1,2,3', 4),(42, 8, '五年级语文', '1,2,3', 5),(43, 8, '六年级语文', '1,2,3', 6),(44, 9, '一年级数学', '1,2,3', 1),(45, 9, '二年级数学', '1,2,3', 2),(46, 9, '三年级数学', '1,2,3', 3),(47, 9, '四年级数学', '1,2,3', 4),(48, 9, '五年级数学', '1,2,3', 5),(49, 9, '六年级数学', '1,2,3', 6),(50, 10, '一年级英语', '1,2,3', 1),(51, 10, '二年级英语', '1,2,3', 2),(52, 10, '三年级英语', '1,2,3', 3),(53, 10, '四年级英语', '1,2,3', 4),(54, 10, '五年级英语', '1,2,3', 5),(55, 10, '六年级英语', '1,2,3', 6),(56, 11, '美术', '1,2,3', 1),(57, 11, '信息技术', '1,2,3', 2),(58, 11, '音乐', '1,2,3', 3),(59, 11, '体育', '1,2,3', 4),(60, 11, '自然科学', '1,2,3', 5),(61, 11, '思想品德', '1,2,3', 6),(62, 11, '阅读', '1,2,3', 7),(63, 12, '初一语文', '1,2,3', 1),(64, 12, '初二语文', '1,2,3', 2),(65, 12, '初三语文', '1,2,3', 3),(66, 12, '初四语文', '1,2,3', 4),(67, 12, '高一语文', '1,2,3', 5),(68, 12, '高二语文', '1,2,3', 6),(69, 12, '高三语文', '1,2,3', 7),(70, 13, '初一英语', '1,2,3', 1),(71, 13, '初二英语', '1,2,3', 2),(72, 13, '初三英语', '1,2,3', 3),(73, 13, '初四英语', '1,2,3', 4),(74, 13, '高一英语', '1,2,3', 5),(75, 13, '高二英语', '1,2,3', 6),(76, 13, '高三英语', '1,2,3', 7),(77, 14, '初一数学', '1,2,3', 1),(78, 14, '初二数学', '1,2,3', 2),(79, 14, '初三数学', '1,2,3', 3),(80, 14, '初四数学', '1,2,3', 4),(81, 14, '高一数学', '1,2,3', 5),(82, 14, '高二数学', '1,2,3', 6),(83, 14, '高三数学', '1,2,3', 7),(84, 15, '初一物理', '1,2,3', 1),(85, 15, '初二物理', '1,2,3', 2),(86, 15, '初三物理', '1,2,3', 3),(87, 15, '初四物理', '1,2,3', 4),(88, 15, '高一物理', '1,2,3', 5),(89, 15, '高二物理', '1,2,3', 6),(90, 15, '高三物理', '1,2,3', 7),(91, 16, '初一化学', '1,2,3', 1),(92, 16, '初二化学', '1,2,3', 2),(93, 16, '初三化学', '1,2,3', 3),(94, 16, '初四化学', '1,2,3', 4),(95, 16, '高一化学', '1,2,3', 5),(96, 16, '高二化学', '1,2,3', 6),(97, 16, '高三化学', '1,2,3', 7),(98, 17, '三级分类A', '23,24,25', 1),(99, 17, '三级分类B', '23,24,25', 2),(100, 17, '三级分类C', '23,24,25', 3),(101, 17, '三级分类D', '23,24,25', 4),(102, 17, '三级分类E', '23,24,25', 5),(103, 17, '三级分类F', '23,24,25', 6),(104, 17, '三级分类G', '23,24,25', 7),(105, 18, '三级分类A', '23,24,25', 1),(106, 18, '三级分类B', '23,24,25', 2),(107, 18, '三级分类C', '23,24,25', 3),(108, 18, '三级分类D', '23,24,25', 4),(109, 18, '三级分类E', '23,24,25', 5),(110, 18, '三级分类F', '23,24,25', 6),(111, 18, '三级分类G', '23,24,25', 7),(112, 19, '三级分类A', '23,24,25', 1),(113, 19, '三级分类B', '23,24,25', 2),(114, 19, '三级分类C', '23,24,25', 3),(115, 19, '三级分类D', '23,24,25', 4),(116, 19, '三级分类E', '23,24,25', 5),(117, 19, '三级分类F', '23,24,25', 6),(118, 19, '三级分类G', '23,24,25', 7),(119, 20, '三级分类A', '23,24,25', 1),(120, 20, '三级分类B', '23,24,25', 2),(121, 20, '三级分类C', '23,24,25', 3),(122, 20, '三级分类D', '23,24,25', 4),(123, 20, '三级分类E', '23,24,25', 5),(124, 20, '三级分类F', '23,24,25', 6),(125, 20, '三级分类G', '23,24,25', 7),(126, 21, '三级分类A', '23,24,25', 1),(127, 21, '三级分类B', '23,24,25', 2),(128, 21, '三级分类C', '23,24,25', 3),(129, 21, '三级分类D', '23,24,25', 4),(130, 21, '三级分类E', '23,24,25', 5),(131, 21, '三级分类F', '23,24,25', 6),(132, 21, '三级分类G', '23,24,25', 7),(133, 22, '三级分类A', '23,24,25', 1),(134, 22, '三级分类B', '23,24,25', 2),(135, 22, '三级分类C', '23,24,25', 3),(136, 22, '三级分类D', '23,24,25', 4),(137, 22, '三级分类E', '23,24,25', 5),(138, 22, '三级分类F', '23,24,25', 6),(139, 22, '三级分类G', '23,24,25', 7),(140, 23, '三级分类A', '23,24,25', 1),(141, 23, '三级分类B', '23,24,25', 2),(142, 23, '三级分类C', '23,24,25', 3),(143, 23, '三级分类D', '23,24,25', 4),(144, 23, '三级分类E', '23,24,25', 5),(145, 23, '三级分类F', '23,24,25', 6),(146, 23, '三级分类G', '23,24,25', 7),(147, 24, '三级分类A', '23,24,25', 1),(148, 24, '三级分类B', '23,24,25', 2),(149, 24, '三级分类C', '23,24,25', 3),(150, 24, '三级分类D', '23,24,25', 4),(151, 24, '三级分类E', '23,24,25', 5),(152, 24, '三级分类F', '23,24,25', 6),(153, 24, '三级分类G', '23,24,25', 7),(154, 25, '三级分类A', '23,24,25', 1),(155, 25, '三级分类B', '23,24,25', 2),(156, 25, '三级分类C', '23,24,25', 3),(157, 25, '三级分类D', '23,24,25', 4),(158, 25, '三级分类E', '23,24,25', 5),(159, 25, '三级分类F', '23,24,25', 6),(160, 25, '三级分类G', '23,24,25', 7),(161, 0, '测试分类', '23,24,25', 8),(162, 0, '测试分类', '23,24,25', 9);
-- 筛选分类 只有2级分类
DROP TABLE IF EXISTS `ds_filter`;
CREATE TABLE `ds_filter`(
	`id` 		int(11) 			AUTO_INCREMENT PRIMARY KEY, -- 分类ID
	`pid` 		int(11)				,							-- 父分类ID
	`name` 		varchar(50) 		,							-- 类型名称
	`sort` 			tinyint(4)		,							-- 排序	
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
INSERT INTO `ds_filter` (`id`, `pid`, `name`, `sort`) VALUES (1, 0, '册别', 1),(2, 0, '类型', 2),(3, 0, '版本', 3),(4, 1, '一年级上册', 1),(5, 1, '一年级下册', 2),(6, 1, '二年级上册', 3),(7, 1, '二年级下册', 4),(8, 1, '三年级上册', 5),(9, 1, '三年级下册', 6),(10, 1, '四年级上册', 7),(11, 1, '四年级下册', 8),(12, 2, '随堂练习', 1),(13, 2, '课后作业', 2),(14, 2, '单元测验', 3),(15, 2, '月考试卷', 4),(16, 2, '期中测验', 5),(17, 2, '期末试卷', 6),(18, 2, '毕业水平测试', 7),(19, 2, '竞赛试卷', 8),(20, 3, '人教版', 1),(21, 3, '鲁教版', 2),(22, 3, '苏教版', 3),(23, 0, '类别A', 4),(24, 0, '类别B', 5),(25, 0, '类别C', 6),(26, 23, '筛选条件A', 1),(27, 23, '筛选条件B', 2),(28, 23, '筛选条件C', 3),(29, 23, '筛选条件D', 4),(30, 23, '筛选条件E', 5),(31, 23, '筛选条件F', 6),(32, 23, '筛选条件G', 7),(33, 23, '筛选条件H', 8),(34, 24, '测一测A', 1),(35, 24, '测一测A', 2),(36, 24, '测一测B', 3),(37, 24, '测一测C', 4),(38, 24, '测一测D', 5),(39, 24, '测一测E', 6),(40, 24, '测一测F', 7),(41, 24, '测一测G', 8),(42, 25, '测试A', 1),(43, 25, '测试B', 2),(44, 25, '测试C', 3);

-- 文档表
DROP TABLE IF EXISTS `ds_doc`;
CREATE TABLE `ds_doc`(
	`docid` 		int(11) 		AUTO_INCREMENT PRIMARY KEY,	-- 文档ID
	`userid` 		int(11)		 	,							-- 文档上传用户ID
	`title` 		varchar(100) 	,							-- 文档标题
	`typeid` 		int(11)			,							-- 文档类型ID
	`filter` 		varchar(50)		,							-- 筛选,例如：1_2_3,搜索可用1_%_3
	`keyword` 		varchar(100) 	,							-- 文档关键字
	`word` 			text			,							-- 文档简介
	`preview`		int(11)			DEFAULT '0',				-- 预览几页，阅读金币为0：免费， 3：就是预览3页，其他需要付费阅读
	`readpay`		float			DEFAULT '0',				-- 阅读金币，如果为0，则免费阅读
	`downpay`		float			DEFAULT '0',				-- 下载金币
	`readcount` 	int(11)			DEFAULT '0',				-- 阅读次数，每次阅读都加1
	`downcount` 	int(11) 		DEFAULT '0',				-- 下载次数，每次下载都加1
	`pcount`		int(11)			DEFAULT '0',				-- 总页数
	`path` 			varchar(250) 	,							-- 文档存储路径
	`size` 			int(11)			,							-- 文档大小	
	`exten` 		varchar(5)		,							-- 文档扩展名，统一为 doc，ppt，xls，pdf，txt，zip
	`note` 			varchar(250) 	,							-- 审核失败原因/推荐原因/VIP原因/下架原因
	`md5` 			varchar(50) 	,							-- 用于判断是否重复
	`isimp` 		tinyint(4) 		DEFAULT '0',				-- 1：推荐文档
	`isvip` 		tinyint(4) 		DEFAULT '0',				-- 1：VIP文档
	`isdel` 		tinyint(4) 		DEFAULT '0',				-- 1：下架文档	
	`draftid`		int(11)			DEFAULT '0',				-- 关联的悬赏稿件ID
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态，-2:不完整 -1：审核失败, 0：待审核，1：已审核
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
ALTER TABLE `ds_doc` ADD FULLTEXT INDEX fulltext_doc(`title`, `word`);

CREATE OR REPLACE VIEW `ds_doc_view` AS 
SELECT `ds_doc`.*,`ds_type`.`typename`,`ds_user`.`nickname`,(`ds_user`.`vipdate` > now()) as vipuser
FROM `ds_doc` 
LEFT JOIN `ds_type` 
ON `ds_doc`.`typeid` = `ds_type`.`typeid` 
LEFT JOIN `ds_user` 
ON `ds_doc`.`userid` = `ds_user`.`userid`;

-- 悬赏投稿表
DROP TABLE IF EXISTS `ds_draft`;
CREATE TABLE `ds_draft`(
	`draftid` 		int(11) 		AUTO_INCREMENT PRIMARY KEY,	-- 投稿ID
	`userid` 		int(11)		 	,							-- 投稿人ID
	`desc` 			text	 		,							-- 说明
	`reid`	 		int(11)		 	,							-- 关联的悬赏任务ID
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态，-2 碎片 0：待用户审稿，1：已中标
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;

-- 悬赏任务表
DROP TABLE IF EXISTS `ds_reward`;
CREATE TABLE `ds_reward`(
	`reid`			int(11) 		AUTO_INCREMENT PRIMARY KEY,	-- 悬赏任务ID
	`userid` 		int(11)		 	,							-- 悬赏人ID
	`title` 		varchar(50) 	,							-- 文档标题
	`keyword` 		varchar(50) 	,							-- 文档关键字
	`word` 			text			,							-- 文档简介
	`price`			float			DEFAULT '0',				-- 悬赏价格
	`todate`		datetime		,							-- 截至日期
	`pubdate`		datetime		,							-- 发布日期
	`istop`			int(11)			,							-- 是否置顶 0：否，1：是
	`topprice`		float			,							-- 置顶服务费（全部）
	`readnum`		int(11)			DEFAULT '0',				-- 预览人数
	`note` 			varchar(250) 	,							-- 审核失败原因	
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态，-1：审核失败， 0：未审核， 1：未定稿(显示截至时间)， 2：已定稿， 3：定稿失败
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
 -- 1：未定稿  < now() 显示截至时间,其他显示已截至  2：已定稿  3：显示任务失败
 -- days 悬赏天数
 -- istoping 置顶中
CREATE OR REPLACE VIEW `ds_reward_num_view` AS
SELECT `reid`,count(`reid`) as `draftnum` 
FROM `ds_draft` 
WHERE `state`>=0
GROUP BY `reid`;
CREATE OR REPLACE VIEW `ds_reward_view` AS 
SELECT `ds_reward`.*,TIMESTAMPDIFF(day,ds_reward.pubdate,ds_reward.todate) as days, istop And (todate > now()) as istoping, `ds_user`.`nickname`,(`ds_user`.`vipdate` > now()) as vipuser,ifnull(`ds_reward_num_view`.`draftnum`,0) as `draftnum`
FROM `ds_reward`  
LEFT JOIN `ds_user` 
ON `ds_reward`.`userid` = `ds_user`.`userid`
LEFT JOIN `ds_reward_num_view`
ON `ds_reward`.`reid` = `ds_reward_num_view`.`reid`;

-- 稿件
CREATE OR REPLACE VIEW `ds_draft_view` AS 
SELECT `ds_draft`.*,`ds_reward`.`title`,`ds_reward`.`price`,`ds_user`.`nickname`,(`ds_user`.`vipdate` > now()) as vipuser  
FROM `ds_draft`
LEFT JOIN `ds_reward` 
ON `ds_draft`.`reid` = `ds_reward`.`reid`
LEFT JOIN `ds_user` 
ON `ds_draft`.`userid` = `ds_user`.`userid`;

-- 文集分类
DROP TABLE IF EXISTS `ds_topic_type`;
CREATE TABLE `ds_topic_type`(
	`typeid` 		int(11) 		AUTO_INCREMENT PRIMARY KEY, -- 分类ID
	`typename` 		varchar(50) 	,							-- 类型名称
	`seotitle` 		varchar(100) 	,							-- 类型名称
	`sort` 			tinyint(4)		,							-- 排序
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
INSERT INTO `ds_topic_type` (`typeid`, `typename`, `seotitle`, `sort`, `state`) VALUES (1, '教育资料', '教育资料', 1, 1);
INSERT INTO `ds_topic_type` (`typeid`, `typename`, `seotitle`, `sort`, `state`) VALUES (2, '建筑资料', '建筑资料', 2, 1);
INSERT INTO `ds_topic_type` (`typeid`, `typename`, `seotitle`, `sort`, `state`) VALUES (3, '专业资料', '专业资料', 3, 1);
INSERT INTO `ds_topic_type` (`typeid`, `typename`, `seotitle`, `sort`, `state`) VALUES (4, '实用文档', '实用文档', 4, 1);
INSERT INTO `ds_topic_type` (`typeid`, `typename`, `seotitle`, `sort`, `state`) VALUES (5, '等级考试', '等级考试', 5, 1);
INSERT INTO `ds_topic_type` (`typeid`, `typename`, `seotitle`, `sort`, `state`) VALUES (6, '其他资料', '其他资料', 6, 1);
 
-- 文集表
DROP TABLE IF EXISTS `ds_topic`;
CREATE TABLE `ds_topic`(
	`topicid` 		int(11) 		AUTO_INCREMENT PRIMARY KEY,	-- 文集ID
	`userid` 		int(11)		 	,							-- 文集创建用户ID
	`title` 		varchar(50) 	,							-- 文集标题
	`word` 			text			,							-- 文档简介
	`keyword` 		varchar(50) 	,							-- 文档关键字 标签
	`typeid` 		int(11)			,							-- 文集类型ID
	`cover` 		varchar(250) 	,							-- 缩略图路径
	`downpay`		float			DEFAULT '0',				-- 打包价，不设置，根据折扣算，折扣也不设置等于总价格
	`discount`		float			DEFAULT '0',				-- 折扣
	`totalpay`		float			DEFAULT '0',				-- 总价格，创建和编辑时自动计算。为了性能，文档价格变化了，这里不变，除非重新编辑。		
	`docnum` 		int(11)			DEFAULT '0',				-- 文档数量
	`size` 			int(11)			DEFAULT '0',				-- 压缩后大小
	`docs` 			varchar(500)	,							-- 文档列表
	`readcount` 	int(11)			DEFAULT '0',				-- 阅读次数，每次阅读都加1	
	`downcount` 	int(11)			DEFAULT '0',				-- 打包下载次数	
	`note` 			varchar(250) 	,							-- 审核失败原因/推荐原因/VIP原因/下架原因
	`isimp` 		tinyint(4) 		DEFAULT '0',				-- 1：推荐文集
	`isvip` 		tinyint(4) 		DEFAULT '0',				-- 1：VIP文档
	`isdel` 		tinyint(4) 		DEFAULT '0',				-- 1：下架文集	
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态，-1：审核失败, 0：待审核，1：已审核
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
CREATE OR REPLACE VIEW `ds_topic_view` AS 
SELECT `ds_topic`.*,`ds_topic_type`.`typename`,`ds_user`.`nickname`,(`ds_user`.`vipdate` > now()) as vipuser
FROM `ds_topic` 
LEFT JOIN `ds_topic_type` 
ON `ds_topic`.`typeid` = `ds_topic_type`.`typeid` 
LEFT JOIN `ds_user` 
ON `ds_topic`.`userid` = `ds_user`.`userid`;

-- 文集评论表
DROP TABLE IF EXISTS `ds_topic_comment`;
CREATE TABLE `ds_topic_comment`(
	`commentid` 	int(11) 		AUTO_INCREMENT PRIMARY KEY, -- 评论ID
	`topicid` 		int(11)			,							-- 文章ID
	`userid` 		int(11) 		,							-- 用户ID
	`comment` 		text		 	,							-- 评论
	`pcommentid` 	int(11) 		, 							-- 父ID,用于回复评论
	`note` 			varchar(250) 	,							-- 操作日志
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态, 0:待审核 1：线上
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
CREATE OR REPLACE VIEW `ds_topic_comment_view` AS 
SELECT `ds_topic_comment`.*,`ds_topic`.`title`,`ds_user`.`nickname`,(`ds_user`.`vipdate` > now()) as vipuser
FROM `ds_topic_comment`
LEFT JOIN `ds_topic` 
ON `ds_topic_comment`.`topicid` = `ds_topic`.`topicid`
LEFT JOIN `ds_user` 
ON `ds_topic_comment`.`userid` = `ds_user`.`userid`;

-- 文章分类
DROP TABLE IF EXISTS `ds_article_tag`;
CREATE TABLE `ds_article_tag`(
	`tagid` 		int(11) 		AUTO_INCREMENT PRIMARY KEY, -- 分类ID
	`tagname` 		varchar(50) 	,							-- 分类名称
	`seotitle` 		varchar(100) 	,							-- seotitle
	`sort` 			tinyint(4)		,							-- 排序
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态 0 不启用 1 启动
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
INSERT INTO `ds_article_tag` (`tagid`, `tagname`, `seotitle`, `sort`, `state`) VALUES (1, '新闻', '新闻', 1, 1);
INSERT INTO `ds_article_tag` (`tagid`, `tagname`, `seotitle`, `sort`, `state`) VALUES (2, '体育', '新闻', 2, 1);
INSERT INTO `ds_article_tag` (`tagid`, `tagname`, `seotitle`, `sort`, `state`) VALUES (3, '科技', '新闻', 3, 1);
INSERT INTO `ds_article_tag` (`tagid`, `tagname`, `seotitle`, `sort`, `state`) VALUES (4, '金融', '新闻', 4, 1);
-- 文章
DROP TABLE IF EXISTS `ds_article`;
CREATE TABLE `ds_article`(
	`articleid` 	int(11) 		AUTO_INCREMENT PRIMARY KEY,	-- 文章ID
	`userid` 		int(11)		 	,							-- 用户ID
	`tagid` 		int(11)			DEFAULT '0',				-- 标签ID,(默认值，解决编辑或添加没有tag的文章时的异常)
	`title` 		varchar(50) 	,							-- 标题	
	`word` 			LONGTEXT		,							-- 内容
	`readnum` 		int(11)			DEFAULT '0',				-- 阅读次数，每次阅读都加1
	`note` 			varchar(250) 	,							-- 操作日志
	`istop` 		tinyint(4) 		DEFAULT '0',				-- 1：置顶文章
	`commemtdate` 	datetime 		,							-- 最后回复时间
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态, -1：回收站, 0:待审核 1：线上
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
CREATE OR REPLACE VIEW `ds_article_view` AS 
SELECT `ds_article`.*,`ds_article_tag`.`tagname`,`ds_user`.`nickname`,(`ds_user`.`vipdate` > now()) as vipuser
FROM `ds_article` 
LEFT JOIN `ds_article_tag` 
ON `ds_article`.`tagid` = `ds_article_tag`.`tagid` 
LEFT JOIN `ds_user` 
ON `ds_article`.`userid` = `ds_user`.`userid`;

-- 文章评论表
DROP TABLE IF EXISTS `ds_article_comment`;
CREATE TABLE `ds_article_comment`(
	`commentid` 	int(11) 		AUTO_INCREMENT PRIMARY KEY, -- 评论ID
	`articleid` 	int(11)			,							-- 文章ID
	`userid` 		int(11) 		,							-- 用户ID
	`comment` 		text		 	,							-- 评论
	`pcommentid` 	int(11) 		, 							-- 父ID,用于回复评论
	`note` 			varchar(250) 	,							-- 操作日志
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态, 0:待审核 1：线上
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
CREATE OR REPLACE VIEW `ds_article_comment_view` AS 
SELECT `ds_article_comment`.*,`ds_article`.`title`,`ds_user`.`nickname`,(`ds_user`.`vipdate` > now()) as vipuser
FROM `ds_article_comment`
LEFT JOIN `ds_article` 
ON `ds_article_comment`.`articleid` = `ds_article`.`articleid`
LEFT JOIN `ds_user` 
ON `ds_article_comment`.`userid` = `ds_user`.`userid`;

-- 问答标签 就是分类
DROP TABLE IF EXISTS `ds_ask_tag`;
CREATE TABLE `ds_ask_tag`(
	`tagid` 		int(11) 		AUTO_INCREMENT PRIMARY KEY, -- 分类ID
	`tagname` 		varchar(50) 	,							-- 分类名称
	`seotitle` 		varchar(100) 	,							-- 分类名称
	`sort` 			tinyint(4)		,							-- 排序
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态 0 不启用 1 启动
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
INSERT INTO `ds_ask_tag` (`tagid`, `tagname`, `seotitle`, `sort`, `state`) VALUES (1, '官方', '官方', 1, 1);
INSERT INTO `ds_ask_tag` (`tagid`, `tagname`, `seotitle`, `sort`, `state`) VALUES (2, '建议', '建议', 2, 1);
INSERT INTO `ds_ask_tag` (`tagid`, `tagname`, `seotitle`, `sort`, `state`) VALUES (3, '教程', '教程', 3, 1);
INSERT INTO `ds_ask_tag` (`tagid`, `tagname`, `seotitle`, `sort`, `state`) VALUES (4, '求助', '求助', 4, 1);

-- 问答
DROP TABLE IF EXISTS `ds_ask`;
CREATE TABLE `ds_ask`(
	`askid` 		int(11) 		AUTO_INCREMENT PRIMARY KEY,	-- 文档ID
	`userid` 		int(11)		 	,							-- 用户ID
	`tagid` 		int(11)			DEFAULT '0',				-- 分类ID,(默认值，解决编辑或添加没有tag的问题时的异常)
	`title` 		varchar(50) 	,							-- 问题	
	`word` 			text			,							-- 内容
	`readnum` 		int(11)			DEFAULT '0',				-- 阅读次数，每次阅读都加1
	`note` 			varchar(250) 	,							-- 操作日志
	`istop` 		tinyint(4) 		DEFAULT '0',				-- 1：置顶回答
	`commemtdate` 	datetime 		,							-- 最后回答时间
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态, -1：回收站, 0:待审核 1：线上
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
CREATE OR REPLACE VIEW `ds_ask_view` AS 
SELECT `ds_ask`.*,`ds_ask_tag`.`tagname`,`ds_user`.`nickname`,(`ds_user`.`vipdate` > now()) as vipuser
FROM `ds_ask` 
LEFT JOIN `ds_ask_tag` 
ON `ds_ask`.`tagid` = `ds_ask_tag`.`tagid` 
LEFT JOIN `ds_user` 
ON `ds_ask`.`userid` = `ds_user`.`userid`;

-- 问答评论表
DROP TABLE IF EXISTS `ds_ask_comment`;
CREATE TABLE `ds_ask_comment`(
	`commentid` 	int(11) 		AUTO_INCREMENT PRIMARY KEY, -- 评论ID
	`askid` 		int(11)			,							-- 问题ID
	`userid` 		int(11) 		,							-- 用户ID
	`comment` 		text		 	,							-- 评论
	`pcommentid` 	int(11) 		, 							-- 父ID,用于回答评论
	`note` 			varchar(250) 	,							-- 操作日志
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态, 0:待审核 1：线上
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
CREATE OR REPLACE VIEW `ds_ask_comment_view` AS 
SELECT `ds_ask_comment`.*,`ds_ask`.`title`,`ds_user`.`nickname`,(`ds_user`.`vipdate` > now()) as vipuser
FROM `ds_ask_comment`
LEFT JOIN `ds_ask` 
ON `ds_ask_comment`.`askid` = `ds_ask`.`askid`
LEFT JOIN `ds_user` 
ON `ds_ask_comment`.`userid` = `ds_user`.`userid`;

-- 支付设置表
DROP TABLE IF EXISTS `ds_payset`;
CREATE TABLE `ds_payset`(
	`alipay` 		int(11)			,							-- 支付宝支付
	`weipay` 		int(11)			,							-- 微信支付	
	`palipay` 		int(11)			,							-- 个人支付宝支付
	`pweipay` 		int(11)			,							-- 个人微信支付
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `ds_payset` (`alipay`,`weipay`,`palipay`,`pweipay`) VALUES(1,1,0,0);

-- 支付宝账号表
DROP TABLE IF EXISTS `ds_alipayset`;
CREATE TABLE `ds_alipayset`(
	`app_id` 		varchar(50)		,							-- 支付宝账号
	`private_key`	varchar(2048)	,							-- 合作者身份
	`public_key`	varchar(2048)	,							-- 交易安全校验码
	`sign_type`		varchar(10)		,							-- 支付宝账号
	`isewm`			tinyint(4)		,							-- 二维码扫码付款方式
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态0：关闭 1 开通 
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `ds_alipayset` (`app_id`,`private_key`,`public_key`,`sign_type`,`isewm`) VALUES('','','','RSA2',1);

-- 微信支付账号表
DROP TABLE IF EXISTS `ds_weipayset`;
CREATE TABLE `ds_weipayset`(
	`APPID` 		varchar(50)		,							-- APPID
	`MCHID`			varchar(50)		,							-- 商户号MCHID
	`KEY`			varchar(50)		,							-- 商户支付密钥KEY 
	`APPSECRET`		varchar(50)		,							-- 公众帐号APPSECRET 		
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态0：关闭 1 开通
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `ds_weipayset` (`APPID`,`MCHID`,`KEY`,`APPSECRET`) VALUES('','','','');

-- 聚合账号表
DROP TABLE IF EXISTS `ds_perpayset`;
CREATE TABLE `ds_perpayset`(
	`appkey` 		varchar(50)		,							-- 密钥
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `ds_perpayset` (`appkey`) VALUES('');

-- 注册设置
DROP TABLE IF EXISTS `ds_regset`;
CREATE TABLE `ds_regset`(
	`email` 		int(11)			,							-- 邮箱注册
	`phone` 		int(11)			,							-- 手机注册
	`invite` 		tinyint(1)		,							-- 邀请码 0：关闭，1:必填
	`groupid` 		int(11)			,							-- 注册成功后默认的用户组
	`vgroupid` 		int(11)			DEFAULT '0',				-- 注册成功后默认的用户组
	`vgroupdays`	int(11)			DEFAULT '0',				-- 注册成功后默认的VIP用户组
	`pwd_length` 	int(4) 			,							-- 密码长度
	`pwd_num` 		tinyint(1)		,							-- 密码是否保护数字：0：可以不包含，1：必须包含
	`pwd_lower` 	tinyint(1)		,							-- 密码是否保护小写字母：0：可以不包含，1：必须包含
	`pwd_upper` 	tinyint(1)		,							-- 密码是否保护大写字母：0：可以不包含，1：必须包含
	`invite_title` 	varchar(50)		,							-- 验证码发送的主题 
	`invite_body` 	text			,							-- 验证码内容
	`message` 		varchar(500)	,							-- 验证码内容
	`insertdate` 	timestamp	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)		DEFAULT '0'					-- 状态
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `ds_regset` (`email`, `phone`, `invite`, `groupid`, `pwd_length`, `pwd_num`, `pwd_lower`, `pwd_upper`, `invite_title`, `invite_body`, `message`) VALUES(1,1,1,3,6,1,1,1,'{sitename}的验证码','感谢您注册{sitename}，您的验证码是：{code}<br>如有问题可联系：{adminemail}','【{sitename}】您的验证码为：{code} ，您正在进行{sitename}用户的注册，请勿泄露您的验证码。');

-- 登录设置表
DROP TABLE IF EXISTS `ds_loginset`;
CREATE TABLE `ds_loginset`(
	`email` 		tinyint(4)			,						-- 邮箱登录
	`phone` 		tinyint(4)			,						-- 手机登录
	`app` 			tinyint(4) 			, 						-- APP扫码登录
	`dz` 			tinyint(4) 			, 						-- discuz
	`ali` 			tinyint(4)			,						-- 支付宝登录
	`wei` 			tinyint(4)			,						-- 微信开发平台登录
	`gzh` 			tinyint(4)			,						-- 微信公众号	
	`qq` 			tinyint(4)			,						-- QQ登录
	`weibo` 		tinyint(4)			,						-- 微博登录
	`renren` 		tinyint(4)			,						-- 人人登录	
	`other` 		tinyint(4)			,						-- 其他登录	
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `ds_loginset` (`email`, `phone`, `app`, `dz`, `ali`, `wei`, `gzh`, `qq`, `weibo`, `renren`, `other`) VALUES(1,0,0,0,0,0,0,0,0,0,0);

-- discuz登录账号表
DROP TABLE IF EXISTS `ds_dzloginset`;
CREATE TABLE `ds_dzloginset`(
	`suffix` 		varchar(50)		,							-- 用户名后缀，防止问答用户名和文库用户名重复
	`config` 		text			,							-- 应用的 UCenter 配置信息
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态0：关闭 1 开通
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `ds_dzloginset` (`suffix`,`config`) VALUES('@docswf.com','');

-- QQ登录账号表
DROP TABLE IF EXISTS `ds_qqloginset`;
CREATE TABLE `ds_qqloginset`(
	`appid` 		varchar(50)		,							-- appid
	`appkey`		varchar(50)		,							-- appkey
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态0：关闭 1 开通
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `ds_qqloginset` (`appid`,`appkey`) VALUES('','');

-- 微信登录账号表
-- 公众号号登录账号表
DROP TABLE IF EXISTS `ds_weiloginset`;
CREATE TABLE `ds_weiloginset`(
	`AppID` 		varchar(50)		,							-- 开发者ID pc
	`AppSecret`		varchar(50)		,							-- 开发者密码 pc
	`AppID_app` 	varchar(50)		,							-- 开发者ID app
	`AppSecret_app`	varchar(50)		,							-- 开发者密码 app
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态0：关闭 1 开通
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `ds_weiloginset` (`AppID`,`AppSecret`,`AppID_app`,`AppSecret_app`) VALUES('','','','');

-- 公众号号登录账号表
DROP TABLE IF EXISTS `ds_gzhloginset`;
CREATE TABLE `ds_gzhloginset`(
	`AppID` 		varchar(50)		,							-- 开发者ID
	`AppSecret`		varchar(50)		,							-- 开发者密码
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态0：关闭 1 开通
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `ds_gzhloginset` (`AppID`,`AppSecret`) VALUES('','');

-- 支付宝登录账号表
DROP TABLE IF EXISTS `ds_aliloginset`;
CREATE TABLE `ds_aliloginset`(
	`app_id` 		varchar(50)		,							-- 支付宝账号
	`private_key`	varchar(2048)	,							-- 合作者身份
	`public_key`	varchar(2048)	,							-- 交易安全校验码
	`sign_type`		varchar(10)		,							-- 支付宝账号 	
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态0：关闭 1 开通 
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `ds_aliloginset` (`app_id`,`private_key`,`public_key`,`sign_type`) VALUES('','','','RSA2');

-- 微博登录账号表
DROP TABLE IF EXISTS `ds_weibologinset`;
CREATE TABLE `ds_weibologinset`(
	`appid` 		varchar(50)		,							-- appid
	`appkey`		varchar(50)		,							-- appkey
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态0：关闭 1 开通
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `ds_weibologinset` (`appid`,`appkey`) VALUES('','');

-- 人人登录账号表
DROP TABLE IF EXISTS `ds_renrenloginset`;
CREATE TABLE `ds_renrenloginset`(
	`appid` 		varchar(50)		,							-- appid
	`appkey`		varchar(50)		,							-- appkey
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态0：关闭 1 开通
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `ds_renrenloginset` (`appid`,`appkey`) VALUES('','');

-- 其他登录账号表
DROP TABLE IF EXISTS `ds_otherloginset`;
CREATE TABLE `ds_otherloginset`(
	`appid` 		varchar(50)		,							-- appid
	`appkey`		varchar(50)		,							-- appkey
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态0：关闭 1 开通
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `ds_otherloginset` (`appid`,`appkey`) VALUES('','');

-- 金币购买订单表
DROP TABLE IF EXISTS `ds_glodorder`;
CREATE TABLE `ds_glodorder`(
	`orderid` 		varchar(50) 	PRIMARY KEY,				-- 订单ID
	`title` 		varchar(50)		,							-- 标题	
	`userid` 		int(11)			,							-- 用户ID
	`cash`			varchar(10)		,							-- 充值现金
	`from` 			varchar(50)		,							-- 来源 充值渠道：1：支付宝 2：微信 3：其他
	`glods`			float			,							-- 充值了多少虚拟金币
	`tradeno` 		varchar(50)		,							-- 微信/支付宝订单ID	
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 充值状态，0：提交订单，未付款，1：已付款 2：完成
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
CREATE OR REPLACE VIEW `ds_glodorder_view` AS 
SELECT `ds_glodorder`.*,`ds_user`.`username` 
FROM `ds_glodorder` 
LEFT JOIN `ds_user` 
ON `ds_glodorder`.`userid` = `ds_user`.`userid`;

-- VIP购买订单表
DROP TABLE IF EXISTS `ds_viporder`;
CREATE TABLE `ds_viporder`(
	`orderid` 		varchar(50) 	PRIMARY KEY,				-- 订单ID
	`title` 		varchar(50)		,							-- 标题
	`userid` 		int(11)			,							-- 用户ID
	`cash` 			varchar(10)		,							-- 充值现金
	`from` 			varchar(50)		,							-- 来源 充值渠道：1：微信 2：支付宝 3：其他
	`vgroupid`		int(11)			,							-- 哪个VIP
	`tradeno` 		varchar(50)		,							-- 微信/支付宝订单ID		
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 充值状态，0：提交订单，未付款，1：已付款 2：完成
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
CREATE OR REPLACE VIEW `ds_viporder_view` AS 
SELECT `ds_viporder`.*,`ds_user`.`username`,`ds_vgroup`.`vipdays`
FROM `ds_viporder` 
LEFT JOIN `ds_user`
ON `ds_viporder`.`userid` = `ds_user`.`userid`
LEFT JOIN `ds_vgroup`
ON `ds_viporder`.`vgroupid` = `ds_vgroup`.`vgroupid`;

-- 文档扫码交易订单
DROP TABLE IF EXISTS `ds_downorder`;
CREATE TABLE `ds_downorder`(
	`orderid` 		varchar(50) 	PRIMARY KEY,				-- 订单ID
	`title` 		varchar(50)		,							-- 标题	
	`userid` 		int(11)			,							-- 用户userid，存sesionid
	`cash`			varchar(10)		,							-- 交易金额
	`from` 			varchar(50)		,							-- 来源 充值渠道：1：支付宝 2：微信 3：其他
	`docid`			int(11)			,							-- 哪个文档
	`tradeno` 		varchar(50)		,							-- 微信/支付宝订单ID
	`readdown` 		varchar(50)		,							-- readpay / downpay
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 充值状态，0：提交订单，未付款，1：已付款 2：完成
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
CREATE OR REPLACE VIEW `ds_downorder_view` AS 
SELECT `ds_downorder`.*,ifnull(`ds_user`.`username`,'游客') as `username`, `ds_doc`.`title` as `dtitle`
FROM `ds_downorder` 
LEFT JOIN `ds_user` 
ON `ds_downorder`.`userid` = `ds_user`.`userid`
LEFT JOIN `ds_doc` 
ON `ds_downorder`.`docid` = `ds_doc`.`docid`;

-- 专题扫码交易订单
DROP TABLE IF EXISTS `ds_topicorder`;
CREATE TABLE `ds_topicorder`(
	`orderid` 		varchar(50) 	PRIMARY KEY,				-- 订单ID
	`title` 		varchar(50)		,							-- 标题	
	`userid` 		int(11)			,							-- 用户userid，存sesionid
	`cash`			varchar(10)		,							-- 交易金额
	`from` 			varchar(50)		,							-- 来源 充值渠道：1：支付宝 2：微信 3：其他
	`topicid`		int(11)			,							-- 哪个专题
	`tradeno` 		varchar(50)		,							-- 微信/支付宝订单ID
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 充值状态，0：提交订单，未付款，1：已付款 2：完成
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
CREATE OR REPLACE VIEW `ds_topicorder_view` AS 
SELECT `ds_topicorder`.*,ifnull(`ds_user`.`username`,'游客') as `username`, `ds_topic`.`title` as `dtitle`
FROM `ds_topicorder` 
LEFT JOIN `ds_user` 
ON `ds_topicorder`.`userid` = `ds_user`.`userid`
LEFT JOIN `ds_topic` 
ON `ds_topicorder`.`topicid` = `ds_topic`.`topicid`;

-- 提现订单表
DROP TABLE IF EXISTS `ds_cashorder`;
CREATE TABLE `ds_cashorder`(
	`orderid` 		int(11) 		AUTO_INCREMENT PRIMARY KEY,	-- 订单ID
	`title` 		varchar(50)		,							-- 标题	
	`userid` 		int(11)			,							-- 用户ID
	`glods` 		int				,							-- 提现金币数量
	`cash` 			varchar(10)		,							-- 提现现金
	`from` 			varchar(50)		,							-- 来源 提现渠道：1：支付宝 2：银行 3：其他
	`account`		varchar(50)		,							-- 对方账号
	`tradeno` 		varchar(50)		,							-- 微信/支付宝订单 付款单号
	`tradecash` 	float			,							-- 微信/支付宝订单 付款金额		
	`tradedate` 	datetime		,							-- 微信/支付宝订单 付款日期
	`tradedesc` 	varchar(100)	,							-- 微信/支付宝订单 备注
	`tradestate` 	tinyint(4)	 	DEFAULT '0',				-- 微信/支付宝订单 付款状态 0：未打款 1：已打款  打款时扣金币
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 订单状态，0：待审核  1：审核通过  -1：审核未过  审核通过扣余额
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
CREATE OR REPLACE VIEW `ds_cashorder_view` AS 
SELECT `ds_cashorder`.*,`ds_user`.`username` 
FROM `ds_cashorder` 
LEFT JOIN `ds_user` 
ON `ds_cashorder`.`userid` = `ds_user`.`userid`;

-- 用户积分记录表
DROP TABLE IF EXISTS `ds_pointpot`;
CREATE TABLE `ds_pointpot`(
	`id` 			int(11) 		AUTO_INCREMENT PRIMARY KEY,	-- ID
	`type`			int(11) 		,							-- 类型来自points表：1.用户注册 2.每天登录 3.用户信息完善 4.审核通过  5.设为推荐 6.设为VIP 7.访问推广 8.注册推广	
	`userid` 		int(11) 		,							-- 用户ID
	`points` 		float			,							-- 积分变更数量
	`docid` 		int(11) 		,							-- 文档ID
	`ip` 			varchar(50)		,							-- 访问注册推广记录IP
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
CREATE OR REPLACE VIEW `ds_point_view` AS 
SELECT `ds_pointpot`.*,`ds_doc`.`title`,`ds_doc`.`pcount`,`ds_doc`.`exten`,`ds_user`.`nickname`
FROM `ds_pointpot` 
LEFT JOIN `ds_doc` 
ON `ds_pointpot`.`docid` = `ds_doc`.`docid`
LEFT JOIN `ds_user`
ON `ds_pointpot`.`userid` = `ds_user`.`userid`;

-- 用户金币记录表
DROP TABLE IF EXISTS `ds_glodpot`;
CREATE TABLE `ds_glodpot`(
	`id` 			int(11) 		AUTO_INCREMENT PRIMARY KEY,	-- ID
	`type` 			int(11) 		,							-- 类型：见下方
	`userid` 		int(11) 		,							-- 用户ID
	`glods` 		float			,							-- 金币变更数量
	`linkid` 		int(11) 		,							-- 文档ID/专题ID/稿件ID/充值时订单ID/被邀请人ID/提现
	`invite` 		varchar(50)		,							-- 邀请奖励设置
	`note` 			varchar(250) 	,							-- 审核失败原因/推荐原因/VIP原因/下架原因
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
CREATE OR REPLACE VIEW `ds_glod_view` AS 
SELECT `ds_glodpot`.*,`ds_user`.`nickname`
FROM `ds_glodpot` 
LEFT JOIN `ds_user`
ON `ds_glodpot`.`userid` = `ds_user`.`userid`;

CREATE OR REPLACE VIEW `ds_glod_doc_view` AS 
SELECT `ds_glodpot`.*,`ds_doc`.`title`,`ds_doc`.`pcount`,`ds_doc`.`exten`,`ds_user`.`nickname`
FROM `ds_glodpot` 
LEFT JOIN `ds_doc`
ON `ds_glodpot`.`linkid` = `ds_doc`.`docid`
LEFT JOIN `ds_user`
ON `ds_glodpot`.`userid` = `ds_user`.`userid`;

CREATE OR REPLACE VIEW `ds_glod_topic_view` AS 
SELECT `ds_glodpot`.*,`ds_topic`.`title`,`ds_user`.`nickname`
FROM `ds_glodpot` 
LEFT JOIN `ds_topic` 
ON `ds_glodpot`.`linkid` = `ds_topic`.`topicid`
LEFT JOIN `ds_user`
ON `ds_glodpot`.`userid` = `ds_user`.`userid`;

CREATE OR REPLACE VIEW `ds_glod_reward_view` AS 
SELECT `ds_glodpot`.*,`ds_reward`.`title`,`ds_user`.`nickname`
FROM `ds_glodpot` 
LEFT JOIN `ds_reward` 
ON `ds_glodpot`.`linkid` = `ds_reward`.`reid`
LEFT JOIN `ds_user`
ON `ds_glodpot`.`userid` = `ds_user`.`userid`;

CREATE OR REPLACE VIEW `ds_glod_invite_view` AS 
SELECT `ds_glodpot`.*,`ds_linkuser`.`nickname` as `linkname`,`ds_user`.`nickname`
FROM `ds_glodpot` 
LEFT JOIN `ds_user` as `ds_linkuser`
ON `ds_glodpot`.`linkid` = `ds_linkuser`.`userid`
LEFT JOIN `ds_user`
ON `ds_glodpot`.`userid` = `ds_user`.`userid`;

-- 下载记录表
DROP TABLE IF EXISTS `ds_downlog`;
CREATE TABLE `ds_downlog`(
	`logid` 		int(11) 		AUTO_INCREMENT PRIMARY KEY,	-- logID
	`userid` 		int(11) 		,							-- 用户ID
	`docid` 		int(11) 		,							-- 文档ID
	`count` 		int(11)			DEFAULT '1',				-- 这个用户下载这个文档的次数
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 首次下载时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
CREATE OR REPLACE VIEW `ds_downlog_view` AS 
SELECT `ds_downlog`.*,`ds_doc`.`title`,`ds_doc`.`pcount`,`ds_doc`.`exten`,`ds_user`.`nickname`
FROM `ds_downlog` 
LEFT JOIN `ds_doc` 
ON `ds_downlog`.`docid` = `ds_doc`.`docid`
LEFT JOIN `ds_user` 
ON `ds_doc`.`userid` = `ds_user`.`userid`;

-- 专题下载记录表
DROP TABLE IF EXISTS `ds_topic_downlog`;
CREATE TABLE `ds_topic_downlog`(
	`logid` 		int(11) 		AUTO_INCREMENT PRIMARY KEY,	-- logID
	`userid` 		int(11) 		,							-- 用户ID
	`topicid` 		int(11) 		,							-- 专题D
	`count` 		int(11)			DEFAULT '1',				-- 这个用户下载这个文档的次数
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 首次下载时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
CREATE OR REPLACE VIEW `ds_topic_downlog_view` AS 
SELECT `ds_topic_downlog`.*,`ds_topic`.`title`,`ds_topic`.`docnum`,`ds_topic`.`size`,`ds_user`.`nickname`
FROM `ds_topic_downlog` 
LEFT JOIN `ds_topic` 
ON `ds_topic_downlog`.`topicid` = `ds_topic`.`topicid`
LEFT JOIN `ds_user` 
ON `ds_topic`.`userid` = `ds_user`.`userid`;

-- 收藏记录表
DROP TABLE IF EXISTS `ds_favorite`;
CREATE TABLE `ds_favorite`(
	`favid` 		int(11) 		AUTO_INCREMENT PRIMARY KEY,	-- 收藏ID
	`userid` 		int(11) 		,							-- 用户ID
	`docid` 		int(11) 		,							-- 文档ID
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 首次收藏时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
CREATE OR REPLACE VIEW `ds_favorite_view` AS 
SELECT `ds_favorite`.*,`ds_doc`.`title`,`ds_doc`.`pcount`,`ds_doc`.`exten`,`ds_user`.`userid` `newid`,`ds_user`.`nickname`
FROM `ds_favorite` 
LEFT JOIN `ds_doc` 
ON `ds_favorite`.`docid` = `ds_doc`.`docid`
LEFT JOIN `ds_user` 
ON `ds_doc`.`userid` = `ds_user`.`userid`;

-- 悬赏收藏记录表
DROP TABLE IF EXISTS `ds_reward_favorite`;
CREATE TABLE `ds_reward_favorite`(
	`favid` 		int(11) 		AUTO_INCREMENT PRIMARY KEY,	-- 收藏ID
	`userid` 		int(11) 		,							-- 用户ID
	`reid` 			int(11) 		,							-- 选赏ID
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 首次收藏时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
CREATE OR REPLACE VIEW `ds_reward_favorite_view` AS 
SELECT `ds_reward_favorite`.*,`ds_reward`.`title`,`ds_reward`.`price`,`ds_reward`.`todate`,`ds_user`.`userid` `newid`,`ds_user`.`nickname`
FROM `ds_reward_favorite` 
LEFT JOIN `ds_reward` 
ON `ds_reward_favorite`.`reid` = `ds_reward`.`reid`
LEFT JOIN `ds_user` 
ON `ds_reward`.`userid` = `ds_user`.`userid`;

-- 专题收藏记录表
DROP TABLE IF EXISTS `ds_topic_favorite`;
CREATE TABLE `ds_topic_favorite`(
	`favid` 		int(11) 		AUTO_INCREMENT PRIMARY KEY,	-- 收藏ID
	`userid` 		int(11) 		,							-- 用户ID
	`topicid` 		int(11) 		,							-- 专题D
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 首次收藏时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
CREATE OR REPLACE VIEW `ds_topic_favorite_view` AS 
SELECT `ds_topic_favorite`.*,`ds_topic`.`title`,`ds_topic`.`docnum`,`ds_topic`.`size`,`ds_user`.`userid` `newid`,`ds_user`.`nickname`
FROM `ds_topic_favorite` 
LEFT JOIN `ds_topic` 
ON `ds_topic_favorite`.`topicid` = `ds_topic`.`topicid`
LEFT JOIN `ds_user` 
ON `ds_topic`.`userid` = `ds_user`.`userid`;

-- 评论表
DROP TABLE IF EXISTS `ds_comment`;
CREATE TABLE `ds_comment`(
	`commentid` 	int(11) 		AUTO_INCREMENT PRIMARY KEY, -- 评论ID
	`docid` 		int(11)			,							-- 文档ID
	`userid` 		int(11) 		,							-- 用户ID
	`comment` 		text		 	,							-- 评论
	`agree` 		int(11)		 	DEFAULT '0',				-- 同意数
	`note` 			varchar(250) 	,							-- 操作日志
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态 0:待审核，1：已审核
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
CREATE OR REPLACE VIEW `ds_comment_view` AS 
SELECT `ds_comment`.*,`ds_doc`.`title`,`ds_user`.`nickname`,(`ds_user`.`vipdate` > now()) as vipuser
FROM `ds_comment`
LEFT JOIN `ds_doc` 
ON `ds_comment`.`docid` = `ds_doc`.`docid`
LEFT JOIN `ds_user` 
ON `ds_comment`.`userid` = `ds_user`.`userid`;

-- 评论点赞记录表
DROP TABLE IF EXISTS `ds_comment_agree`;
CREATE TABLE `ds_comment_agree`(
	`cagreeid` 		int(11) 		AUTO_INCREMENT PRIMARY KEY, -- 评论点赞ID
	`commentid` 	int(11) 		, 							-- 评论ID
	`userid` 		int(11) 		,							-- 用户ID
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;

-- 举报表
DROP TABLE IF EXISTS `ds_report`;
CREATE TABLE `ds_report`(
	`reportid` 		int(11) 		AUTO_INCREMENT PRIMARY KEY, -- 举报ID
	`docid` 		int(11)			,							-- 文档ID
	`userid` 		int(11) 		,							-- 举报用户ID
	`report` 		text		 	,							-- 举报内容
	`extra` 		text		 	,							-- 附件内容
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
CREATE OR REPLACE VIEW `ds_report_view` AS 
SELECT `ds_report`.*,`ds_doc`.`title`,`ds_doc`.`exten`,`ds_doc`.`path`,`ds_user`.`nickname`
FROM `ds_report` 
LEFT JOIN `ds_doc` 
ON `ds_report`.`docid` = `ds_doc`.`docid`
LEFT JOIN `ds_user`
ON `ds_report`.`userid` = `ds_user`.`userid`;

-- 消息表 发送一条消息，会插入2条数据
DROP TABLE IF EXISTS `ds_message`;
CREATE TABLE `ds_message`(
	`id` 			int(11) 		AUTO_INCREMENT PRIMARY KEY, -- 消息ID
	`pid` 			int(11)		 	,							-- 消息条目ID
	`from` 			int(11)			,							-- 消息发送者ID
	`to` 			int(11) 		,							-- 消息接受者ID
	`message` 		text		 	,							-- 消息内容
	`whos` 			int(11)		 	,							-- 谁的消息表
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态: 0 关闭 1 开通 
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
CREATE OR REPLACE VIEW `ds_message_view` AS 
SELECT `ds_message`.*,`from`.`nickname` as fname,`to`.`nickname` as tname
FROM `ds_message` 
LEFT JOIN `ds_user` `from`
ON `ds_message`.`from` = `from`.`userid`
LEFT JOIN `ds_user` `to`
ON `ds_message`.`to` = `to`.`userid`;

-- seo 表
DROP TABLE IF EXISTS `ds_seo`;
CREATE TABLE `ds_seo`(
	`home`	 		varchar(50)		,							-- 首页url前缀
	`home_title` 	varchar(100)	,							-- 首页
	`home_keys`		varchar(200)	,							-- 首页
	`home_desc`		varchar(500)	,							-- 首页
	`list` 			varchar(50)	,								-- 列表url前缀
	`list_title` 	varchar(100)	,							-- 列表
	`list_keys`		varchar(200)	,							-- 列表
	`list_desc`		varchar(500)	,							-- 列表
	`search`	 	varchar(50)		,							-- 搜索url前缀
	`search_title` 	varchar(100)	,							-- 搜索
	`search_keys`	varchar(200)	,							-- 搜索
	`search_desc`	varchar(500)	,							-- 搜索
	`doc`	 		varchar(50)		,							-- 搜索url前缀
	`doc_title` 	varchar(100)	,							-- 文档
	`doc_keys`		varchar(200)	,							-- 文档
	`doc_desc`		varchar(500)	,							-- 文档
	`topl`	 		varchar(50)		,							-- 专题url前缀
	`topl_title` 	varchar(100)	,							-- 专题
	`topl_keys`		varchar(200)	,							-- 专题
	`topl_desc`		varchar(500)	,							-- 专题
	`topic`	 		varchar(50)		,							-- 专题url前缀
	`topic_title` 	varchar(100)	,							-- 专题
	`topic_key`		varchar(200)	,							-- 专题
	`topic_desc`	varchar(500)	,							-- 专题
	`rewl`	 		varchar(50)		,							-- 悬赏url前缀
	`rewl_title` 	varchar(100)	,							-- 悬赏
	`rewl_keys`		varchar(200)	,							-- 悬赏
	`rewl_desc`		varchar(500)	,							-- 悬赏
	`reward` 		varchar(50)		,							-- 悬赏url前缀
	`reward_title` 	varchar(100)	,							-- 悬赏
	`reward_keys`	varchar(200)	,							-- 悬赏
	`reward_desc`	varchar(500)	,							-- 悬赏
	`artl`	 		varchar(50)		,							-- 文章url前缀
	`artl_title` 	varchar(100)	,							-- 文章
	`artl_keys`		varchar(200)	,							-- 文章
	`artl_desc`		varchar(500)	,							-- 文章
	`article`	 	varchar(50)		,							-- 文章url前缀
	`article_title` varchar(100)	,							-- 文章
	`article_keys`	varchar(200)	,							-- 文章
	`article_desc`	varchar(500)	,							-- 文章
	`askl`	 		varchar(50)		,							-- 问答url前缀
	`askl_title` 	varchar(100)	,							-- 问答
	`askl_keys`		varchar(200)	,							-- 问答
	`askl_desc`		varchar(500)	,							-- 问答
	`ask`	 		varchar(50)		,							-- 问答url前缀
	`ask_title` 	varchar(100)	,							-- 问答
	`ask_keys`		varchar(200)	,							-- 问答
	`ask_desc`		varchar(500)	,							-- 问答
	`userl`	 		varchar(50)		,							-- 用户url前缀
	`userl_title`	varchar(100)	,							-- 用户
	`userl_keys`	varchar(200)	,							-- 用户
	`userl_desc`	varchar(500)	,							-- 用户
	`user`	 		varchar(50)		,							-- 用户url前缀
	`user_title`	varchar(100)	,							-- 用户
	`user_keys`		varchar(200)	,							-- 用户
	`user_desc`		varchar(500)	,							-- 用户
	`notice`	 	varchar(50)		,							-- noticeurl前缀
	`notice_title`	varchar(100)	,							-- about
	`notice_keys`	varchar(200)	,							-- about
	`notice_desc`	varchar(500)	,							-- about
	`about`	 		varchar(50)		,							-- abouturl前缀
	`about_title`	varchar(100)	,							-- about
	`about_keys`	varchar(200)	,							-- about
	`about_desc`	varchar(500)	,							-- about
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '1'					-- 状态 启用状态， 0:未启用，1:启用
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
INSERT INTO `ds_seo` (`home`, `home_title`, `home_keys`, `home_desc`, `list`, `list_title`, `list_keys`, `list_desc`, `search`, `search_title`, `search_keys`, `search_desc`, `doc`, `doc_title`, `doc_keys`, `doc_desc`, `topl`, `topl_title`, `topl_keys`, `topl_desc`, `topic`, `topic_title`, `topic_key`, `topic_desc`, `rewl`, `rewl_title`, `rewl_keys`, `rewl_desc`, `reward`, `reward_title`, `reward_keys`, `reward_desc`, `artl`, `artl_title`, `artl_keys`, `artl_desc`, `article`, `article_title`, `article_keys`, `article_desc`, `askl`, `askl_title`, `askl_keys`, `askl_desc`, `ask`, `ask_title`, `ask_keys`, `ask_desc`, `userl`, `userl_title`, `userl_keys`, `userl_desc`, `user`, `user_title`, `user_keys`, `user_desc`, `notice`, `notice_title`, `notice_keys`, `notice_desc`, `about`, `about_title`, `about_keys`, `about_desc`) VALUES ('', '{name}', '文库,文档,下载', '提供最全面的文库解决方案', 'list-', '{type} - {name}', '{type}', '分类为{type}的文档列表', 'search-', '{keys} - {type}格式 - {name}', '{keys},{type}', '关键字为{keys},类型为{type}的文档列表', 'doc-', '{title} - {type} - {name}', '{keys}', '{word}', 'topic/list-', '{type} - 专题 - {name}', '{type},专题', '专题为{type}的专题列表', 'topic/', '{title} - {type} - {name}', '{keys}', '{word}', 'reward/list-', '{state} - 悬赏 - {name}', '{state},悬赏', '状态为{state}的悬赏列表', 'reward/', '{title} - {state} - {name}', '{keys}-{state}', '{word}', 'article/list-', '{type} - 文章 - {name}', '{type},文章', '分类为{type}文章列表', 'article/', '{title} - {type} - {name}', '{title},{type}', '分类为{type}，标题为{title}的文章内容', 'ask/list-', '{type} - 问题 - {name}', '{type},问题', '分类为{type}问题列表', 'ask/', '{title} - {type} - {name}', '{title},{type}', '在分类{type}下,标题为{title}的回答内容', 'user/list-', '圈子 - {name}', '圈子', '用户圈子列表展示页', 'user/', '{title} - 用户 - {name}', '{title},用户', '用户{title}的文档展示页', 'notice/', '{title} - {time} - {name}', '{title},公告', '这是{time}时发布的标题为{title}的公告', 'about/', '{title} - {type} - {name}', '{title},{type}', '{title}-{type}');

-- sitemap 表
DROP TABLE IF EXISTS `ds_sitemap`;
CREATE TABLE `ds_sitemap`(
	`home` 			tinyint(4) 		,							-- 首页 1个
	`type` 			tinyint(4)	 	,							-- 分类 1个type + 多个list-id.html
	`doc` 			tinyint(4) 		,							-- Doc  多个doc
	`docid` 		int(4) 			,							-- Doc  开始ID
	`topic` 		tinyint(4) 		,							-- topic 1个 + 多个topic
	`topicid` 		int(4) 			,							-- topic 开始ID
	`reward` 		tinyint(4) 		,							-- reward 1个 + 多个reward
	`rewardid` 		int(4) 			,							-- reward  开始ID
	`article` 		tinyint(4) 		,							-- article 1个 + 多个article
	`articleid` 	int(4) 			,							-- article  开始ID
	`ask` 			tinyint(4) 		,							-- ask 1个 + 多个ask
	`askid` 		int(4) 			,							-- ask  开始ID
	`about` 		tinyint(4) 		,							-- 多个about
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '1'					-- 状态 启用状态， 0:未启用，1:启用
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
INSERT INTO `ds_sitemap` (`home`,`type`,`doc`,`docid`,`topic`,`topicid`,`reward`,`rewardid`,`article`,`articleid`,`ask`,`askid`,`about`) VALUES(1,1,1,0,1,0,1,0,1,0,1,0,1);


-- dockey
DROP TABLE IF EXISTS `ds_dockey`;
CREATE TABLE `ds_dockey`(
	`id` 			int(11) 		AUTO_INCREMENT PRIMARY KEY,	-- ID
	`key` 			varchar(50) 	,							-- 关键字
	`url` 			varchar(250) 	,							-- To关键字	
	`sort` 			tinyint(4)		,							-- 排序
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '1'					-- 状态 启用状态， 0:未启用，1:启用
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;


-- 自增ID
DROP TABLE IF EXISTS `ds_incid`;
CREATE TABLE `ds_incid`(
	`doc_sid`		int(11)			,							-- 文档开始ID
	`topic_sid`		int(11)			,							-- 专题开始ID
	`reward_sid`	int(11)			,							-- 悬赏开始ID
	`article_sid`	int(11)			,							-- 文章开始ID
	`ask_sid`		int(11)			,							-- 问答开始ID
	`user_sid`		int(11)			,							-- 用户开始ID
	`type_sid`		int(11)			,							-- 文档分类开始ID
	`filter_sid`	int(11)			,							-- 文档附加分类开始ID
	`toptype_sid`	int(11)			,							-- 专题分类开始ID
	`arttype_sid`	int(11)			,							-- 文章分类开始ID
	`asktype_sid`	int(11)			,							-- 问答分类开始ID	
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
INSERT INTO `ds_incid` (`doc_sid`,`topic_sid`,`reward_sid`,`article_sid`,`ask_sid`,`user_sid`,`type_sid`,`filter_sid`,`toptype_sid`,`arttype_sid`,`asktype_sid`) VALUES(1000000,1000000,1000000,1000000,1000000,100,100,1,1,1,1);

-- 禁止IP
DROP TABLE IF EXISTS `ds_forbidip`;
CREATE TABLE `ds_forbidip`(
	`id` 			int(11) 		AUTO_INCREMENT PRIMARY KEY,	-- ID
	`ip` 			varchar(50) 	,							-- IP
	`sort` 			tinyint(4)		,							-- 排序
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '1'					-- 状态 启用状态， 0:未启用，1:启用
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
ALTER TABLE `ds_forbidip` ADD INDEX( `ip`);

-- 管理员IP
DROP TABLE IF EXISTS `ds_adminip`;
CREATE TABLE `ds_adminip`(
	`id` 			int(11) 		AUTO_INCREMENT PRIMARY KEY,	-- ID
	`ip` 			varchar(50) 	,							-- IP
	`sort` 			tinyint(4)		,							-- 排序
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '1'					-- 状态 启用状态， 0:未启用，1:启用
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;

-- 升级记录表
DROP TABLE IF EXISTS `ds_update`;
CREATE TABLE `ds_update`(
	`updateid` 		int(11) 		AUTO_INCREMENT PRIMARY KEY,	-- 升级ID
	`from` 			varchar(50) 	,							-- 老版本
	`to` 			varchar(500)	,							-- 新版本
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;

-- 插件表 OSS
DROP TABLE IF EXISTS `ds_ossset`;
CREATE TABLE `ds_ossset`(
	`keyid` 		varchar(50)		,							-- Access Key ID
	`keysecret`		varchar(50)		,							-- Access Key Secret
	`bucket`		varchar(50)		,							-- Bucket
	`endpoint`		varchar(50)		,							-- EndPoint
	`delfile`		int(11)			DEFAULT '1',				-- 是否删除本地文件，1删除本地文件   1.2版本增加
	`fluxoss`		int(11)			DEFAULT '0',				-- 是否直接走oss流量 ，1:走oss流量   	 1.2版本增加
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态: 0 关闭 1 开通
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `ds_ossset` (`keyid`) VALUES('');

-- 插件表 share
DROP TABLE IF EXISTS `ds_shareset`;
CREATE TABLE `ds_shareset`(
	`src` 			text			,							-- SRC
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态: 0 关闭 1 开通
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `ds_shareset` (`src`,`state`) VALUES('<script>window._bd_share_config={"common":{"bdSnsKey":{},"bdText":"","bdMini":"2","bdMiniList":false,"bdPic":"","bdStyle":"0","bdSize":"16"},"slide":{"type":"slide","bdImg":"4","bdPos":"right","bdTop":"250"}};with(document)0[(getElementsByTagName(''head'')[0]||body).appendChild(createElement(''script'')).src=''http://bdimg.share.baidu.com/static/api/js/share.js?v=89860593.js?cdnversion=''+~(-new Date()/36e5)];</script>', 1);

-- 插件表 shang
DROP TABLE IF EXISTS `ds_shangset`;
CREATE TABLE `ds_shangset`(
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态: 0 关闭 1 开通
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `ds_shangset` (`state`) VALUES(1);

-- 插件表 fenci
DROP TABLE IF EXISTS `ds_fenciset`;
CREATE TABLE `ds_fenciset`(
	`id` 			int(11) 		AUTO_INCREMENT PRIMARY KEY,	-- ID
	`appkey` 		varchar(50)		,							-- KEY
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态: 0 关闭 1 开通
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `ds_fenciset` (`appkey`,`state`) VALUES('D1LJF5822AEDF772',1);

-- 插件表 fenci 分词数据
DROP TABLE IF EXISTS `ds_fencidata`;
CREATE TABLE `ds_fencidata`(
	`id` 			int(11) 		AUTO_INCREMENT PRIMARY KEY,	-- ID
	`word` 			varchar(50)		,							-- 专有分词
	`sort` 			tinyint(4)		,							-- 排序	
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `ds_fencidata` (`word`,`sort`) VALUES('月考',1);

-- 插件表 百度推送
DROP TABLE IF EXISTS `ds_bdpushset`;
CREATE TABLE `ds_bdpushset`(
	`token` 		varchar(50)		,							-- 主动推送token
	`src` 			text			,							-- 自动推送JS
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态: 0 关闭 1 开通
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `ds_bdpushset` (`token`,`src`) VALUES('','');

-- 插件表 sms
DROP TABLE IF EXISTS `ds_smsset`;
CREATE TABLE `ds_smsset`(
	`keyid` 		varchar(50)		,							-- Access Key ID
	`keysecret`		varchar(50)		,							-- Access Key Secret
	`signname1`		varchar(50)		,							-- 短信签名1 注册
	`template1`		varchar(50)		,							-- 短信模板1
	`signname2`		varchar(50)		,							-- 短信签名2 找密
	`template2`		varchar(50)		,							-- 短信模板2
	`testphone`		varchar(20)		,							-- 测试手机号
	`insertdate` 	timestamp 	 	DEFAULT CURRENT_TIMESTAMP,	-- 时间
	`state` 		tinyint(4)	 	DEFAULT '0'					-- 状态: 0 关闭 1 开通
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `ds_smsset` (`keyid`) VALUES('');
