<?php
defined('BASEPATH') or exit('No direct script access allowed');

/*
| -------------------------------------------------------------------------
| URI ROUTING
| -------------------------------------------------------------------------
| This file lets you re-map URI requests to specific controller functions.
|
| Typically there is a one-to-one relationship between a URL string
| and its corresponding controller class/method. The segments in a
| URL normally follow this pattern:
|
|    example.com/class/method/id/
|
| In some instances, however, you may want to remap this relationship
| so that a different class/function is called than the one
| corresponding to the URL.
|
| Please see the user guide for complete details:
|
|    https://codeigniter.com/user_guide/general/routing.html
|
| -------------------------------------------------------------------------
| RESERVED ROUTES
| -------------------------------------------------------------------------
|
| There are three reserved routes:
|
|    $route['default_controller'] = 'welcome';
|
| This route indicates which controller class should be loaded if the
| URI contains no data. In the above example, the "welcome" class
| would be loaded.
|
|    $route['404_override'] = 'errors/page_missing';
|
| This route will tell the Router which controller/method to use if those
| provided in the URL cannot be matched to a valid route.
|
|    $route['translate_uri_dashes'] = FALSE;
|
| This is not exactly a route, but allows you to automatically route
| controller and method names that contain dashes. '-' isn't a valid
| class or method name character, so it requires translation.
| When you set this option to TRUE, it will replace ALL dashes in the
| controller and method URI segments.
|
| Examples:    my-controller/index    -> my_controller/index
|        my-controller/my-method    -> my_controller/my_method
 */
$route['default_controller'] = 'home';
$route['404_override'] = '';
$route['translate_uri_dashes'] = false;

$route['home.html'] = 'home/index';
$route['login'] = 'login/index';
$route['login.html'] = 'login/index';
$route['login_f.html'] = 'login/login_f';
$route['register'] = 'login/register';
$route['register.html'] = 'login/register';
$route['logout'] = 'login/logout';
$route['logout.html'] = 'login/logout';
$route['forget'] = 'forget/index';
$route['forget.html'] = 'forget/index';
$route['change'] = 'change/index';
$route['change.html'] = 'change/index';
$route['type'] = 'type/index';
$route['type.html'] = 'type/index';
$route['help.html'] = 'about/index/help.html';
$route['tip.html'] = 'tip/index';

$route['qcback.html'] = 'login/qcback';
$route['applogin_ewm.html'] = 'login/applogin_ewm';
$route['applogin.html'] = 'login/applogin';
$route['alilogin.html'] = 'login/alilogin';
$route['weilogin.html'] = 'login/weilogin';
$route['gzh.html'] = 'login/gzh';
$route['gzh_pc.html'] = 'login/gzh_pc';
$route['gzhlogin.html'] = 'login/gzhlogin';
$route['api/uc.php'] = 'login/uclient';

$route['fenci/(.*)'] = '/c/fenci/$1';
$route['neditor'] = '/c/neditor';

$route['about/(.*)'] = 'about/index/$1';
$route['notice/(:num).html'] = 'notice/index/$1';

$route['message/(:num).html'] = 'message/index/$1';
$route['message/get-(:num).html'] = 'message/getmsg/$1';
$route['message/send-(:num).html'] = 'message/sendmsg/$1';

$route['user'] = '404';
$route['user/(:num).html'] = 'user/index/$1';
$route['user/(:num).pic'] = 'user/photo/$1';

$route['upload.html'] = 'upload/index';
$route['upload/(:num).html'] = 'upload/reward/$1';
$route['upload.file'] = 'upload/file';
$route['upload.save'] = 'upload/save';

$route['down'] = '404';
$route['down.(doc|topic).(:num).html'] = 'down/$1/$2';

$route['lists'] = '404';
$route['doc/list-(:num).html'] = 'lists/index/$1/1/1/0';
$route['doc/list-(:num)-(:num)-(:num).html'] = 'lists/index/$1/$2/$3/0';
$route['doc/list-(:num)-(:num)-(:num)-([\d.]+).html'] = 'lists/index/$1/$2/$3/$4';
$route['vip.html'] = 'lists/index/0/4/1/0';

$route['doc'] = '404';
$route['doc.html'] = 'lists/index/0/1/1/0';
$route['doc/(:num).html'] = 'doc/index/$1/1';
$route['doc/(:num)-(:num).html'] = 'doc/index/$1/$2';
$route['doc/edit-(:num).html'] = 'edit/index/$1';
$route['doc/(:num).thum'] = 'thum/index/$1';

$route['search.html'] = 'search/index/1/1/1/';
$route['search/(:num)-(:num).html'] = 'search/index/$1/$2/';
$route['search/(:num)-(:num)-(.*).html'] = 'search/index/$1/$2/$3';

$route['topic.html'] = 'topic/index/0/1/';
$route['topic/list-(:num).html'] = 'topic/index/$1/1/';
$route['topic/list-(:num)-(:num).html'] = 'topic/index/$1/$2/';
$route['topic/list-(:num)-(:num)-(.*).html'] = 'topic/index/$1/$2/$3';
$route['topic/(:num).html'] = 'topic/view/$1/1';
$route['topic/(:num)-(:num).html'] = 'topic/view/$1/$2';
$route['topic/pub.html'] = 'topic/publish/0';
$route['topic/edit-(:num).html'] = 'topic/publish/$1';
$route['topic/select.html'] = 'topic/select';
$route['topic/getdoc-(:num).html'] = 'topic/getdoc/$1';
$route['topic/cover-(:num).(.*)'] = 'topic/cover/$1/$2';
$route['topic/reply-(:num).html'] = 'topic/reply_add/$1';
$route['topic/reply-del-(:num).html'] = 'topic/reply_del/$1';
$route['topic/reply-edit-(:num).html'] = 'topic/reply_edit/$1';
$route['topic/reply-reply-(:num).html'] = 'topic/reply_reply/$1';
$route['topic/reply-report-(:num).html'] = 'topic/reply_report/$1';

$route['reward.html'] = 'reward/index/0/0/1/1/';
$route['reward/list-(:num)-(:num)-(:num)-(:num).html'] = 'reward/index/$1/$2/$3/$4/';
$route['reward/list-(:num)-(:num)-(:num)-(:num)-(.*).html'] = 'reward/index/$1/$2/$3/$4/$5';
$route['reward/(:num).html'] = 'reward/view/$1/1';
$route['reward/(:num)-(:num).html'] = 'reward/view/$1/$2';
$route['reward/pub.html'] = 'reward/publish';

$route['article.html'] = 'article/index/0/1/1/';
$route['article/list-(:num)-(:num)-(:num).html'] = 'article/index/$1/$2/$3/';
$route['article/list-(:num)-(:num)-(:num)-(.*).html'] = 'article/index/$1/$2/$3/$4';
$route['article/pub.html'] = 'article/pub/0';
$route['article/pub-(:num).html'] = 'article/pub/$1';
$route['article/edit-(:num).html'] = 'article/edit/$1';
$route['article/del-(:num).html'] = 'article/del/$1';
$route['article/(:num).html'] = 'article/view/$1/1';
$route['article/(:num)-(:num).html'] = 'article/view/$1/$2';
$route['article/reply-(:num).html'] = 'article/reply_add/$1';
$route['article/reply-del-(:num).html'] = 'article/reply_del/$1';
$route['article/reply-edit-(:num).html'] = 'article/reply_edit/$1';
$route['article/reply-reply-(:num).html'] = 'article/reply_reply/$1';
$route['article/reply-report-(:num).html'] = 'article/reply_report/$1';

$route['ask.html'] = 'ask/index/0/1/1/';
$route['ask/list-(:num)-(:num)-(:num).html'] = 'ask/index/$1/$2/$3/';
$route['ask/list-(:num)-(:num)-(:num)-(.*).html'] = 'ask/index/$1/$2/$3/$4';
$route['ask/pub.html'] = 'ask/pub/0';
$route['ask/pub-(:num).html'] = 'ask/pub/$1';
$route['ask/edit-(:num).html'] = 'ask/edit/$1';
$route['ask/del-(:num).html'] = 'ask/del/$1';
$route['ask/(:num).html'] = 'ask/view/$1/1';
$route['ask/(:num)-(:num).html'] = 'ask/view/$1/$2';
$route['ask/reply-(:num).html'] = 'ask/reply_add/$1';
$route['ask/reply-del-(:num).html'] = 'ask/reply_del/$1';
$route['ask/reply-edit-(:num).html'] = 'ask/reply_edit/$1';
$route['ask/reply-reply-(:num).html'] = 'ask/reply_reply/$1';
$route['ask/reply-report-(:num).html'] = 'ask/reply_report/$1';

$route['menu.html'] = 'center/menu';
$route['center.html'] = 'center/index';
$route['center/income.html'] = 'center/income';
$route['center/purchase.html'] = 'center/purchase';
$route['center/down.html'] = 'center/down';
$route['center/favorite.html'] = 'center/favorite';
$route['center/topic.html'] = 'center/topic';
$route['center/reward.html'] = 'center/reward';
$route['center/ask.html'] = 'center/ask';
$route['center/article.html'] = 'center/article';
$route['center/task.html'] = 'center/task';
$route['center/message.html'] = 'center/message';
$route['center/order.html'] = 'center/order';
$route['center/vip.html'] = 'center/vip';
$route['center/glodpay.html'] = 'center/glodpay';
$route['center/cash.html'] = 'center/cash';
$route['center/change.html'] = 'center/change';
$route['center/auth.html'] = 'center/auth';
$route['center/auth/(person|company).html'] = 'center/auth/$1';
$route['center/authpic/(:num).html'] = 'center/authpic/$1';
$route['center/group.html'] = 'center/group';
$route['center/ugroup.html'] = 'center/ugroup';
$route['center/account.html'] = 'center/account';
$route['center/photo'] = 'center/photo';

$route['alipay.(:num).html'] = 'c/alipay/$1';
$route['alipay2.(:num).html'] = 'c/alipay2/$1';
$route['alipay3.(doc|topic).(readpay|downpay).(:num).html'] = 'c/alipay3/$1/$2/$3';
$route['alipay.notify'] = '/c/alipaynotify';
$route['weipay.(:num).html'] = 'c/weipay/$1';
$route['weipay2.(:num).html'] = 'c/weipay2/$1';
$route['weipay3.(doc|topic).(readpay|downpay).(:num).html'] = 'c/weipay3/$1/$2/$3';
$route['weipay.notify'] = '/c/weipaynotify';
$route['perpay.notify'] = '/c/perpaynotify';
$route['glodpaystate.(:num)'] = '/c/glodpaystate/$1';
$route['vippaystate.(:num)'] = '/c/vippaystate/$1';
$route['docpaystate.(:num).(readpay|downpay)'] = 'c/docpaystate/$1/$2';
$route['topicpaystate.(:num).downpay'] = 'c/topicpaystate/$1/$2';

$route['pay.(doc|topic).(readpay|downpay).(:any)-(:any)-(:any)'] = 'pay/index/$1/$2/$3/$4/$5';

$route['admin'] = 'admin/sys/index';
$route['admin/doc/(audit|passed|nopass|online|free|vip|imp|unline|conver|clear)'] = 'admin/doc/index/$1';
$route['admin/doc/comment/(audit|online)'] = 'admin/doc/comment/$1';
$route['admin/topic/(audit|passed|nopass|online|free|vip|imp|unline)'] = 'admin/topic/index/$1';
$route['admin/topic/comment/(audit|online)'] = 'admin/topic/comment/$1';
$route['admin/user/(audit|passed|nopass)'] = 'admin/user/auth/$1';
$route['admin/reward/(audit|passed|nopass)'] = 'admin/reward/index/$1';
$route['admin/article/(audit|online|recycle)'] = 'admin/article/index/$1';
$route['admin/article/comment/(audit|online)'] = 'admin/article/comment/$1';
$route['admin/ask/(audit|online|recycle)'] = 'admin/ask/index/$1';
$route['admin/ask/comment/(audit|online)'] = 'admin/ask/comment/$1';
$route['admin/adv/(home|list|doc|search)'] = 'admin/adv/index/$1';
$route['admin/pay'] = 'admin/pay/index';
