<?php

defined('BASEPATH') or exit('No direct script access allowed');

class Article extends Home_Controller
{

    public function __construct()
    {
        parent::__construct();
    }

    //article-0-1.html  标签-页数
    public function index($tagid, $order, $cpage, $key)
    {
        $this->right_print(60);

        $psize = 10;

        if ($tagid) {
            $type = $this->db->get_where('article_tag', ['tagid' => $tagid])->row();
            $this->db->where('tagid', $tagid);
        } else {
            $type = (object) (array('tagid' => 0, 'tagname' => '全部', 'seotitle' => '全部'));
        }

        $key = urldecode(urldecode($key));
        if ($key) {
            $keywords = explode(',', fenci($key));
            $where1 = '(';
            foreach ($keywords as $k) {
                $where1 .= "SIGN(LOCATE('$k',`title`)) + ";
            }
            $where1 = substr($where1, 0, -3) . ')';
            $this->db->where("($where1 > 0)");
            $this->db->order_by("$where1 desc");
        }

        $this->db->where('state', 1);

        $this->db->order_by('istop desc');
        if ($order == 1) {
            $this->db->order_by('articleid desc');
        } elseif ($order == 2) {
            $this->db->order_by('commemtdate desc');
        } elseif ($order == 3) {
            $this->db->order_by('readnum desc');
        }

        $total = $this->db->count_all_results('article_view', false);

        $articles = $this->db->limit($psize, ($psize * $cpage - $psize))->get()->result();

        foreach ($articles as $article) {
            $article->p = mb_substr(deletehtml($article->word), 0, 202);
            $article->img = getfirstimg($article->word);
            if (isset($keywords)) {
                foreach ($keywords as $k) {
                    $article->title = str_replace($k, '<span style="color:#f00">' . $k . '</span>', $article->title);
                }
            }
        }

        $data['article_tag'] = $this->db->get_where('article_tag', ['state' => 1])->result();
        $data['articles'] = $articles;
        $data['psize'] = $psize;
        $data['cpage'] = $cpage;
        $data['total'] = $total;

        $data['tagid'] = $tagid;
        $data['order'] = $order;
        $data['key'] = $key;

        $data['title'] = str_ireplace(['{type}', '{seotitle}', '{name}'], [$type->tagname, $type->seotitle, $this->site->name], $this->seo->artl_title);
        $data['keywords'] = str_ireplace(['{type}', '{seotitle}', '{name}'], [$type->tagname, $type->seotitle, $this->site->name], $this->seo->artl_keys);
        $data['description'] = str_ireplace(['{type}', '{seotitle}', '{name}'], [$type->tagname, $type->seotitle, $this->site->name], $this->seo->artl_desc);

        $this->load->view($this->template . 'article', $data);
    }

    public function view($articleid, $cpage)
    {
        $this->right_print(60);

        if ($articleid && $article = $this->db->get_where('article_view', array('state' => 1, 'articleid' => $articleid))->row()) {

            if ($cpage == 1) {
                $this->db->set('readnum', 'readnum+1', false)->where('articleid', $articleid)->update('article');
            }

            $psize = 10;
            $this->db->where(['articleid' => $articleid, 'state' => 1]);
            $this->db->order_by('commentid');
            $total = $this->db->count_all_results('article_comment_view', false);
            $comments = $this->db->limit($psize, ($psize * $cpage - $psize))->get()->result();

            foreach ($comments as $comment) {
                if ($comment->pcommentid && $pcomment = $this->db->get_where('article_comment_view', ['commentid' => $comment->pcommentid])->row()) {
                    $comment->pcomment = $pcomment;
                }
            }

            $last = $this->db->select('articleid,title')->where(['articleid <' => $articleid, 'state' => 1])->order_by('articleid desc')->limit(1)->get('article')->row();
            $next = $this->db->select('articleid,title')->where(['articleid >' => $articleid, 'state' => 1])->order_by('articleid asc')->limit(1)->get('article')->row();

            $keywords = explode(',', fenci($article->title));
            $where1 = '(';
            foreach ($keywords as $k) {
                $where1 .= "SIGN(LOCATE('$k',`title`)) + ";
            }
            $where1 = substr($where1, 0, -3) . ')';
            $this->db->where("($where1 > 0)");
            $this->db->order_by("$where1 desc");
            $this->db->where(['articleid <>' => $articleid, 'state' => 1]);
            $likes = $this->db->limit(10)->get('article')->result();

            $data['article_tag'] = $this->db->get_where('article_tag', ['state' => 1])->result();
            $data['article'] = $article;
            $data['comments'] = $comments;

            $data['next'] = $next;
            $data['last'] = $last;
            $data['likes'] = $likes;

            $data['psize'] = $psize;
            $data['cpage'] = $cpage;
            $data['total'] = $total;

            $data['title'] = str_ireplace(['{title}', '{type}', '{name}'], [$article->title, $article->tagname, $this->site->name], $this->seo->article_title);
            $data['keywords'] = str_ireplace(['{title}', '{type}', '{name}'], [$article->title, $article->tagname, $this->site->name], $this->seo->article_keys);
            $data['description'] = str_ireplace(['{title}', '{type}', '{name}'], [$article->title, $article->tagname, $this->site->name], $this->seo->article_desc);

            $this->load->view($this->template . 'article_view', $data);
        } else {
            $data['message'] = '文章正在审核或已删除';
            $data['title'] = '文章不存在 - ' . $this->site->name;
            $data['keywords'] = '文章不存在';
            $data['description'] = '文章正在审核或已删除';

            $this->load->view($this->template . 'tip', $data);
        }
    }

    public function pub($tagid)
    {
        $this->right_print(62, '您暂时没有发表文章的权限');

        if (IS_GET) {
            $data['tagid'] = $tagid;
            $data['tagname'] = '-';

            $tags = $this->db->order_by('sort')->get_where('article_tag', ['state' => 1])->result();
            foreach ($tags as $tag) {
                if ($tag->tagid == $tagid) {
                    $data['tagname'] = $tag->tagname;
                }
            }
            $data['tags'] = $tags;
            $data['title'] = '发表文章 - ' . $this->site->name;
            $data['keywords'] = '发表文章';
            $data['description'] = '发表文章';
            $this->load->view($this->template . 'article_pub', $data);
        } elseif (IS_POST) {
            $data = array(
                'userid' => $this->user->userid,
                'tagid' => $this->input->post('tagid'),
                'title' => $this->input->post('title'),
                'word' => $this->input->post('word'),
                'state' => $this->has_right(63) ? 1 : 0,
            );
            if ($this->db->insert('article', $data)) {
                echo $this->db->insert_id();
            } else {
                echo -1;
            }
        }
    }

    public function edit($articleid)
    {
        $this->right_print(64, '您暂时没有编辑文章的权限');

        if (IS_GET) {
            if ($articleid && ($article = $this->db->get_where('article', array('articleid' => $articleid))->row()) && $this->user->userid == $article->userid) {

                $data['tagid'] = $article->tagid;
                $data['tagname'] = '-';

                $tags = $this->db->order_by('sort')->get_where('article_tag', ['state' => 1])->result();
                foreach ($tags as $tag) {
                    if ($tag->tagid == $article->tagid) {
                        $data['tagname'] = $tag->tagname;
                    }
                }
                $data['tags'] = $tags;
                $data['article'] = $article;
                $data['title'] = '编辑文章 - ' . $this->site->name;
                $data['keywords'] = '编辑文章';
                $data['description'] = '编辑文章';
                $this->load->view($this->template . 'article_edit', $data);
            } else {
                $data['message'] = '没有找到您要编辑的文章';
                $data['title'] = '文章不存在 - ' . $this->site->name;
                $data['keywords'] = '文章不存在';
                $data['description'] = '没有找到您要编辑的文章';
                $this->load->view($this->template . 'tip', $data);
            }
        } elseif (IS_POST) {
            $data = array(
                'userid' => $this->user->userid,
                'tagid' => $this->input->post('tagid'),
                'title' => $this->input->post('title'),
                'word' => $this->input->post('word'),
                'state' => $this->has_right(63) ? 1 : 0,
            );
            if ($this->db->update('article', $data, ['articleid' => $articleid, 'userid' => $this->user->userid])) {
                echo $articleid;
            } else {
                echo -1;
            }
        }
    }

    public function del($articleid)
    {
        if ($this->has_right(65)) {
            $this->db->set('state', '-1', false)->where(['articleid' => $articleid, 'userid' => $this->user->userid])->update('article');
            echo 1;            
        } else {
            echo -1;
        }
    }

    public function reply_add($articleid)
    {
        $this->right_print(66);
        if ($articleid && $article = $this->db->get_where('article', array('articleid' => $articleid))->row()) {
            $data = array(
                'articleid' => $articleid,
                'userid' => $this->user->userid,
                'comment' => $this->input->post('comment'),
                'state' => $this->has_right(67) ? 1 : 0,
            );
            $this->db->set('commemtdate', 'now()', false)->where('articleid', $articleid)->update('article');
            echo $this->db->insert('article_comment', $data);
        } else {
            echo -1;
        }
    }

    public function reply_edit($commentid)
    {
        $this->right_print(68);

        if (IS_GET) {
            if ($commentid && $comment = $this->db->get_where('article_comment', ['commentid' => $commentid, 'userid' => $this->user->userid])->row()) {
                $data['article_title'] = $this->db->select('title')->get_where('article', ['articleid' => $comment->articleid])->row()->title;
                $data['comment'] = $comment;
                $data['title'] = '编辑文章评论 - ' . $this->site->name;
                $data['keywords'] = '编辑文章评论';
                $data['description'] = '编辑文章评论';
                $this->load->view($this->template . 'article_reply_edit', $data);
            } else {
                echo -2; //只能编辑已有评论并且是自己的评论
            }
        } elseif (IS_POST) {
            $data = array(
                'comment' => $this->input->post('comment'),
            );
            echo $this->db->update('article_comment', $data, ['commentid' => $commentid, 'userid' => $this->user->userid]);
        }

    }

    public function reply_reply($commentid)
    {
        $this->right_print(66);

        if (IS_GET) {
            if ($commentid && $comment = $this->db->get_where('article_comment', ['commentid' => $commentid])->row()) {
                $data['article_title'] = $this->db->select('title')->get_where('article', ['articleid' => $comment->articleid])->row()->title;
                $data['comment'] = $comment;
                $data['title'] = '评论文章评论 - ' . $this->site->name;
                $data['keywords'] = '评论文章评论';
                $data['description'] = '评论文章评论';
                $this->load->view($this->template . 'article_reply_reply', $data);
            } else {
                echo -2; //只能评论已有评论
            }
        } elseif (IS_POST) {
            $data = array(
                'articleid' => $this->input->post('articleid'),
                'userid' => $this->user->userid,
                'comment' => $this->input->post('comment'),
                'pcommentid' => $commentid,
                'state' => $this->has_right(67) ? 1 : 0,
            );
            $this->db->set('commemtdate', 'now()', false)->where('articleid', $this->input->post('articleid'))->update('article');
            echo $this->db->insert('article_comment', $data);
        }
    }

    public function reply_del($commentid)
    {
        if ($this->has_right(69)) {
            if ($this->db->delete('article_comment', ['commentid' => $commentid, 'userid' => $this->user->userid])) {
                echo 1;
            } else {
                echo -1;
            }
        } else {
            echo -1;
        }
    }

    public function reply_report($docid)
    {
        if ($docid) {
            if (IS_GET) {
                $data['report_item'] = $this->db->order_by('sort')->get_where('report_item', ['state' => 1])->result();
                if ($report = $this->db->select('reportid,report,extra')->get_where('report', array('docid' => $docid, 'userid' => $this->user->userid))->row()) {
                    $data['report'] = (object) array(
                        'reportid' => $report->reportid,
                        'docid' => $docid,
                        'report' => $report->report,
                        'extra' => $report->extra,
                    );
                } else {
                    $data['report'] = (object) array(
                        'reportid' => '',
                        'docid' => $docid,
                        'report' => $data['report_item'][0]->title,
                        'extra' => '',
                    );
                }
                $this->load->view($this->template . 'report.html', $data);
            } elseif (IS_POST) {
                $data = array(
                    'docid' => $docid,
                    'userid' => $this->user->userid,
                    'report' => $this->input->post('report'),
                    'extra' => $this->input->post('extra'),
                );
                if ($reportid = $this->input->post('reportid')) {
                    echo $this->db->update('report', $data, array('reportid' => $reportid));
                } else {
                    echo $this->db->insert('report', $data);
                }
            }
        }
    }

    public function report_submit($docid, $report)
    {
        if ($docid && $report && $this->user->groupid) {
            $data = array(
                'docid' => $this->input->post('docid'),
                'userid' => $this->user->userid,
                'report' => $report,
            );
            $this->db->insert('report', $data);
            echo 1;
        } else {
            echo -1;
        }
    }
}
