<?php

defined('BASEPATH') or exit('No direct script access allowed');

class Ask extends Home_Controller
{

    public function __construct()
    {
        parent::__construct();
    }

    //ask/list-0-1.html  标签-页数
    public function index($tagid, $order, $cpage, $key)
    {
        $this->right_print(70);

        $psize = 10;

        if ($tagid) {
            $type = $this->db->get_where('ask_tag', ['tagid' => $tagid])->row();
            $this->db->where('tagid', $tagid);
        } else {
            $type = (object) (array('tagid' => 0, 'tagname' => '全部', 'seotitle' => '全部'));
        }
        
        $key = urldecode(urldecode($key));
        if ($key) {
            $keywords = explode(',', fenci($key));
            $where1 = '(';
            foreach ($keywords as $k) {
                $where1 .= "SIGN(LOCATE('$k',`title`)) + ";
            }
            $where1 = substr($where1, 0, -3) . ')';
            $this->db->where("($where1 > 0)");
            $this->db->order_by("$where1 desc");
        }

        $this->db->where('state', 1);

        $this->db->order_by('istop desc');
        if ($order == 1) {
            $this->db->order_by('askid desc');
        } elseif ($order == 2) {
            $this->db->order_by('commemtdate desc');
        } elseif ($order == 3) {
            $this->db->order_by('readnum desc');
        }

        $total = $this->db->count_all_results('ask_view', false);

        $asks = $this->db->limit($psize, ($psize * $cpage - $psize))->get()->result();

        foreach ($asks as $ask) {
            $ask->p = mb_substr(deletehtml($ask->word), 0, 202);
            $ask->img = getfirstimg($ask->word);
            if (isset($keywords)) {
                foreach ($keywords as $k) {
                    $ask->title = str_replace($k, '<span style="color:#f00">' . $k . '</span>', $ask->title);
                }
            }
        }

        $data['ask_tag'] = $this->db->get_where('ask_tag', ['state' => 1])->result();
        $data['asks'] = $asks;
        $data['psize'] = $psize;
        $data['cpage'] = $cpage;
        $data['total'] = $total;

        $data['tagid'] = $tagid;
        $data['order'] = $order;
        $data['key'] = $key;

        $data['title'] = str_ireplace(['{type}', '{seotitle}', '{name}'], [$type->tagname, $type->seotitle, $this->site->name], $this->seo->askl_title);
        $data['keywords'] = str_ireplace(['{type}', '{seotitle}', '{name}'], [$type->tagname, $type->seotitle, $this->site->name], $this->seo->askl_keys);
        $data['description'] = str_ireplace(['{type}', '{seotitle}', '{name}'], [$type->tagname, $type->seotitle, $this->site->name], $this->seo->askl_desc);

        $this->load->view($this->template . 'ask', $data);
    }

    public function view($askid, $cpage)
    {
        $this->right_print(70);

        if ($askid && $ask = $this->db->get_where('ask_view', array('state' => 1, 'askid' => $askid))->row()) {

            if ($cpage == 1) {
                $this->db->set('readnum', 'readnum+1', false)->where('askid', $askid)->update('ask');
            }

            $psize = 10;
            $this->db->where(['askid' => $askid, 'state' => 1]);
            $this->db->order_by('commentid');
            $total = $this->db->count_all_results('ask_comment_view', false);
            $comments = $this->db->limit($psize, ($psize * $cpage - $psize))->get()->result();

            foreach ($comments as $comment) {
                if ($comment->pcommentid && $pcomment = $this->db->get_where('ask_comment_view', ['commentid' => $comment->pcommentid])->row()) {
                    $comment->pcomment = $pcomment;
                }
            }

            $last = $this->db->select('askid,title')->where(['askid <' => $askid, 'state' => 1])->order_by('askid desc')->limit(1)->get('ask')->row();
            $next = $this->db->select('askid,title')->where(['askid >' => $askid, 'state' => 1])->order_by('askid asc')->limit(1)->get('ask')->row();

            $keywords = explode(',', fenci($ask->title));
            $where1 = '(';
            foreach ($keywords as $k) {
                $where1 .= "SIGN(LOCATE('$k',`title`)) + ";
            }
            $where1 = substr($where1, 0, -3) . ')';
            $this->db->where("($where1 > 0)");
            $this->db->order_by("$where1 desc");
            $this->db->where(['askid <>' => $askid, 'state' => 1]);
            $likes = $this->db->limit(10)->get('ask')->result();

            $data['ask_tag'] = $this->db->get_where('ask_tag', ['state' => 1])->result();
            $data['ask'] = $ask;
            $data['comments'] = $comments;

            $data['next'] = $next;
            $data['last'] = $last;
            $data['likes'] = $likes;

            $data['psize'] = $psize;
            $data['cpage'] = $cpage;
            $data['total'] = $total;

            $data['title'] = str_ireplace(['{title}', '{type}', '{name}'], [$ask->title, $ask->tagname, $this->site->name], $this->seo->ask_title);
            $data['keywords'] = str_ireplace(['{title}', '{type}', '{name}'], [$ask->title, $ask->tagname, $this->site->name], $this->seo->ask_keys);
            $data['description'] = str_ireplace(['{title}', '{type}', '{name}'], [$ask->title, $ask->tagname, $this->site->name], $this->seo->ask_desc);

            $this->load->view($this->template . 'ask_view', $data);
        } else {
            $data['message'] = '问题正在审核或已删除';
            $data['title'] = '问题不存在 - ' . $this->site->name;
            $data['keywords'] = '问题不存在';
            $data['description'] = '问题正在审核或已删除';

            $this->load->view($this->template . 'tip', $data);
        }
    }

    public function pub($tagid)
    {
        $this->right_print(72, '您暂时没有提问问题的权限');

        if (IS_GET) {
            $data['tagid'] = $tagid;
            $data['tagname'] = '-';

            $tags = $this->db->order_by('sort')->get_where('ask_tag', ['state' => 1])->result();
            foreach ($tags as $tag) {
                if ($tag->tagid == $tagid) {
                    $data['tagname'] = $tag->tagname;
                }
            }
            $data['tags'] = $tags;
            $data['title'] = '提问问题 - ' . $this->site->name;
            $data['keywords'] = '提问问题';
            $data['description'] = '提问问题';

            $this->load->view($this->template . 'ask_pub', $data);
        } elseif (IS_POST) {
            $data = array(
                'userid' => $this->user->userid,
                'tagid' => $this->input->post('tagid'),
                'title' => $this->input->post('title'),
                'word' => $this->input->post('word'),
                'state' => $this->has_right(73) ? 1 : 0,
            );
            if ($this->db->insert('ask', $data)) {
                echo $this->db->insert_id();
            } else {
                echo -1;
            }
        }
    }

    public function edit($askid)
    {
        $this->right_print(74, '您暂时没有编辑问题的权限');

        if (IS_GET) {
            if ($askid && ($ask = $this->db->get_where('ask', array('askid' => $askid))->row()) && $this->user->userid == $ask->userid) {

                $data['tagid'] = $ask->tagid;
                $data['tagname'] = '-';

                $tags = $this->db->order_by('sort')->get_where('ask_tag', ['state' => 1])->result();
                foreach ($tags as $tag) {
                    if ($tag->tagid == $ask->tagid) {
                        $data['tagname'] = $tag->tagname;
                    }
                }
                $data['tags'] = $tags;
                $data['ask'] = $ask;
                $data['title'] = '编辑问题 - ' . $this->site->name;
                $data['keywords'] = '编辑问题';
                $data['description'] = '编辑问题';

                $this->load->view($this->template . 'ask_edit', $data);
            } else {
                $data['message'] = '没有找到您要编辑的问题';
                $data['title'] = '问题不存在 - ' . $this->site->name;
                $data['keywords'] = '问题不存在';
                $data['description'] = '没有找到您要编辑的问题';

                $this->load->view($this->template . 'tip', $data);
            }
        } elseif (IS_POST) {
            $data = array(
                'userid' => $this->user->userid,
                'tagid' => $this->input->post('tagid'),
                'title' => $this->input->post('title'),
                'word' => $this->input->post('word'),
                'state' => $this->has_right(73) ? 1 : 0,
            );
            if ($this->db->update('ask', $data, ['askid' => $askid, 'userid' => $this->user->userid])) {
                echo $askid;
            } else {
                echo -1;
            }
        }
    }

    public function del($askid)
    {
        if ($this->has_right(75)) {
            $this->db->set('state', '-1', false)->where(['askid' => $askid, 'userid' => $this->user->userid])->update('ask');
            echo 1;            
        } else {
            echo -1;
        }
    }

    public function reply_add($askid)
    {
        $this->right_print(76);
        if ($askid && $ask = $this->db->get_where('ask', array('askid' => $askid))->row()) {
            $data = array(
                'askid' => $askid,
                'userid' => $this->user->userid,
                'comment' => $this->input->post('comment'),
                'state' => $this->has_right(77) ? 1 : 0,
            );
            $this->db->set('commemtdate', 'now()', false)->where('askid', $askid)->update('ask');
            echo $this->db->insert('ask_comment', $data);
        } else {
            echo -1;
        }
    }

    public function reply_edit($commentid)
    {
        $this->right_print(78);

        if (IS_GET) {
            if ($commentid && $comment = $this->db->get_where('ask_comment', ['commentid' => $commentid, 'userid' => $this->user->userid])->row()) {
                $data['ask_title'] = $this->db->select('title')->get_where('ask', ['askid' => $comment->askid])->row()->title;
                $data['comment'] = $comment;
                $data['title'] = '编辑问题回答 - ' . $this->site->name;
                $data['keywords'] = '编辑问题回答';
                $data['description'] = '编辑问题回答';

                $this->load->view($this->template . 'ask_reply_edit', $data);
            } else {
                echo -2; //只能编辑已有回答并且是自己的回答
            }
        } elseif (IS_POST) {
            $data = array(
                'comment' => $this->input->post('comment'),
            );
            echo $this->db->update('ask_comment', $data, ['commentid' => $commentid, 'userid' => $this->user->userid]);
        }

    }

    public function reply_reply($commentid)
    {
        $this->right_print(76);

        if (IS_GET) {
            if ($commentid && $comment = $this->db->get_where('ask_comment', ['commentid' => $commentid])->row()) {
                $data['ask_title'] = $this->db->select('title')->get_where('ask', ['askid' => $comment->askid])->row()->title;
                $data['comment'] = $comment;
                $data['title'] = '回复问题回答 - ' . $this->site->name;
                $data['keywords'] = '回复问题回答';
                $data['description'] = '回复问题回答';

                $this->load->view($this->template . 'ask_reply_reply', $data);
            } else {
                echo -2; //只能回复已有回答
            }
        } elseif (IS_POST) {
            $data = array(
                'askid' => $this->input->post('askid'),
                'userid' => $this->user->userid,
                'comment' => $this->input->post('comment'),
                'pcommentid' => $commentid,
                'state' => $this->has_right(77) ? 1 : 0,
            );
            $this->db->set('commemtdate', 'now()', false)->where('askid', $this->input->post('askid'))->update('ask');
            echo $this->db->insert('ask_comment', $data);
        }
    }

    public function reply_del($commentid)
    {
        if ($this->has_right(79)) {
            if ($this->db->delete('ask_comment', ['commentid' => $commentid, 'userid' => $this->user->userid])) {
                echo 1;
            } else {
                echo -1;
            }
        } else {
            echo -1;
        }
    }

    public function reply_report($docid)
    {
        if ($docid) {
            if (IS_GET) {
                $data['report_item'] = $this->db->order_by('sort')->get_where('report_item', ['state' => 1])->result();
                if ($report = $this->db->select('reportid,report,extra')->get_where('report', array('docid' => $docid, 'userid' => $this->user->userid))->row()) {
                    $data['report'] = (object) array(
                        'reportid' => $report->reportid,
                        'docid' => $docid,
                        'report' => $report->report,
                        'extra' => $report->extra,
                    );
                } else {
                    $data['report'] = (object) array(
                        'reportid' => '',
                        'docid' => $docid,
                        'report' => $data['report_item'][0]->title,
                        'extra' => '',
                    );
                }
                $this->load->view($this->template . 'report.html', $data);
            } elseif (IS_POST) {
                $data = array(
                    'docid' => $docid,
                    'userid' => $this->user->userid,
                    'report' => $this->input->post('report'),
                    'extra' => $this->input->post('extra'),
                );
                if ($reportid = $this->input->post('reportid')) {
                    echo $this->db->update('report', $data, array('reportid' => $reportid));
                } else {
                    echo $this->db->insert('report', $data);
                }
            }
        }
    }

    public function report_submit($docid, $report)
    {
        if ($docid && $report && $this->user->groupid) {
            $data = array(
                'docid' => $this->input->post('docid'),
                'userid' => $this->user->userid,
                'report' => $report,
            );
            $this->db->insert('report', $data);
            echo 1;
        } else {
            echo -1;
        }
    }
}
