<?php

defined('BASEPATH') or exit('No direct script access allowed');

class Doc extends Home_Controller
{

    public function __construct()
    {
        parent::__construct();
        $this->right_print(10);
    }

    public function index($docid, $pcurrent)
    {
        if ($this->user->userid > 0) {
            $this->readlog($docid);
        }

        if ($this->docset->doc_cache && $data1 = get_cache(str_replace('/', '-', $this->template) . implode('_', $this->uri->rsegments), $this->docset->doc_cache)) {
            echo $data1;
        } else if (($doc = $this->get_doc($docid)) && !$doc->isdel) {
            $data['doc'] = $doc;
            $data['adv'] = $this->get_adv();
            $data['share'] = $this->get_share();
            $data['bdpush'] = $this->get_bdpush();
            $data['shang'] = $this->get_shang();
            $data['docnum'] = $this->get_docnum($doc->userid);
            $data['likedoc'] = $this->get_likedocs($doc);
            $data['comment'] = $this->get_comment($doc->docid);
            $data['fav_state'] = $this->get_favstate($doc->docid);
            $data['pcurrent'] = $pcurrent;
            $data['doc_cache'] = $this->load->view($this->template . 'doc_cache', $data, true);
            $data['doc_cache_vip'] = $this->load->view($this->template . 'doc_cache_vip', $data, true);

            $crumbs = get_ptypes($doc->typeid);
            $crumb1 = '';
            $crumb2 = '';
            if ($crumbs[0]) {
                foreach ($crumbs as $crumb) {
                    $crumb1 .= $crumb->typename . '-';
                    $crumb2 .= $crumb->typename . ',';
                }
                $crumb1 = substr($crumb1, 0, -1);
                $crumb2 = substr($crumb2, 0, -1);
                $data['crumbs'] = array_reverse($crumbs);
            } else {
                $crumb1 = '无分类';
                $crumb2 = '无分类';
            }

            $description = mb_substr($doc->word, 0, 200);
            $doc->word = mb_substr($doc->word, 0, $this->docset->wordcount);

            $data['title'] = str_ireplace(['{title}', '{type}', '{name}'], [$doc->title, $crumb1, $this->site->name], $this->seo->doc_title);
            $data['keywords'] = str_ireplace(['{keys}', '{type}', '{name}'], [$doc->keyword, $crumb2, $this->site->name], $this->seo->doc_keys);
            $data['description'] = str_ireplace(['{word}', '{type}', '{name}'], [$description, $crumb1, $this->site->name], $this->seo->doc_desc);

            $cache = $this->load->view($this->template . 'doc', $data, true);
            $this->docset->doc_cache && put_cache(str_replace('/', '-', $this->template) . implode('_', $this->uri->rsegments), $cache);
            echo $cache;

        } else {
            $data['message'] = '您预览的文档不存在';
            $data['title'] = '文档不存在 - ' . $this->site->name;
            $data['keywords'] = '文档不存在';
            $data['description'] = '您预览的文档不存在';
            $this->load->view($this->template . 'tip', $data);
        }
    }

    private function readlog($docid)
    {
        $this->db->set('readcount', 'readcount+1', false)->where('docid', $docid)->update('doc'); //文档被阅读次数
    }

    private function get_adv()
    {
        return $this->db->order_by('sort')->get_where('advv', array('page' => 'doc'))->result();
    }

    private function get_share()
    {
        return $this->db->get_where('shareset', array('state' => '1'))->row();
    }

    private function get_bdpush()
    {
        return $this->db->get_where('bdpushset', array('state' => '1'))->row();
    }

    private function get_shang()
    {
        return $this->db->get_where('shangset', array('state' => '1'))->row();
    }

    // 0：普通用户->文档 (普通+VIP)显示（原价）
    // 1：VIP用户-> VIP免文档      显示（原价 + 折扣价）
    // 2：VIP用户-> 文档文档       显示（原价 + 折扣价）
    // 3：自己的文档               显示（原价 + 折扣价）
    // 4：只阅读过                 显示 (原价 + 折扣价)
    // 5：已下载过                 显示 (原价 + 折扣价)
    // 不相等 显示原价和折扣
    // VIP免费文档显示VIP角标
    private function get_doc($docid)
    {
        if ($docid && $doc = get_docv($docid)) {

            $docdir = get_dir($doc->path);
            $doc->hcount = get_pcount($docdir);
            if ($doc->hcount == 0) {
                $doc->hcount = 1;
            }

            $doc->preview = $doc->readpay == 0 ? $doc->hcount : ($doc->preview > $doc->hcount ? $doc->hcount : $doc->preview);
            $doc->readpay2 = $doc->readpay;
            $doc->downpay2 = $doc->downpay;

            //是否有阅读权限
            // if (!$this->has_right(10)) {
            //     $doc->preview = 1;
            //     return $doc;
            // }

            //自己的文档
            if ($doc->userid == $this->user->userid) {
                $doc->preview = $doc->hcount;
                $doc->readpay2 = 0;
                $doc->downpay2 = 0;
                return $doc;
            }
            //VIP用户折扣，如果是vip免费文档，折扣为0
            if ($this->vgroup && strtotime($this->user->vipdate) >= time() && ($this->vgroup->docmoney==-1 || $this->vgroup->docmoney>=$doc->downpay)) {
                //$doc->preview = $doc->hcount; 折扣为0也要付费，但不弹出pay.html
                $doc->readpay2 = $doc->readpay * ($doc->isvip ? 0 : $this->vgroup->discount);
                $doc->downpay2 = $doc->downpay * ($doc->isvip ? 0 : $this->vgroup->discount2);
            }
            //已购买或下载过
            $paydue = $this->tradeset->paydue;
            if ($paydue) {
                $this->db->where('TO_DAYS(NOW()) - TO_DAYS(insertdate) <=', $paydue);
            }
            $readpaylog = $this->db->where_in('type', array(-30, -31, -32))->get_where('glodpot', array('userid' => $this->user->userid, 'linkid' => $doc->docid))->row();

            if ($paydue) {
                $this->db->where('TO_DAYS(NOW()) - TO_DAYS(insertdate) <=', $paydue);
            }
            $downpaylog = $this->db->where_in('type', array(-40, -41, -42))->get_where('glodpot', array('userid' => $this->user->userid, 'linkid' => $doc->docid))->row();

            //付费阅读过
            if ($readpaylog) {
                $doc->preview = $doc->hcount;
                $doc->readpay2 = 0;
            }
            //付费下载过，可免费阅读
            if ($downpaylog) {
                $doc->preview = $doc->hcount;
                $doc->readpay2 = 0;
                $doc->downpay2 = 0;
            }
            return $doc;
        } else {
            return null; //文档不存在
        }
    }

    public function payread($docid)
    {
        if ($docid && ($doc = get_doc($docid))) {
            //自己的文档 （不会出现  get_doc处理了）
            if ($doc->userid == $this->user->userid) {
                echo 3;
                return;
            }
            //已购买或下载过 （不会出现  get_doc处理了）
            $paydue = $this->tradeset->paydue;
            if ($paydue) {
                $this->db->where('TO_DAYS(NOW()) - TO_DAYS(insertdate) <=', $paydue);
            }
            $readpaylog = $this->db->where_in('type', array(-30, -31, -32))->get_where('glodpot', array('userid' => $this->user->userid, 'linkid' => $doc->docid))->row();

            if ($paydue) {
                $this->db->where('TO_DAYS(NOW()) - TO_DAYS(insertdate) <=', $paydue);
            }
            $downpaylog = $this->db->where_in('type', array(-40, -41, -42))->get_where('glodpot', array('userid' => $this->user->userid, 'linkid' => $doc->docid))->row();
            if ($readpaylog || $downpaylog) {
                echo 4;
                return;
            }

            $rate = 1;
            $type = 30;
            $dtype = -30;
            //VIP权限
            if ($this->vgroup && strtotime($this->user->vipdate) >= time()) {
                $rate = $doc->isvip ? 0 : $this->vgroup->discount;
                $type = 31;
                $dtype = -31;
            }

            //游客是否有阅读权限
            if (!$this->has_right(10)) {
                if (!$this->user->groupid) {
                    echo -11;
                } else {
                    echo -13;
                }
                return;
            }

            $many = ($doc->readpay) * $rate;
            if ($this->user->glods >= $many) {
                $glodpotdata = array(
                    'userid' => $doc->userid,
                    'linkid' => $docid,
                    'type' => $type,
                    'glods' => $many * (1 - $this->tradeset->rate),
                );
                $this->db->insert('glodpot', $glodpotdata);

                $glodpotdata2 = array(
                    'userid' => $this->user->userid,
                    'linkid' => $docid,
                    'type' => $dtype,
                    'glods' => 0 - $many,
                );
                $this->db->insert('glodpot', $glodpotdata2);

                $this->db->set('glods', 'glods+' . $many * (1 - $this->tradeset->rate), false)->where('userid', $doc->userid)->update('user');
                $this->db->set('glods', 'glods-' . $many, false)->where('userid', $this->user->userid)->update('user');

                //邀请奖励
                if ($user = $this->db->select('userid,groupid')->get_where('user', array('iinvicode' => $this->user->finvicode))->row()) {
                    if ($group = $this->db->select('groupid,invite,invitedays')->get_where('group', array('groupid' => $user->groupid))->row()) {
                        if (strpos($group->invite, '%') > 0 && ($group->invitedays == 0 || time() - strtotime($this->user->insertdate) < $group->invitedays * 86400)) {

                            $glodpotdata = array(
                                'userid' => $user->userid,
                                'linkid' => $this->user->userid,
                                'type' => 12,
                                'glods' => $group->invite * $many / 100,
                                'invite' => $group->invite,
                            );
                            $this->db->insert('glodpot', $glodpotdata);

                            $this->db->set('glods', 'glods+' . $group->invite * $many / 100, false)->where('userid',$user->userid)->update('user');
                        }
                    }
                }
                echo 1;
            } else {
                echo -1; //积分不足
            }
        } else {
            echo -12; //文档不存在
        }
    }

    public function page($docid, $cpage)
    {
        if ($docid && $cpage && $doc = get_doc($docid)) {
            $doc->hcount = get_pcount(get_dir($doc->path));
            if ($doc->hcount == 0) {
                $doc->hcount = 1;
            }

            if ($doc->readpay == 0) {
                $doc->preview = $doc->hcount;
            } else {
                $doc->preview = $doc->preview > $doc->hcount ? $doc->hcount : $doc->preview;
            }

            if ($doc->userid == $this->user->userid) { //自己的文档
                $doc->preview = $doc->hcount;
            } else { //已购买或下载过
                $paydue = $this->tradeset->paydue;
                if ($paydue) {
                    $this->db->where('TO_DAYS(NOW()) - TO_DAYS(insertdate) <=', $paydue);
                }
                $readpaylog = $this->db->where_in('type', array(-30, -31, -32))->get_where('glodpot', array('userid' => $this->user->userid, 'linkid' => $doc->docid))->row();

                if ($paydue) {
                    $this->db->where('TO_DAYS(NOW()) - TO_DAYS(insertdate) <=', $paydue);
                }
                $downpaylog = $this->db->where_in('type', array(-40, -41, -42))->get_where('glodpot', array('userid' => $this->user->userid, 'linkid' => $doc->docid))->row();
                if ($readpaylog || $downpaylog) {
                    $doc->preview = $doc->hcount;
                }
            }
            if ($cpage <= $doc->preview) {
                $svg = get_dir($doc->path) . $cpage . '.view';

                if (file_exists($svg)) {
                    $etag = md5_file($svg);
                    if (array_key_exists('HTTP_IF_NONE_MATCH', $_SERVER) and $_SERVER['HTTP_IF_NONE_MATCH'] == $etag) {
                        header("HTTP/1.1 304 Not Modified");
                        header("Cache-Control: public, max-age=86400000, pre-check=86400000");
                        header("Pragma: public");
                        header("Etag:" . $etag);
                        exit();
                    } else {
                        header("Cache-Control: public, max-age=86400000, pre-check=86400000");
                        header("Pragma: public");
                        header("Etag:" . $etag);
                        header('Content-type: image/svg+xml');

                        $water = $this->db->get_where('water', ['state' => 1])->row();
                        if ($water) {
                            $svg_p1 = file_get_contents($svg);
                            $svg_p2 = $water->watermark;
                            echo str_ireplace('</svg>', $svg_p2 . '</svg>', $svg_p1);
                        } else {
                            readfile($svg);
                        }
                    }

                } else if (($instance = &get_instance()) && ($oss = $instance->db->get('ossset')->row()) && $oss->state && $instance->load->library('Oss/oss') && $instance->oss->objectexists($svg)) {
                    $url = $instance->oss->signUrl($svg);
                    if ($oss->fluxoss) {
                        header('Location:' . $url);
                    } else {
                        $etag = md5_file($url);
                        if (array_key_exists('HTTP_IF_NONE_MATCH', $_SERVER) and $_SERVER['HTTP_IF_NONE_MATCH'] == $etag) {
                            header("HTTP/1.1 304 Not Modified");
                            header("Cache-Control: public, max-age=86400000, pre-check=86400000");
                            header("Pragma: public");
                            header("Etag:" . $etag);
                            exit();
                        } else {
                            header("Cache-Control: public, max-age=86400000, pre-check=86400000");
                            header("Pragma: public");
                            header("Etag:" . $etag);
                            header('Content-type: image/svg+xml');

                            $water = $this->db->get_where('water', ['state' => 1])->row();
                            if ($water) {
                                $svg_p1 = file_get_contents($url);
                                $svg_p2 = $water->watermark;
                                echo str_ireplace('</svg>', $svg_p2 . '</svg>', $svg_p1);
                            } else {
                                readfile($url);
                            }
                        }
                    }
                } else {
                    header("Cache-Control:no-store, no-cache, must-revalidate");
                    header("Pragma:no-cache");
                    header("Expires:-1");
                    header('Content-type: image/svg+xml');
                    readfile('data/img/4.svg');
                }
            } else {
                echo -3;
            }
        } else {
            echo -1;
        }
    }

    private function get_docnum($uid)
    {
        return $this->db->select('count(*) as count')->get_where('doc', array('userid' => $uid, 'state' => 1, 'isdel' => 0))->row()->count;
    }

    private function get_likedocs($doc)
    {
        if ($doc->keyword) {
            $docs = $this->db->where("MATCH(title, word) AGAINST('$doc->title')")->limit(10)->get_where('doc', array('state' => 1, 'isdel' => 0))->result();
            return $docs;
        }
    }

    private function get_likedocs2($doc)
    {
        if ($doc->keyword) {
            $keywords = explode(',', $doc->keyword);
            $where1 = '(';
            $where2 = '(';
            $where3 = '(';
            foreach ($keywords as $k) {
                $where1 .= "SIGN(LOCATE('$k',`title`)) + ";
                $where2 .= "SIGN(LOCATE('$k',`word`)) + ";
                $where3 .= "SIGN(LOCATE('$k',`keyword`)) + ";
            }
            $where1 = substr($where1, 0, -3) . ')';
            $where2 = substr($where2, 0, -3) . ')';
            $where3 = substr($where3, 0, -3) . ')';

            $this->db->where("($where1 > 0 or $where2 > 0 or $where3 > 0)");

            $this->db->order_by("$where1 desc");
            $this->db->order_by("$where2 desc");
            $this->db->order_by("$where3 desc");
            $docs = $this->db->limit(10)->get_where('doc', array('state' => 1, 'isdel' => 0))->result();
            return $docs;
        }
    }

    private function get_favstate($docid)
    {
        if ($this->user->groupid && $this->db->select('favid')->get_where('favorite', array('userid' => $this->user->userid, 'docid' => $docid))->row()) {
            return 1;
        } else {
            return 0;
        }
    }

    public function favorite($docid)
    {
        if (!$this->user->groupid) {
            echo -1;
            return;
        }
        if ($docid) {
            $row = $this->db->select('favid')->get_where('favorite', array('userid' => $this->user->userid, 'docid' => $docid))->row();
            if ($row) {
                $this->db->delete('favorite', array('favid' => $row->favid));
            } else {
                $data = array(
                    'userid' => $this->user->userid,
                    'docid' => $docid,
                );
                $this->db->insert('favorite', $data);
            }
        }
        echo 1;
    }

    private function get_comment($docid)
    {
        $comment = $this->db->order_by('insertdate desc')->get_where('comment_view', array('state' => 1, 'docid' => $docid))->result();
        foreach ($comment as $com) {
            $get = $this->db->get_where('comment_agree', array('commentid' => $com->commentid, 'userid' => $this->user->userid));
            if ($get->num_rows() > 0) {
                $com->state = 2; //模拟我的同意
            }
        }
        return $comment;
    }

    public function comment_submit()
    {
        if ($this->has_right(16)) {
            $data = array(
                'docid' => $this->input->post('docid'),
                'userid' => $this->user->userid,
                'comment' => $this->input->post('comment'),
                'state' => $this->has_right(17) ? 1 : 0,
            );
            $this->db->insert('comment', $data);
            echo $data['state'];
        } else {
            echo -1;
        }
    }

    public function comment_agree($commentid)
    {
        if ($this->has_right(16)) {
            if ($commentid) {
                $row = $this->db->get_where('comment_agree', array('commentid' => $commentid, 'userid' => $this->user->userid))->row();
                if ($row) {
                    $this->db->set('agree', 'agree-1', false)->where('commentid', $commentid)->update('comment');
                    $this->db->delete('comment_agree', array('cagreeid' => $row->cagreeid));
                } else {
                    $this->db->set('agree', 'agree+1', false)->where('commentid', $commentid)->update('comment');
                    $data = array(
                        'commentid' => $commentid,
                        'userid' => $this->user->userid,
                    );
                    $this->db->insert('comment_agree', $data);
                }
                $comment = $this->db->get_where('comment', array('commentid' => $commentid))->row();
                echo $comment->agree;
            }
        } else {
            echo -1;
        }
    }

    public function comment_del()
    {
        if ($this->has_right(19)) {
            $commentid = $this->input->post('commentid');
            $this->db->delete('comment', array('commentid' => $commentid));
            $this->db->delete('comment_agree', array('commentid' => $commentid, 'userid' => $this->user->userid));
        } else {
            echo -1;
        }
    }

    public function report($docid)
    {
        if ($docid) {
            if (IS_GET) {
                $data['report_item'] = $this->db->order_by('sort')->get_where('report_item', ['state' => 1])->result();
                if ($report = $this->db->select('reportid,report,extra')->get_where('report', array('docid' => $docid, 'userid' => $this->user->userid))->row()) {
                    $data['report'] = (object) array(
                        'reportid' => $report->reportid,
                        'docid' => $docid,
                        'report' => $report->report,
                        'extra' => $report->extra,
                    );
                } else {
                    $data['report'] = (object) array(
                        'reportid' => '',
                        'docid' => $docid,
                        'report' => $data['report_item'][0]->title,
                        'extra' => '',
                    );
                }
                $this->load->view($this->template . 'report.html', $data);
            } elseif (IS_POST) {
                $data = array(
                    'docid' => $docid,
                    'userid' => $this->user->userid,
                    'report' => $this->input->post('report'),
                    'extra' => $this->input->post('extra'),
                );
                if ($reportid = $this->input->post('reportid')) {
                    echo $this->db->update('report', $data, array('reportid' => $reportid));
                } else {
                    echo $this->db->insert('report', $data);
                }
            }
        }
    }

    public function report_submit($docid, $report)
    {
        if ($docid && $report && $this->user->groupid) {
            $data = array(
                'docid' => $this->input->post('docid'),
                'userid' => $this->user->userid,
                'report' => $report,
            );
            $this->db->insert('report', $data);
            echo 1;
        } else {
            echo -1;
        }
    }
}
