<?php

defined('BASEPATH') or exit('No direct script access allowed');

class Down extends Home_Controller
{

    public function __construct()
    {
        parent::__construct();
    }

    public function doc($docid)
    {
        if ($docid && ($doc = get_doc($docid)) && downfile($doc->path, 0)) {

            //自己的文档
            if ($doc->userid == $this->user->userid) {
                if (IS_GET) {
                    $this->docdown($doc);
                } else {
                    echo 3;
                }
                return;
            }
            //已下载过
            $paydue = $this->tradeset->paydue;
            if ($paydue) {
                $this->db->where('TO_DAYS(NOW()) - TO_DAYS(insertdate) <=', $paydue);
            }
            $paylog = $this->db->where_in('type', array(-40, -41, -42))->get_where('glodpot', array('userid' => $this->user->userid, 'linkid' => $doc->docid))->row();
            if ($paylog) {
                if (IS_GET) {
                    $this->docdown($doc);
                } else {
                    echo 4;
                }
                return;
            }

            //下载是否超限
            $daynum = $this->db->where_in('type', array(-40, -41, -42))->get_where('glodpot', array('userid' => $this->user->userid, 'TO_DAYS(NOW())-TO_DAYS(insertdate)' => 0))->num_rows();
            $allnum = $this->db->where_in('type', array(-40, -41, -42))->get_where('glodpot', array('userid' => $this->user->userid))->num_rows();
            //VIP没过期 且 价格在区间内
            if ($this->vgroup && strtotime($this->user->vipdate) >= time() && ($this->vgroup->docmoney==-1 || $this->vgroup->docmoney>=$doc->downpay)) {
                if (($daynum > $this->vgroup->downcount || $allnum > $this->vgroup->downcount2) && $this->ugroup->downcount != -1 && $this->vgroup->downcount != -1 && $this->vgroup->downcount2 != -1) {
                    echo -14;
                    return;
                }
            } else {
                if ($daynum > $this->ugroup->downcount && $this->ugroup->downcount != -1) {
                    echo -14;
                    return;
                }
            }

            $rate = 1;
            $type = 40;
            $dtype = -40;
            //VIP权限
            if ($this->vgroup && strtotime($this->user->vipdate) >= time()) {
                $rate = $doc->isvip ? 0 : $this->vgroup->discount2;
                $type = 41;
                $dtype = -41;
            }

            //游客是否有下载免费文档的权限
            if (!$this->has_right(11)) {
                if (!$this->user->groupid) {
                    echo -11;
                } else {
                    echo -13;
                }
                return;
            }

            $many = ($doc->downpay) * $rate;
            if ($this->user->glods >= $many) {
                $glodpotdata = array(
                    'userid' => $doc->userid,
                    'linkid' => $docid,
                    'type' => $type,
                    'glods' => $many * (1 - $this->tradeset->rate),
                );
                $this->db->insert('glodpot', $glodpotdata);

                $glodpotdata2 = array(
                    'userid' => $this->user->userid,
                    'linkid' => $docid,
                    'type' => $dtype,
                    'glods' => 0 - $many,
                );
                $this->db->insert('glodpot', $glodpotdata2);

                $this->db->set('glods', 'glods+' . $many * (1 - $this->tradeset->rate), false)->where('userid', $doc->userid)->update('user');
                $this->db->set('glods', 'glods-' . $many, false)->where('userid', $this->user->userid)->update('user');

                //邀请奖励
                if ($user = $this->db->select('userid,groupid')->get_where('user', array('iinvicode' => $this->user->finvicode))->row()) {
                    if ($group = $this->db->select('groupid,invite,invitedays')->get_where('group', array('groupid' => $user->groupid))->row()) {
                        if (strpos($group->invite, '%') > 0 && ($group->invitedays == 0 || time() - strtotime($this->user->insertdate) < $group->invitedays * 86400)) {

                            $glodpotdata = array(
                                'userid' => $user->userid,
                                'linkid' => $this->user->userid,
                                'type' => 12,
                                'glods' => $group->invite * $many / 100,
                                'invite' => $group->invite
                            );
                            $this->db->insert('glodpot', $glodpotdata);

                            $this->db->set('glods', 'glods+' . $group->invite * $many / 100, false)->where('userid',$user->userid)->update('user');
                        }
                    }
                }

                echo 1;
            } else {
                echo -1;
            }
        } else {
            echo -12;
        }
    }

    private function docdown($doc)
    {
        set_time_limit(0);
        ini_set('max_execution_time', '0');

        $log = $this->db->get_where('downlog', array('userid' => $this->user->userid, 'docid' => $doc->docid))->row();
        if ($log) {
            $this->db->set('count', 'count+1', false)->where('logid', $log->logid)->update('downlog');
        } else {
            $data = array(
                'userid' => $this->user->userid,
                'docid' => $doc->docid,
            );
            $this->db->insert('downlog', $data);
        }
        $this->db->set('downcount', 'downcount+1', false)->where('docid', $doc->docid)->update('doc'); //文档被下载次数

        header('Content-Description:File Transfer');
        header('Content-Type:application/octet-stream');
        header('Content-Transfer-Encoding:binary');
        header("Accept-Ranges: bytes");
        header('Expires:0');
        header('Cache-Control:must-revalidate');
        header('Pragma:public');
        header('Content-Length:' . $doc->size);
        header('Content-Disposition:attachment;filename=' . str_replace(',', '，', $doc->title) . '.' . $doc->exten);

        downfile($doc->path);

        flush();
        ob_flush();
    }

    public function topic($topicid)
    {
        if ($topicid && $topic = get_topic($topicid)) {

            //下载是否超限
            $daynum = $this->db->where_in('type', array(-40, -41, -42))->get_where('glodpot', array('userid' => $this->user->userid, 'TO_DAYS(NOW())-TO_DAYS(insertdate)' => 0))->num_rows();
            $allnum = $this->db->where_in('type', array(-40, -41, -42))->get_where('glodpot', array('userid' => $this->user->userid))->num_rows();
            if (($this->vgroup && strtotime($this->user->vipdate) >= time() && $this->ugroup->downcount != -1 && $this->vgroup->downcount != -1 && $this->vgroup->downcount2 != -1 && ($daynum > $this->vgroup->downcount || $allnum > $this->vgroup->downcount2)) || ($this->ugroup->downcount != -1 && $daynum > $this->ugroup->downcount)) {
                echo -14;
                return;
            }

            //自己的文档
            if ($topic->userid == $this->user->userid) {
                if (IS_GET) {
                    $this->topicdown($topic);
                } else {
                    echo 3;
                }
                return;
            }
            //已下载过
            $paydue = $this->tradeset->paydue;
            if ($paydue) {
                $this->db->where('TO_DAYS(NOW()) - TO_DAYS(insertdate) <=', $paydue);
            }
            $paylog = $this->db->where_in('type', array(-50, -51, -52))->get_where('glodpot', array('userid' => $this->user->userid, 'linkid' => $topic->topicid))->row();
            if ($paylog) {
                if (IS_GET) {
                    $this->topicdown($topic);
                } else {
                    echo 4;
                }
                return;
            }

            $rate = 1;
            $type = 50;
            $dtype = -50;
            //VIP权限
            if ($this->vgroup && strtotime($this->user->vipdate) >= time()) {
                $rate = $topic->isvip ? 0 : $this->vgroup->discount2;
                $type = 51;
                $dtype = -51;
            }

            //游客是否有下载免费专题的权限
            if (!$this->has_right(41)) {
                if (!$this->user->groupid) {
                    echo -11;
                } else {
                    echo -13;
                }
                return;
            }

            $many = $topic->downpay * $rate;
            if ($this->user->glods >= $many) {
                $glodpotdata = array(
                    'userid' => $topic->userid,
                    'linkid' => $topicid,
                    'type' => $type,
                    'glods' => $many * (1 - $this->tradeset->rate),
                );
                $this->db->insert('glodpot', $glodpotdata);

                $glodpotdata2 = array(
                    'userid' => $this->user->userid,
                    'linkid' => $topicid,
                    'type' => $dtype,
                    'glods' => 0 - $many,
                );
                $this->db->insert('glodpot', $glodpotdata2);

                $this->db->set('glods', 'glods+' . $many * (1 - $this->tradeset->rate), false)->where('userid', $topic->userid)->update('user');
                $this->db->set('glods', 'glods-' . $many, false)->where('userid', $this->user->userid)->update('user');

                //邀请奖励
                if ($user = $this->db->select('userid,groupid')->get_where('user', array('iinvicode' => $this->user->finvicode))->row()) {
                    if ($group = $this->db->select('groupid,invite,invitedays')->get_where('group', array('groupid' => $user->groupid))->row()) {
                        if (strpos($group->invite, '%') > 0 && ($group->invitedays == 0 || time() - strtotime($this->user->insertdate) < $group->invitedays * 86400)) {

                            $glodpotdata = array(
                                'userid' => $user->userid,
                                'linkid' => $this->user->userid,
                                'type' => 12,
                                'glods' => $group->invite * $many,
                                'invite' => $group->invite,
                            );
                            $this->db->insert('glodpot', $glodpotdata);
                        }
                    }
                }

                echo 1;
            } else {
                echo -1;
            }
        } else {
            echo -12;
        }
    }

    private function topicdown($topic)
    {
        $log = $this->db->get_where('topic_downlog', array('userid' => $this->user->userid, 'topicid' => $topic->topicid))->row();
        if ($log) {
            $this->db->set('count', 'count+1', false)->where('logid', $log->logid)->update('topic_downlog');
        } else {
            $data = array(
                'userid' => $this->user->userid,
                'topicid' => $topic->topicid,
            );
            $this->db->insert('topic_downlog', $data);
        }
        $this->db->set('downcount', 'downcount+1', false)->where('topicid', $topic->topicid)->update('topic'); //文档被下载次数

        $this->load->library('zip');
        $doclist = $this->db->select('docid,title,path,exten')->where_in('docid', explode(',', $topic->docs))->get('doc')->result();
        foreach ($doclist as $doc) {
            $filename = iconv("UTF-8", "GBK//IGNORE", $doc->docid . '_' . $doc->title . '.' . $doc->exten);
            if (is_file($doc->path)) {
                $this->zip->read_file($doc->path, $filename);
            } else if (($oss = $this->db->get('ossset')->row()) && $oss->state && $this->load->library('Oss/oss') && $this->oss->objectexists($doc->path)) {
                $url = $this->oss->signUrl($doc->path);
                $this->zip->add_data($filename, file_get_contents($url));
            }
        }
        if ($this->zip->file_num) {
            $this->zip->download($topic->title . '.zip');
        } else {
            echo '专题文件不存在';
        }
    }
}
