<?php

defined('BASEPATH') or exit('No direct script access allowed');

class Edit extends Home_Controller
{

    public function __construct()
    {
        parent::__construct();
        $this->right_print(14, '您没有编辑文档的权限');
    }

    public function index($docid)
    {
        if (IS_GET) {
            $data['title'] = '编辑文档 - ' . $this->site->name;
            $data['keywords'] = '编辑文档';
            $data['description'] = '编辑文档';

            if ($docid && $doc = get_docv($docid)) {
                if ($this->user->userid == $doc->userid || $this->has_right(3) || $this->has_right(4)) {
                    $data['doc'] = $doc;
                    $data['filter'] = $this->get_filter($doc->filter);
                    $data['typelink'] = get_typelink($doc->typeid);
                    $this->load->view($this->template . 'edit', $data);
                } else {
                    $data['message'] = '您只能编辑自己的文档';
                    $this->load->view($this->template . 'tip', $data);
                }
            } else {
                $data['message'] = '文件不存在';
                $this->load->view($this->template . 'tip', $data);
            }
        } elseif (IS_POST) {
            $tids = explode('-', $this->input->post('typeid'));
            if ($this->input->post('filter')) {
                $filter = implode('.', $this->input->post('filter'));
            } else {
                $filter = -1;
            }

            if (!get_magic_quotes_gpc()) {
                $title = addslashes($this->input->post('title'));
            }
            $data = array(
                'title' => $title,
                'keyword' => $this->input->post('keyword'),
                'word' => $this->input->post('word'),
                'typeid' => end($tids),
                'filter' => $filter,
                'readpay' => $this->input->post('readpay'),
                'preview' => $this->input->post('preview'),
                'downpay' => $this->input->post('downpay'),
            );
            if ($docid) {
                if ($this->db->update('doc', $data, array('docid' => $docid))) {
                    echo 1;
                } else {
                    echo 0;
                }
            } else {
                echo 0;
            }
        }
    }

    //2.3.3
    public function get_filter($filters)
    {
        if ($filters == '-1' || $filters == '0' || $filters == '0.0' || $filters == '0.0.0' || $filters == '0.0.0.0') {
            return;
        }

        //获取父类ID
        $pids = $this->db->select('id,name,pid')->order_by('sort')->where_in('id', explode('.', $filters))->get('filter')->result();
        $p = array();
        foreach ($pids as $pid) {
            $p[$pid->pid] = [$pid->id, $pid->name];
        }

        //获取所有分类,包括父类[0],子类
        $rows = $this->db->select('id,pid,name')->order_by('sort')->where_in('id', array_keys($p))->or_where_in('pid', array_keys($p))->get('filter')->result();
        $filter_array = [];
        foreach ($rows as $row) {
            $filter_array[$row->pid][] = $row;
        }

        $i = $this->docset->minfilter ? '<i>*</i>' : '';

        $filter_str = '';
        if ($filter_array) {
            foreach ($filter_array[0] as $filter) {
                $filter_str .= '<div class="doc-filter"><label>' . $i . $filter->name . '</label><div class="ui-dropdown"><div>' . $p[$filter->id][1] . '</div><ul>';
                if (isset($filter_array[$filter->id])) {
                    foreach ($filter_array[$filter->id] as $fil) {
                        $filter_str .= '<li data-val="' . $fil->id . '">' . $fil->name . '</li>';
                    }
                }
                $filter_str .= '</ul><input name="filter[]" type="hidden" value="' . $p[$filter->id][0] . '"><i></i></div></div>';
            }
        }

        return $filter_str;
    }

}
