<?php

defined('BASEPATH') or exit('No direct script access allowed');

class Home extends Home_Controller
{

    public function __construct()
    {
        parent::__construct();
    }

    public function index()
    {
        if ($this->docset->home_cache && $data = get_cache(str_replace('/', '-', $this->template) . 'home_index', $this->docset->home_cache)) {
            echo $data;
        } else {
            $data['banner'] = $this->get_banner();
            if ($this->docset->isnotice) {
                $data['notice'] = $this->get_notice();
            } else {
                $data['notice'] = [];
            }
            if ($this->docset->isarticle) {
                $data['article'] = $this->get_article();
            } else {
                $data['article'] = [];
            }
            $data['pointpot'] = $this->get_pointpot();
            $data['glodpot'] = $this->get_glodpot();
            $data['impdocs'] = $this->get_impdocs();
            $data['newdocs'] = $this->get_newdocs();
            $data['vipdocs'] = $this->get_vipdocs();
            $data['mfdocs'] = $this->get_mfdocs();
            $data['homety'] = $this->get_homety();
            $data['popudocs'] = $this->get_popudocs();
            $data['adv'] = $this->get_adv();
            $data['impuser'] = $this->get_impuser();
            $data['partner'] = $this->get_partner();
            $data['links'] = $this->get_links();
            $data['doccount'] = number_format($this->db->select('count(*) as count')->get_where('doc', array('state' => 1, 'isdel' => 0))->row()->count + $this->docset->doc_num);
            if ($this->docset->isreward) {
                $data['reward'] = $this->get_reward(1);
                $data['rewardnum'] = $this->db->select('count(*) as count')->get_where('reward_view', array('state' => 2))->row()->count;
                $data['draft'] = $this->get_draft();
            }

            $data['title'] = str_ireplace('{name}', $this->site->name, $this->seo->home_title);
            $data['keywords'] = str_ireplace('{name}', $this->site->name, $this->seo->home_keys);
            $data['description'] = str_ireplace('{name}', $this->site->name, $this->seo->home_desc);

            $cache = $this->load->view($this->template . 'home', $data, true);
            $this->docset->home_cache && put_cache(str_replace('/', '-', $this->template) . 'home_index', $cache);
            echo $cache;
        }
    }

    public function header_cache()
    {
        $this->load->view($this->template . 'header_cache');
    }

    public function reward($cpage)
    {
        echo json_encode($this->get_reward($cpage));
    }

    private function get_banner()
    {
        if ($this->iswap) {
            return $this->db->order_by('sort')->get_where('banner', array('mobile' => 1))->result();
        } else {
            return $this->db->order_by('sort')->get_where('banner', array('pc' => 1))->result();
        }
    }

    private function get_notice()
    {
        return $this->db->select('id,title,import')->order_by('id', 'desc')->limit(5)->get_where('notice', array('state' => 1))->result();
    }

    private function get_article()
    {
        return $this->db->select('articleid,title,istop,tagname')->order_by('articleid', 'desc')->limit(5)->get_where('article_view', array('state' => 1))->result();
    }

    private function get_pointpot()
    {
        return $this->db->where_in('type', array(1, 2, 3, 4, 5, 6, 7, 8))->order_by('id', 'desc')->limit(20)->get_where('point_view')->result();
    }

    private function get_glodpot()
    {
        return $this->db->where_in('type', array(10, 11, 12, 21, 30, 31, 32, 40, 41, 42, 50, 51, 52))->order_by('id', 'desc')->limit(20)->get_where('glod_doc_view')->result();
    }

    private function get_impdocs()
    {
        return $this->db->order_by('docid', 'desc')->get_where('doc', array('isimp' => 1, 'state' => 1, 'isdel' => 0))->result();
    }

    private function get_newdocs()
    {
        return $this->db->order_by('docid', 'desc')->limit(12)->get_where('doc', array('state' => 1, 'isdel' => 0))->result();
    }

    private function get_vipdocs()
    {
        return $this->db->order_by('docid', 'desc')->limit(12)->get_where('doc', array('isvip' => 1, 'state' => 1, 'isdel' => 0))->result();
    }

    private function get_mfdocs()
    {
        return $this->db->order_by('docid', 'desc')->limit(12)->get_where('doc', array('downpay' => 0, 'state' => 1, 'isdel' => 0))->result();
    }

    private function get_homety()
    {
        return $this->db->select('typeid,typename')->order_by('sort')->get_where('type', array('state' => 1))->result();
    }

    private function get_popudocs()
    {
        return $this->db->order_by('downcount', 'desc')->limit(6)->get_where('doc', array('state' => 1, 'isdel' => 0))->result();
    }

    private function get_adv()
    {
        return $this->db->order_by('sort')->get_where('advv', array('page' => 'home'))->result();
    }

    private function get_reward($cpage)
    {
        return $this->db->order_by('todate', 'desc')->limit(8, 8 * $cpage - 8)->get_where('reward_view', array('state >' => 0))->result();
    }

    private function get_draft()
    {
        return $this->db->order_by('draftid desc')->limit(10)->get_where('draft_view', array('state' => 1))->result();
    }

    private function get_impuser()
    {
        return $this->db->select('userid,nickname,vipuser,count(userid) as count,sum(readcount) as readcount,sum(downcount) as downcount')->group_by(array('userid'))->order_by('count', 'desc')->limit(6)->get_where('doc_view', array('state' => 1, 'isdel' => 0))->result();
    }

    private function get_links()
    {
        $likes = $this->db->order_by('sort')->get_where('links', array('state' => 1))->result();
        return $likes;
    }

    private function get_partner()
    {
        $likes = $this->db->order_by('sort')->get_where('partner', array('state' => 1))->result();
        return $likes;
    }
}
