<?php

defined('BASEPATH') or exit('No direct script access allowed');

class Lists extends Home_Controller
{

    public function __construct()
    {
        parent::__construct();
    }

    public function index($tid, $order, $cpage, $fi)
    {
        if ($this->docset->list_cache && $data = get_cache(str_replace('/', '-', $this->template) . implode('_', $this->uri->rsegments), $this->docset->list_cache)) {
            echo $data;
        } else {
            $psize = 10;
            $data['all_total'] = number_format($this->db->select('count(*) as count')->get_where('doc', array('state' => 1, 'isdel' => 0))->row()->count + $this->docset->doc_num);
            if ($tid == 0) { //点击全部分类
                $ctype = (object) (array('typeid' => 0, 'typename' => '全部分类', 'seotitle' => '全部分类', 'filter' => '-1'));
                $child_type = get_childtype(0);
            } else {
                $ctype = get_type($tid);
                $child_type = get_childtype($tid);
            }

            if ($ctype == null) {
                echo '404';
                exit();
            }

            if (empty($child_type)) {
                $data['parent_type'] = get_type($ctype->ptypeid);
                $data['child_type'] = get_childtype($ctype->ptypeid);
            } else {
                $data['parent_type'] = $ctype;
                $data['child_type'] = $child_type;
            }
            $data['ctype'] = $ctype;

            $data['order'] = $order;
            $isvip = 0;
            $isimp = 0;
            if ($order == 1) {
                $order = 'docid desc';
            } elseif ($order == 2) {
                $order = 'readcount desc';
            } elseif ($order == 3) {
                $order = 'downpay asc';
            } elseif ($order == 4) {
                $isvip = 1;
            } elseif ($order == 5) {
                $isimp = 1;
            }

            $rows = $this->db->select('id,pid,name')->order_by('sort')->where_in('id', explode(',', $ctype->filter))->or_where_in('pid', explode(',', $ctype->filter))->get('filter')->result();

            $fi_arr = explode('.', $fi);
            $fi_str = [];
            $filter_array = [];
            foreach ($rows as $row) {
                $filter_array[$row->pid][] = $row;
                if (in_array($row->id, $fi_arr)) {
                    $fi_str[] = $row->name;
                }
            }
            if (!$fi && $rows) {
                for ($i = 0; $i < count($filter_array[0]); $i++) {
                    $fi .= '.0';
                }
                $fi = substr($fi, 0, strrpos($fi, '.'));
            }

            $data['filter_array'] = $filter_array;
            $data['fi'] = $fi;

            $flex_docs = get_docs_bypage(null, $tid, str_replace('0.', '%.', str_replace('.0', '.%', $fi)), null, null, null, $isimp, $isvip, 0, $psize, $cpage, $order);

            $crumbs = get_ptypes($ctype->typeid);
            $crumb1 = '';
            $crumb2 = '';
            $crumb3 = '';
            if ($crumbs[0]) {
                foreach ($crumbs as $crumb) {
                    $crumb1 .= $crumb->typename . '-';
                    $crumb2 .= $crumb->typename . ',';
                    $crumb3 .= $crumb->typeid . ',';
                }
                $crumb1 = substr($crumb1, 0, -1);
                $crumb2 = substr($crumb2, 0, -1);
                $crumb3 = substr($crumb3, 0, -1);
                $data['crumbs'] = array_reverse($crumbs);
            } else {
                $crumb1 = '文档';
                $crumb2 = '文档';
                $crumb2 = '0';
            }

            $data['crumb3'] = array_reverse( explode(',', $crumb3));

            $data['docs'] = $flex_docs['data'];
            $data['tid'] = $tid;
            $data['adv'] = $this->get_adv();

            $data['psize'] = $psize;
            $data['cpage'] = $cpage;
            $data['total'] = $flex_docs['total'];

            $data['title'] = str_ireplace(['{type}', '{seotitle}', '{name}', '{filter1}', '{filter2}', '{filter3}', '{filter4}', '{filter5}'], array_merge([$crumb1, $ctype->seotitle, $this->site->name], $fi_str), $this->seo->list_title);
            $data['keywords'] = str_ireplace(['{type}', '{name}'], [$crumb2, $this->site->name], $this->seo->list_keys);
            $data['description'] = str_ireplace(['{type}', '{name}'], [$crumb1, $this->site->name], $this->seo->list_desc);

            $cache = $this->load->view($this->template . 'list', $data, true);
            $this->docset->list_cache && put_cache(str_replace('/', '-', $this->template) . implode('_', $this->uri->rsegments), $cache);
            echo $cache;
        }
    }

    private function get_adv()
    {
        return $this->db->order_by('sort')->get_where('advv', array('page' => 'list'))->result();
    }
}
