<?php

defined('BASEPATH') or exit('No direct script access allowed');

class Login extends Home_Controller
{

    public function __construct()
    {
        parent::__construct();
    }

    public function index()
    {
        $data['title'] = '用户登录 - ' . $this->site->name;
        $data['keywords'] = '用户登录';
        $data['description'] = '用户登录';

        if (IS_GET) {
            $regset = $this->db->get('regset')->row();
            $protocol = $this->db->select('title')->get_where('protocol', array('type' => 'agree'))->row();
            if ($regset && $protocol) {
                $data['regset'] = $regset;
                $data['protitle'] = $protocol->title;

                if ($this->loginset->ali) {
                    $aliloginset = $this->db->get('aliloginset')->row();
                    $data['aliloginset'] = $aliloginset;
                    $data['alilogin'] = $this->site->host . '/alilogin.html';
                    $data['alilogin_state'] = $rand = random(6);
                    $_SESSION['alilogin_state'] = $data['alilogin_state'];
                }
                if ($this->loginset->wei) {
                    $weiloginset = $this->db->get('weiloginset')->row();
                    $data['weiloginset'] = $weiloginset;
                    $data['weilogin'] = $this->site->host . '/weilogin.html';
                    $data['weilogin_state'] = $rand = random(6);
                    $_SESSION['weilogin_state'] = $data['weilogin_state'];
                }

                $this->load->view($this->template . 'login', $data);
            } else {
                $data['message'] = '数据表loginset|regset|protocol数据为空';
                $this->load->view($this->template . 'tip', $data);
            }
        } else {
            $username = $this->input->post('username');
            $password = $this->input->post('password');
            $remember = $this->input->post('remember');

            $user = get_user($username, md5($password));
            if ($user && $password) {
                if ($user->state) {
                    $_SESSION['userid'] = $user->userid;
                    if ($remember) {
                        $this->input->set_cookie('id', $username, 3600 * 24 * 30);
                        $this->input->set_cookie('in', md5($password), 3600 * 24 * 30);
                    } else {
                        $this->input->set_cookie('id', $username, 3600 * 24 * 1);
                        $this->input->set_cookie('in', md5($password), 3600 * 24 * 1);
                    }

                    $data = array(
                        'loginip' => getip(),
                        'logindate' => date('Y-m-d H:i:s'),
                    );
                    $this->db->update('user', $data, array('userid' => $user->userid));
                    echo 1;
                } else {
                    echo '用户名被禁止登录';
                }
            } else if ($this->loginset->dz) {
                $this->dzlogin($username, $password, $remember);
            } else {
                echo '用户名或密码错误';
            }
        }
    }

    public function login_f()
    {
        $data['title'] = '用户登录 - ' . $this->site->name;
        $data['keywords'] = '用户登录';
        $data['description'] = '用户登录';

        $regset = $this->db->get('regset')->row();
        $protocol = $this->db->select('title')->get_where('protocol', array('type' => 'agree'))->row();
        if ($regset && $protocol) {
            $data['regset'] = $regset;
            $data['protitle'] = $protocol->title;

            if ($this->loginset->ali) {
                $aliloginset = $this->db->get('aliloginset')->row();
                $data['aliloginset'] = $aliloginset;
                $data['alilogin'] = $this->site->host . '/alilogin.html';
                $data['alilogin_state'] = $rand = random(6);
                $_SESSION['alilogin_state'] = $data['alilogin_state'];
            }
            if ($this->loginset->wei) {
                $weiloginset = $this->db->get('weiloginset')->row();
                $data['weiloginset'] = $weiloginset;
                $data['weilogin'] = $this->site->host . '/weilogin.html';
                $data['weilogin_state'] = $rand = random(6);
                $_SESSION['weilogin_state'] = $data['weilogin_state'];
            }

            $this->load->view($this->template . 'login_f', $data);
        } else {
            $data['message'] = '数据表loginset|regset|protocol数据为空';
            $this->load->view($this->template . 'tip', $data);
        }
    }

    public function protocol()
    {
        if ($protocol = $this->db->get_where('protocol', array('type' => 'agree'))->row()) {
            echo $protocol->content;
        } else {
            echo '暂无协议';
        }
    }

    public function register()
    {
        $username = $this->input->post('username');
        $password = $this->input->post('password');
        $finvicode = $this->input->post('finvicode');
        $yzm = $this->input->post('yzm');
        $agree = $this->input->post('agree');

        $regset = $this->db->get('regset')->row();
        if ($regset) {
            $groupid = $regset->groupid;
            $vgroupid = $regset->vgroupid;
            $vgroupdays = $regset->vgroupdays;
        } else {
            echo '数据库错误，请联系管理员';
            return;
        }

        if (!$agree) {
            echo '您需要同意用户协议，才能注册';
            return;
        }
        if (!isset($_SESSION['yzm']) || $yzm != $_SESSION['yzm']) {
            echo '验证码错误';
            return;
        }
        if ($this->user_exists($username)) {
            echo '用户名已存在';
            return;
        }

        $rand = random(6);
        $row = $this->db->get_where('user', array('iinvicode' => $rand));
        while ($row->num_rows() > 0) {
            $rand = random(6);
            $row = $this->db->get_where('user', array('iinvicode' => $rand));
        }

        $points = get_points(1);
        $data = array(
            'username' => $username,
            'password' => md5($password),
            'phone' => preg_match('/^1[3456789]{1}\d{9}$/', $username) ? $username : '',
            'nickname' => preg_match('/^1[3456789]{1}\d{9}$/', $username) ? substr($username, 0, 3) . '*' . substr($username, -3, 3) : substr(substr($username, 0, strrpos($username, '@')), 0, 3) . '*' . substr(substr($username, 0, strrpos($username, '@')), -3, 3),
            'groupid' => $groupid,
            'vgroupid' => $vgroupid,
            'vipdate' => $vgroupid && $vgroupdays ? date('Y-m-d H:i:s', strtotime("+$vgroupdays day")) : null,
            'points' => $points ? $points->points : 0,
            'finvicode' => $finvicode,
            'iinvicode' => $rand,
            'regip' => getip(),
            'regdate' => date('Y-m-d H:i:s'),
        );

        if ($this->db->insert('user', $data)) {
            $userid = $this->db->insert_id();
            $_SESSION['userid'] = $userid;
            $this->input->set_cookie('id', $username, 3600 * 24 * 1);
            $this->input->set_cookie('in', md5($password), 3600 * 24 * 1);

            //用户注册
            if ($points) {
                $potdata = array(
                    'type' => 1,
                    'userid' => $userid,
                    'points' => $data['points'],
                    'docid' => 0,
                    'ip' => $data['regip'],
                );
                $this->db->insert('pointpot', $potdata);
            }

            //注册推广
            if (isset($_SESSION['from']) && ($from = $_SESSION['from'])) {
                pointpot(8, $from, '0', $data['regip']);

                $iinvicode = $this->db->select('iinvicode')->get_where('user', array('userid' => $from))->row()->iinvicode;
                $this->db->set('finvicode', $iinvicode, true)->where('userid', $userid)->update('user');
            }

            if ($finvicode && $user = $this->db->select('userid,groupid')->get_where('user', array('iinvicode' => $finvicode))->row()) {
                if ($group = $this->db->select('groupid,invite,invitedays')->get_where('group', array('groupid' => $user->groupid))->row()) {
                    if (strpos($group->invite, '%') === false && $group->invite > 0) {

                        $glodpotdata = array(
                            'userid' => $user->userid,
                            'linkid' => $this->user->userid,
                            'type' => 11,
                            'glods' => $group->invite,
                            'invite' => $group->invite,
                        );
                        $this->db->insert('glodpot', $glodpotdata);
                        $this->db->set('glods', 'glods+' . $$glodpotdata->glods, false)->where('userid', $user->userid)->update('user');
                    }
                }
            }

            echo 1;
        } else {
            echo '数据库错误';
        }
    }

    public function logout()
    {
        unset($_SESSION['userid']);
        $this->input->set_cookie('id', '', 0 - 3600 * 24 * 7);
        $this->input->set_cookie('in', '', 0 - 3600 * 24 * 7);

        if (strpos($this->input->server('HTTP_REFERER'), '/admin') !== false) {
            header('Location: /login.html?logout');
        } else if (substr(strrchr($this->input->server('HTTP_REFERER'), '/'), 1) == 'menu.html') {
            header('Location: /login.html?logout');
        } else if ($this->input->server('HTTP_REFERER')) {
            header('Location:' . $this->input->server('HTTP_REFERER') . '?logout');
        } else {
            echo 1;
        }

    }

    private function user_exists($username)
    {
        $user = $this->db->get_where('user', array('username' => $username))->row();
        if ($user) {
            return $user;
        } else {
            return 0;
        }
    }
    private function user_exists_qq($username)
    {
        $user = $this->db->get_where('user', array('openqq' => $username))->row();
        if ($user) {
            return $user;
        } else {
            return 0;
        }
    }
    private function user_exists_wx($username)
    {
        $user = $this->db->get_where('user', array('openwx' => $username))->row();
        if ($user) {
            return $user;
        } else {
            return 0;
        }
    }

    private function user_exists_ali($username)
    {
        $user = $this->db->get_where('user', array('openali' => $username))->row();
        if ($user) {
            return $user;
        } else {
            return 0;
        }
    }

    public function uclient()
    {
        $this->load->library('Uclient/Uclient');
        $this->uclient->connect();
    }

    public function qcback()
    {
        $data['title'] = 'QQ回调 - ' . $this->site->name;
        $data['keywords'] = 'QQ回调';
        $data['description'] = 'QQ回调';

        $this->load->view($this->template . 'qcback', $data);
    }

    //pc端生成二维码
    public function applogin_ewm()
    {
        require_once 'app/libraries/Weipay/pay/phpqrcode/phpqrcode.php';
        $sid = session_id();
        $url = "{$this->site->host}/applogin.html?sid=$sid";
        QRcode::png($url);
    }

    //pc端检测是否app搜码
    public function applogin_pc()
    {
        $sid = session_id();
        $session_id = @file_get_contents('data/session/app_' . $sid);
        if ($session_id) {
            session_destroy();
            session_id($session_id);
            Session_start();
            unlink('data/session/app_' . $sid);
            echo 1;
        }
    }

    //app扫码
    public function applogin()
    {
        $sid = $this->input->get('sid');
        file_put_contents('data/session/app_' . $sid, session_id());
        echo 1;
    }

    public function dzlogin($username, $password, $remember)
    {
        $this->load->library('Uclient/Uclient');
        $dzuser = $this->uclient->login($username, $password);

        $uid = $dzuser['uid'];
        $suffix = $dzuser['suffix'];
        $photo = $dzuser['photo'];

        $nickname = $username;
        $username = $username . $suffix;
        $sex = '';
        $address = '';

        if ($uid > 0) {
            echo $this->register2($username, '', $nickname, $photo, $sex, $address, 6);
        } else {
            echo '用户名或密码错误';
        }
    }

    public function qqlogin()
    {
        $username = $this->input->post('openId');
        //$password = $this->input->post('accessToken');
        $nickname = $this->input->post('nickname');
        $photo = $this->input->post('photo');
        $sex = $this->input->post('sex');
        $address = $this->input->post('address');

        echo $this->register2($username, '', $nickname, $photo, $sex, $address, 3);
    }

    public function alilogin()
    {
        $scope = $this->input->get('scope');
        $auth_code = $this->input->get('auth_code');
        $state = $this->input->get('state');

        if ($scope == 'auth_user' && $auth_code && $state == $_SESSION['alilogin_state']) {

            require_once 'app/libraries/Alipay/AopSdk.php';
            $aliloginset = $this->db->get('aliloginset')->row();

            $aop = new AopClient();
            $aop->gatewayUrl = "https://openapi.alipay.com/gateway.do";
            $aop->appId = $aliloginset->app_id;
            $aop->rsaPrivateKey = $aliloginset->private_key;
            $aop->alipayrsaPublicKey = $aliloginset->public_key;
            $aop->apiVersion = '1.0';
            $aop->signType = $aliloginset->sign_type;
            $aop->postCharset = "UTF-8";
            $aop->format = 'json';
            $request = new AlipaySystemOauthTokenRequest();
            $request->setGrantType("authorization_code");
            $request->setCode($auth_code);
            $result = $aop->execute($request);

            if (isset($result->alipay_system_oauth_token_response)) {
                $userinfo = new AlipayUserInfoShareRequest();
                $access_token = $result->alipay_system_oauth_token_response->access_token;
                $result = $aop->execute($userinfo, $access_token);

                if ($result && isset($result->alipay_user_info_share_response) && $result->alipay_user_info_share_response->code == 10000) {
                    $username = 'ali-' . $result->alipay_user_info_share_response->user_id;
                    $nickname = $result->alipay_user_info_share_response->nick_name;
                    $photo = $result->alipay_user_info_share_response->avatar;
                    $sex = $result->alipay_user_info_share_response->gender == 'm' ? '男' : '女';
                    $address = $result->alipay_user_info_share_response->province . $result->alipay_user_info_share_response->city;

                    $rtn = $this->register2($username, '', $nickname, $photo, $sex, $address, 5);
                    if ($rtn == '1') {
                        header('Location: /');
                    } else {
                        echo $rtn;
                    }
                }
            } else if (isset($result->error_response)) {
                echo $result->error_response->sub_msg;
            }
        }
    }

    public function weilogin()
    {
        $code = $this->input->get('code');
        $state = $this->input->get('state');

        if ($code && $state == $_SESSION['weilogin_state']) {
            $weiloginset = $this->db->get('weiloginset')->row();
            $token_url = "https://api.weixin.qq.com/sns/oauth2/access_token?appid=$weiloginset->AppID&secret=$weiloginset->AppSecret&code=$code&grant_type=authorization_code";
            $result = json_decode(gethttp($token_url));

            if (isset($result->access_token) && isset($result->openid)) {
                $user_url = "https://api.weixin.qq.com/sns/userinfo?access_token=$result->access_token&openid=$result->openid";
                $result = json_decode(gethttp($user_url));

                if ($result && isset($result->openid)) {
                    $username = 'wei-' . $result->openid;
                    $nickname = $result->nickname;
                    $photo = $result->headimgurl;
                    $sex = $result->sex == 1 ? '男' : '女';
                    $address = $result->province . $result->city;

                    $rtn = $this->register2($username, '', $nickname, $photo, $sex, $address, 4);
                    if ($rtn == '1') {
                        header('Location: /');
                    } else {
                        echo $rtn;
                    }
                } else if (isset($result->errmsg)) {
                    echo $result->errmsg;
                }
            } else if (isset($result->errcode)) {
                echo $result->errmsg;
            }
        }
    }

    public function gzh()
    {
        $gzhloginset = $this->db->get('gzhloginset')->row();
        $_SESSION['gzhlogin_state'] = $state = random(6);
        $url = "https://open.weixin.qq.com/connect/oauth2/authorize?appid=$gzhloginset->AppID&redirect_uri={$this->site->host}/gzhlogin.html&response_type=code&scope=snsapi_userinfo&state=$state#wechat_redirect";
        header('Location:' . $url);
    }

    public function gzh_pc()
    {
        $gzhloginset = $this->db->get('gzhloginset')->row();
        require_once 'app/libraries/Weipay/pay/phpqrcode/phpqrcode.php';
        $state = session_id();
        $url = "https://open.weixin.qq.com/connect/oauth2/authorize?appid=$gzhloginset->AppID&redirect_uri={$this->site->host}/gzhlogin.html&response_type=code&scope=snsapi_userinfo&state=$state#wechat_redirect";
        QRcode::png($url);
    }

    public function gzh_pcin()
    {
        echo $_SESSION['userid'] > 0;
    }

    public function login_gzh()
    {
        $data['title'] = '用户登录 - ' . $this->site->name;
        $data['keywords'] = '用户登录';
        $data['description'] = '用户登录';

        $this->load->view($this->template . 'login_gzh', $data);
    }

    //公众号
    public function gzhlogin()
    {
        $code = $this->input->get('code');
        $state = $this->input->get('state');
        if (strlen($state) > 6) {
            session_destroy();
            session_id($state);
            Session_start();
            $state = 'pc';
        }

        if ($code && ($state == 'pc' || $state == $_SESSION['gzhlogin_state'])) {
            $gzhloginset = $this->db->get('gzhloginset')->row();
            $token_url = "https://api.weixin.qq.com/sns/oauth2/access_token?appid=$gzhloginset->AppID&secret=$gzhloginset->AppSecret&code=$code&grant_type=authorization_code";
            $result = json_decode(gethttp($token_url));

            if (isset($result->access_token) && isset($result->openid)) {
                $user_url = "https://api.weixin.qq.com/sns/userinfo?access_token=$result->access_token&openid=$result->openid&lang=zh_CN";
                $result = json_decode(gethttp($user_url));

                if ($result && isset($result->openid)) {
                    $username = 'wei-' . (isset($result->unionid) ? $result->unionid : $result->openid);
                    $nickname = $result->nickname;
                    $photo = $result->headimgurl;
                    $sex = $result->sex == 1 ? '男' : ($result->sex == 2 ? '女' : '');
                    $address = $result->province . $result->city;

                    $rtn = $this->register2($username, '', $nickname, $photo, $sex, $address, 4);
                    if ($rtn == '1') {
                        $state == 'pc' ? $this->login_gzh() : header('Location: /');
                    } else {
                        echo $rtn;
                    }
                } else if (isset($result->errmsg)) {
                    echo $result->errmsg;
                }
            } else if (isset($result->errcode)) {
                echo $result->errmsg;
            }
        }
    }

    private function register2($username, $password, $nickname, $photo, $sex, $address, $regfrom)
    {
        $regset = $this->db->get('regset')->row();
        if ($regset) {
            $groupid = $regset->groupid;
            $vgroupid = $regset->vgroupid;
            $vgroupdays = $regset->vgroupdays;
        } else {
            return '数据库错误，请联系管理员';
        }

        if (($regfrom == 3 && $user = $this->user_exists_qq($username)) || ($regfrom == 4 && $user = $this->user_exists_wx($username)) || ($regfrom == 5 && $user = $this->user_exists_ali($username))) {
            if ($user->state) {
                $_SESSION['userid'] = $user->userid;
                $data = array(
                    'nickname' => substr($nickname, 0, 3) . '*' . substr($nickname, -3, 3),
                    'photo' => $photo,
                    'sex' => $sex,
                    'address' => $address,
                    'loginip' => getip(),
                    'logindate' => date('Y-m-d H:i:s'),
                );
                $this->db->update('user', $data, array('userid' => $user->userid));
                $this->input->set_cookie('id', $username, 3600 * 24 * 1);
                $this->input->set_cookie('in', md5($password), 3600 * 24 * 1);
                return 1;
            } else {
                return '用户名被禁止登录';
            }
        } else {
            $rand = random(6);
            $row = $this->db->get_where('user', array('iinvicode' => $rand));
            while ($row->num_rows() > 0) {
                $rand = random(6);
                $row = $this->db->get_where('user', array('iinvicode' => $rand));
            }

            $points = get_points(1);
            $data = array(
                'username' => $nickname,
                'password' => md5($password),
                'nickname' => substr($nickname, 0, 3) . '*' . substr($nickname, -3, 3),
                'photo' => $photo,
                'sex' => $sex,
                'address' => $address,
                'groupid' => $groupid,
                'vgroupid' => $vgroupid,
                'vipdate' => $vgroupid && $vgroupdays ? date('Y-m-d H:i:s', strtotime("+$vgroupdays day")) : null,
                'points' => $points ? $points->points : 0,
                'finvicode' => '',
                'iinvicode' => $rand,
                'regfrom' => $regfrom,
                'openqq' => $regfrom == 3 ? $username : '',
                'openwx' => $regfrom == 4 ? $username : '',
                'openali' => $regfrom == 5 ? $username : '',
                'regip' => getip(),
                'regdate' => date('Y-m-d H:i:s'),
            );

            if ($this->db->insert('user', $data)) {
                $userid = $this->db->insert_id();
                $_SESSION['userid'] = $userid;
                $this->input->set_cookie('id', $username, 3600 * 24 * 1);
                $this->input->set_cookie('in', md5($password), 3600 * 24 * 1);

                //用户注册
                if ($points) {
                    $potdata = array(
                        'type' => 1,
                        'userid' => $userid,
                        'points' => $data['points'],
                        'docid' => 0,
                        'ip' => $data['regip'],
                    );
                    $this->db->insert('pointpot', $potdata);
                }

                //注册推广
                if (isset($_SESSION['from']) && ($from = $_SESSION['from'])) {
                    pointpot(8, $from, '0', $data['regip']);
                    $iinvicode = $this->db->select('iinvicode')->get_where('user', array('userid' => $from))->row()->iinvicode;
                    $this->db->set('finvicode', $iinvicode, true)->where('userid', $userid)->update('user');
                }
                return 1;
            } else {
                return '数据库错误';
            }
        }
    }
}
