<?php

defined('BASEPATH') or exit('No direct script access allowed');

class Notice extends Home_Controller
{

    public function __construct()
    {
        parent::__construct();
    }

    public function index($id)
    {
        $notice = $this->get_notice($id);
        if ($notice) {

            $data['notice'] = $notice; 
            $data['title'] = str_ireplace(['{title}', '{time}', '{name}'], [$notice->title, $notice->pubdate, $this->site->name], $this->seo->notice_title);
            $data['keywords'] = str_ireplace(['{title}', '{time}', '{name}'], [$notice->title, $notice->pubdate, $this->site->name], $this->seo->notice_keys);
            $data['description'] = str_ireplace(['{title}', '{time}', '{name}'], [$notice->title, $notice->pubdate, $this->site->name], $this->seo->notice_desc);

            $this->load->view($this->template . 'notice', $data);
        } else {
            $data['message'] = '暂时没有发布这个公告';
            $data['title'] = '没有这个公告 - ' . $this->site->name;
            $data['keywords'] = '没有这个公告';
            $data['description'] = '暂时没有发布这个公告';

            $this->load->view($this->template . 'tip', $data);
        }
    }

    private function get_notice($id)
    {
        return $this->db->get_where('notice', array('state' => 1, 'id' => $id))->row();
    }

}
