<?php

defined('BASEPATH') or exit('No direct script access allowed');

class Reward extends Home_Controller
{

    public function __construct()
    {
        parent::__construct();
    }

    //2018.06.13
    //根据分页信息获取悬赏列表  reward/list-1-1-1-1.html  时间-状态-排序-页数
    //时间 0：全部 1：今天 3：天内 7：天内
    //状态 0：全部 1：未定稿 2：已定稿 3：失败
    //排序 1,2：发布时间  3,4：截至时间 5,6：价格 7,8：稿件数
    public function index($pubday, $state, $order, $cpage, $key)
    {
        $this->right_print(50);

        $key = urldecode(urldecode($key));

        $psize = 10;

        if ($key) {
            $keys = explode(' ', $key);
            $where = '(';
            foreach ($keys as $k) {
                $where .= "(title like '%$k%' or word like '%$k%' or keyword like '%$k%') or ";
            }
            $where = substr($where, 0, -4);
            $where .= ')';
            $this->db->where($where);
        }

        if ($pubday == 1) {
            $this->db->where('date(pubdate)', date('Y-m-d'));
        } elseif ($pubday == 2) {
            $this->db->where('date(pubdate)', date('Y-m-d', strtotime('-1 day')));
        } elseif ($pubday == 3) {
            $this->db->where('pubdate >', date('Y-m-d', strtotime('-3 day')));
        } elseif ($pubday == 7) {
            $this->db->where('pubdate >', date('Y-m-d', strtotime('-7 day')));
        }

        if ($state == 0) {
            $this->db->where('state >', 0);
        } else {
            $this->db->where('state', $state);
        }

        $this->db->order_by('istoping desc');

        if ($order == 1) {
            $this->db->order_by('pubdate desc');
        } elseif ($order == 2) {
            $this->db->order_by('todate desc');
        } elseif ($order == 3) {
            $this->db->order_by('price desc');
        } elseif ($order == 4) {
            $this->db->order_by('draftnum desc');
        }

        $total = $this->db->count_all_results('reward_view', false);

        $rewards = $this->db->limit($psize, ($psize * $cpage - $psize))->get()->result();
        foreach ($rewards as $reward) {
            $reward->pubdate = date('Y-m-d', strtotime($reward->pubdate));
            //$reward->draftnum = $this->db->select('count(*) as count')->get_where('draft', array('state >=' => 0, 'reid' => $reward->reid))->row()->count;
            if ($reward->state == 1) {
                $seconds = strtotime($reward->todate) - strtotime(date('Y-m-d H:i:s'));
                if ($seconds > 86400) {
                    $reward->sshow = intval($seconds / 86400) . ' 天后 截止';
                } elseif ($seconds > 3600) {
                    $reward->sshow = intval($seconds / 3600) . ' 小时后 截止';
                } elseif ($seconds > 60) {
                    $reward->sshow = intval($seconds / 60) . ' 分钟后 截止';
                } elseif ($seconds > 0) {
                    $reward->sshow = $seconds . ' 秒后 截止';
                } elseif ($seconds > -86400) {
                    $reward->sshow = ceil($seconds / 3600 + 24) . ' 小时内 审稿完成';
                } else {
                    if ($reward->draftnum > 0) {
                        $this->db->set('state', 2, false)->where('reid', $reward->reid)->update('reward');
                        $reward->sshow = '已定稿';
                    } else {
                        $this->db->set('state', 3, false)->where('reid', $reward->reid)->update('reward');
                        $reward->sshow = '悬赏失败';
                    }
                }
            } elseif ($reward->state == 2) {
                $reward->sshow = '已定稿';
            } else {
                $reward->sshow = '悬赏失败';
            }
        }

        $topuser = $this->db->select('userid,nickname,count(*) count')->group_by('userid')->order_by('count desc')->limit(5)->get_where('reward_view', array('state >' => 1))->result();

        $data['rewards'] = $rewards;
        $data['topuser'] = $topuser;

        $data['psize'] = $psize;
        $data['cpage'] = $cpage;
        $data['total'] = $total;

        $data['pubday'] = $pubday;
        $data['state'] = $state;
        $data['order'] = $order;
        $data['key'] = $key;

        $state = $state == 0 ? "全部" : ($state == 1 ? "未定稿" : ($state == 2 ? "已定稿" : "失败"));

        $data['title'] = str_ireplace(['{state}', '{name}'], [$state, $this->site->name], $this->seo->rewl_title);
        $data['keywords'] = str_ireplace(['{state}', '{name}'], [$state, $this->site->name], $this->seo->rewl_keys);
        $data['description'] = str_ireplace(['{state}', '{name}'], [$state, $this->site->name], $this->seo->rewl_desc);

        $this->load->view($this->template . 'reward', $data);
    }

    public function view($reid, $cpage)
    {
        $this->right_print(50);

        if ($reid && $reward = $this->db->get_where('reward_view', array('state >' => 0, 'reid' => $reid))->row()) {

            $this->db->set('readnum', 'readnum+1', false)->where('reid', $reid)->update('reward');

            $reward->pubdate = date('Y-m-d', strtotime($reward->pubdate));
            if ($reward->state == 1) {
                $seconds = strtotime($reward->todate) - strtotime(date('Y-m-d H:i:s'));
                if ($seconds > 86400) {
                    $reward->sshow = intval($seconds / 86400) . ' 天后 截止';
                } elseif ($seconds > 3600) {
                    $reward->sshow = intval($seconds / 3600) . ' 小时后 截止';
                } elseif ($seconds > 60) {
                    $reward->sshow = intval($seconds / 60) . ' 分钟后 截止';
                } elseif ($seconds > 0) {
                    $reward->sshow = $seconds . ' 秒后 截止';
                } elseif ($seconds > -86400) {
                    $reward->sshow = ceil($seconds / 3600 + 24) . ' 小时内 审稿完成';
                } else {
                    if ($draft = $this->db->order_by('draftid desc')->get_where('draft', array('state' => 0, 'reid' => $reid))->row()) {
                        $this->db->set('state', 1, false)->where('draftid', $draft->draftid)->update('draft');
                        $this->db->set('state', 2, false)->where('reid', $draft->reid)->update('reward');

                        //悬赏积分
                        $this->db->set('glods', 'glods+' . $reward->price, false)->where('userid', $draft->userid)->update('user');
                        $potdata = array(
                            'userid' => $draft->userid,
                            'linkid' => $draft->reid,
                            'type' => 21,
                            'glods' => $reward->price,
                        );
                        $this->db->insert('glodpot', $potdata);

                        $reward->sshow = '已定稿';
                    } else {
                        $this->db->set('state', 3, false)->where('reid', $reward->reid)->update('reward');
                        $reward->sshow = '悬赏失败';
                    }
                }
            } elseif ($reward->state == 2) {
                $reward->sshow = '已定稿';
            } else {
                $reward->sshow = '悬赏失败';
            }

            $data['fav_state'] = $this->get_favstate($reid);

            $psize = 10;
            $this->db->where(array('state >=' => 0, 'reid' => $reid));
            $this->db->order_by('state desc,draftid desc');
            $total = $this->db->count_all_results('draft_view', false);
            $drafts = $this->db->limit($psize, ($psize * $cpage - $psize))->get()->result();
            foreach ($drafts as $draft) {
                $draft->docs = $this->db->select('docid,title,exten')->get_where('doc', array('draftid' => $draft->draftid, 'state' => 1, 'isdel' => 0))->result();
                $draft->draftnum = $this->db->select('count(*) as count')->get_where('draft', array('state >=' => 0, 'userid' => $draft->userid))->row()->count;
                $draft->draftnum1 = $this->db->select('count(*) as count')->get_where('draft', array('state' => 1, 'userid' => $draft->userid))->row()->count;
            }

            $topuser = $this->db->select('userid,nickname')->select_sum('price')->group_by('userid')->order_by('price desc')->limit(5)->get_where('draft_view', array('state' => 1))->result();

            $data['reward'] = $reward;
            $data['drafts'] = $drafts;
            $data['topuser'] = $topuser;

            $data['psize'] = $psize;
            $data['cpage'] = $cpage;
            $data['total'] = $total;

            $data['title'] = str_ireplace(['{title}', '{state}', '{name}'], [$reward->title, $reward->sshow, $this->site->name], $this->seo->reward_title);
            $data['keywords'] = str_ireplace(['{keys}', '{state}', '{name}'], [$reward->keyword, $reward->sshow, $this->site->name], $this->seo->reward_keys);
            $data['description'] = str_ireplace(['{word}', '{state}', '{name}'], [$reward->word, $reward->sshow, $this->site->name], $this->seo->reward_desc);

            $this->load->view($this->template . 'reward_view', $data);
        } else {
            $data['message'] = '悬赏任务不存在或未审核';
            $data['title'] = '悬赏任务不存在 - ' . $this->site->name;
            $data['keywords'] = '悬赏任务不存在';
            $data['description'] = '悬赏任务不存在或未审核';

            $this->load->view($this->template . 'tip', $data);
        }
    }

    public function publish()
    {
        $data['title'] = '发布悬赏 - ' . $this->site->name;
        $data['keywords'] = '发布悬赏';
        $data['description'] = '发布悬赏';

        $this->right_print(52, '您没有发布悬赏的权限');

        if (IS_GET) {
            $this->load->view($this->template . 'reward_pub', $data);
        } else {
            $data = array(
                'userid' => $this->user->userid,
                'title' => $this->input->post('title'),
                'keyword' => $this->input->post('keyword'),
                'word' => $this->input->post('word'),
                'price' => $this->input->post('price'),
                'pubdate' => date('Y-m-d H:i:s'),
                'todate' => date('Y-m-d H:i:s', strtotime('+' . $this->input->post('days') . ' day')),
                'istop' => $this->input->post('istop'),
                'topprice' => $this->input->post('istop') == '1' ? $this->input->post('days') * $this->tradeset->rewardtop : 0,
                'state' => $this->has_right(53) ? 1 : 0,
            );

            $topay = $data['price'] + $data['topprice'];

            if ($this->user->glods >= $topay) {
                $this->db->insert('reward', $data);
                $reid = $this->db->insert_id();
                $potdata = array(
                    'userid' => $this->user->userid,
                    'linkid' => $reid,
                    'type' => -21,
                    'glods' => 0 - $topay,
                );
                $this->db->insert('glodpot', $potdata);
                $this->db->set('glods', 'glods-' . $topay, false)->where('userid', $this->user->userid)->update('user');
                echo 1;
            } else {
                echo -1; //积分不足
            }
        }
    }

    public function dodraft($draftid)
    {
        $this->right_print(56);
        if ($draftid && $draft = $this->db->get_where('draft', array('state' => 0, 'draftid' => $draftid))->row()) {

            if ($reward = $this->db->get_where('reward', array('state' => 1, 'reid' => $draft->reid, 'userid' => $this->user->userid))->row()) {

                $this->db->set('state', 1, false)->where('draftid', $draftid)->update('draft');
                $this->db->set('state', 2, false)->where('reid', $draft->reid)->update('reward');

                //悬赏积分
                $this->db->set('glods', 'glods+' . $reward->price, false)->where('userid', $draft->userid)->update('user');
                $potdata = array(
                    'userid' => $draft->userid,
                    'linkid' => $draft->reid,
                    'type' => 21,
                    'glods' => $reward->price,
                );
                $this->db->insert('glodpot', $potdata);

                echo 1;
            } else {
                echo '-1'; //已中标或不是自己的任务
            }
        }
    }

    private function get_favstate($reid)
    {
        if ($this->user->groupid && $this->db->select('favid')->get_where('reward_favorite', array('userid' => $this->user->userid, 'reid' => $reid))->row()) {
            return 1;
        } else {
            return 0;
        }
    }

    public function favorite($reid)
    {
        if (!$this->user->groupid) {
            echo -1;
            return;
        }
        if ($reid) {
            $row = $this->db->select('favid')->get_where('reward_favorite', array('userid' => $this->user->userid, 'reid' => $reid))->row();
            if ($row) {
                $this->db->delete('reward_favorite', array('favid' => $row->favid));
            } else {
                $data = array(
                    'userid' => $this->user->userid,
                    'reid' => $reid,
                );
                $this->db->insert('reward_favorite', $data);
            }
        }
        echo 1;
    }

    public function glods()
    {
        if ($this->has_right(52)) {
            echo $this->user->glods;
        } else {
            echo -1;
        }
    }

}
