<?php

defined('BASEPATH') or exit('No direct script access allowed');

class Search extends Home_Controller
{

    public function __construct()
    {
        parent::__construct();
    }

    public function index($exten, $cpage, $key)
    {
        $psize = 10;

        $key = urldecode(urldecode($key));
        $data['exten'] = $exten;
        $data['psize'] = $psize;
        $data['cpage'] = $cpage;
        $data['key'] = $key;

        if ($exten == 1) {
            $exten = null;
        } elseif ($exten == 2) {
            $exten = 'doc';
        } elseif ($exten == 3) {
            $exten = 'ppt';
        } elseif ($exten == 4) {
            $exten = 'xls';
        } elseif ($exten == 5) {
            $exten = 'pdf';
        } elseif ($exten == 6) {
            $exten = 'txt';
        }

        $flex_docs = get_docs_bypage(null, null, null, $key, 1, $exten, null, null, 0, $psize, $cpage, 'docid desc');

        $data['docs'] = $flex_docs['data'];
        $data['total'] = $flex_docs['total'];

        $data['adv'] = $this->get_adv();

        if ($exten == null) {
            $exten = "全部";
        }

        $data['title'] = str_ireplace(['{keys}', '{type}', '{name}'], [$key, $exten, $this->site->name], $this->seo->search_title);
        $data['keywords'] = str_ireplace(['{keys}', '{type}', '{name}'], [$key, $exten, $this->site->name], $this->seo->search_keys);
        $data['description'] = str_ireplace(['{keys}', '{type}', '{name}'], [$key, $exten, $this->site->name], $this->seo->search_desc);

        $this->load->view($this->template . 'search', $data);
    }

    private function get_adv()
    {
        return $this->db->order_by('sort')->get_where('advv', array('page' => 'search'))->result();
    }

}
