<?php

defined('BASEPATH') or exit('No direct script access allowed');

class Topic extends Home_Controller
{

    public function __construct()
    {
        parent::__construct();
    }

    public function index($tid, $cpage, $key)
    {
        $this->right_print(40);

        $psize = 9;

        if ($tid) {
            $type = $this->db->get_where('topic_type', array('typeid' => $tid))->row();
            $this->db->where(array('typeid' => $tid));
        } else {
            $type = (object) (array('typeid' => 0, 'typename' => '全部', 'seotitle' => '全部'));
        }

        $key = urldecode(urldecode($key));
        $data['key'] = $key;
        if ($key) {
            $keywords = explode(',', fenci($key));
            $where1 = '(';
            foreach ($keywords as $k) {
                $where1 .= "SIGN(LOCATE('$k',`title`)) + ";
            }
            $where1 = substr($where1, 0, -3) . ')';
            $this->db->where("($where1 > 0)");
            $this->db->order_by("$where1 desc");
        }

        $this->db->where(array('state' => 1, 'isdel' => 0))->order_by('topicid desc');
        $total = $this->db->count_all_results('topic_view', false);

        if ($psize && $cpage) {
            $this->db->limit($psize, $psize * $cpage - $psize);
        }

        $topics = $this->db->get()->result();
        foreach ($topics as $topic) {
            $topic->typename = $topic->typename ? $topic->typename : '无分类';
            $topic->insertdate = date('Y-m-d', strtotime($topic->insertdate));
        }

        $types = $this->db->order_by('sort')->get_where('topic_type', array('state' => 1))->result();
        $data['types'] = $types;

        $data['topics'] = $topics;
        $data['tid'] = $tid;
        $data['psize'] = $psize;
        $data['cpage'] = $cpage;
        $data['total'] = $total;

        $data['title'] = str_ireplace(['{type}', '{seotitle}', '{name}'], [$type->typename, $type->seotitle, $this->site->name], $this->seo->topl_title);
        $data['keywords'] = str_ireplace(['{type}', '{name}'], [$type->typename, $type->seotitle, $this->site->name], $this->seo->topl_keys);
        $data['description'] = str_ireplace(['{type}', '{name}'], [$type->typename, $type->seotitle, $this->site->name], $this->seo->topl_desc);

        $this->load->view($this->template . 'topic', $data);
    }

    public function view($topicid, $cpage)
    {
        $this->right_print(40);

        if ($topic = $this->get_topic($topicid)) {

            if ($this->user->userid > 0) {
                $this->readlog($topicid);
            }

            $types = $this->db->order_by('sort')->get_where('topic_type', array('state' => 1))->result();

            //评论
            $psize = 10;
            $this->db->where(['topicid' => $topicid, 'state' => 1]);
            $this->db->order_by('commentid');
            $total = $this->db->count_all_results('topic_comment_view', false);
            $comments = $this->db->limit($psize, ($psize * $cpage - $psize))->get()->result();

            foreach ($comments as $comment) {
                if ($comment->pcommentid && $pcomment = $this->db->get_where('topic_comment_view', ['commentid' => $comment->pcommentid])->row()) {
                    $comment->pcomment = $pcomment;
                }
            }

            $downlogs = $this->db->order_by('logid')->get_where("topic_downlog_view", ['topicid' => $topicid])->result();

            $data['fav_state'] = $this->get_favstate($topicid);

            $data['types'] = $types;
            $data['topic'] = $topic;
            $data['comments'] = $comments;
            $data['downlogs'] = $downlogs;

            $data['psize'] = $psize;
            $data['cpage'] = $cpage;
            $data['total'] = $total;

            $data['title'] = str_ireplace(['{title}', '{type}', '{name}'], [$topic->title, $topic->typename, $this->site->name], $this->seo->topic_title);
            $data['keywords'] = str_ireplace(['{keys}', '{type}', '{name}'], [$topic->keyword, $topic->typename, $this->site->name], $this->seo->topic_key);
            $data['description'] = str_ireplace(['{word}', '{type}', '{name}'], [$topic->word, $topic->typename, $this->site->name], $this->seo->topic_desc);

            $this->load->view($this->template . 'topic_view', $data);
        } else {
            $data['message'] = '您预览的专题不存在';
            $data['title'] = '专题不存在 - ' . $this->site->name;
            $data['keywords'] = '专题不存在';
            $data['description'] = '您预览的专题不存在';
            $this->load->view($this->template . 'tip', $data);
        }
    }

    private function readlog($topicid)
    {
        $this->db->set('readcount', 'readcount+1', false)->where('topicid', $topicid)->update('topic');
    }

    public function get_topic($topicid)
    {
        if ($topicid && $topic = get_topicv($topicid)) {

            $topic->docs = $this->db->select('docid,title,downpay,pcount,exten,size,insertdate')->where_in('docid', explode(',', $topic->docs))->get('doc')->result();
            $topic->downpay2 = $topic->downpay;

            //自己的专题
            if ($topic->userid == $this->user->userid) {
                $topic->downpay2 = 0;
                return $topic;
            }
            //已下载过
            $paydue = $this->tradeset->paydue;
            if ($paydue) {
                $this->db->where('TO_DAYS(NOW()) - TO_DAYS(insertdate) <=', $paydue);
            }
            $downpaylog = $this->db->where_in('type', array(-50, -51, -52))->get_where('glodpot', array('userid' => $this->user->userid, 'linkid' => $topic->topicid))->row();
            if ($downpaylog) {
                $topic->downpay2 = 0;
                return $topic;
            }
            //VIP用户折扣，如果是vip免费专题，折扣为0
            if ($this->vgroup && strtotime($this->user->vipdate) >= time()) {
                $topic->downpay2 = $topic->downpay * ($topic->isvip ? 0 : $this->vgroup->discount);
            }
            return $topic;
        } else {
            return null; //专题不存在
        }
    }

    public function publish($topicid)
    {
        if (IS_GET) {
            $types = $this->db->order_by('sort')->get_where('topic_type', array('state' => 1))->result();
            $data['types'] = $types;

            if ($topicid && ($topic = $this->db->get_where('topic', array('topicid' => $topicid))->row())) {
                $this->right_print(44, '您没有编辑专题的权限');
                if ($this->has_right(3) || $this->has_right(4) || $this->user->userid == $topic->userid) {
                    $data['topic'] = $topic;
                    $data['title'] = '编辑专题 - ' . $this->site->name;
                    $data['keywords'] = '编辑专题';
                    $data['description'] = '编辑专题';
                    $this->load->view($this->template . 'topic_pub', $data);
                } else {
                    $data['message'] = '非管理人员只能编辑自己专题';
                    $data['title'] = '创建专题 - ' . $this->site->name;
                    $data['keywords'] = '创建专题';
                    $data['description'] = '创建专题';
                    $this->load->view($this->template . 'tip', $data);
                }
            } else {
                $this->right_print(42, '您没有创建专题的权限');
                $data['title'] = '创建专题 - ' . $this->site->name;
                $data['keywords'] = '创建专题';
                $data['description'] = '创建专题';
                $this->load->view($this->template . 'topic_pub', $data);
            }
        } else {
            $downpay = $this->input->post('downpay');
            $discount = $this->input->post('discount');
            $docs = $this->input->post('docs');

            $row = $this->db->select('count(docid) as docnum,sum(downpay) as totalpay,sum(size) as size')->where_in('docid', explode(',', $docs))->get('doc')->row();
            $totalpay = number_format($row->totalpay, 2, '.', '');
            $downpay = number_format($downpay == "" ? ($discount == "" ? $totalpay : $discount * $totalpay) : $downpay, 2, '.', '');

            $data = array(
                'title' => $this->input->post('title'),
                'word' => trim($this->input->post('word'), ','),
                'keyword' => $this->input->post('keyword'),
                'typeid' => $this->input->post('typeid'),
                'downpay' => $downpay,
                'discount' => $discount,
                'totalpay' => $totalpay,
                'docnum' => $row->docnum,
                'size' => $row->size,
                'docs' => $docs,
                'state' => $this->has_right(43) ? 1 : 0,
            );

            if ($topicid) {
                $this->right_print(44, '您没有编辑专题的权限');
                $this->db->update('topic', $data, array('topicid' => $topicid));
            } else {
                $this->right_print(42, '您没有创建专题的权限');
                $data['userid'] = $this->user->userid;
                $this->db->insert('topic', $data);
                $topicid = $this->db->insert_id();
            }

            $cover = 'data/topic/cover_' . $topicid . '.pic';
            if ($_FILES && !$_FILES['cover']['error']) {
                $size = $_FILES["cover"]['size'];
                $exten = get_exten($_FILES["cover"]['name']);
                if ($size <= 1024 * 1024) {
                    if ($exten === "png" || $exten === "jpeg" || $exten === "jpg" || $exten === "gif" || $exten === "bmp") {
                        if (move_uploaded_file($_FILES['cover']['tmp_name'], $cover)) {
                            $this->db->set('cover', $exten)->where('topicid', $topicid)->update('topic');
                            echo $topicid;
                        } else {
                            echo -1;
                        }
                    } else {
                        echo -11; //扩展名不对
                    }
                } else {
                    echo -12; //封面图片大于1M
                }
            } else {
                echo $topicid;
            }

            if (file_exists($cover)) {
                synoss($cover);
            }
        }
    }

    private function get_adv()
    {
        return $this->db->order_by('sort')->get_where('advv', array('page' => 'list'))->result();
    }

    private function get_ptype($typeid)
    {
        $temp = get_type($typeid);
        $type = array($temp);
        if (isset($temp->ptypeid) && $temp->ptypeid) {
            $type = array_merge($type, $this->get_ptype($temp->ptypeid));
        }
        return $type;
    }

    private function get_favstate($topicid)
    {
        if ($this->user->groupid && $this->db->select('favid')->get_where('topic_favorite', array('userid' => $this->user->userid, 'topicid' => $topicid))->row()) {
            return 1;
        } else {
            return 0;
        }
    }

    public function favorite($topicid)
    {
        if (!$this->user->groupid) {
            echo -1;
            return;
        }
        if ($topicid) {
            $row = $this->db->select('favid')->get_where('topic_favorite', array('userid' => $this->user->userid, 'topicid' => $topicid))->row();
            if ($row) {
                $this->db->delete('topic_favorite', array('favid' => $row->favid));
            } else {
                $data = array(
                    'userid' => $this->user->userid,
                    'topicid' => $topicid,
                );
                $this->db->insert('topic_favorite', $data);
            }
        }
        echo 1;
    }

    public function select()
    {
        if (IS_GET) {
            $this->load->view($this->template . 'topic_select');
        } elseif (IS_POST) {

            $searchcol = $this->input->post('searchcol');
            $searchtext = $this->input->post('searchtext');
            $sortcol = $this->input->post('sortcol');
            $sorttext = $this->input->post('sorttext');
            $pagesize = $this->input->post('pagesize');
            $pagecurrent = $this->input->post('pagecurrent');

            if ($this->has_right(3) || $this->has_right(4)) {
                $this->db->where(array('state' => 1, 'isdel' => 0));
            } else {
                $this->db->where(array('userid' => $this->user->userid, 'state' => 1, 'isdel' => 0));
            }

            $this->db->like($searchcol, $searchtext);

            $total = $this->db->count_all_results('doc_view', false);

            $docs = $this->db->select('docid,title,typename,preview,readpay,downpay,readcount,downcount,pcount,exten,isvip,isimp')->order_by($sortcol, $sorttext)->limit($pagesize, ($pagesize * $pagecurrent - $pagesize))->get()->result();

            foreach ($docs as $key => $doc) {
                $doc->docpic = "doc/$doc->docid.thum";
                $doc->downpay = $doc->downpay == null ? '<span class="tip-bg bg-red">禁止下载</span>' : ($doc->downpay == 0 ? '<span class="tip-bg bg-pink">免费</span>' : $doc->downpay.' '.$this->tradeset->glodunit);
                $doc->typename = $doc->typename ? $doc->typename : '<span style="color:#f00">分类已删</span>';
                $doc->info = $doc->isimp ? '<span class="tip-bg bg-blue">推荐</span>' : '';
                $doc->info .= $doc->isvip ? ' <span class="tip-bg bg-red">VIP</span>' : '';
            }
            echo json_encode(array('total' => $total, 'data' => $docs));
        }
    }

    public function getdoc($docid)
    {
        if (($doc = get_doc($docid)) && ($this->has_right(3) || $this->has_right(4) || $doc->userid == $this->user->userid)) {
            echo json_encode(['docid' => $docid, 'exten' => $doc->exten, 'title' => $doc->title]);
        } else {
            echo -1; //自己文档
        }
    }

    public function cover($id, $exten)
    {
        $cover = 'data/topic/cover_' . $id . '.pic';
        if ($id && file_exists($cover)) {
            $etag = md5_file($cover);
            if (array_key_exists('HTTP_IF_NONE_MATCH', $_SERVER) and $_SERVER['HTTP_IF_NONE_MATCH'] == $etag) {
                header("HTTP/1.1 304 Not Modified");
                header("Cache-Control: public, max-age=86400000, pre-check=86400000");
                header("Pragma: public");
                header("Etag:" . $etag);
                exit();
            } else {
                header("Cache-Control: public, max-age=86400000, pre-check=86400000");
                header("Pragma: public");
                header("Etag:" . $etag);
                header('Content-type: image/' . $exten);
                readfile($cover);
            }
        } else if (($instance = &get_instance()) && ($oss = $instance->db->get('ossset')->row()) && $oss->state && $instance->load->library('Oss/oss') && $instance->oss->objectexists($cover)) {
            $url = $instance->oss->signUrl($cover);
            if ($oss->fluxoss) {
                header('Location:' . $url);
            } else {
                readfile($url);
            }
            return true;
        } else {
            header("Cache-Control:no-store, no-cache, must-revalidate");
            header("Pragma:no-cache");
            header("Expires:-1");
            header('Content-type: image/png');
            readfile('data/img/topic.png');
        }
    }

    public function reply_add($topicid)
    {
        $this->right_print(46);
        if ($topicid && $topic = $this->db->get_where('topic', array('topicid' => $topicid))->row()) {
            $data = array(
                'topicid' => $topicid,
                'userid' => $this->user->userid,
                'comment' => $this->input->post('comment'),
                'state' => $this->has_right(47) ? 1 : 0,
            );
            //$this->db->set('commemtdate', 'now()', false)->where('topicid', $topicid)->update('topic');
            echo $this->db->insert('topic_comment', $data);
        } else {
            echo -1;
        }
    }

    public function reply_edit($commentid)
    {
        $this->right_print(48);

        if (IS_GET) {
            if ($commentid && $comment = $this->db->get_where('topic_comment', ['commentid' => $commentid, 'userid' => $this->user->userid])->row()) {
                $data['topic_title'] = $this->db->select('title')->get_where('topic', ['topicid' => $comment->topicid])->row()->title;
                $data['comment'] = $comment;
                $data['title'] = '编辑专题评论 - ' . $this->site->name;
                $data['keywords'] = '编辑专题评论';
                $data['description'] = '编辑专题评论';
                $this->load->view($this->template . 'topic_reply_edit', $data);
            } else {
                echo -2; //只能编辑已有评论并且是自己的评论
            }
        } elseif (IS_POST) {
            $data = array(
                'comment' => $this->input->post('comment'),
            );
            echo $this->db->update('topic_comment', $data, ['commentid' => $commentid, 'userid' => $this->user->userid]);
        }

    }

    public function reply_reply($commentid)
    {
        $this->right_print(46);

        if (IS_GET) {
            if ($commentid && $comment = $this->db->get_where('topic_comment', ['commentid' => $commentid])->row()) {
                $data['topic_title'] = $this->db->select('title')->get_where('topic', ['topicid' => $comment->topicid])->row()->title;
                $data['comment'] = $comment;
                $data['title'] = '评论专题评论 - ' . $this->site->name;
                $data['keywords'] = '评论专题评论';
                $data['description'] = '评论专题评论';
                $this->load->view($this->template . 'topic_reply_reply', $data);
            } else {
                echo -2; //只能评论已有评论
            }
        } elseif (IS_POST) {
            $data = array(
                'topicid' => $this->input->post('topicid'),
                'userid' => $this->user->userid,
                'comment' => $this->input->post('comment'),
                'pcommentid' => $commentid,
                'state' => $this->has_right(47) ? 1 : 0,
            );
            //$this->db->set('commemtdate', 'now()', false)->where('topicid', $this->input->post('topicid'))->update('topic');
            echo $this->db->insert('topic_comment', $data);
        }
    }

    public function reply_del($commentid)
    {
        if ($this->has_right(49)) {
            if ($this->db->delete('topic_comment', ['commentid' => $commentid, 'userid' => $this->user->userid])) {
                echo 1;
            } else {
                echo -1;
            }
        } else {
            echo -1;
        }
    }

    public function reply_report($docid)
    {
        if ($docid) {
            if (IS_GET) {
                $data['report_item'] = $this->db->order_by('sort')->get_where('report_item', ['state' => 1])->result();
                if ($report = $this->db->select('reportid,report,extra')->get_where('report', array('docid' => $docid, 'userid' => $this->user->userid))->row()) {
                    $data['report'] = (object) array(
                        'reportid' => $report->reportid,
                        'docid' => $docid,
                        'report' => $report->report,
                        'extra' => $report->extra,
                    );
                } else {
                    $data['report'] = (object) array(
                        'reportid' => '',
                        'docid' => $docid,
                        'report' => $data['report_item'][0]->title,
                        'extra' => '',
                    );
                }
                $this->load->view($this->template . 'report.html', $data);
            } elseif (IS_POST) {
                $data = array(
                    'docid' => $docid,
                    'userid' => $this->user->userid,
                    'report' => $this->input->post('report'),
                    'extra' => $this->input->post('extra'),
                );
                if ($reportid = $this->input->post('reportid')) {
                    echo $this->db->update('report', $data, array('reportid' => $reportid));
                } else {
                    echo $this->db->insert('report', $data);
                }
            }
        }
    }

    public function report_submit($docid, $report)
    {
        if ($docid && $report && $this->user->groupid) {
            $data = array(
                'docid' => $this->input->post('docid'),
                'userid' => $this->user->userid,
                'report' => $report,
            );
            $this->db->insert('report', $data);
            echo 1;
        } else {
            echo -1;
        }
    }
}
