<?php

defined('BASEPATH') or exit('No direct script access allowed');

class Upload extends Home_Controller
{

    public function __construct()
    {
        parent::__construct();
        if (!$this->user->groupid) {
            header('Location:/login.html');
            exit;
        }
    }

    public function index()
    {
        $data['title'] = '上传文档 - ' . $this->site->name;
        $data['keywords'] = '上传文档';
        $data['description'] = '上传文档';

        if ($this->has_right(12)) {

            if ($this->docset->isauth1 && !$this->user->isauth) {
                $data['message'] = '认证用户才能上传文档！';
                $this->load->view($this->template . 'tip', $data);
            } else {
                $data['points'] = get_points(4);
                $data['updocnum'] = $this->updocnum();
                $this->load->view($this->template . 'upload', $data);
            }

        } else {
            $data['message'] = '您没有上传文档的权限！';
            $this->load->view($this->template . 'tip', $data);
        }
    }

    public function reward($reid)
    {
        $data['title'] = '上传悬赏文档 - ' . $this->site->name;
        $data['keywords'] = '上传悬赏文档';
        $data['description'] = '上传悬赏文档';

        if ($this->has_right(56)) {
            if ($reid && ($reward = $this->db->get_where('reward', array('reid' => $reid, 'state' => 1))->row())) {
                $data['points'] = get_points(4);
                $draft = array(
                    'userid' => $this->user->userid,
                    'desc' => '',
                    'reid' => $reid,
                    'state' => -2,
                );
                $this->db->insert('draft', $draft);
                $data['draftid'] = $this->db->insert_id();
                $data['price'] = $reward->price;
                $data['updocnum'] = $this->updocnum();
                $this->load->view($this->template . 'upload', $data);
            } else {
                $data['message'] = '抱歉，悬赏任务已截至或已定稿';
                $this->load->view($this->template . 'tip', $data);
            }
        } else {
            $data['message'] = '您没有领取悬赏任务的权限！';
            $this->load->view($this->template . 'tip', $data);
        }
    }

    public function save()
    {
        if (!$this->has_right(12) && !$this->has_right(56)) {
            echo -101;
            return;
        }

        $tids = explode('-', $this->input->post('typeid'));
        if ($this->input->post('filter')) {
            $filter = implode('.', $this->input->post('filter'));
        } else {
            $filter = -1;
        }

        if (!get_magic_quotes_gpc()) {
            $title = addslashes($this->input->post('title'));
        }
        $draftid = $this->input->post('draftid');
        $data = array(
            'userid' => $this->user->userid,
            'title' => $title,
            'keyword' => $this->input->post('keyword'),
            'word' => dockey($this->input->post('word')),
            'typeid' => end($tids),
            'filter' => $filter,
            'readpay' => $this->input->post('readpay'),
            'preview' => $this->input->post('preview'),
            'downpay' => $this->input->post('downpay'),
            'draftid' => $draftid,
            'state' => $this->has_right(13) ? 1 : 0,
        );
        if (($docid = $this->input->post('docid')) && ($doc = get_doc($docid)) && $this->db->update('doc', $data, array('docid' => $docid))) {

            if ($draftid) {
                $this->db->update('draft', array('state' => 0), array('draftid' => $draftid));
            }

            //免审用户，上传文档奖励
            if ($data['state']) {
                pointpot(4, $this->user->userid, $docid);
            }

            //删除碎片 30分钟内没后保存
            $tempdoc = $this->db->select('path,docid')->get_where('doc', array('state' => -2, 'insertdate <' => date('Y-m-d H:i:s', time() - 3000)))->result();
            foreach ($tempdoc as $d) {
                $this->db->delete('doc', array('docid' => $d->docid));
                delfile($d->path);
            }
            $this->db->delete('draft', array('state' => -2, 'insertdate <' => date('Y-m-d H:i:s', time() - 3000)));

            if ($doc->exten == 'gif' || $doc->exten == 'jpg' || $doc->exten == 'jpeg' || $doc->exten == 'bmp' || $doc->exten == 'png' || $doc->exten == 'svg') {
                $config['source_image'] = $doc->path;
                $config['new_image'] = get_dir($doc->path) . '1.' . $doc->exten;
                $config['create_thumb'] = true;
                $config['maintain_ratio'] = true;
                $config['thumb_marker'] = '';
                $config['width'] = 210;
                $config['height'] = 297;
                $this->load->library('image_lib', $config);
                synoss($doc->path);
                echo $this->image_lib->resize();
            } else if ($doc->exten == 'zip' || $doc->exten == 'rar') {

            } else {
                echo yun($this->docset, $this->site->host, $doc->path, $data['title'], $doc->exten, $this->config->item('version'));
            }
        } else {
            echo '文档没上传成功';
        }

    }

    public function file()
    {
        if (!$this->has_right(12) && !$this->has_right(56)) {
            die('{"code": -101, "message": "没有上传权限"}');
            return;
        }

        header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
        header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT');
        header('Cache-Control: no-store, no-cache, must-revalidate');
        header('Cache-Control: post-check=0, pre-check=0', false);
        header('Pragma: no-cache');

        // Support CORS
        // header('Access-Control-Allow-Origin: *');
        // other CORS headers if any...
        if ($_SERVER['REQUEST_METHOD'] == 'OPTIONS') {
            exit; // finish preflight CORS requests here
        }

        @set_time_limit(5 * 60);

        $temp_dir = 'data/cache/';
        $doc_dir = 'data/doc/';

        $clean_temp = true;
        $file_exptime = 600; //10分钟

        $file_ext = get_exten($_FILES["file"]['name']);
        $valid_ext = explode(',', $this->ugroup->uploadexten);
        if (!in_array($file_ext, $valid_ext)) {
            die('{"code": 100, "message": "扩展名被禁止上传"}');
            exit;
        }

        $md5 = $this->input->post('md5');
        $temp_file = $temp_dir . $md5;

        $chunk = isset($_REQUEST['chunk']) ? intval($_REQUEST['chunk']) : 0;
        $chunks = isset($_REQUEST['chunks']) ? intval($_REQUEST['chunks']) : 1;

        if (!empty($_FILES)) {
            if ($_FILES['file']['error'] || !is_uploaded_file($_FILES['file']['tmp_name'])) {
                die('{"code": 101, "message": "上传文件失败"}');
            }
            if (!$in = @fopen($_FILES['file']['tmp_name'], 'rb')) {
                die('{"code": 102, "message": "读取文件失败"}');
            }
            if (!$out = @fopen("{$temp_file}_{$chunk}.parttmp", 'wb')) {
                die('{"code": 103, "message": "创建临时文件失败"}');
            }
        } else {
            die('{"code": 104, "message": "上传文件为空"}');
        }

        while ($buff = fread($in, 4096)) {
            fwrite($out, $buff);
        }

        @fclose($out);
        @fclose($in);

        rename("{$temp_file}_{$chunk}.parttmp", "{$temp_file}_{$chunk}.part");

        $index = 0;
        $done = true;
        for ($index = 0; $index < $chunks; $index++) {
            if (!file_exists("{$temp_file}_{$index}.part")) {
                $done = false;
                break;
            }
        }
        if ($done) {
            $fname = microtime(true) * 10000;
            $doc_dir = createdir($doc_dir);
            $doc_file = $doc_dir . $fname . '.' . $file_ext;
            if (!$out = @fopen($doc_file, 'wb')) {
                die('{"code": 105, "message": "创建文件失败"}');
            }

            if (flock($out, LOCK_EX)) {
                for ($index = 0; $index < $chunks; $index++) {
                    if (!$in = @fopen("{$temp_file}_{$index}.part", 'rb')) {
                        break;
                    }
                    while ($buff = fread($in, 4096)) {
                        fwrite($out, $buff);
                    }
                    @fclose($in);
                    @unlink("{$temp_file}_{$index}.part");
                }
                flock($out, LOCK_UN);
            }
            @fclose($out);

            if (!is_dir($doc_dir . $fname . '/')) {
                @mkdir($doc_dir . $fname . '/', 0777);
                @chmod($doc_dir . $fname . '/', 0777); 
            }

            @chmod($doc_file, 0777);

            if ($clean_temp) {
                if (!is_dir($temp_dir) || !$dir = opendir($temp_dir)) {
                    die('{"code": 106, "message": "打开临时目录失败"}');
                }
                while (($file = readdir($dir)) !== false) {
                    $old_tmpfile = $temp_dir . $file;
                    if ($old_tmpfile == "{$temp_file}_{$chunk}.part" || $old_tmpfile == "{$temp_file}_{$chunk}.parttmp") {
                        continue;
                    }
                    if (preg_match('/\.(part|parttmp)$/', $file) && (@filemtime($old_tmpfile) < time() - $file_exptime)) {
                        @unlink($old_tmpfile);
                    }
                }
                closedir($dir);
            }

            // $data = array(
            //     'userid' => $this->user->userid,
            //     'md5' => substr($md5, 0, 32),
            //     'path' => $doc_file,
            //     'size' => $this->input->post('size'),
            //     'exten' => $file_ext,
            //     'state' => -2,
            // );
            $data = [];
            if ($file_ext == 'zip') {
                $zip = new ZipArchive;
                if ($zip->open($doc_file) === true) {
                    $k = 0;
                    for ($i = 0; $i < $zip->numFiles; $i++) {
                        $name = $zip->getNameIndex($i);
                        $name2 = $zip->getNameIndex($i, ZipArchive::FL_ENC_RAW);
                        if ($ss = @iconv('GBK//IGONRE', 'UTF-8', $name2)) {
                            $name2 = $ss;
                        }
                        $exten = get_exten($name);
                        if ($exten == '') {
                            continue;
                        }

                        $path = $doc_dir . $fname . '_' . $i . '.' . $exten;
                        $title = substr($name2, 0, strrpos($name2, '.'));

                        copy("zip://$doc_file#$name", $path);

                        @chmod($path, 0777);

                        $md5 = md5_file($path);

                        if (!in_array($exten, $valid_ext)) {
                            $data[$k] = array(
                                'docid' => -1,
                                'title' => $title,
                                'exten' => $exten,
                            );
                            unlink($path);
                        } else if ($this->hasdoc($md5)) {
                            $data[$k] = array(
                                'docid' => -2,
                                'title' => $title,
                                'exten' => $exten,
                            );
                            unlink($path);
                        } else {

                            if (in_array($exten, ['doc', 'docx', 'ppt', 'pptx', 'xls', 'xlsx', 'csv', 'epub', 'vsd', 'pot', 'pps', 'rtf', 'wps', 'et', 'dps', 'pdf', 'txt']) && !is_dir($doc_dir . $fname . '_' . $i . '/')) {
                                @mkdir($doc_dir . $fname . '_' . $i . '/', 0777);
                                @chmod($doc_dir . $fname . '_' . $i . '/', 0777);
                            }
                            $data[$k] = array(
                                'userid' => $this->user->userid,
                                'title' => $title,
                                'keyword' => fenci($title),
                                'word' => '',
                                'typeid' => '',
                                'filter' => -1,
                                'readpay' => $this->docset->readpay,
                                'preview' => $this->docset->preview,
                                'downpay' => $this->docset->downpay,
                                'draftid' => $this->input->post('draftid'),
                                'md5' => $md5,
                                'path' => $path,
                                'size' => filesize($path),
                                'exten' => $exten,
                                'state' => -2,
                            );
                            if ($this->db->insert('doc', $data[$k])) {
                                $data[$k]['docid'] = $this->db->insert_id();
                                unset($data[$k]['path']);
                            }
                        }
                        $k++;
                    }
                    $zip->close();
                    unlink($doc_file);
                    rmdir($doc_dir . $fname);
                }
            } else {
                $data[0] = array(
                    'userid' => $this->user->userid,
                    'title' => $this->input->post('title'),
                    'keyword' => fenci($this->input->post('title')),
                    'word' => '',
                    'typeid' => '',
                    'filter' => -1,
                    'readpay' => $this->docset->readpay,
                    'preview' => $this->docset->preview,
                    'downpay' => $this->docset->downpay,
                    'draftid' => $this->input->post('draftid'),
                    'md5' => substr($md5, 0, 32),
                    'path' => $doc_file,
                    'size' => $this->input->post('size'),
                    'exten' => $file_ext,
                    'state' => -2,
                );

                if ($this->db->insert('doc', $data[0])) {
                    $data[0]['docid'] = $this->db->insert_id();
                    unset($data[0]['path']);
                }
            }
            if ($data) {
                echo json_encode($data);
            } else {
                die('{"code": 107, "message": "数据错误"}');
            }
        }
    }

    public function hasdoc($md5)
    {
        if ($md5) {
            $docrow = $this->db->order_by('docid desc')->get_where('doc', array('md5' => $md5))->row();
            return $docrow && $this->docset && $this->docset->ismd5;
        }
        return false;
    }

    public function getunimd5($md5)
    {
        if ($md5) {
            $docrow = $this->db->order_by('docid desc')->get_where('doc', array('md5' => $md5))->row();
            if ($docrow) {
                if ($this->docset && $this->docset->ismd5) {
                    echo 2;
                } else {
                    echo 1;
                }
            } else {
                echo 0;
            }
        }
    }

    public function get_filter($typeid)
    {
        $ctype = get_type($typeid);

        $rows = $this->db->select('id,pid,name')->order_by('sort')->where_in('id', explode(',', $ctype->filter))->or_where_in('pid', explode(',', $ctype->filter))->get('filter')->result();
        $filter_array = [];
        foreach ($rows as $row) {
            $filter_array[$row->pid][] = $row;
        }

        $i = $this->docset->minfilter ? '<i>*</i>' : '';

        $filter_str = '';
        if ($filter_array) {
            foreach ($filter_array[0] as $filter) {
                $filter_str .= '<div class="doc-filter"><label>' . $i . $filter->name . '</label><div class="ui-dropdown"><div>请选择...</div><ul>';
                if (isset($filter_array[$filter->id])) {
                    foreach ($filter_array[$filter->id] as $fil) {
                        $filter_str .= '<li data-val="' . $fil->id . '">' . $fil->name . '</li>';
                    }
                }
                $filter_str .= '</ul><input name="filter[]" type="hidden" value="0"><i></i></div></div>';
            }
        }
        echo $filter_str;
    }

    //0 不限制 -1 不能
    public function updocnum()
    {
        $docnum = $this->db->select('count(userid) as count')->get_where('doc', array('userid' => $this->user->userid, 'date(insertdate)' => date('Y-m-d')))->row()->count;

        if ($this->ugroup->uploadcount == -1) {
            return 0;
        } else {
            return $this->ugroup->uploadcount - $docnum;
        }
    }

}
