<?php

defined('BASEPATH') or exit('No direct script access allowed');

class User extends Home_Controller
{

    public function __construct()
    {
        parent::__construct();
    }

    public function index($id)
    {
        $uuser = get_user2($id);
        if ($uuser) {
            $data['uuser'] = $uuser;

            $docnum = $this->db->select('userid,count(userid) as count,sum(readcount) as readcount,sum(downcount) as downcount')->get_where('doc', array('userid' => $id, 'state' => 1, 'isdel' => 0))->row();

            $data['docnum'] = $docnum->count;
            $data['readcount'] = $docnum->readcount ? $docnum->readcount : 0;
            $data['downcount'] = $docnum->downcount ? $docnum->downcount : 0;

            $data['title'] = str_ireplace(['{title}', '{name}'], [$uuser->nickname, $this->site->name], $this->seo->user_title);
            $data['keywords'] = str_ireplace(['{title}', '{name}'], [$uuser->nickname, $this->site->name], $this->seo->user_keys);
            $data['description'] = str_ireplace(['{title}', '{name}'], [$uuser->nickname, $this->site->name], $this->seo->user_desc);

            $this->load->view($this->template . 'user', $data);
        } else {
            $data['message'] = '用户不存在';
            $data['title'] = '用户不存在 - ' . $this->site->name;
            $data['keywords'] = '用户不存在';
            $data['description'] = '用户不存在';

            $this->load->view($this->template . 'tip', $data);
        }
    }

    public function getdoc($userid)
    {
        $cpage = $this->input->post('pagecurrent');
        $pagesize = $this->input->post('pagesize');
        if ($userid) {
            $docs = get_docs_bypage($userid, null, null, null, null, null, null, null, 0, $pagesize, $cpage, 'docid desc');
            foreach ($docs['data'] as $doc) {
                $doc->insertdate = date('Y-m-d', strtotime($doc->insertdate));
                $doc->downpay = $doc->downpay == null ? '<span class="tip-bg bg-red">禁止下载</span>' : ($doc->downpay == 0 ? '<span class="tip-bg bg-pink">免费</span>' : $doc->downpay.' '.$this->tradeset->glodunit);
                $doc->typename = $doc->typename ? $doc->typename : '<span style="color:#f00">分类已删</span>';
                $doc->info = $doc->isimp ? '<span class="tip-bg bg-blue">推荐</span>' : '';
                $doc->info .= $doc->isvip ? ' <span class="tip-bg bg-red">VIP</span>' : '';
                $doc->info .= $doc->isdel ? ' <span class="tip-bg bg-green">下架</span>' : '';
            }

            echo json_encode($docs);
        } else {
            echo '';
        }
    }

    public function photo($userid)
    {
        $user = get_user2($userid);
        $photo = 'data/photo/' . $userid . '.pic';
        if ($user && file_exists($photo)) {
            $etag = md5_file($photo);
            if (array_key_exists('HTTP_IF_NONE_MATCH', $_SERVER) and $_SERVER['HTTP_IF_NONE_MATCH'] == $etag) {
                header("HTTP/1.1 304 Not Modified");
                header("Cache-Control: public, max-age=86400000, pre-check=86400000");
                header("Pragma: public");
                header("Etag:" . $etag);
                exit();
            } else {
                header("Cache-Control: public, max-age=86400000, pre-check=86400000");
                header("Pragma: public");
                header("Etag:" . $etag);
                header('Content-type: image/' . $user->photo);
                readfile($photo);
            }
        } else if ($user && substr($user->photo, 0, 4) == 'http') {
            header('Location:' . $user->photo);
        } else {
            header("Cache-Control:no-store, no-cache, must-revalidate");
            header("Pragma:no-cache");
            header("Expires:-1");
            header('Content-type: image/png');
            readfile('data/img/photo.png');
        }
    }

}
