<?php

defined('BASEPATH') or exit('No direct script access allowed');

class Adv extends Admin_Controller
{

    public function __construct()
    {
        parent::__construct();
        $menu = array(
            'title' => '广告设置',
            'menu' => array(
                'admin/adv/home' => '首页广告',
                'admin/adv/list' => '分类页广告',
                'admin/adv/doc' => '阅读页广告',
                'admin/adv/search' => '搜索页广告',
            ));
        $this->load->vars('menu', $menu);
    }

    public function index($page)
    {
        $data['adv'] = $this->db->order_by('sort')->get_where('advv', array('page' => $page))->result();
        $this->load->view($this->template . 'admin/adv/index', $data);
    }

    public function adv_edit($page, $id)
    {
        if (IS_GET) {
            if ($id && $row = $this->db->get_where('advv', array('id' => $id))->row()) {
                $data['adv'] = $row;
            } else {
                $data['adv'] = (object) array(
                    'id' => '0',
                    'name' => '',
                    'page' => $page,
                    'pointid' => '-1',
                    'point' => '-',
                    'src' => '',
                    'sort' => '1',
                );
            }
            $advpoint = $this->db->order_by('sort')->get_where('advpoint', array('page' =>  $page))->result();
            $data['advpoint'] = $advpoint;
            $this->load->view($this->template . 'admin/adv/adv_edit', $data);
        } elseif (IS_POST) {
            $data = array(
                'name' => $this->input->post('name'),
                'page' => $page,
                'pointid' => $this->input->post('pointid'),
                'src' => $this->input->post('src'),
                'sort' => $this->input->post('sort'),
            );
            if ($id) {
                echo $this->db->update('adv', $data, array('id' => $id));
            } else {
                echo $this->db->insert('adv', $data);
            }
        }
    }

    public function adv_del($page, $id)
    {
        if ($id) {
            echo $this->db->delete('adv', array('id' => $id));
        }
    }

    public function display($id)
    {
        $row = $this->db->get_where('adv', array('id' => $id))->row();
        if ($row) {
            $data['adv'] = $row->src;
        } else {
            $data['adv'] = '没有广告效果';
        }
        $this->load->view($this->template . 'admin/adv/display', $data);
    }

}
