<?php

defined('BASEPATH') or exit('No direct script access allowed');

class Doc extends Admin_Controller
{

    public function __construct()
    {
        parent::__construct();
        $menu = array(
            'title' => '文档管理',
            'menu' => array(
                'admin/doc/online' => '线上文档',
                'admin/doc/imp' => '推荐文档',
                'admin/doc/vip' => 'VIP 免费',
                'admin/doc/free' => '免费文档',
                'admin/doc/unline' => '下架文档',
                'javascript:;" class="i' => '<span></span>',
                'admin/doc/audit' => '等待审核',
                'admin/doc/passed' => '审核通过',
                'admin/doc/nopass' => '审核失败',
                'javascript:;;" class="i' => '<span></span>',
                'admin/doc/conver' => '转换失败',
                'admin/doc/clear' => '清理碎片',
                'javascript:;;;" class="i' => '<span></span>',
                'admin/doc/report' => '被举报文档',
                'javascript:;;;;" class="i' => '<span></span>',
                'admin/doc/comment/audit' => '待审评论',
                'admin/doc/comment/online' => '已审评论',
            ));
        $this->load->vars('menu', $menu);
    }

    public function index($which)
    {
        if (IS_GET) {
            $this->load->view($this->template . 'admin/doc/index');
        } elseif (IS_POST) {
            $this->doclist($which);
        }
    }

    public function doclist($which)
    {
        $searchcol = $this->input->post('searchcol');
        $searchtext = $this->input->post('searchtext');
        $sortcol = $this->input->post('sortcol');
        $sorttext = $this->input->post('sorttext');
        $pagesize = $this->input->post('pagesize');
        $pagecurrent = $this->input->post('pagecurrent');

        switch ($which) {
            case 'audit':
                $this->db->where('state', 0);
                break;
            case 'passed':
                $this->db->where('state', 1);
                break;
            case 'nopass':
                $this->db->where('state', -1);
                break;
            case 'online':
                $this->db->where(array('state' => 1, 'isdel' => 0));
                break;
            case 'free':
                $this->db->where(array('state' => 1, 'isdel' => 0, 'downpay' => 0));
                break;
            case 'vip':
                $this->db->where(array('state' => 1, 'isdel' => 0, 'isvip' => 1));
                break;
            case 'imp':
                $this->db->where(array('state' => 1, 'isdel' => 0, 'isimp' => 1));
                break;
            case 'unline':
                $this->db->where(array('state' => 1, 'isdel' => 1));
                break;
            case 'conver':
                $this->db->where(['pcount' => 0, 'title<>' => null, 'exten<>' => 'mp4']);
                break;
            case 'clear':
                $this->db->where(array('state' => -2));
                break;
            case 'report':
                //$this->db->where('state', -1);
                break;
        }
        if ($searchtext != '') {
            $this->db->like($searchcol, $searchtext);
        }

        $total = $this->db->count_all_results('doc_view', false);

        $docs = $this->db->select('docid,title,typename,userid,nickname,preview,readpay,downpay,readcount,downcount,pcount,path,size,exten,isvip,isimp,isdel,insertdate,state')->order_by($sortcol, $sorttext)->limit($pagesize, ($pagesize * $pagecurrent - $pagesize))->get()->result();

        foreach ($docs as $key => $doc) {
            $doc->size = bsize($doc->size);
            $doc->downpay = $doc->downpay == null ? '<span class="tip-bg bg-red">禁止下载</span>' : ($doc->downpay == 0 ? '<span class="tip-bg bg-pink">免费</span>' : $doc->downpay.' '.$this->tradeset->glodunit);
            $doc->typename = $doc->typename ? $doc->typename : '<span style="color:#f00">分类已删</span>';
            $doc->info = $doc->isimp ? '<span class="tip-bg bg-blue">推荐</span>' : '';
            $doc->info .= $doc->isvip ? ' <span class="tip-bg bg-red">VIP</span>' : '';
            $doc->info .= $doc->isdel ? ' <span class="tip-bg bg-green">下架</span>' : '';

            $doc->uploaddate = date('Y-m-d', strtotime($doc->insertdate));
        }
        echo json_encode(array('total' => $total, 'data' => $docs));
    }

    public function doc_edit($docid)
    {
        if (IS_GET) {
            if ($docid && $doc = get_doc($docid)) {
                $data['doc'] = $doc;
                $this->load->view($this->template . 'admin/doc/doc_edit', $data);
            }
        } elseif (IS_POST) {
            $passed = $this->input->post('passed');
            $nopass = $this->input->post('nopass');
            $isimp = $this->input->post('isimp');
            $isvip = $this->input->post('isvip');
            $isdel = $this->input->post('isdel');
            $note = $this->input->post('note');

            if ($passed == '0' && $nopass == '0') {
                $data['state'] = 0;
            }
            if ($passed == '1') {
                $data['state'] = 1;
            }
            if ($nopass == '1') {
                $data['state'] = -1;
            }

            $data['isimp'] = $isimp;
            $data['isvip'] = $isvip;
            $data['isdel'] = $isdel;
            $data['note'] = $note;

            if ($doc = get_doc($docid)) {
                if ($passed) {
                    pointpot(4, $doc->userid, $docid);
                }

                if ($isimp) {
                    pointpot(5, $doc->userid, $docid);
                }

                if ($isvip) {
                    pointpot(6, $doc->userid, $docid);
                }
            }
            echo $this->db->update('doc', $data, array('docid' => $docid));
        }
    }

    public function edit_audit($docids = 0)
    {
        if (IS_GET) {
            $data['docids'] = $docids;
            $this->load->view($this->template . 'admin/doc/edit_audit', $data);
        } elseif (IS_POST) {
            if ($docids) {
                $passed = $this->input->post('passed');
                $nopass = $this->input->post('nopass');
                $note = $this->input->post('note');

                $data['state'] = 0;
                if ($passed == '1') {
                    $data['state'] = 1;
                }
                if ($nopass == '1') {
                    $data['state'] = -1;
                }
                $data['note'] = $note;
                foreach (explode('_', $docids) as $docid) {
                    if ($doc = get_doc($docid)) {
                        if ($passed) {
                            pointpot(4, $doc->userid, $docid);
                        }
                    }
                    echo $this->db->update('doc', $data, array('docid' => $docid));
                }
            }
        }
    }

    public function edit_imp($docids = 0)
    {
        if (IS_GET) {
            $data['docids'] = $docids;
            $this->load->view($this->template . 'admin/doc/edit_imp', $data);
        } elseif (IS_POST) {
            if ($docids) {
                $isimp = $this->input->post('isimp');
                $note = $this->input->post('note');
                $data['isimp'] = $isimp;
                $data['note'] = $note;
                foreach (explode('_', $docids) as $docid) {
                    if ($doc = get_doc($docid)) {
                        if ($isimp) {
                            pointpot(5, $doc->userid, $docid);
                        }
                    }
                    echo $this->db->update('doc', $data, array('docid' => $docid));
                }
            }
        }
    }

    public function edit_vip($docids = 0)
    {
        if (IS_GET) {
            $data['docids'] = $docids;
            $this->load->view($this->template . 'admin/doc/edit_vip', $data);
        } elseif (IS_POST) {
            if ($docids) {
                $isvip = $this->input->post('isvip');
                $note = $this->input->post('note');
                $data['isvip'] = $isvip;
                $data['note'] = $note;
                foreach (explode('_', $docids) as $docid) {
                    if ($doc = get_doc($docid)) {
                        if ($isvip) {
                            pointpot(6, $doc->userid, $docid);
                        }
                    }
                    echo $this->db->update('doc', $data, array('docid' => $docid));
                }
            }
        }
    }

    public function edit_del($docids = 0)
    {
        if (IS_GET) {
            $data['docids'] = $docids;
            $this->load->view($this->template . 'admin/doc/edit_del', $data);
        } elseif (IS_POST) {
            if ($docids) {
                $isdel = $this->input->post('isdel');
                $note = $this->input->post('note');
                $data['isdel'] = $isdel;
                $data['note'] = $note;
                foreach (explode('_', $docids) as $docid) {
                    echo $this->db->update('doc', $data, array('docid' => $docid));
                }
            }
        }
    }

    public function edit_type($docids = 0)
    {
        if (IS_GET) {
            $data['docids'] = $docids;
            $data['type_array'] = get_type_array();
            $this->load->view($this->template . 'admin/doc/edit_type', $data);
        } elseif (IS_POST) {
            if ($docids) {

                $tids = explode('-', $this->input->post('typeid'));
                if ($this->input->post('filter')) {
                    $filter = implode('.', $this->input->post('filter'));
                } else {
                    $filter = -1;
                }
                $data = array(
                    'typeid' => end($tids),
                    'filter' => $filter,
                );

                foreach (explode('_', $docids) as $docid) {
                    echo $this->db->update('doc', $data, array('docid' => $docid));
                }
            }
        }
    }

    public function doc_del($docids = 0)
    {
        if ($docids) {
            foreach (explode('_', $docids) as $docid) {
                $path_row = $this->db->select('path')->get_where('doc', array('docid' => $docid))->row();
                if ($path_row) {
                    $this->db->delete('doc', array('docid' => $docid));
                    delfile($path_row->path);
                }
            }
        }
    }

    public function doc_rev($docids = 0)
    {
        if ($docids) {
            foreach (explode('_', $docids) as $docid) {
                if ($doc = get_doc($docid)) {
                    $this->db->update('doc', ['pcount' => 0, 'word' => ''], array('docid' => $docid));

                    if (!file_exists($doc->path) && ($oss = $this->db->get('ossset')->row()) && $oss->state && $this->load->library('Oss/oss') && $this->oss->objectexists($doc->path)) {
                        $this->oss->downfile($doc->path, $doc->path);
                    }
                    echo yun($this->docset, $this->site->host, $doc->path, $doc->title, $doc->exten, $this->config->item('version'));
                }
            }
        }
    }

    public function convert_all()
    {
        $docs = $this->db->select('docid,path,title,exten')->get_where('doc', ['pcount' => 0])->result();
        foreach ($docs as $doc) {
            $this->db->update('doc', ['pcount' => 0, 'word' => ''], array('docid' => $doc->docid));
            if (!file_exists($doc->path) && ($oss = $this->db->get('ossset')->row()) && $oss->state && $this->load->library('Oss/oss') && $this->oss->objectexists($doc->path)) {
                $this->oss->downfile($doc->path, $doc->path);
            }
            yun($this->docset, $this->site->host, $doc->path, $doc->title, $doc->exten, $this->config->item('version'));
        }
    }

    public function doc_bdpush($docids = 0)
    {
        if ($docids && $bdpush = $this->db->get_where('bdpushset', array('state' => '1'))->row()) {
            $urls = array();
            foreach (explode('_', $docids) as $docid) {
                $urls[] = $this->site->host . '/doc/' . $docid . 'html';
            }

            $site = str_replace('https://', '', $this->site->host);
            $site = str_replace('http://', '', $this->site->host);

            $api = 'http://data.zz.baidu.com/urls?site=' . $site . '&token=' . $bdpush->token;
            $ch = curl_init();
            $options = array(
                CURLOPT_URL => $api,
                CURLOPT_POST => true,
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_POSTFIELDS => implode("\n", $urls),
                CURLOPT_HTTPHEADER => array('Content-Type: text/plain'),
            );
            curl_setopt_array($ch, $options);
            $result = curl_exec($ch);

            $r = json_decode($result);

            if (isset($r->error)) {
                echo $r->message;
            } else if (isset($r->success)) {
                echo '成功推送' . $r->success . '条，还剩' . $r->remain . '条';
            }

        } else {
            echo "没有开启百度主动推送";
        }
    }

    public function down($docid)
    {
        if ($docid && ($doc = get_doc($docid)) && downfile($doc->path, 0)) {
            header('Content-Type:application/octet-stream');
            header('Content-Disposition:attachment;filename=' . $doc->title . '.' . $doc->exten);
            header('Content-Transfer-Encoding:binary');
            header('Content-Length:' . $doc->size);

            downfile($doc->path);

            flush();
            ob_flush();
        } else {
            echo '文档不存在';
        }
    }

    public function report()
    {
        if (IS_GET) {
            $this->load->view($this->template . 'admin/doc/report');
        } elseif (IS_POST) {

            $searchcol = $this->input->post('searchcol');
            $searchtext = $this->input->post('searchtext');
            $sortcol = $this->input->post('sortcol');
            $sorttext = $this->input->post('sorttext');
            $pagesize = $this->input->post('pagesize');
            $pagecurrent = $this->input->post('pagecurrent');

            if ($searchtext != '') {
                $this->db->like($searchcol, $searchtext);
            }

            $this->db->where('state', 0);

            $total = $this->db->count_all_results('report_view', false);

            $reports = $this->db->select('reportid,docid,title,userid,nickname,exten,report,extra,insertdate,state')->order_by($sortcol, $sorttext)->limit($pagesize, ($pagesize * $pagecurrent - $pagesize))->get()->result();

            foreach ($reports as $report) {
                $report->docpic = "doc/$report->docid.thum";
                $report->uploaddate = date('Y-m-d', strtotime($report->insertdate));
            }
            echo json_encode(array('total' => $total, 'data' => $reports));
        }
    }

    //删除举报文档，同时删除举报信息(逻辑)，当一个文档被多个用户举报时，删除了此文档，多个举报信息会被删除
    public function report_del($docids)
    {
        if ($docids) {
            foreach (explode('_', $docids) as $docid) {
                $this->doc_del($docid);
                $data = array(
                    'state' => -1,
                );
                $this->db->update('report', $data, array('docid' => $docid));

            }
        }
    }

    public function comment($which)
    {
        if (IS_GET) {
            $this->load->view($this->template . 'admin/doc/comment');
        } elseif (IS_POST) {
            $this->commentlist($which);
        }
    }

    public function commentlist($which)
    {
        $searchcol = $this->input->post('searchcol');
        $searchtext = $this->input->post('searchtext');
        $sortcol = $this->input->post('sortcol');
        $sorttext = $this->input->post('sorttext');
        $pagesize = $this->input->post('pagesize');
        $pagecurrent = $this->input->post('pagecurrent');

        switch ($which) {
            case 'audit':
                $this->db->where(array('state' => 0));
                break;
            case 'online':
                $this->db->where(array('state' => 1));
                break;
        }
        if ($searchtext != '') {
            $this->db->like($searchcol, $searchtext);
        }

        $total = $this->db->count_all_results('comment_view', false);

        $comments = $this->db->order_by($sortcol, $sorttext)->limit($pagesize, ($pagesize * $pagecurrent - $pagesize))->get()->result();
        foreach ($comments as $comment) {
        }
        echo json_encode(array('total' => $total, 'data' => $comments));
    }

    public function comment_audit($commentids = 0)
    {
        if (IS_GET) {
            $data['commentids'] = $commentids;
            $this->load->view($this->template . 'admin/doc/comment_audit', $data);
        } elseif (IS_POST) {
            if ($commentids) {
                $passed = $this->input->post('passed');
                $nopass = $this->input->post('nopass');
                $note = $this->input->post('note');

                $data['state'] = 0;
                if ($passed == '1') {
                    $data['state'] = 1;
                    $data['note'] = $note;
                    foreach (explode('_', $commentids) as $commentid) {
                        echo $this->db->update('comment', $data, array('commentid' => $commentid));
                    }
                }
                if ($nopass == '1') {
                    $this->comment_del2($commentids);
                }
            }
        }
    }

    public function comment_del2($commentids = 0)
    {
        if ($commentids) {
            foreach (explode('_', $commentids) as $commentid) {
                $this->db->delete('comment', array('commentid' => $commentid));
            }
        }
    }
}
