<?php

defined('BASEPATH') or exit('No direct script access allowed');

class Ips extends Admin_Controller
{

    public function __construct()
    {
        parent::__construct();

        $menu = array(
            'title' => 'IP管理',
            'menu' => array(
                'admin/ips/forbidip' => '禁止访问IP',
                'admin/ips/adminip' => '管理后台IP',
            ));
        $this->load->vars('menu', $menu);
    }

    public function forbidip()
    {
        $data['forbidip'] = $this->db->order_by('sort')->get('forbidip')->result();
        $this->load->view($this->template . 'admin/ips/forbidip', $data);
    }

    public function forbidip_edit($id)
    {
        if (IS_GET) {
            if ($id && $row = $this->db->get_where('forbidip', array('id' => $id))->row()) {
                $data['forbidip'] = $row;
            } else {
                $data['forbidip'] = (object) array(
                    'id' => '0',
                    'ip' => '',
                    'sort' => '',
                    'state' => '1',
                );
            }
            $this->load->view($this->template . 'admin/ips/forbidip_edit', $data);
        } elseif (IS_POST) {
            $data = array(
                'ip' => $this->input->post('ip'),
                'sort' => $this->input->post('sort'),
                'state' => $this->input->post('state'),
            );
            if ($id) {
                echo $this->db->update('forbidip', $data, array('id' => $id));
            } else {
                echo $this->db->insert('forbidip', $data);
            }
        }
    }

    public function forbidip_del($id)
    {
        if ($id) {
            echo $this->db->delete('forbidip', array('id' => $id));
        }
    }

    public function forbidip_state()
    {
        $data = array(
            'state' => $this->input->post('val'),
        );
        if ($id = $this->input->post('key')) {
            echo $this->db->update('forbidip', $data, array('id' => $id));
        }
    }

    public function adminip()
    {
        $data['adminip'] = $this->db->order_by('sort')->get('adminip')->result();
        $this->load->view($this->template . 'admin/ips/adminip', $data);
    }

    public function adminip_edit($id)
    {
        if (IS_GET) {
            if ($id && $row = $this->db->get_where('adminip', array('id' => $id))->row()) {
                $data['adminip'] = $row;
            } else {
                $data['adminip'] = (object) array(
                    'id' => '0',
                    'ip' => '',
                    'sort' => '',
                    'state' => '1',
                );
            }
            $this->load->view($this->template . 'admin/ips/adminip_edit', $data);
        } elseif (IS_POST) {
            $data = array(
                'ip' => $this->input->post('ip'),
                'sort' => $this->input->post('sort'),
                'state' => $this->input->post('state'),
            );
            if ($id) {
                echo $this->db->update('adminip', $data, array('id' => $id));
            } else {
                echo $this->db->insert('adminip', $data);
            }
        }
    }

    public function adminip_del($id)
    {
        if ($id) {
            echo $this->db->delete('adminip', array('id' => $id));
        }
    }

    public function adminip_state()
    {
        $data = array(
            'state' => $this->input->post('val'),
        );
        if ($id = $this->input->post('key')) {
            echo $this->db->update('adminip', $data, array('id' => $id));
        }
    }
}
