<?php

defined('BASEPATH') or exit('No direct script access allowed');

class Order extends Admin_Controller
{

    public function __construct()
    {
        parent::__construct();
        $menu = array(
            'title' => '订单管理',
            'menu' => array(
                'admin/order/glod' => '充值订单',
                'admin/order/vip' => 'VIP 订单',
                'admin/order/down' => '文档扫码',
                'admin/order/topic' => '专题扫码',
                'javascript:;;" class="i' => '<span></span>',
                'admin/order/cash' => '提现订单',
            ));
        $this->load->vars('menu', $menu);
    }

    public function glod()
    {
        $this->load->view($this->template . 'admin/order/glod');
    }

    public function glodlist()
    {
        $searchcol = $this->input->post('searchcol');
        $searchtext = $this->input->post('searchtext');
        $sortcol = $this->input->post('sortcol');
        $sorttext = $this->input->post('sorttext');
        $pagesize = $this->input->post('pagesize');
        $pagecurrent = $this->input->post('pagecurrent');

        if ($searchtext != '') {
            $this->db->like($searchcol, $searchtext);
        }

        $total = $this->db->count_all_results('glodorder_view', false);

        $order = $this->db->order_by($sortcol, $sorttext)->limit($pagesize, ($pagesize * $pagecurrent - $pagesize))->get()->result();

        foreach ($order as $item) {
            switch ($item->from) {
                case 1:
                    $item->from = '微信';
                    break;
                case 2:
                    $item->from = '支付宝';
                    break;
                case 3:
                    $item->from = '个人';
                    break;
                default:
                    $item->from = '其他';
                    break;
            }
            switch ($item->tradeno) {
                case '2':
                    $item->from = '微信';
                    break;
                case '1':
                    $item->from = '支付宝';
                    break;
            }
            switch ($item->state) {
                case 0:
                    $item->state = '<span style="color:#f00">未付款</span>';
                    break;
                case 1:
                    $item->state = '<span style="color:#129A5C">已付款</span>';
                    break;
                case 2:
                    $item->state = '<span>完成</span>';
                    break;
                default:
                    $item->state = '';
                    break;
            }
        }
        echo json_encode(array('total' => $total, 'data' => $order));
    }

    public function glod_export()
    {
        header("Content-type:application/vnd.ms-excel");
        header("Content-Disposition:attachment;filename=glod_data.xls");

        echo iconv('UTF-8', "GB2312//IGNORE", "订单\t标题\t用户ID\t用户账号\t金额\t支付方式\t充值金币\t充值日期\t状态\r\n");
        $order = $this->db->order_by('orderid')->get("glodorder_view")->result();
        foreach ($order as $item) {
            switch ($item->from) {
                case 1:
                    $item->from = '微信';
                    break;
                case 2:
                    $item->from = '支付宝';
                    break;
                case 3:
                    $item->from = '个人';
                    break;
                default:
                    $item->from = '其他';
                    break;
            }
            switch ($item->tradeno) {
                case '2':
                    $item->from = '微信';
                    break;
                case '1':
                    $item->from = '支付宝';
                    break;
            }
            switch ($item->state) {
                case 0:
                    $item->state = '未付款';
                    break;
                case 1:
                    $item->state = '已付款';
                    break;
                case 2:
                    $item->state = '完成';
                    break;
                default:
                    $item->state = '';
                    break;
            }
            echo iconv('UTF-8', "GB2312//IGNORE", 'No' . $item->orderid . "\t" . $item->title . "\t" . $item->userid . "\t" . $item->username . "\t" . $item->cash . "\t" . $item->from . "\t" . $item->glods . "\t" . $item->insertdate . "\t" . $item->state . "\r\n");
        }
    }

    public function vip()
    {
        $this->load->view($this->template . 'admin/order/vip');
    }

    public function viplist()
    {
        $searchcol = $this->input->post('searchcol');
        $searchtext = $this->input->post('searchtext');
        $sortcol = $this->input->post('sortcol');
        $sorttext = $this->input->post('sorttext');
        $pagesize = $this->input->post('pagesize');
        $pagecurrent = $this->input->post('pagecurrent');

        if ($searchtext != '') {
            $this->db->like($searchcol, $searchtext);
        }

        $total = $this->db->count_all_results('viporder_view', false);

        $order = $this->db->order_by($sortcol, $sorttext)->limit($pagesize, ($pagesize * $pagecurrent - $pagesize))->get()->result();

        foreach ($order as $item) {
            switch ($item->from) {
                case 1:
                    $item->from = '微信';
                    break;
                case 2:
                    $item->from = '支付宝';
                    break;
                case 3:
                    $item->from = '个人';
                    break;
                default:
                    $item->from = '其他';
                    break;
            }
            switch ($item->tradeno) {
                case '2':
                    $item->from = '微信';
                    break;
                case '1':
                    $item->from = '支付宝';
                    break;
            }
            switch ($item->state) {
                case 0:
                    $item->state = '<span style="color:#f00">未付款</span>';
                    break;
                case 1:
                    $item->state = '<span style="color:#129A5C">已付款</span>';
                    break;
                case 2:
                    $item->state = '<span>完成</span>';
                    break;
                default:
                    $item->state = '';
                    break;
            }
        }
        echo json_encode(array('total' => $total, 'data' => $order));
    }

    public function vip_export()
    {
        header("Content-type:application/vnd.ms-excel");
        header("Content-Disposition:attachment;filename=vip_data.xls");

        echo iconv('UTF-8', "GB2312//IGNORE", "订单\t标题\t用户ID\t用户账号\t金额\t支付方式\t开通天数\t充值日期\t状态\r\n");
        $order = $this->db->order_by('orderid')->get("viporder_view")->result();
        foreach ($order as $item) {
            switch ($item->from) {
                case 1:
                    $item->from = '微信';
                    break;
                case 2:
                    $item->from = '支付宝';
                    break;
                case 3:
                    $item->from = '个人';
                    break;
                default:
                    $item->from = '其他';
                    break;
            }
            switch ($item->tradeno) {
                case '2':
                    $item->from = '微信';
                    break;
                case '1':
                    $item->from = '支付宝';
                    break;
            }
            switch ($item->state) {
                case 0:
                    $item->state = '未付款';
                    break;
                case 1:
                    $item->state = '已付款';
                    break;
                case 2:
                    $item->state = '完成';
                    break;
                default:
                    $item->state = '';
                    break;
            }
            echo iconv('UTF-8', "GB2312//IGNORE", 'No' . $item->orderid . "\t" . $item->title . "\t" . $item->userid . "\t" . $item->username . "\t" . $item->cash . "\t" . $item->from . "\t" . $item->vipdays . "\t" . $item->insertdate . "\t" . $item->state . "\r\n");
        }
    }

    public function down()
    {
        $this->load->view($this->template . 'admin/order/down');
    }

    public function downlist()
    {
        $searchcol = $this->input->post('searchcol');
        $searchtext = $this->input->post('searchtext');
        $sortcol = $this->input->post('sortcol');
        $sorttext = $this->input->post('sorttext');
        $pagesize = $this->input->post('pagesize');
        $pagecurrent = $this->input->post('pagecurrent');

        if ($searchtext != '') {
            $this->db->like($searchcol, $searchtext);
        }

        $total = $this->db->count_all_results('downorder_view', false);

        $order = $this->db->order_by($sortcol, $sorttext)->limit($pagesize, ($pagesize * $pagecurrent - $pagesize))->get()->result();

        foreach ($order as $item) {
            switch ($item->from) {
                case 1:
                    $item->from = '微信';
                    break;
                case 2:
                    $item->from = '支付宝';
                    break;
                case 3:
                    $item->from = '个人';
                    break;
                default:
                    $item->from = '其他';
                    break;
            }
            switch ($item->tradeno) {
                case '2':
                    $item->from = '微信';
                    break;
                case '1':
                    $item->from = '支付宝';
                    break;
            }
            switch ($item->state) {
                case 0:
                    $item->state = '<span style="color:#f00">未付款</span>';
                    break;
                case 1:
                    $item->state = '<span style="color:#129A5C">已付款</span>';
                    break;
                case 2:
                    $item->state = '<span>完成</span>';
                    break;
                default:
                    $item->state = '';
                    break;
            }
        }
        echo json_encode(array('total' => $total, 'data' => $order));
    }

    public function down_export()
    {
        header("Content-type:application/vnd.ms-excel");
        header("Content-Disposition:attachment;filename=down_data.xls");

        echo iconv('UTF-8', "GB2312//IGNORE", "订单\t标题\t用户ID\t用户账号\t金额\t支付方式\t相关文档\t充值日期\t状态\r\n");
        $order = $this->db->order_by('orderid')->get("downorder_view")->result();
        foreach ($order as $item) {
            switch ($item->from) {
                case 1:
                    $item->from = '微信';
                    break;
                case 2:
                    $item->from = '支付宝';
                    break;
                case 3:
                    $item->from = '个人';
                    break;
                default:
                    $item->from = '其他';
                    break;
            }
            switch ($item->tradeno) {
                case '2':
                    $item->from = '微信';
                    break;
                case '1':
                    $item->from = '支付宝';
                    break;
            }
            switch ($item->state) {
                case 0:
                    $item->state = '未付款';
                    break;
                case 1:
                    $item->state = '已付款';
                    break;
                case 2:
                    $item->state = '完成';
                    break;
                default:
                    $item->state = '';
                    break;
            }
            echo iconv('UTF-8', "GB2312//IGNORE", 'No' . $item->orderid . "\t" . $item->title . "\t" . $item->userid . "\t" . $item->username . "\t" . $item->cash . "\t" . $item->from . "\t" . $item->dtitle . "\t" . $item->insertdate . "\t" . $item->state . "\r\n");
        }
    }

    public function topic()
    {
        $this->load->view($this->template . 'admin/order/topic');
    }

    public function topiclist()
    {
        $searchcol = $this->input->post('searchcol');
        $searchtext = $this->input->post('searchtext');
        $sortcol = $this->input->post('sortcol');
        $sorttext = $this->input->post('sorttext');
        $pagesize = $this->input->post('pagesize');
        $pagecurrent = $this->input->post('pagecurrent');

        if ($searchtext != '') {
            $this->db->like($searchcol, $searchtext);
        }

        $total = $this->db->count_all_results('topicorder_view', false);

        $order = $this->db->order_by($sortcol, $sorttext)->limit($pagesize, ($pagesize * $pagecurrent - $pagesize))->get()->result();

        foreach ($order as $item) {
            switch ($item->from) {
                case 1:
                    $item->from = '微信';
                    break;
                case 2:
                    $item->from = '支付宝';
                    break;
                case 3:
                    $item->from = '个人';
                    break;
                default:
                    $item->from = '其他';
                    break;
            }
            switch ($item->tradeno) {
                case '2':
                    $item->from = '微信';
                    break;
                case '1':
                    $item->from = '支付宝';
                    break;
            }
            switch ($item->state) {
                case 0:
                    $item->state = '<span style="color:#f00">未付款</span>';
                    break;
                case 1:
                    $item->state = '<span style="color:#129A5C">已付款</span>';
                    break;
                case 2:
                    $item->state = '<span>完成</span>';
                    break;
                default:
                    $item->state = '';
                    break;
            }
        }
        echo json_encode(array('total' => $total, 'data' => $order));
    }

    public function topic_export()
    {
        header("Content-type:application/vnd.ms-excel");
        header("Content-Disposition:attachment;filename=topic_data.xls");

        echo iconv('UTF-8', "GB2312//IGNORE", "订单\t标题\t用户ID\t用户账号\t金额\t支付方式\t相关文档\t充值日期\t状态\r\n");
        $order = $this->db->order_by('orderid')->get("topicorder_view")->result();
        foreach ($order as $item) {
            switch ($item->from) {
                case 1:
                    $item->from = '微信';
                    break;
                case 2:
                    $item->from = '支付宝';
                    break;
                case 3:
                    $item->from = '个人';
                    break;
                default:
                    $item->from = '其他';
                    break;
            }
            switch ($item->tradeno) {
                case '2':
                    $item->from = '微信';
                    break;
                case '1':
                    $item->from = '支付宝';
                    break;
            }
            switch ($item->state) {
                case 0:
                    $item->state = '未付款';
                    break;
                case 1:
                    $item->state = '已付款';
                    break;
                case 2:
                    $item->state = '完成';
                    break;
                default:
                    $item->state = '';
                    break;
            }
            echo iconv('UTF-8', "GB2312//IGNORE", 'No' . $item->orderid . "\t" . $item->title . "\t" . $item->userid . "\t" . $item->username . "\t" . $item->cash . "\t" . $item->from . "\t" . $item->dtitle . "\t" . $item->insertdate . "\t" . $item->state . "\r\n");
        }
    }

    public function cash()
    {
        $this->load->view($this->template . 'admin/order/cash');
    }

    public function cashlist()
    {
        $searchcol = $this->input->post('searchcol');
        $searchtext = $this->input->post('searchtext');
        $sortcol = $this->input->post('sortcol');
        $sorttext = $this->input->post('sorttext');
        $pagesize = $this->input->post('pagesize');
        $pagecurrent = $this->input->post('pagecurrent');

        if ($searchtext != '') {
            $this->db->like($searchcol, $searchtext);
        }

        $total = $this->db->count_all_results('cashorder_view', false);

        $order = $this->db->order_by($sortcol, $sorttext)->limit($pagesize, ($pagesize * $pagecurrent - $pagesize))->get()->result();

        foreach ($order as $item) {
            $item->insertdate = date('Y-m-d', strtotime($item->insertdate));
            $item->tradedate = date('Y-m-d', strtotime($item->tradedate));
            switch ($item->from) {
                case 1:
                    $item->from = '支付宝';
                    break;
                case 2:
                    $item->from = '微信';
                    break;
                default:
                    $item->from = '其他';
                    break;
            }
            switch ($item->tradestate) {
                case 0:
                    $item->tradeno = '';
                    $item->tradedate = '';
                    $item->tradedesc = '';
                    $item->tradestate = '<span style="color:#f60">未打款</span>';
                    break;
                case 1:
                    $item->tradestate = '<span style="color:#129A5C">已付款</span>';
                    break;
            }
            switch ($item->state) {
                case 0:
                    $item->state = '<span style="color:#f60">待审核</span>';
                    break;
                case 1:
                    $item->state = '<span style="color:#129A5C">审核通过</span>';
                    break;
                case -1:
                    $item->state = '<span style="color:#f00">审核未过</span>';
                    break;
            }
        }
        echo json_encode(array('total' => $total, 'data' => $order));
    }

    public function cash_edit($orderid)
    {
        if (IS_GET) {
            if ($orderid && $row = $this->db->get_where('cashorder', array('orderid' => $orderid))->row()) {
                $data['cashorder'] = $row;
                $this->load->view($this->template . 'admin/order/cash_edit', $data);
            }
        } elseif (IS_POST) {
            $data = array(
                'userid' => $this->input->post('userid'),
                'glods' => $this->input->post('glods'),
                'tradeno' => $this->input->post('tradeno'),
                'tradecash' => $this->input->post('tradecash'),
                'tradedate' => $this->input->post('tradedate'),
                'tradedesc' => $this->input->post('tradedesc'),
                'tradestate' => $this->input->post('tradestate'),
                'state' => $this->input->post('state'),
            );
            if ($orderid) {
                $tradeold = $this->db->select('state')->get_where('cashorder', array('orderid' => $orderid))->row();
                if ($tradeold) {
                    if ($tradeold->state == '0' && $data['state'] == 1) {

                        $glodpotdata = array(
                            'userid' => $data['userid'],
                            'linkid' => $orderid,
                            'type' => -10,
                            'glods' => 0 - $data['glods'],
                        );
                        $this->db->insert('glodpot', $glodpotdata);

                        $this->db->set('glods', 'glods-' . $data['glods'], false)->where('userid', $data['userid'])->update('user');
                    }
                }
                echo $this->db->update('cashorder', $data, array('orderid' => $orderid));
            }
        }
    }

    public function cash_del($orderids)
    {
        if ($orderids) {
            foreach (explode('_', $orderids) as $orderid) {
                $this->db->delete('cashorder', array('orderid' => $orderid));
            }
        }
    }

    public function glod_state($orderids)
    {
        if ($orderids) {
            foreach (explode('_', $orderids) as $orderid) {
                $data['state'] = 1;
                echo $this->db->update('glodorder', $data, array('orderid' => $orderid));
            }
        }
    }

    public function glod_del($orderids)
    {
        if ($orderids) {
            foreach (explode('_', $orderids) as $orderid) {
                $this->db->delete('glodorder', array('orderid' => $orderid));
            }
        }
    }

    public function vip_state($orderids)
    {
        if ($orderids) {
            foreach (explode('_', $orderids) as $orderid) {
                $data['state'] = 1;
                echo $this->db->update('viporder', $data, array('orderid' => $orderid));

                //$vipgroup = get_vipgroup($order->vgroupid);
                //addvipdays($user, $vipgroup->vgroupid, $vipgroup->vipdays);
            }
        }
    }

    public function vip_del($orderids)
    {
        if ($orderids) {
            foreach (explode('_', $orderids) as $orderid) {
                $this->db->delete('viporder', array('orderid' => $orderid));
            }
        }
    }

    public function down_state($orderids)
    {
        if ($orderids) {
            foreach (explode('_', $orderids) as $orderid) {
                $data['state'] = 1;
                echo $this->db->update('downorder', $data, array('orderid' => $orderid));
            }
        }
    }

    public function down_del($orderids)
    {
        if ($orderids) {
            foreach (explode('_', $orderids) as $orderid) {
                $this->db->delete('downorder', array('orderid' => $orderid));
            }
        }
    }

    public function topic_state($orderids)
    {
        if ($orderids) {
            foreach (explode('_', $orderids) as $orderid) {
                $data['state'] = 1;
                echo $this->db->update('topicorder', $data, array('orderid' => $orderid));
            }
        }
    }

    public function topic_del($orderids)
    {
        if ($orderids) {
            foreach (explode('_', $orderids) as $orderid) {
                $this->db->delete('topicorder', array('orderid' => $orderid));
            }
        }
    }
}
