<?php

defined('BASEPATH') or exit('No direct script access allowed');

class Pay extends Admin_Controller
{
    public function __construct()
    {
        parent::__construct();

        $menu = array(
            'title' => '支付设置',
            'menu' => array(
                'admin/pay' => '支付设置',
            ));
        $this->load->vars('menu', $menu);
    }

    public function index()
    {
        if (IS_GET) {
            if ($row = $this->db->get('payset')->row()) {
                $data['payset'] = $row;
                $this->load->view($this->template . 'admin/pay/index', $data);
            } else {
                $data['error'] = '数据表glodset数据为空';
                $this->load->view($this->template . 'admin/error', $data);
            }
        } else {
            $data = array(
                'alipay' => $this->input->post('alipay'),
                'weipay' => $this->input->post('weipay'),
                'palipay' => $this->input->post('palipay'),
                'pweipay' => $this->input->post('pweipay'),
            );
            echo $this->db->update('payset', $data);
        }
    }

    public function alipay_edit()
    {
        if (IS_GET) {
            if ($row = $this->db->get('alipayset')->row()) {
                $data['alipayset'] = $row;
            } else {
                $data['alipayset'] = (object) array(
                    'app_id' => '',
                    'private_key' => '',
                    'public_key' => '',
                    'sign_type' => 'RSA2',
                    'isewm' => 1,
                );
            }
            $this->load->view($this->template . 'admin/pay/alipay_edit', $data);
        } elseif (IS_POST) {
            $data = array(
                'app_id' => $this->input->post('app_id'),
                'private_key' => $this->input->post('private_key'),
                'public_key' => $this->input->post('public_key'),
                'sign_type' => $this->input->post('sign_type'),
                'isewm' => $this->input->post('isewm'),
            );
            echo $this->db->update('alipayset', $data);
        }
    }

    public function weipay_edit()
    {
        if (IS_GET) {
            if ($row = $this->db->get('weipayset')->row()) {
                $data['weipayset'] = $row;
            } else {
                $data['weipayset'] = (object) array(
                    'APPID' => '',
                    'MCHID' => '',
                    'KEY' => '',
                    'APPSECRET' => '',
                );
            }
            $this->load->view($this->template . 'admin/pay/weipay_edit', $data);
        } elseif (IS_POST) {
            $data = array(
                'APPID' => $this->input->post('APPID'),
                'MCHID' => $this->input->post('MCHID'),
                'KEY' => $this->input->post('KEY'),
                'APPSECRET' => $this->input->post('APPSECRET'),
            );
            if ($this->db->update('weipayset', $data)) {
                echo 1;
            }
        }
    }

    public function perpay_edit()
    {
        if (IS_GET) {
            if ($row = $this->db->get('perpayset')->row()) {
                $data['perpayset'] = $row;
            } else {
                $data['perpayset'] = (object) array(
                    'appkey' => '',
                );
            }
            $this->load->view($this->template . 'admin/pay/perpay_edit', $data);
        } elseif (IS_POST) {
            $data = array(
                'appkey' => $this->input->post('appkey'),
            );
            echo $this->db->update('perpayset', $data);
        }
    }

}
