<?php

defined('BASEPATH') or exit('No direct script access allowed');

class Plugin extends Admin_Controller
{

    public function __construct()
    {
        parent::__construct();

        $menu = array(
            'title' => '插件设置',
            'menu' => array(
                'admin/plugin/oss' => '阿里存储OSS',
                'admin/plugin/share' => '百度分享',
                'admin/plugin/shang' => '阅读打赏',
                'admin/plugin/fenci' => '分词服务',
            ));
        $this->load->vars('menu', $menu);
    }

    public function index()
    {

    }

    public function oss()
    {
        if (IS_GET) {
            if ($row = $this->db->get('ossset')->row()) {
                if (is_dir('app/libraries/Oss/')) {
                    $data['install'] = 1;
                } else {
                    $data['install'] = 0;
                }
                $data['ossset'] = $row;
                $this->load->view($this->template . 'admin/plugin/oss', $data);
            } else {
                $data['message'] = '数据表ossset数据为空';
                $this->load->view($this->template . 'admin/error', $data);
            }
        } elseif (IS_POST) {
            $data = array(
                'keyid' => $this->input->post('keyid'),
                'keysecret' => $this->input->post('keysecret'),
                'bucket' => $this->input->post('bucket'),
                'endpoint' => $this->input->post('endpoint'),
                'delfile' => $this->input->post('delfile'),
                'fluxoss' => $this->input->post('fluxoss'),
                'state' => $this->input->post('state'),
            );
            if ($this->db->update('ossset', $data)) {
                $this->load->library('Oss/oss');
                $this->oss->createBucket();
            } else {
                echo 0;
            }
        }
    }

    public function share()
    {
        if (IS_GET) {
            if ($row = $this->db->get('shareset')->row()) {
                if (is_dir('app/libraries/BaiduShare/')) {
                    $data['install'] = 1;
                } else {
                    $data['install'] = 0;
                }
                $data['shareset'] = $row;
                $this->load->view($this->template . 'admin/plugin/share', $data);
            } else {
                $data['error'] = '数据表shareset数据为空';
                $this->load->view($this->template . 'admin/error', $data);
            }
        } elseif (IS_POST) {
            $data = array(
                'src' => $this->input->post('src'),
                'state' => $this->input->post('state'),
            );
            if ($this->db->update('shareset', $data)) {
                echo 1;
            } else {
                echo 0;
            }
        }
    }

    public function shang()
    {
        if (IS_GET) {
            if ($row = $this->db->get('shangset')->row()) {
                $data['shangset'] = $row;
                $this->load->view($this->template . 'admin/plugin/shang', $data);
            } else {
                $data['error'] = '数据表shangset数据为空';
                $this->load->view($this->template . 'admin/error', $data);
            }
        } elseif (IS_POST) {
            savebase64($this->input->post('weipay'), 'data/perpay/weipay');
            savebase64($this->input->post('alipay'), 'data/perpay/alipay');

            $data = array(
                'state' => $this->input->post('state'),
            );
            if ($this->db->update('shangset', $data)) {
                echo 1;
            } else {
                echo 0;
            }
        }
    }

    public function fenci()
    {
        if (IS_GET) {
            if ($row = $this->db->get('fenciset')->row()) {
                $data['fenciset'] = $row;
                $this->load->view($this->template . 'admin/plugin/fenci', $data);
            } else {
                $data['error'] = '数据表fenciset数据为空';
                $this->load->view($this->template . 'admin/error', $data);
            }
        } elseif (IS_POST) {
            $data = array(
                'appkey' => $this->input->post('appkey'),
                'state' => $this->input->post('state'),
            );
            if ($this->db->update('fenciset', $data)) {
                echo 1;
            } else {
                echo 0;
            }
        }
    }

    public function fencidata()
    {
        if (IS_GET) {
            $this->load->view($this->template . 'admin/plugin/fenci');
        } elseif (IS_POST) {
            $searchcol = $this->input->post('searchcol');
            $searchtext = $this->input->post('searchtext');
            $sortcol = $this->input->post('sortcol');
            $sorttext = $this->input->post('sorttext');
            $pagesize = $this->input->post('pagesize');
            $pagecurrent = $this->input->post('pagecurrent');

            if ($searchtext != '') {
                $this->db->like($searchcol, $searchtext);
            }

            $total = $this->db->count_all_results('fencidata', false);
            $fencidata = $this->db->order_by($sortcol, $sorttext)->limit($pagesize, ($pagesize * $pagecurrent - $pagesize))->get()->result();

            echo json_encode(array('total' => $total, 'data' => $fencidata));
        }
    }

    public function fencidata_edit($id)
    {
        if (IS_GET) {
            if ($id && $row = $this->db->get_where('fencidata', array('id' => $id))->row()) {
                $data['fencidata'] = $row;
            } else {
                $data['fencidata'] = (object) array(
                    'id' => 0,
                    'word' => '',
                    'sort' => 1,
                );
            }
            $this->load->view($this->template . 'admin/plugin/fencidata_edit', $data);
        } elseif (IS_POST) {
            $data = array(
                'word' => $this->input->post('word'),
                'sort' => $this->input->post('sort'),
            );
            if ($id) {
                echo $this->db->update('fencidata', $data, array('id' => $id));
            } else {
                echo $this->db->insert('fencidata', $data);
            }
        }
    }

    public function fencidata_del2($ids = 0)
    {
        if ($ids) {
            foreach (explode('_', $ids) as $id) {
                $this->db->delete('fencidata', array('id' => $id));
            }
        }
    }
}
