<?php

defined('BASEPATH') or exit('No direct script access allowed');

class Reward extends Admin_Controller
{

    public function __construct()
    {
        parent::__construct();
        $menu = array(
            'title' => '悬赏管理',
            'menu' => array(
                'admin/reward/audit' => '待审悬赏任务',
                'admin/reward/passed' => '审核通过悬赏',
                'admin/reward/nopass' => '审核失败悬赏',
            ));
        $this->load->vars('menu', $menu);
    }

    public function index($which)
    {
        if (IS_GET) {
            $this->load->view($this->template . 'admin/reward/index');
        } elseif (IS_POST) {
            $this->rewardlist($which);
        }
    }

    public function rewardlist($which)
    {
        $searchcol = $this->input->post('searchcol');
        $searchtext = $this->input->post('searchtext');
        $sortcol = $this->input->post('sortcol');
        $sorttext = $this->input->post('sorttext');
        $pagesize = $this->input->post('pagesize');
        $pagecurrent = $this->input->post('pagecurrent');

        switch ($which) {
            case 'audit':
                $this->db->where('state', 0);
                break;
            case 'passed':
                $this->db->where('state >', 0);
                break;
            case 'nopass':
                $this->db->where('state', -1);
                break;
        }
        if ($searchtext != '') {
            $this->db->like($searchcol, $searchtext);
        }

        $total = $this->db->count_all_results('reward_view', false);

        $rewards = $this->db->order_by($sortcol, $sorttext)->limit($pagesize, ($pagesize * $pagecurrent - $pagesize))->get()->result();

        foreach ($rewards as $reward) {
            $reward->istop = $reward->istoping ? '<span class="block">置顶中</span>' : '';
            $reward->pubdate = date('Y-m-d', strtotime($reward->insertdate));
            $reward->draftnum = $this->db->select('count(*) as count')->get_where('draft', array('state >=' => 0, 'reid' => $reward->reid))->row()->count;
            switch ($reward->state) {
                case '-1':
                    $reward->sshow = '审核失败';
                    break;
                case '0':
                    $reward->sshow = '未审核';
                    break;
                case '1':
                    $reward->sshow = '未定稿';
                    break;
                case '2':
                    $reward->sshow = '已定稿';
                    break;
                case '3':
                    $reward->sshow = '悬赏失败';
                    break;
            }
        }
        echo json_encode(array('total' => $total, 'data' => $rewards));
    }

    public function reward_audit($reids = 0)
    {
        if (IS_GET) {
            $data['reids'] = $reids;
            $this->load->view($this->template . 'admin/reward/reward_audit', $data);
        } else {
            if ($reids) {
                $passed = $this->input->post('passed');
                $nopass = $this->input->post('nopass');
                $note = $this->input->post('note');

                $data['note'] = $note;
                $data['state'] = 0;
                if ($passed == '1') {
                    $data['state'] = 1;
                }
                if ($nopass == '1') {
                    $data['state'] = -1;
                }
                foreach (explode('_', $reids) as $reid) {
                    echo $this->db->update('reward', $data, array('reid' => $reid));
                }
            }
        }
    }

    public function reward_del($reids = -1)
    {
        if ($reids) {
            foreach (explode('_', $reids) as $reid) {
                $this->db->delete('reward', array('reid' => $reid));
            }
        }
    }

}
