<?php

defined('BASEPATH') or exit('No direct script access allowed');

class Seo extends Admin_Controller
{
    private $size = 39999;

    public function __construct()
    {
        parent::__construct();

        $menu = array(
            'title' => 'SEO管理',
            'menu' => array(
                'admin/seo' => 'SEO设置',
                'admin/seo/bdpush' => '链接推送',
                'admin/seo/sitemap' => 'Sitemap',
                'admin/seo/dockey' => '内联关键字',
                'admin/seo/incid' => '自增ID值',
            ));
        $this->load->vars('menu', $menu);
    }

    public function index()
    {
        if (IS_GET) {
            if ($row = $this->db->get('seo')->row()) {
                $data['seo'] = $row;
                $this->load->view($this->template . 'admin/seo/index', $data);
            } else {
                $data['error'] = '数据表seo数据为空';
                $this->load->view($this->template . 'admin/error', $data);
            }
        } elseif (IS_POST) {
            $data = array(
                'home' => $this->input->post('home'),
                'home_title' => $this->input->post('home_title'),
                'home_keys' => $this->input->post('home_keys'),
                'home_desc' => $this->input->post('home_desc'),
                'list' => $this->input->post('list'),
                'list_title' => $this->input->post('list_title'),
                'list_keys' => $this->input->post('list_keys'),
                'list_desc' => $this->input->post('list_desc'),
                'doc' => $this->input->post('doc'),
                'doc_title' => $this->input->post('doc_title'),
                'doc_keys' => $this->input->post('doc_keys'),
                'doc_desc' => $this->input->post('doc_desc'),
                'search' => $this->input->post('search'),
                'search_title' => $this->input->post('search_title'),
                'search_keys' => $this->input->post('search_keys'),
                'search_desc' => $this->input->post('search_desc'),
                'topl' => $this->input->post('topl'),
                'topl_title' => $this->input->post('topl_title'),
                'topl_keys' => $this->input->post('topl_keys'),
                'topl_desc' => $this->input->post('topl_desc'),
                'topic' => $this->input->post('topic'),
                'topic_title' => $this->input->post('topic_title'),
                'topic_key' => $this->input->post('topic_key'),
                'topic_desc' => $this->input->post('topic_desc'),
                'rewl' => $this->input->post('rewl'),
                'rewl_title' => $this->input->post('rewl_title'),
                'rewl_keys' => $this->input->post('rewl_keys'),
                'rewl_desc' => $this->input->post('rewl_desc'),
                'reward' => $this->input->post('reward'),
                'reward_title' => $this->input->post('reward_title'),
                'reward_keys' => $this->input->post('reward_keys'),
                'reward_desc' => $this->input->post('reward_desc'),
                'artl' => $this->input->post('artl'),
                'artl_title' => $this->input->post('artl_title'),
                'artl_keys' => $this->input->post('artl_keys'),
                'artl_desc' => $this->input->post('artl_desc'),
                'article' => $this->input->post('article'),
                'article_title' => $this->input->post('article_title'),
                'article_keys' => $this->input->post('article_keys'),
                'article_desc' => $this->input->post('article_desc'),
                'askl' => $this->input->post('askl'),
                'askl_title' => $this->input->post('askl_title'),
                'askl_keys' => $this->input->post('askl_keys'),
                'askl_desc' => $this->input->post('askl_desc'),
                'ask' => $this->input->post('ask'),
                'ask_title' => $this->input->post('ask_title'),
                'ask_keys' => $this->input->post('ask_keys'),
                'ask_desc' => $this->input->post('ask_desc'),
                'userl' => $this->input->post('userl'),
                'userl_title' => $this->input->post('userl_title'),
                'userl_keys' => $this->input->post('userl_keys'),
                'userl_desc' => $this->input->post('userl_desc'),
                'user' => $this->input->post('user'),
                'user_title' => $this->input->post('user_title'),
                'user_keys' => $this->input->post('user_keys'),
                'user_desc' => $this->input->post('user_desc'),
                'notice' => $this->input->post('notice'),
                'notice_title' => $this->input->post('notice_title'),
                'notice_keys' => $this->input->post('notice_keys'),
                'notice_desc' => $this->input->post('notice_desc'),
                'about' => $this->input->post('about'),
                'about_title' => $this->input->post('about_title'),
                'about_keys' => $this->input->post('about_keys'),
                'about_desc' => $this->input->post('about_desc'),
            );
            $this->db->update('seo', $data);
            writerouter();
        }
    }

    public function bdpush()
    {
        if (IS_GET) {
            if ($row = $this->db->get('bdpushset')->row()) {
                $data['bdpushset'] = $row;
                $this->load->view($this->template . 'admin/seo/bdpush', $data);
            } else {
                $data['error'] = '数据表bdpushset数据为空';
                $this->load->view($this->template . 'admin/error', $data);
            }
        } elseif (IS_POST) {
            $data = array(
                'token' => $this->input->post('token'),
                'src' => $this->input->post('src'),
                'state' => $this->input->post('state'),
            );
            if ($this->db->update('bdpushset', $data)) {
                echo 1;
            } else {
                echo 0;
            }
        }
    }

    private $nav;
    public function sitemap()
    {
        if (IS_GET) {
            $data['sitemap'] = $this->db->get('sitemap')->row();
            $this->load->view($this->template . 'admin/seo/sitemap', $data);
        } elseif (IS_POST) {
            $data = array(
                'home' => $this->input->post('home'),
                'type' => $this->input->post('type'),
                'doc' => $this->input->post('doc'),
                'topic' => $this->input->post('topic'),
                'reward' => $this->input->post('reward'),
                'article' => $this->input->post('article'),
                'ask' => $this->input->post('ask'),
                'about' => $this->input->post('about'),
            );
            $this->db->update('sitemap', $data);

            $other = [];
            if ($data['home']) {
                $other['home'] = 1;
            }
            if ($data['type']) {
                $other['type'] = 1;
            }
            if ($data['about']) {
                $other['about'] = 1;
            }

            $navbar = $this->db->select('id,href')->get('navbar')->result();
            $this->nav = [];
            foreach ($navbar as $n) {
                $this->nav[$n->id] = $n->href;
            }

            $this->createother($other);

            if ($data['doc']) {
                $count = $this->db->select('count(*) as count')->get_where('doc', array('state' => 1, 'isdel' => 0))->row()->count;
                for ($i = 1; $i <= ceil($count / $this->size); $i++) {
                    $this->createdoc($i);
                }
            }
            if ($data['topic']) {
                $count = $this->db->select('count(*) as count')->get_where('topic', array('state' => 1, 'isdel' => 0))->row()->count;
                for ($i = 1; $i <= ceil($count / $this->size); $i++) {
                    $this->createtopic($i);
                }
            }
            if ($data['reward']) {
                $count = $this->db->select('count(*) as count')->get_where('reward', array('state >' => 0))->row()->count;
                for ($i = 1; $i <= ceil($count / $this->size); $i++) {
                    $this->createreward($i);
                }
            }
            if ($data['article']) {
                $count = $this->db->select('count(*) as count')->get_where('article', array('state' => 1))->row()->count;
                for ($i = 1; $i <= ceil($count / $this->size); $i++) {
                    $this->createarticle($i);
                }
            }
            if ($data['ask']) {
                $count = $this->db->select('count(*) as count')->get_where('ask', array('state' => 1))->row()->count;
                for ($i = 1; $i <= ceil($count / $this->size); $i++) {
                    $this->createask($i);
                }
            }

            $this->createsitemap();
            $this->createrobots();
        }
    }

    private function createother($other)
    {
        if ($other) {
            $map = '<?xml version="1.0" encoding="utf-8"?>';
            $map .= '<urlset>';

            if ($other['home']) {
                $map .= '<url>' .
                '<loc>' . $this->site->host . '</loc>' .
                '<lastmod>' . date("Y-m-d H:i:s") . '</lastmod>' .
                    '<changefreq>always</changefreq>' .
                    '<priority>1</priority>' .
                    '</url>';
            }

            if ($other['type']) {
                $map .= '<url>' .
                '<loc>' . $this->site->host . '/'. $this->nav[2] . '</loc>' .
                '<lastmod>' . date("Y-m-d H:i:s") . '</lastmod>' .
                    '<changefreq>monthly</changefreq>' .
                    '<priority>0.8</priority>' .
                    '</url>';
                $types = $this->db->select('typeid,insertdate')->get_where('type')->result();
                foreach ($types as $type) {
                    $map .= '<url>' .
                    '<loc>' . $this->site->host . '/' . $this->seo->list . $type->typeid . '.html' . '</loc>' .
                    '<lastmod>' . date("Y-m-d H:i:s") . '</lastmod>' .
                        '<changefreq>always</changefreq>' .
                        '<priority>0.8</priority>' .
                        '</url>';
                }
            }

            if ($other['about']) {
                $abouts = $this->db->select('link,insertdate')->get_where('about', array('state >' => 0))->result();
                foreach ($abouts as $about) {
                    $map .= '<url>' .
                    '<loc>' . $this->site->host . '/' . $this->seo->about . $about->link . '</loc>' .
                    '<lastmod>' . $about->insertdate . '</lastmod>' .
                        '<changefreq>monthly</changefreq>' .
                        '<priority>0.8</priority>' .
                        '</url>';
                }
            }

            $map .= '</urlset>';
            file_put_contents('data/sitemap/other.xml', $map);
        }
    }

    private function createdoc($page)
    {
        $docs = $this->db->select('docid,insertdate')->limit($this->size, ($this->size * $page - $this->size))->get_where('doc', array('state' => 1, 'isdel' => 0))->result();
        $map = '<?xml version="1.0" encoding="utf-8"?>';
        $map .= '<urlset>';
        $map .= '<url>' .
        '<loc>' . $this->site->host . '/' . $this->nav[3] . '</loc>' .
        '<lastmod>' . date("Y-m-d H:i:s") . '</lastmod>' .
            '<changefreq>always</changefreq>' .
            '<priority>1</priority>' .
            '</url>';
        foreach ($docs as $doc) {
            $map .= '<url>' .
            '<loc>' . $this->site->host . '/' . $this->seo->doc . $doc->docid . '.html' . '</loc>' .
            '<lastmod>' . $doc->insertdate . '</lastmod>' .
                '<changefreq>weekly</changefreq>' .
                '<priority>1</priority>' .
                '</url>';
        }
        $map .= '</urlset>';
        file_put_contents('data/sitemap/doc' . $page . '.xml', $map);
    }

    private function createtopic($page)
    {
        $topics = $this->db->select('topicid,insertdate')->limit($this->size, ($this->size * $page - $this->size))->get_where('topic', array('state' => 1, 'isdel' => 0))->result();
        $map = '<?xml version="1.0" encoding="utf-8"?>';
        $map .= '<urlset>';
        $map .= '<url>' .
        '<loc>' . $this->site->host . '/' . $this->nav[4] . '</loc>' .
        '<lastmod>' . date("Y-m-d H:i:s") . '</lastmod>' .
            '<changefreq>always</changefreq>' .
            '<priority>1</priority>' .
            '</url>';
        foreach ($topics as $topic) {
            $map .= '<url>' .
            '<loc>' . $this->site->host . '/' . $this->seo->topic . $topic->topicid . '.html' . '</loc>' .
            '<lastmod>' . $topic->insertdate . '</lastmod>' .
                '<changefreq>daily</changefreq>' .
                '<priority>1</priority>' .
                '</url>';
        }
        $map .= '</urlset>';
        file_put_contents('data/sitemap/topic' . $page . '.xml', $map);
    }

    private function createreward($page)
    {
        $rewards = $this->db->select('reid,insertdate')->limit($this->size, ($this->size * $page - $this->size))->get_where('reward', array('state >' => 0))->result();
        $map = '<?xml version="1.0" encoding="utf-8"?>';
        $map .= '<urlset>';
        $map .= '<url>' .
        '<loc>' . $this->site->host . '/' . $this->nav[6] . '</loc>' .
        '<lastmod>' . date("Y-m-d H:i:s") . '</lastmod>' .
            '<changefreq>always</changefreq>' .
            '<priority>1</priority>' .
            '</url>';
        foreach ($rewards as $reward) {
            $map .= '<url>' .
            '<loc>' . $this->site->host . '/' . $this->seo->reward . $reward->reid . '.html' . '</loc>' .
            '<lastmod>' . $reward->insertdate . '</lastmod>' .
                '<changefreq>daily</changefreq>' .
                '<priority>1</priority>' .
                '</url>';
        }
        $map .= '</urlset>';
        file_put_contents('data/sitemap/reward' . $page . '.xml', $map);
    }

    private function createarticle($page)
    {
        $articles = $this->db->select('articleid,insertdate')->limit($this->size, ($this->size * $page - $this->size))->get_where('article', array('state' => 1))->result();
        $map = '<?xml version="1.0" encoding="utf-8"?>';
        $map .= '<urlset>';
        $map .= '<url>' .
        '<loc>' . $this->site->host . '/' . $this->nav[7] . '</loc>' .
        '<lastmod>' . date("Y-m-d H:i:s") . '</lastmod>' .
            '<changefreq>always</changefreq>' .
            '<priority>1</priority>' .
            '</url>';
        foreach ($articles as $article) {
            $map .= '<url>' .
            '<loc>' . $this->site->host . '/' . $this->seo->article . $article->articleid . '.html' . '</loc>' .
            '<lastmod>' . $article->insertdate . '</lastmod>' .
                '<changefreq>daily</changefreq>' .
                '<priority>1</priority>' .
                '</url>';
        }
        $map .= '</urlset>';
        file_put_contents('data/sitemap/article' . $page . '.xml', $map);
    }

    private function createask($page)
    {
        $asks = $this->db->select('askid,insertdate')->limit($this->size, ($this->size * $page - $this->size))->get_where('ask', array('state' => 1))->result();
        $map = '<?xml version="1.0" encoding="utf-8"?>';
        $map .= '<urlset>';
        $map .= '<url>' .
        '<loc>' . $this->site->host . '/' . $this->nav[8]  . '</loc>' .
        '<lastmod>' . date("Y-m-d H:i:s") . '</lastmod>' .
            '<changefreq>always</changefreq>' .
            '<priority>1</priority>' .
            '</url>';
        foreach ($asks as $ask) {
            $map .= '<url>' .
            '<loc>' . $this->site->host . '/' . $this->seo->ask . $ask->askid . '.html' . '</loc>' .
            '<lastmod>' . $ask->insertdate . '</lastmod>' .
                '<changefreq>daily</changefreq>' .
                '<priority>1</priority>' .
                '</url>';
        }
        $map .= '</urlset>';
        file_put_contents('data/sitemap/ask' . $page . '.xml', $map);
    }

    private function createsitemap()
    {
        $dir = './data/sitemap/';
        if (is_dir($dir) && $dh = opendir($dir)) {
            $map = '<?xml version="1.0" encoding="utf-8"?>';
            $map .= '<sitemapindex>';
            while ($file = readdir($dh)) {
                if ($file != '.' && $file != '..' && $file != 'index.html') {
                    $map .= '<sitemap>' .
                    '<loc>' . $this->site->host . '/data/sitemap/' . $file . '</loc>' .
                    '<lastmod>' . date("Y-m-d H:i:s", filemtime('data/sitemap/' . $file)) . '</lastmod>' .
                        '</sitemap>';
                }
            }
            $map .= '</sitemapindex>';
            closedir($dh);
            file_put_contents('sitemap.xml', $map);
        }

    }

    private function createrobots()
    {
        $robots = <<<EOF
#
# robots.txt for ds-wenku
#

User-agent: *
Allow: /data/sitemap/
Allow: /data/neditor/

Disallow: /api/
Disallow: /app/
Disallow: /template/
Disallow: /admin
Disallow: /center

Sitemap: {$this->site->host}/sitemap.xml
EOF;
        file_put_contents('robots.txt', $robots);
    }

    //dockey
    public function dockey()
    {
        $data['dockey'] = $this->db->order_by('sort')->get('dockey')->result();
        $this->load->view($this->template . 'admin/seo/dockey', $data);
    }

    public function dockey_edit($id)
    {
        if (IS_GET) {
            if ($id && $row = $this->db->get_where('dockey', array('id' => $id))->row()) {
                $data['dockey'] = $row;
            } else {
                $data['dockey'] = (object) array(
                    'id' => '0',
                    'key' => '',
                    'url' => '',
                    'sort' => '',
                    'state' => '1',
                );
            }
            $this->load->view($this->template . 'admin/seo/dockey_edit', $data);
        } elseif (IS_POST) {
            $data = array(
                'key' => $this->input->post('key'),
                'url' => $this->input->post('url'),
                'sort' => $this->input->post('sort'),
                'state' => $this->input->post('state'),
            );
            if ($id) {
                echo $this->db->update('dockey', $data, array('id' => $id));
            } else {
                echo $this->db->insert('dockey', $data);
            }
        }
    }

    public function dockey_del($id)
    {
        if ($id) {
            echo $this->db->delete('dockey', array('id' => $id));
        }
    }

    public function dockey_state()
    {
        $data = array(
            'state' => $this->input->post('val'),
        );
        if ($id = $this->input->post('key')) {
            echo $this->db->update('dockey', $data, array('id' => $id));
        }
    }


    public function incid()
    {
        if (IS_GET) {
            if ($row = $this->db->get('incid')->row()) {
                $data['incid'] = $row;
                $this->load->view($this->template . 'admin/seo/incid', $data);
            } else {
                $data['error'] = '数据表incid数据为空';
                $this->load->view($this->template . 'admin/error', $data);
            }
        } else {
            $data = array(
                'doc_sid' => $this->input->post('doc_sid'),
                'topic_sid' => $this->input->post('topic_sid'),
                'reward_sid' => $this->input->post('reward_sid'),
                'article_sid' => $this->input->post('article_sid'),
                'ask_sid' => $this->input->post('ask_sid'),
                'user_sid' => $this->input->post('user_sid'),
                'type_sid' => $this->input->post('type_sid'),
                'filter_sid' => $this->input->post('filter_sid'),
                'toptype_sid' => $this->input->post('toptype_sid'),
                'arttype_sid' => $this->input->post('arttype_sid'),
                'asktype_sid' => $this->input->post('asktype_sid'),
            );
            $sql = "";
            if ($this->input->post('doc_clear')) {
                deldir('data/doc', 'data/doc');
                $sql .= 'TRUNCATE TABLE `ds_doc`;';
            }
            $sql .= 'ALTER TABLE `ds_doc` auto_increment=' . $data['doc_sid'] . ';';

            if ($this->input->post('topic_clear')) {
                deldir('data/topic', 'data/topic');
                $sql .= 'TRUNCATE TABLE `ds_topic`;';
            }
            $sql .= 'ALTER TABLE `ds_topic` auto_increment=' . $data['topic_sid'] . ';';

            if ($this->input->post('reward_clear')) {
                $sql .= 'TRUNCATE TABLE `ds_reward`;';
            }
            $sql .= 'ALTER TABLE `ds_reward` auto_increment=' . $data['reward_sid'] . ';';

            if ($this->input->post('article_clear')) {
                $sql .= 'TRUNCATE TABLE `ds_article`;';
            }
            $sql .= 'ALTER TABLE `ds_article` auto_increment=' . $data['article_sid'] . ';';

            if ($this->input->post('ask_clear')) {
                $sql .= 'TRUNCATE TABLE `ds_ask`;';
            }
            $sql .= 'ALTER TABLE `ds_ask` auto_increment=' . $data['ask_sid'] . ';';

            if ($this->input->post('user_clear')) {
                deldir('/data/photo', '/data/photo');
                $sql .= 'TRUNCATE TABLE `ds_user`;';
                $sql .= "INSERT INTO `ds_user` (`userid`, `username`, `password`, `nickname`, `groupid`) VALUES(1, 'admin@docswf.com', 'e10adc3949ba59abbe56e057f20f883e', '小库', 1);";
                $sql .= 'ALTER TABLE `ds_user` auto_increment=' . $data['user_sid'] . ';';
            } else {
                $sql .= 'ALTER TABLE `ds_user` auto_increment=' . $data['user_sid'] . ';';
            }

            if ($this->input->post('type_clear')) {
                $sql .= 'TRUNCATE TABLE `ds_type`;';
                $sql .= 'ALTER TABLE `ds_type` auto_increment=' . $data['type_sid'] . ';';
                $sql .= "INSERT INTO `ds_type` (`ptypeid`, `typename`, `sort`) VALUES (0, '新分类A', 1);";
                $sql .= "INSERT INTO `ds_type` (`ptypeid`, `typename`, `sort`) VALUES (0, '新分类B', 2);";
                $sql .= "INSERT INTO `ds_type` (`ptypeid`, `typename`, `sort`) VALUES (0, '新分类C', 3);";
                $sql .= "INSERT INTO `ds_type` (`ptypeid`, `typename`, `sort`) VALUES (0, '新分类D', 4);";
                $sql .= "INSERT INTO `ds_type` (`ptypeid`, `typename`, `sort`) VALUES (0, '新分类E', 5);";
                $sql .= "INSERT INTO `ds_type` (`ptypeid`, `typename`, `sort`) VALUES (0, '新分类F', 6);";
                $sql .= "INSERT INTO `ds_type` (`ptypeid`, `typename`, `sort`) VALUES (0, '新分类G', 7);";
                $sql .= "INSERT INTO `ds_type` (`ptypeid`, `typename`, `sort`) VALUES (0, '新分类H', 8);";
                $sql .= "INSERT INTO `ds_type` (`ptypeid`, `typename`, `sort`) VALUES (0, '新分类I', 9);";
            } else {
                $sql .= 'ALTER TABLE `ds_type` auto_increment=' . $data['type_sid'] . ';';
            }

            if ($this->input->post('filter_clear')) {
                $sql .= 'TRUNCATE TABLE `ds_filter`;';
                $sql .= 'ALTER TABLE `ds_filter` auto_increment=' . $data['filter_sid'] . ';';
                $sql .= "INSERT INTO `ds_filter` (`id`, `pid`, `name`, `sort`) VALUES (1, 0, '册别', 1),(2, 0, '类型', 2),(3, 0, '版本', 3),(4, 1, '一年级上册', 1),(5, 1, '一年级下册', 2),(6, 1, '二年级上册', 3),(7, 1, '二年级下册', 4),(8, 1, '三年级上册', 5),(9, 1, '三年级下册', 6),(10, 1, '四年级上册', 7),(11, 1, '四年级下册', 8),(12, 2, '随堂练习', 1),(13, 2, '课后作业', 2),(14, 2, '单元测验', 3),(15, 2, '月考试卷', 4),(16, 2, '期中测验', 5),(17, 2, '期末试卷', 6),(18, 2, '毕业水平测试', 7),(19, 2, ' 竞赛试卷', 8),(20, 3, '人教版', 1),(21, 3, '鲁教版', 2),(22, 3, '苏教版', 3);";
            } else {
                $sql .= 'ALTER TABLE `ds_filter` auto_increment=' . $data['filter_sid'] . ';';
            }

            if ($this->input->post('cortype_clear')) {
                $sql .= 'TRUNCATE TABLE `ds_topic_type`;';
                $sql .= 'ALTER TABLE `ds_topic_type` auto_increment= ' . $data['toptype_sid'] . ';';
                $sql .= "INSERT INTO `ds_topic_type` (`typename`, `sort`, `state`) VALUES ('教育资料', 1, 1);";
                $sql .= "INSERT INTO `ds_topic_type` (`typename`, `sort`, `state`) VALUES ('建筑资料', 2, 1);";
                $sql .= "INSERT INTO `ds_topic_type` (`typename`, `sort`, `state`) VALUES ('专业资料', 3, 1);";
                $sql .= "INSERT INTO `ds_topic_type` (`typename`, `sort`, `state`) VALUES ('实用文档', 4, 1);";
                $sql .= "INSERT INTO `ds_topic_type` (`typename`, `sort`, `state`) VALUES ('等级考试', 5, 1);";
                $sql .= "INSERT INTO `ds_topic_type` (`typename`, `sort`, `state`) VALUES ('其他资料', 6, 1);";
            } else {
                $sql .= 'ALTER TABLE `ds_topic_type` auto_increment= ' . $data['toptype_sid'] . ';';
            }

            if ($this->input->post('arttype_clear')) {
                $sql .= 'TRUNCATE TABLE `ds_article_tag`;';
                $sql .= 'ALTER TABLE `ds_article_tag` auto_increment= ' . $data['arttype_sid'] . ';';
                $sql .= "INSERT INTO `ds_article_tag` (`tagname`, `sort`, `state`) VALUES ('新闻', 1, 1);";
                $sql .= "INSERT INTO `ds_article_tag` (`tagname`, `sort`, `state`) VALUES ('体育', 2, 1);";
                $sql .= "INSERT INTO `ds_article_tag` (`tagname`, `sort`, `state`) VALUES ('科技', 3, 1);";
                $sql .= "INSERT INTO `ds_article_tag` (`tagname`, `sort`, `state`) VALUES ('金融', 4, 1);";
            } else {
                $sql .= 'ALTER TABLE `ds_article_tag` auto_increment= ' . $data['arttype_sid'] . ';';
            }

            if ($this->input->post('fortype_clear')) {
                $sql .= 'TRUNCATE TABLE `ds_ask_tag`;';
                $sql .= 'ALTER TABLE `ds_ask_tag` auto_increment= ' . $data['asktype_sid'] . ';';
                $sql .= "INSERT INTO `ds_ask_tag` (`tagname`, `sort`, `state`) VALUES ('官方', 1, 1);";
                $sql .= "INSERT INTO `ds_ask_tag` (`tagname`, `sort`, `state`) VALUES ('建议', 2, 1);";
                $sql .= "INSERT INTO `ds_ask_tag` (`tagname`, `sort`, `state`) VALUES ('教程', 3, 1);";
                $sql .= "INSERT INTO `ds_ask_tag` (`tagname`, `sort`, `state`) VALUES ('求助', 4, 1);";
            } else {
                $sql .= 'ALTER TABLE `ds_ask_tag` auto_increment= ' . $data['asktype_sid'] . ';';
            }

            $this->db->query($sql);
            echo $this->db->update('incid', $data);
        }
    }

}
