<?php

defined('BASEPATH') or exit('No direct script access allowed');

class Sys extends Admin_Controller
{

    public function __construct()
    {
        parent::__construct();

        $menu = array(
            'title' => '基本设置',
            'menu' => array(
                'admin' => '系统信息',
                'admin/sys/site' => '网站设置',
                'admin/sys/navbar' => '导航设置',
                'admin/sys/banner' => '首页幻灯',
                'admin/sys/notice' => '公告设置',
                'admin/sys/home' => '首页模块',
                'admin/sys/regset' => '注册设置',
                'admin/sys/loginset' => '登录设置',
                'admin/sys/docset' => '功能设置',
                'admin/sys/tradeset' => '交易规则',
                'admin/sys/points' => '积分设置',
                'admin/sys/partner' => '合作伙伴',
                'admin/sys/links' => '友情连接',
                'admin/sys/about' => '底部菜单',
                'admin/sys/report' => '举报项目',
                'admin/sys/hotkey' => '热门搜索',
                'admin/sys/badword' => '词语过滤',
                'admin/sys/template' => '模板设置',
                'admin/sys/smtp' => '邮件服务',
                'admin/sys/sms' => '短信服务',
                'admin/sys/agree' => '文库协议',
            ));
        $this->load->vars('menu', $menu);
    }

    public function index()
    {
        $glod_today = $this->glodnum('glodorder', 0);
        $vip_today = $this->glodnum('viporder', 0);
        $down_today = $this->glodnum('downorder', 0);

        $glod_yesterday = $this->glodnum('glodorder', 1);
        $vip_yesterday = $this->glodnum('viporder', 1);
        $down_yesterday = $this->glodnum('downorder', 1);

        $glod_month = $this->glodnum_month('glodorder', 0);
        $vip_month = $this->glodnum_month('viporder', 0);
        $down_month = $this->glodnum_month('downorder', 0);

        $glod_month2 = $this->glodnum_month('glodorder', 1);
        $vip_month2 = $this->glodnum_month('viporder', 1);
        $down_month2 = $this->glodnum_month('downorder', 1);

        $data['sysinfo'] = array(
            '今日会员' => $this->usernum(0) . '人',
            '昨日会员' => $this->usernum(1) . '人',
            '今日收入' => ($glod_today + $vip_today + $down_today) . $this->tradeset->glodunit . '(会员充值 ' . $glod_today . $this->tradeset->glodunit . ' + 开通VIP ' . $vip_today . $this->tradeset->glodunit . ' + 文档下载 ' . $down_today . $this->tradeset->glodunit . ')',
            '昨日收入' => ($glod_yesterday + $vip_yesterday + $down_yesterday) . $this->tradeset->glodunit . '(会员充值 ' . $glod_yesterday . $this->tradeset->glodunit . ' + 开通VIP ' . $vip_yesterday . $this->tradeset->glodunit . ' + 文档下载 ' . $down_yesterday . $this->tradeset->glodunit . ')',
            '本月收入' => ($glod_month + $vip_month + $down_month) . $this->tradeset->glodunit . '(会员充值 ' . $glod_month . $this->tradeset->glodunit . ' + 开通VIP ' . $vip_month . $this->tradeset->glodunit . ' + 文档下载 ' . $down_month . $this->tradeset->glodunit . ')',
            '上月收入' => ($glod_month2 + $vip_month2 + $down_month2) . $this->tradeset->glodunit . '(会员充值 ' . $glod_month2 . $this->tradeset->glodunit . ' + 开通VIP ' . $vip_month2 . $this->tradeset->glodunit . ' + 文档下载 ' . $down_month2 . $this->tradeset->glodunit . ')',
            '：：：：' => '：：：：：：：：：：：：：：：：：：：：：：：：：：：：：：：：：：：：：',
            '文库版本' => $this->config->item('version') . '<a class="active" href="admin/update">获取最新版本</a>',
            '操作系统' => PHP_OS,
            '运行环境' => $_SERVER['SERVER_SOFTWARE'],
            'PHP版本' => PHP_VERSION,
            'SQL版本' => $this->db->version(),
            '网站目录' => $_SERVER['DOCUMENT_ROOT'],
            '上传限制' => ini_get('upload_max_filesize') . '  [ 系统使用了分段上传，理论上这里 >1M，任何大小的文件都可以成功上传 ]',
//          '时间限制' => ini_get('max_execution_time') . '秒',
            '运行内存' => $this->usememory(),
            '内存限制' => ini_get('memory_limit'),
            '剩余空间' => function_exists('disk_free_space') ? round((disk_free_space('.') / (1024 * 1024)), 2) . 'M' : '无法获取',
            '系统时间' => date('Y年m月d日 H:i:s'),
        );
        $this->load->view($this->template . 'admin/sys/index', $data);
    }

    public function usernum($when)
    {
        $user = $this->db->query("SELECT count(*) as number FROM ds_user WHERE TO_DAYS(NOW())-TO_DAYS(insertdate)=$when AND `state`=1")->row();
        return $user->number ? $user->number : 0;
    }

    public function glodnum($which, $when)
    {
        $glod = $this->db->query("SELECT sum(cash) as glod FROM `ds_$which` WHERE TO_DAYS(NOW())-TO_DAYS(insertdate)=$when AND `state`=1")->row();
        return $glod->glod ? number_format($glod->glod, 2,'.','') : 0;
    }

    public function glodnum_month($which, $when)
    {
        $glod = $this->db->query("SELECT sum(cash) as glod FROM `ds_$which` WHERE DATE_FORMAT(CURDATE(),'%Y%m' )-DATE_FORMAT(insertdate, '%Y%m')=$when AND `state`= 1")->row();
        return $glod->glod ? number_format($glod->glod, 2,'.','') : 0;
    }

    public function usememory()
    {
        $memory = (!function_exists('memory_get_usage')) ? '0' : round(memory_get_usage() / 1024 / 1024, 2) . 'MB';
        return $memory;
    }

    public function site()
    {
        if (IS_GET) {
            if ($row = $this->db->get('site')->row()) {
                $data['site'] = $row;
                $this->load->view($this->template . 'admin/sys/site', $data);
            } else {
                $data['error'] = '数据表site数据为空';
                $this->load->view($this->template . 'admin/error', $data);
            }
        } elseif (IS_POST) {
            $data = array(
                'name' => $this->input->post('name'),
                'host' => $this->input->post('host'),
                'appcode' => $this->input->post('appcode'),
                'phone' => $this->input->post('phone'),
                'email' => $this->input->post('email'),
                'qq' => $this->input->post('qq'),
                'address' => $this->input->post('address'),
                'icp' => $this->input->post('icp'),
                'tongji' => $this->input->post('tongji'),
            );
            file_put_contents('data/temp/host.info', $data['host']);
            $this->db->update('site', $data);
        }
    }

    public function navbar()
    {
        $data['navbar'] = $this->db->order_by('sort')->get('navbar')->result();
        $this->load->view($this->template . 'admin/sys/navbar', $data);
    }

    public function navbar_edit($id)
    {
        if (IS_GET) {
            if ($id && $row = $this->db->get_where('navbar', array('id' => $id))->row()) {
                $data['navbar'] = $row;
            } else {
                $data['navbar'] = (object) array(
                    'id' => '0',
                    'title' => '',
                    'href' => '',
                    'blank' => '_self',
                    'pc' => '1',
                    'mobile' => '1',
                    'sort' => '1',
                );
            }
            $this->load->view($this->template . 'admin/sys/navbar_edit', $data);
        } elseif (IS_POST) {
            $data = array(
                'title' => $this->input->post('title'),
                'href' => $this->input->post('href'),
                'blank' => $this->input->post('blank'),
                'pc' => $this->input->post('pc'),
                'mobile' => $this->input->post('mobile'),
                'sort' => $this->input->post('sort'),
            );
            if ($id) {
                echo $this->db->update('navbar', $data, array('id' => $id));
            } else {
                echo $this->db->insert('navbar', $data);
            }
            writerouter();
        }
    }

    public function navbar_del($id)
    {
        if ($id && $id > 9) {
            echo $this->db->delete('navbar', array('id' => $id));
        } else {
            echo -1;
        }
    }

    public function navbar_pc()
    {
        $data = array(
            'pc' => $this->input->post('val'),
        );
        if ($id = $this->input->post('key')) {
            echo $this->db->update('navbar', $data, array('id' => $id));
        }
    }

    public function navbar_mobile()
    {
        $data = array(
            'mobile' => $this->input->post('val'),
        );
        if ($id = $this->input->post('key')) {
            echo $this->db->update('navbar', $data, array('id' => $id));
        }
    }

    public function navbar_blank()
    {
        $data = array(
            'blank' => $this->input->post('val') == '1' ? '_blank' : '_self',
        );
        if ($id = $this->input->post('key')) {
            echo $this->db->update('navbar', $data, array('id' => $id));
        }
    }

    public function banner()
    {
        $data['banner'] = $this->db->order_by('sort')->get('banner')->result();
        $this->load->view($this->template . 'admin/sys/banner', $data);
    }

    public function banner_edit($id)
    {
        if (IS_GET) {
            if ($id && $row = $this->db->get_where('banner', array('id' => $id))->row()) {
                $data['banner'] = $row;
            } else {
                $data['banner'] = (object) array(
                    'id' => '0',
                    'name' => '',
                    'img' => '',
                    'src' => '',
                    'pc' => '1',
                    'mobile' => '1',
                    'sort' => '1',
                );
            }
            $this->load->view($this->template . 'admin/sys/banner_edit', $data);
        } elseif (IS_POST) {
            $data = array(
                'name' => $this->input->post('name'),
                'img' => $this->input->post('img'),
                'src' => $this->input->post('src'),
                'pc' => $this->input->post('pc'),
                'mobile' => $this->input->post('mobile'),
                'sort' => $this->input->post('sort'),
            );
            if ($id) {
                echo $this->db->update('banner', $data, array('id' => $id));
            } else {
                echo $this->db->insert('banner', $data);
            }
        }
    }

    public function banner_del($id)
    {
        if ($id) {
            echo $this->db->delete('banner', array('id' => $id));
        }
    }

    public function banner_pc()
    {
        $data = array(
            'pc' => $this->input->post('val'),
        );
        if ($id = $this->input->post('key')) {
            echo $this->db->update('banner', $data, array('id' => $id));
        }
    }

    public function banner_mobile()
    {
        $data = array(
            'mobile' => $this->input->post('val'),
        );
        if ($id = $this->input->post('key')) {
            echo $this->db->update('banner', $data, array('id' => $id));
        }
    }

    public function notice()
    {
        $data['notice'] = $this->db->order_by('pubdate', 'desc')->get('notice')->result();
        $this->load->view($this->template . 'admin/sys/notice', $data);
    }

    public function notice_edit($id)
    {
        if (IS_GET) {
            if ($id && $row = $this->db->get_where('notice', array('id' => $id))->row()) {
                $data['notice'] = $row;
            } else {
                $data['notice'] = (object) array(
                    'id' => '0',
                    'title' => '',
                    'body' => '',
                    'import' => '0',
                    'pubdate' => '',
                    'state' => '1',
                );
            }
            $this->load->view($this->template . 'admin/sys/notice_edit', $data);
        } elseif (IS_POST) {
            $data = array(
                'title' => $this->input->post('title'),
                'body' => $this->input->post('body'),
                'import' => $this->input->post('import'),
                'pubdate' => $this->input->post('pubdate'),
                'state' => $this->input->post('state'),
            );
            if ($id) {
                echo $this->db->update('notice', $data, array('id' => $id));
            } else {
                echo $this->db->insert('notice', $data);
            }
        }
    }

    public function notice_del($id)
    {
        if ($id) {
            echo $this->db->delete('notice', array('id' => $id));
        }
    }

    public function notice_import()
    {
        $data = array(
            'import' => $this->input->post('val'),
        );
        if ($id = $this->input->post('key')) {
            echo $this->db->update('notice', $data, array('id' => $id));
        }
    }

    public function notice_state()
    {
        $data = array(
            'state' => $this->input->post('val'),
        );
        if ($id = $this->input->post('key')) {
            echo $this->db->update('notice', $data, array('id' => $id));
        }
    }

    public function home()
    {
        if (IS_GET) {
            if ($row = $this->db->get('docset')->row()) {
                $data['type'] = get_childtype(0);
                $data['docset'] = $row;
                $this->load->view($this->template . 'admin/sys/home', $data);
            } else {
                $data['error'] = '数据表docset数据为空';
                $this->load->view($this->template . 'admin/error', $data);
            }
        } else {
            $data = array(
                'isnotice' => $this->input->post('isnotice'),
                'isarticle' => $this->input->post('isarticle'),
                'istui' => $this->input->post('istui'),
                'isnew' => $this->input->post('isnew'),
                'isfree' => $this->input->post('isfree'),
                'isvip' => $this->input->post('isvip'),
                'isreward' => $this->input->post('isreward'),
                'isuser' => $this->input->post('isuser'),
            );
            echo $this->db->update('docset', $data);
        }
    }

    public function home_type()
    {
        if (IS_POST) {
            if ($typeid = $this->input->post('key')) {
                $data = array(
                    'state' => $this->input->post('val'),
                );
                echo $this->db->update('type', $data, array('typeid' => $typeid));
            }
        }
    }

    //points
    public function points()
    {
        $data['points'] = $this->db->order_by('sort')->get('points')->result();
        $this->load->view($this->template . 'admin/sys/points', $data);
    }

    public function points_edit($id)
    {
        if (IS_GET) {
            if ($id && $row = $this->db->get_where('points', array('id' => $id))->row()) {
                $data['points'] = $row;
            } else {
                $data['points'] = (object) array(
                    'id' => '0',
                    'name' => '',
                    'cycle' => '',
                    'points' => '0',
                    'note' => '0',
                    'state' => '1',
                );
            }
            $this->load->view($this->template . 'admin/sys/points_edit', $data);
        } elseif (IS_POST) {
            $data = array(
                'points' => $this->input->post('points'),
                'state' => $this->input->post('state'),
            );
            if ($id) {
                echo $this->db->update('points', $data, array('id' => $id));
            } else {
                echo $this->db->insert('points', $data);
            }
        }
    }

    public function points_del($id)
    {
        if ($id) {
            echo $this->db->delete('points', array('id' => $id));
        }
    }

    public function points_state()
    {
        $data = array(
            'state' => $this->input->post('val'),
        );
        if ($id = $this->input->post('key')) {
            echo $this->db->update('points', $data, array('id' => $id));
        }
    }

    public function links()
    {
        $data['links'] = $this->db->order_by('sort')->get('links')->result();
        $this->load->view($this->template . 'admin/sys/links', $data);
    }

    public function links_edit($id)
    {
        if (IS_GET) {
            if ($id && $row = $this->db->get_where('links', array('id' => $id))->row()) {
                $data['links'] = $row;
            } else {
                $data['links'] = (object) array(
                    'id' => '0',
                    'name' => '',
                    'img' => '',
                    'src' => '',
                    'sort' => '1',
                    'state' => '1',
                );
            }
            $this->load->view($this->template . 'admin/sys/links_edit', $data);
        } elseif (IS_POST) {
            $data = array(
                'name' => $this->input->post('name'),
                'img' => $this->input->post('img'),
                'src' => $this->input->post('src'),
                'sort' => $this->input->post('sort'),
                'state' => $this->input->post('state'),
            );
            if ($id) {
                echo $this->db->update('links', $data, array('id' => $id));
            } else {
                echo $this->db->insert('links', $data);
            }
        }
    }

    public function links_del($id)
    {
        if ($id) {
            echo $this->db->delete('links', array('id' => $id));
        }
    }

    public function links_state()
    {
        $data = array(
            'state' => $this->input->post('val'),
        );
        if ($id = $this->input->post('key')) {
            echo $this->db->update('links', $data, array('id' => $id));
        }
    }

    public function partner()
    {
        $data['partner'] = $this->db->order_by('sort')->get('partner')->result();
        $this->load->view($this->template . 'admin/sys/partner', $data);
    }

    public function partner_edit($id)
    {
        if (IS_GET) {
            if ($id && $row = $this->db->get_where('partner', array('id' => $id))->row()) {
                $data['partner'] = $row;
            } else {
                $data['partner'] = (object) array(
                    'id' => '0',
                    'name' => '',
                    'img' => '',
                    'src' => '',
                    'sort' => '1',
                    'state' => '1',
                );
            }
            $this->load->view($this->template . 'admin/sys/partner_edit', $data);
        } elseif (IS_POST) {
            $data = array(
                'name' => $this->input->post('name'),
                'img' => $this->input->post('img'),
                'src' => $this->input->post('src'),
                'sort' => $this->input->post('sort'),
                'state' => $this->input->post('state'),
            );
            if ($id) {
                echo $this->db->update('partner', $data, array('id' => $id));
            } else {
                echo $this->db->insert('partner', $data);
            }
        }
    }

    public function partner_del($id)
    {
        if ($id) {
            echo $this->db->delete('partner', array('id' => $id));
        }
    }

    public function partner_state()
    {
        $data = array(
            'state' => $this->input->post('val'),
        );
        if ($id = $this->input->post('key')) {
            echo $this->db->update('partner', $data, array('id' => $id));
        }
    }

    public function report()
    {
        $data['report'] = $this->db->order_by('sort')->get('report_item')->result();
        $this->load->view($this->template . 'admin/sys/report', $data);
    }

    public function report_edit($id)
    {
        if (IS_GET) {
            if ($id && $row = $this->db->get_where('report_item', array('id' => $id))->row()) {
                $data['report'] = $row;
            } else {
                $data['report'] = (object) array(
                    'id' => '0',
                    'title' => '',
                    'sort' => '',
                    'state' => '1',
                );
            }
            $this->load->view($this->template . 'admin/sys/report_edit', $data);
        } elseif (IS_POST) {
            $data = array(
                'title' => $this->input->post('title'),
                'sort' => $this->input->post('sort'),
                'state' => $this->input->post('state'),
            );
            if ($id) {
                echo $this->db->update('report_item', $data, array('id' => $id));
            } else {
                echo $this->db->insert('report_item', $data);
            }
        }
    }

    public function report_del($id)
    {
        if ($id) {
            echo $this->db->delete('report_item', array('id' => $id));
        }
    }

    public function report_state()
    {
        $data = array(
            'state' => $this->input->post('val'),
        );
        if ($id = $this->input->post('key')) {
            echo $this->db->update('report_item', $data, array('id' => $id));
        }
    }

    public function hotkey()
    {
        $data['hotkey'] = $this->db->order_by('sort')->get('hotkey')->result();
        $this->load->view($this->template . 'admin/sys/hotkey', $data);
    }

    public function hotkey_edit($id)
    {
        if (IS_GET) {
            if ($id && $row = $this->db->get_where('hotkey', array('id' => $id))->row()) {
                $data['hotkey'] = $row;
            } else {
                $data['hotkey'] = (object) array(
                    'id' => '0',
                    'key' => '',
                    'sort' => '',
                    'state' => '1',
                );
            }
            $this->load->view($this->template . 'admin/sys/hotkey_edit', $data);
        } elseif (IS_POST) {
            $data = array(
                'key' => $this->input->post('key'),
                'sort' => $this->input->post('sort'),
                'state' => $this->input->post('state'),
            );
            if ($id) {
                echo $this->db->update('hotkey', $data, array('id' => $id));
            } else {
                echo $this->db->insert('hotkey', $data);
            }
        }
    }

    public function hotkey_del($id)
    {
        if ($id) {
            echo $this->db->delete('hotkey', array('id' => $id));
        }
    }

    public function hotkey_state()
    {
        $data = array(
            'state' => $this->input->post('val'),
        );
        if ($id = $this->input->post('key')) {
            echo $this->db->update('hotkey', $data, array('id' => $id));
        }
    }

    public function badword()
    {
        $data['badword'] = $this->db->order_by('sort')->get('badword')->result();
        $this->load->view($this->template . 'admin/sys/badword', $data);
    }

    public function badword_edit($id)
    {
        if (IS_GET) {
            if ($id && $row = $this->db->get_where('badword', array('id' => $id))->row()) {
                $data['badword'] = $row;
            } else {
                $data['badword'] = (object) array(
                    'id' => '0',
                    'word' => '',
                    'word2' => '',
                    'sort' => '',
                    'state' => '1',
                );
            }
            $this->load->view($this->template . 'admin/sys/badword_edit', $data);
        } elseif (IS_POST) {
            $data = array(
                'word' => $this->input->post('word'),
                'word2' => $this->input->post('word2'),
                'sort' => $this->input->post('sort'),
                'state' => $this->input->post('state'),
            );
            if ($id) {
                echo $this->db->update('badword', $data, array('id' => $id));
            } else {
                echo $this->db->insert('badword', $data);
            }
        }
    }

    public function badword_del($id)
    {
        if ($id) {
            echo $this->db->delete('badword', array('id' => $id));
        }
    }

    public function badword_state()
    {
        $data = array(
            'state' => $this->input->post('val'),
        );
        if ($id = $this->input->post('key')) {
            echo $this->db->update('badword', $data, array('id' => $id));
        }
    }

    public function about()
    {
        $data['about'] = $this->db->select('id,title,link,groupname,sort,state')->order_by('groupid,sort')->get('about_view')->result();
        $this->load->view($this->template . 'admin/sys/about', $data);
    }

    public function about_edit($id)
    {
        if (IS_GET) {
            if ($id && $row = $this->db->get_where('about_view', array('id' => $id))->row()) {
                $data['about'] = $row;
            } else {
                $data['about'] = (object) array(
                    'id' => '0',
                    'title' => '',
                    'link' => '',
                    'content' => '',
                    'groupid' => '0',
                    'groupname' => '-',
                    'sort' => '1',
                    'state' => '1',
                );
            }
            $data['group'] = $this->db->order_by('sort desc')->get_where('about_group')->result();
            $this->load->view($this->template . 'admin/sys/about_edit', $data);
        } elseif (IS_POST) {
            $data = array(
                'title' => $this->input->post('title'),
                'link' => $this->input->post('link'),
                'content' => $this->input->post('content'),
                'groupid' => $this->input->post('groupid'),
                'sort' => $this->input->post('groupid') . $this->input->post('sort'),
                'state' => $this->input->post('state'),
            );
            if ($id) {
                echo $this->db->update('about', $data, array('id' => $id));
            } else {
                echo $this->db->insert('about', $data);
            }
        }
    }

    public function about_state()
    {
        $data = array(
            'state' => $this->input->post('val'),
        );
        if ($id = $this->input->post('key')) {
            echo $this->db->update('about', $data, array('id' => $id));
        }
    }

    public function about_del($id)
    {
        if ($id) {
            echo $this->db->delete('about', array('id' => $id));
        }
    }

    public function about_content($id)
    {
        if (IS_GET) {
            if ($id && $row = $this->db->get_where('about', array('id' => $id))->row()) {
                $data['about'] = $row;
            } else {
                $data['about'] = (object) array(
                    'id' => '0',
                    'content' => '',
                );
            }
            $this->load->view($this->template . 'admin/sys/about_content', $data);
        } elseif (IS_POST) {
            $data = array(
                'content' => $this->input->post('content'),
            );
            if ($id) {
                echo $this->db->update('about', $data, array('id' => $id));
            } else {
                echo $this->db->insert('about', $data);
            }
        }
    }

    //neditor
    public function neditor_controller()
    {
        $this->load->library('Neditor/neditor');
    }

    public function regset()
    {
        if (IS_GET) {
            $row = $this->db->get('regset')->row();
            $group = $this->db->order_by('sort')->get_where('group', ['groupid >' => 0])->result();
            $vgroup = $this->db->order_by('sort')->get_where('vgroup', ['state' => 1])->result();
            if ($row && $group) {
                $data['regset'] = $row;
                $data['group'] = $group;
                $data['vgroup'] = $vgroup;
                $this->load->view($this->template . 'admin/sys/regset', $data);
            } else {
                $data['error'] = '数据表regset数据为空';
                $this->load->view($this->template . 'admin/error', $data);
            }
        } else {
            $data = array(
                'email' => $this->input->post('email'),
                'phone' => $this->input->post('phone'),
                'invite' => $this->input->post('invite'),
                'groupid' => $this->input->post('groupid'),
                'vgroupid' => $this->input->post('vgroupid'),
                'vgroupdays' => $this->input->post('vgroupdays'),
                'pwd_length' => $this->input->post('pwd_length'),
                'pwd_num' => $this->input->post('pwd_num'),
                'pwd_lower' => $this->input->post('pwd_lower'),
                'pwd_upper' => $this->input->post('pwd_upper'),
                'invite_title' => $this->input->post('invite_title'),
                'invite_body' => $this->input->post('invite_body'),
            );
            echo $this->db->update('regset', $data);
        }
    }

    public function loginset()
    {
        if (IS_GET) {
            if ($row = $this->db->get('loginset')->row()) {
                $data['loginset'] = $row;
                $this->load->view($this->template . 'admin/sys/loginset', $data);
            } else {
                $data['error'] = '数据表loginset数据为空';
                $this->load->view($this->template . 'admin/error', $data);
            }
        } else {
            $data = array(
                'email' => $this->input->post('email'),
                'phone' => $this->input->post('phone'),
                'app' => $this->input->post('app'),
                'dz' => $this->input->post('dz'),
                'ali' => $this->input->post('ali'),
                'wei' => $this->input->post('wei'),
                'gzh' => $this->input->post('gzh'),
                'qq' => $this->input->post('qq'),
                'weibo' => $this->input->post('weibo'),
                'renren' => $this->input->post('renren'),
                'other' => $this->input->post('other'),
            );
            echo $this->db->update('loginset', $data);
        }
    }

    public function dzlogin_edit()
    {
        if (IS_GET) {
            if ($row = $this->db->get('dzloginset')->row()) {
                $data['dzloginset'] = $row;
            } else {
                $data['error'] = '数据表dzloginset数据为空';
                $this->load->view($this->template . 'admin/error', $data);
            }
            $this->load->view($this->template . 'admin/sys/dzlogin_edit', $data);
        } elseif (IS_POST) {
            $data = array(
                'suffix' => $this->input->post('suffix'),
                'config' => $this->input->post('config'),
            );
            echo $this->db->update('dzloginset', $data);
        }
    }

    public function qqlogin_edit()
    {
        if (IS_GET) {
            if ($row = $this->db->get('qqloginset')->row()) {
                $data['qqloginset'] = $row;
            } else {
                $data['error'] = '数据表qqloginset数据为空';
                $this->load->view($this->template . 'admin/error', $data);
            }
            $this->load->view($this->template . 'admin/sys/qqlogin_edit', $data);
        } elseif (IS_POST) {
            $data = array(
                'appid' => $this->input->post('appid'),
                'appkey' => $this->input->post('appkey'),
            );
            echo $this->db->update('qqloginset', $data);
        }
    }

    public function alilogin_edit()
    {
        if (IS_GET) {
            if ($row = $this->db->get('aliloginset')->row()) {
                $data['aliloginset'] = $row;
            } else {
                $data['aliloginset'] = (object) array(
                    'app_id' => '',
                    'private_key' => '',
                    'public_key' => '',
                    'sign_type' => 'RSA2',
                );
            }
            $this->load->view($this->template . 'admin/sys/alilogin_edit', $data);
        } elseif (IS_POST) {
            $data = array(
                'app_id' => $this->input->post('app_id'),
                'private_key' => $this->input->post('private_key'),
                'public_key' => $this->input->post('public_key'),
                'sign_type' => $this->input->post('sign_type'),
            );
            echo $this->db->update('aliloginset', $data);
        }
    }

    public function weilogin_edit()
    {
        if (IS_GET) {
            if ($row = $this->db->get('weiloginset')->row()) {
                $data['weiloginset'] = $row;
            } else {
                $data['weiloginset'] = (object) array(
                    'AppID' => '',
                    'AppSecret' => '',
                    'AppID_app' => '',
                    'AppSecret_app' => '',
                );
            }
            $this->load->view($this->template . 'admin/sys/weilogin_edit', $data);
        } elseif (IS_POST) {
            $data = array(
                'AppID' => $this->input->post('AppID'),
                'AppSecret' => $this->input->post('AppSecret'),
                'AppID_app' => $this->input->post('AppID_app'),
                'AppSecret_app' => $this->input->post('AppSecret_app'),
            );
            if ($this->db->update('weiloginset', $data)) {
                echo 1;
            }
        }
    }

    public function gzhlogin_edit()
    {
        if (IS_GET) {
            if ($row = $this->db->get('gzhloginset')->row()) {
                $data['gzhloginset'] = $row;
            } else {
                $data['gzhloginset'] = (object) array(
                    'AppID' => '',
                    'AppSecret' => '',
                );
            }
            $this->load->view($this->template . 'admin/sys/gzhlogin_edit', $data);
        } elseif (IS_POST) {
            $data = array(
                'AppID' => $this->input->post('AppID'),
                'AppSecret' => $this->input->post('AppSecret'),
            );
            if ($this->db->update('gzhloginset', $data)) {
                echo 1;
            }
        }
    }

    public function weibologin_edit()
    {
        if (IS_GET) {
            if ($row = $this->db->get('weibologinset')->row()) {
                $data['weibologinset'] = $row;
            } else {
                $data['error'] = '数据表weibologinset数据为空';
                $this->load->view($this->template . 'admin/error', $data);
            }
            $this->load->view($this->template . 'admin/sys/weibologin_edit', $data);
        } elseif (IS_POST) {
            $data = array(
                'appid' => $this->input->post('appid'),
                'appkey' => $this->input->post('appkey'),
            );
            echo $this->db->update('weibologinset', $data);
        }
    }

    public function renrenlogin_edit()
    {
        if (IS_GET) {
            if ($row = $this->db->get('renrenloginset')->row()) {
                $data['renrenloginset'] = $row;
            } else {
                $data['error'] = '数据表renrenloginset数据为空';
                $this->load->view($this->template . 'admin/error', $data);
            }
            $this->load->view($this->template . 'admin/sys/renrenlogin_edit', $data);
        } elseif (IS_POST) {
            $data = array(
                'appid' => $this->input->post('appid'),
                'appkey' => $this->input->post('appkey'),
            );
            echo $this->db->update('renrenloginset', $data);
        }
    }

    public function otherlogin_edit()
    {
        if (IS_GET) {
            if ($row = $this->db->get('otherloginset')->row()) {
                $data['otherloginset'] = $row;
            } else {
                $data['error'] = '数据表otherloginset数据为空';
                $this->load->view($this->template . 'admin/error', $data);
            }
            $this->load->view($this->template . 'admin/sys/otherlogin_edit', $data);
        } elseif (IS_POST) {
            $data = array(
                'appid' => $this->input->post('appid'),
                'appkey' => $this->input->post('appkey'),
            );
            echo $this->db->update('otherloginset', $data);
        }
    }

    public function tradeset()
    {
        if (IS_GET) {
            if ($row = $this->db->get('tradeset')->row()) {
                $data['tradeset'] = $row;
                $this->load->view($this->template . 'admin/sys/tradeset', $data);
            } else {
                $data['error'] = '数据表tradeset数据为空';
                $this->load->view($this->template . 'admin/error', $data);
            }
        } else {
            $data = array(
                'glodname' => $this->input->post('glodname'),
                'glodunit' => $this->input->post('glodunit'),
                'toauth' => $this->input->post('toauth'),
                'toauth2' => $this->input->post('toauth2'),
                'rate' => $this->input->post('rate'),
                'paydue' => $this->input->post('paydue'),
                'rewardtop' => $this->input->post('rewardtop'),
                'backrate' => $this->input->post('backrate'),
                'glodin' => $this->input->post('glodin'),
                'glodout' => $this->input->post('glodout'),
                'glodrate' => $this->input->post('glodrate'),
                'pointout' => $this->input->post('pointout'),
                'pointrate' => $this->input->post('pointrate'),
            );
            echo $this->db->update('tradeset', $data);
        }
    }

    public function docset()
    {
        if (IS_GET) {
            if ($row = $this->db->get('docset')->row()) {
                $data['docset'] = $row;
                $data['water'] = $this->db->get('water')->row();
                $this->load->view($this->template . 'admin/sys/docset', $data);
            } else {
                $data['error'] = '数据表docset数据为空';
                $this->load->view($this->template . 'admin/error', $data);
            }
        } else {
            $data = array(
                'home_cache' => $this->input->post('home_cache'),
                'list_cache' => $this->input->post('list_cache'),
                'doc_cache' => $this->input->post('doc_cache'),
                'anonypay' => $this->input->post('anonypay'),
                'doc_num' => $this->input->post('doc_num'),
                'ismd5' => $this->input->post('ismd5'),
                'wordcount' => $this->input->post('wordcount'),
                'preview' => $this->input->post('preview'),
                'readpay' => $this->input->post('readpay'),
                'downpay' => $this->input->post('downpay'),
                'mintype' => $this->input->post('mintype'),
                'minfilter' => $this->input->post('minfilter'),
                'iscopy' => $this->input->post('iscopy'),
                'iszip' => $this->input->post('iszip'),
                'ish5' => $this->input->post('ish5'),
                'isyun' => $this->input->post('isyun'),
                'ypage' => $this->input->post('ypage'),
                'isauth1' => $this->input->post('isauth1'),
                'isauth2' => $this->input->post('isauth2'),
            );
            echo $this->db->update('docset', $data);

            $text = $this->input->post('text');
            $font = $this->input->post('font');
            $size = $this->input->post('size');
            $width = $this->input->post('width');
            $height = $this->input->post('height');
            $x = $this->input->post('x');
            $y = $this->input->post('y');
            $rotate = $this->input->post('rotate');
            $fill = $this->input->post('fill');
            $state = $this->input->post('state');
            $watermark = "<defs><pattern id='ds_watermark' x='0' y='0' width='$width' height='$height' patternUnits='userSpaceOnUse'><text x='$x' y='$y' font-size='$size' font-family='$font' transform='rotate($rotate)' fill='rgba($fill)'>$text</text></pattern></defs><rect width='100%' height='100%' fill='url(#ds_watermark)' />";

            $waterdata = array(
                'text' => $text,
                'font' => $font,
                'size' => $size,
                'width' => $width,
                'height' => $height,
                'x' => $x,
                'y' => $y,
                'rotate' => $rotate,
                'fill' => $fill,
                'watermark' => $watermark,
                'state' => $state,
            );
            echo $this->db->update('water', $waterdata);
        }
    }

    public function cache_del($mod)
    {
        if ($dh = opendir('data/cache/')) {
            while ($file = readdir($dh)) {
                if ($file != '.' && $file != '..' && strpos($file, $mod) > 0) {
                    @unlink('data/cache/' . $file);
                }
            }
        }
    }

    public function template()
    {
        if (IS_GET) {
            if ($site = $this->db->get('site')->row()) {
                $data['tpl'] = $site->template;
            } else {
                $data['tpl'] = 'default';
            }

            $view_dir = './template/';
            $templates = array();
            if (is_dir($view_dir) && $handle = opendir($view_dir)) {
                while ($file = readdir($handle)) {
                    if ($file != '.' && $file != '..' && $file != '.htaccess' && $file != 'index.html' && $file != 'default') {
                        $templates[] = $file;
                    }

                }
                closedir($handle);
            }
            $data['tpls'] = $templates;
            $this->load->view($this->template . 'admin/sys/template', $data);
        } elseif (IS_POST) {
            $data = array(
                'template' => $this->input->post('key'),
            );
            echo $this->db->update('site', $data);
        }
    }

    public function smtp()
    {
        if (IS_GET) {
            if ($row = $this->db->get('smtp')->row()) {
                $data['smtp'] = $row;
                $this->load->view($this->template . 'admin/sys/smtp', $data);
            } else {
                $data['error'] = '数据表smtp数据为空';
                $this->load->view($this->template . 'admin/error', $data);
            }
        } elseif (IS_POST) {
            $data = array(
                'smtp' => $this->input->post('smtp'),
                'port' => $this->input->post('port'),
                'email' => $this->input->post('email'),
                'username' => $this->input->post('username'),
                'password' => $this->input->post('password'),
                'email_from' => $this->input->post('email'),
                'email_to' => $this->input->post('email_to'),
                'email_body' => $this->input->post('email_body'),
            );
            if ($this->db->update('smtp', $data)) {
                echo $this->send_email($data['email_to'], $data['email_body'], $data['email_body']);
            } else {
                echo 0;
            }
        }
    }

    public function sms()
    {
        if (IS_GET) {
            if ($row = $this->db->get('smsset')->row()) {
                $data['smsset'] = $row;
                $this->load->view($this->template . 'admin/sys/sms', $data);
            } else {
                $data['error'] = '数据表smsset数据为空';
                $this->load->view($this->template . 'admin/error', $data);
            }
        } elseif (IS_POST) {
            $data = array(
                'keyid' => $this->input->post('keyid'),
                'keysecret' => $this->input->post('keysecret'),
                'signname1' => $this->input->post('signname1'),
                'template1' => $this->input->post('template1'),
                'signname2' => $this->input->post('signname2'),
                'template2' => $this->input->post('template2'),
                'testphone' => $this->input->post('testphone'),
            );
            if ($this->db->update('smsset', $data)) {
                $this->load->library('Alisms/alisms');
                $mes = $this->alisms->sms2reg($this->input->post('testphone'), 123456);
                echo $mes->Message;
            } else {
                echo 0;
            }
        }
    }

    public function agree()
    {
        if (IS_GET) {
            if ($row = $this->db->get_where('protocol', array('type' => 'agree'))->row()) {
                $data['protocol'] = $row;
                $this->load->view($this->template . 'admin/sys/agree', $data);
            } else {
                $data['error'] = '数据表protocol中agree协议为空';
                $this->load->view($this->template . 'admin/error', $data);
            }
        } else {
            $data = array(
                'title' => $this->input->post('title'),
                'content' => $this->input->post('content'),
            );
            echo $this->db->update('protocol', $data, array('type' => 'agree'));
        }
    }

}
