<?php

defined('BASEPATH') or exit('No direct script access allowed');

class Topic extends Admin_Controller
{

    public function __construct()
    {
        parent::__construct();
        $menu = array(
            'title' => '专题管理',
            'menu' => array(
                'admin/topic/online' => '线上专题',
                'admin/topic/imp' => '推荐专题',
                'admin/topic/vip' => 'VIP 免费',
                'admin/topic/free' => '免费专题',
                'admin/topic/unline' => '下架专题',
                'javascript:;" class="i' => '<span></span>',
                'admin/topic/audit' => '等待审核',
                'admin/topic/passed' => '审核通过',
                'admin/topic/nopass' => '审核失败',
                'javascript:;;" class="i' => '<span></span>',
                'admin/topic/comment/audit' => '待审评论',
                'admin/topic/comment/online' => '已审评论',
                'javascript:;;;" class="i' => '<span></span>',
                'admin/topic/type' => '专题分类',
            ));
        $this->load->vars('menu', $menu);
    }

    public function index($which)
    {
        if (IS_GET) {
            $this->load->view($this->template . 'admin/topic/index');
        } elseif (IS_POST) {
            $this->topiclist($which);
        }
    }

    public function topiclist($which)
    {
        $searchcol = $this->input->post('searchcol');
        $searchtext = $this->input->post('searchtext');
        $sortcol = $this->input->post('sortcol');
        $sorttext = $this->input->post('sorttext');
        $pagesize = $this->input->post('pagesize');
        $pagecurrent = $this->input->post('pagecurrent');

        switch ($which) {
            case 'audit':
                $this->db->where('state', 0);
                break;
            case 'passed':
                $this->db->where('state', 1);
                break;
            case 'nopass':
                $this->db->where('state', -1);
                break;
            case 'online':
                $this->db->where(array('state' => 1, 'isdel' => 0));
                break;
            case 'free':
                $this->db->where(array('state' => 1, 'isdel' => 0, 'downpay' => 0));
                break;
            case 'vip':
                $this->db->where(array('state' => 1, 'isdel' => 0, 'isvip' => 1));
                break;
            case 'imp':
                $this->db->where(array('state' => 1, 'isdel' => 0, 'isimp' => 1));
                break;
            case 'unline':
                $this->db->where(array('state' => 1, 'isdel' => 1));
                break;
        }

        if ($searchtext != '') {
            $this->db->like($searchcol, $searchtext);
        }

        $total = $this->db->count_all_results('topic_view', false);

        $topics = $this->db->select('topicid,title,typeid,typename,userid,nickname,cover,downpay,docnum,size,readcount,downcount,isvip,isimp,isdel,insertdate,state')->order_by($sortcol, $sorttext)->limit($pagesize, ($pagesize * $pagecurrent - $pagesize))->get()->result();

        foreach ($topics as $key => $topic) {

            $topic->size = bsize($topic->size);
            $topic->downpay = $topic->downpay ? $topic->downpay . $this->tradeset->glodunit : '<span class="tip-bg bg-pink">免费</span>';
            $topic->typename = $topic->typename ? $topic->typename : '<span style="color:#f00">分类已删</span>';
            $topic->info = $topic->isimp ? '<span class="tip-bg bg-blue">推荐</span>' : '';
            $topic->info .= $topic->isvip ? ' <span class="tip-bg bg-red">VIP</span>' : '';
            $topic->info .= $topic->isdel ? ' <span class="tip-bg bg-green">下架</span>' : '';

            $topic->uploaddate = date('Y-m-d', strtotime($topic->insertdate));
        }
        echo json_encode(array('total' => $total, 'data' => $topics));
    }

    public function topic_edit($topicid)
    {
        if (IS_GET) {
            if ($topicid && $topic = get_topic($topicid)) {
                $data['topic'] = $topic;
                $this->load->view($this->template . 'admin/topic/topic_edit', $data);
            }
        } elseif (IS_POST) {
            $passed = $this->input->post('passed');
            $nopass = $this->input->post('nopass');
            $isimp = $this->input->post('isimp');
            $isvip = $this->input->post('isvip');
            $isdel = $this->input->post('isdel');
            $note = $this->input->post('note');

            if ($passed == '0' && $nopass == '0') {
                $data['state'] = 0;
            }
            if ($passed == '1') {
                $data['state'] = 1;
            }
            if ($nopass == '1') {
                $data['state'] = -1;
            }

            $data['isimp'] = $isimp;
            $data['isvip'] = $isvip;
            $data['isdel'] = $isdel;
            $data['note'] = $note;

            if ($topic = get_topic($topicid)) {
                if ($passed) {
                    pointpot(4, $topic->userid, $topicid);
                }

                if ($isimp) {
                    pointpot(5, $topic->userid, $topicid);
                }

                if ($isvip) {
                    pointpot(6, $topic->userid, $topicid);
                }
            }
            echo $this->db->update('topic', $data, array('topicid' => $topicid));
        }
    }

    public function edit_audit($topicids = 0)
    {
        if (IS_GET) {
            $data['topicids'] = $topicids;
            $this->load->view($this->template . 'admin/topic/edit_audit', $data);
        } elseif (IS_POST) {
            if ($topicids) {
                $passed = $this->input->post('passed');
                $nopass = $this->input->post('nopass');
                $note = $this->input->post('note');

                $data['state'] = 0;
                if ($passed == '1') {
                    $data['state'] = 1;
                }
                if ($nopass == '1') {
                    $data['state'] = -1;
                }
                $data['note'] = $note;
                foreach (explode('_', $topicids) as $topicid) {
                    if ($topic = get_topic($topicid)) {
                        if ($passed) {
                            pointpot(4, $topic->userid, $topicid);
                        }
                    }
                    echo $this->db->update('topic', $data, array('topicid' => $topicid));
                }
            }
        }
    }

    public function edit_imp($topicids = 0)
    {
        if (IS_GET) {
            $data['topicids'] = $topicids;
            $this->load->view($this->template . 'admin/topic/edit_imp', $data);
        } elseif (IS_POST) {
            if ($topicids) {
                $isimp = $this->input->post('isimp');
                $note = $this->input->post('note');
                $data['isimp'] = $isimp;
                $data['note'] = $note;
                foreach (explode('_', $topicids) as $topicid) {
                    if ($topic = get_topic($topicid)) {
                        if ($isimp) {
                            pointpot(5, $topic->userid, $topicid);
                        }
                    }
                    echo $this->db->update('topic', $data, array('topicid' => $topicid));
                }
            }
        }
    }

    public function edit_vip($topicids = 0)
    {
        if (IS_GET) {
            $data['topicids'] = $topicids;
            $this->load->view($this->template . 'admin/topic/edit_vip', $data);
        } elseif (IS_POST) {
            if ($topicids) {
                $isvip = $this->input->post('isvip');
                $note = $this->input->post('note');
                $data['isvip'] = $isvip;
                $data['note'] = $note;
                foreach (explode('_', $topicids) as $topicid) {
                    if ($topic = get_topic($topicid)) {
                        if ($isvip) {
                            pointpot(6, $topic->userid, $topicid);
                        }
                    }
                    echo $this->db->update('topic', $data, array('topicid' => $topicid));
                }
            }
        }
    }

    public function edit_del($topicids = 0)
    {
        if (IS_GET) {
            $data['topicids'] = $topicids;
            $this->load->view($this->template . 'admin/topic/edit_del', $data);
        } elseif (IS_POST) {
            if ($topicids) {
                $isdel = $this->input->post('isdel');
                $note = $this->input->post('note');
                $data['isdel'] = $isdel;
                $data['note'] = $note;
                foreach (explode('_', $topicids) as $topicid) {
                    echo $this->db->update('topic', $data, array('topicid' => $topicid));
                }
            }
        }
    }

    public function topic_del($topicids = 0)
    {
        if ($topicids) {
            foreach (explode('_', $topicids) as $topicid) {
                $this->db->delete('topic', array('topicid' => $topicid));
                $this->db->delete('topic_comment', array('topicid' => $topicid));
                delfile('data/topic/cover_' . $topicid . '.pic');
            }
        }
    }

    public function topic_bdpush($topicids = 0)
    {
        if ($topicids && $bdpush = $this->db->get_where('bdpushset', array('state' => '1'))->row()) {
            $urls = array();
            foreach (explode('_', $topicids) as $topicid) {
                $urls[] = $this->site->host . '/topic/' . $topicid . 'html';
            }

            $site = str_replace('https://', '', $this->site->host);
            $site = str_replace('http://', '', $this->site->host);

            $api = 'http://data.zz.baidu.com/urls?site=' . $site . '&token=' . $bdpush->token;
            $ch = curl_init();
            $options = array(
                CURLOPT_URL => $api,
                CURLOPT_POST => true,
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_POSTFIELDS => implode("\n", $urls),
                CURLOPT_HTTPHEADER => array('Content-Type: text/plain'),
            );
            curl_setopt_array($ch, $options);
            $result = curl_exec($ch);

            $r = json_decode($result);

            if (isset($r->error)) {
                echo $r->message;
            } else if (isset($r->success)) {
                echo '成功推送' . $r->success . '条，还剩' . $r->remain . '条';
            }

        } else {
            echo "没有开启百度主动推送";
        }
    }

    public function down($topicid)
    {
        if ($topicid && $topic = get_topic($topicid)) {

            $this->load->library('zip');
            $doclist = $this->db->select('docid,title,path,exten')->where_in('docid', explode(',', $topic->docs))->get('doc')->result();
            foreach ($doclist as $doc) {
                $filename = iconv("UTF-8", "GBK//IGNORE", $doc->docid . '_' . $doc->title . '.' . $doc->exten);
                if (is_file($doc->path)) {
                    $this->zip->read_file($doc->path, $filename);
                } else if (($oss = $this->db->get('ossset')->row()) && $oss->state && $this->load->library('Oss/oss') && $this->oss->objectexists($doc->path)) {
                    $url = $this->oss->signUrl($doc->path);
                    $this->zip->add_data($filename, file_get_contents($url));
                }
            }
            if ($this->zip->file_num) {
                $this->zip->download($topic->title . '.zip');
            } else {
                echo '专题文件不存在';
            }
        }
    }

    public function comment($which)
    {
        if (IS_GET) {
            $this->load->view($this->template . 'admin/topic/comment');
        } elseif (IS_POST) {
            $this->commentlist($which);
        }
    }

    public function commentlist($which)
    {
        $searchcol = $this->input->post('searchcol');
        $searchtext = $this->input->post('searchtext');
        $sortcol = $this->input->post('sortcol');
        $sorttext = $this->input->post('sorttext');
        $pagesize = $this->input->post('pagesize');
        $pagecurrent = $this->input->post('pagecurrent');

        switch ($which) {
            case 'audit':
                $this->db->where(array('state' => 0));
                break;
            case 'online':
                $this->db->where(array('state' => 1));
                break;
        }
        if ($searchtext != '') {
            $this->db->like($searchcol, $searchtext);
        }

        $total = $this->db->count_all_results('topic_comment_view', false);

        $comments = $this->db->order_by($sortcol, $sorttext)->limit($pagesize, ($pagesize * $pagecurrent - $pagesize))->get()->result();
        foreach ($comments as $comment) {
        }
        echo json_encode(array('total' => $total, 'data' => $comments));
    }

    public function comment_audit($commentids = 0)
    {
        if (IS_GET) {
            $data['commentids'] = $commentids;
            $this->load->view($this->template . 'admin/topic/comment_audit', $data);
        } elseif (IS_POST) {
            if ($commentids) {
                $passed = $this->input->post('passed');
                $nopass = $this->input->post('nopass');
                $note = $this->input->post('note');

                $data['state'] = 0;
                if ($passed == '1') {
                    $data['state'] = 1;
                    $data['note'] = $note;
                    foreach (explode('_', $commentids) as $commentid) {
                        echo $this->db->update('topic_comment', $data, array('commentid' => $commentid));
                    }
                }
                if ($nopass == '1') {
                    $this->comment_del2($commentids);
                }
            }
        }
    }

    public function comment_del2($commentids = 0)
    {
        if ($commentids) {
            foreach (explode('_', $commentids) as $commentid) {
                $this->db->delete('topic_comment', array('commentid' => $commentid));
            }
        }
    }

    public function type()
    {
        $data['type'] = $this->db->order_by('sort')->get('topic_type')->result();
        $this->load->view($this->template . 'admin/topic/type', $data);
    }

    public function type_edit($typeid)
    {
        if (IS_GET) {
            if ($typeid && $row = $this->db->get_where('topic_type', array('typeid' => $typeid))->row()) {
                $data['type'] = $row;
            } else {
                $data['type'] = (object) array(
                    'typeid' => '0',
                    'typename' => '',
                    'seotitle' => '',
                    'sort' => '',
                    'state' => '1',
                );
            }
            $this->load->view($this->template . 'admin/topic/type_edit', $data);
        } elseif (IS_POST) {
            $data = array(
                'typename' => $this->input->post('typename'),
                'seotitle' => $this->input->post('seotitle'),
                'sort' => $this->input->post('sort'),
                'state' => $this->input->post('state'),
            );
            if ($typeid) {
                echo $this->db->update('topic_type', $data, array('typeid' => $typeid));
            } else {
                echo $this->db->insert('topic_type', $data);
            }
        }
    }

    public function type_del($typeid)
    {
        if ($typeid) {
            echo $this->db->delete('topic_type', array('typeid' => $typeid));
        }
    }

    public function type_state()
    {
        $data = array(
            'state' => $this->input->post('val'),
        );
        if ($typeid = $this->input->post('key')) {
            echo $this->db->update('topic_type', $data, array('typeid' => $typeid));
        }
    }
}
