<?php

defined('BASEPATH') or exit('No direct script access allowed');

class Type extends Admin_Controller
{

    public function __construct()
    {
        parent::__construct();
        $menu = array(
            'title' => '分类管理',
            'menu' => array(
                'admin/type' => '文档分类',
                'admin/type/filter' => '附加分类',
            ));
        $this->load->vars('menu', $menu);
    }

    public function index()
    {
        $data['type'] = $this->getchildtype('0');
        $this->load->view($this->template . 'admin/type/index', $data);
    }

    public function getchildtype($ptypeid)
    {
        $rows = $this->db->select('typeid,ptypeid,typename,seotitle,sort')->order_by('sort')->get_where('type', array('ptypeid' => $ptypeid))->result();
        $sb = '';
        if ($rows) {
            $sb = '<ul>';
            foreach ($rows as $item) {
                $sb .= '<li data-id="' . $item->typeid . '"> ';
                $sb .= '<input type="text" class="ui-text h7" placeholder="排序" value="' . $item->sort . '" /> ';
                $sb .= '<input type="text" class="ui-text h6" placeholder="输入分类名称" value="' . $item->typename . '" /> ';
                $sb .= '<input type="text" class="ui-text h8" placeholder="设置SEO标题" value="' . $item->seotitle . '" /> ';
                $sb .= '<span class="type-addchlid">添加子分类</span> ';
                $sb .= '<a class="type-filter" modal-form="{title:\'移动分类\',body:\'admin/type/type_move/' . $item->typeid . '\',back:[\'移动成功\', \'不能移动到本分类待子分类下\']}">移动分类</a> ';
                $sb .= '<a class="type-filter" modal-form="{title:\'设置附加分类\',body:\'admin/type/type_filter/' . $item->typeid . '\',click:select_right,back:[\'编辑成功\', \'编辑失败\']}">附加分类</a> ';
                $sb .= '<span class="type-close">折叠</span> ';
                $sb .= '<span class="type-del"><i class="fa fa-trash-o fa-lg"></i></span> ';
                $sb .= $this->getchildtype($item->typeid);
                $sb .= '</li>';
            }
            $sb .= '</ul>';
        }
        return $sb;
    }

    public function type_edit()
    {
        $type = $this->input->post('type');
        if ($type) {
            $types = explode(',', $type);
            foreach ($types as $ty) {
                $tys = explode('|', $ty);
                if (count($tys) == 5) {
                    $typeid = $tys[0];
                    $data = array(
                        'ptypeid' => $tys[1],
                        'typename' => $tys[3],
                        'seotitle' => $tys[4],
                        'sort' => $tys[2],
                    );
                    if ($typeid == '-1') {
                        $this->db->insert('type', $data);
                    } else {
                        $this->db->update('type', $data, array('typeid' => $typeid));
                    }
                }
            }
        }
        echo 1;
    }

    public function type_move($typeid)
    {
        if (IS_GET) {
            $data['typeid'] = $typeid;
            $data['type_array'] = get_type_array();
            $this->load->view($this->template . 'admin/type/type_move', $data);
        } elseif (IS_POST) {
            if ($typeid) {
                $pid = explode('-', $this->input->post('typeid'));
                if(!in_array($typeid,$pid)){
                    echo $this->db->set('ptypeid',end($pid), false)->where('typeid', $typeid)->update('type');
                }
            }
        }
    }

    public function type_del($typeid)
    {
        if ($typeid) {
            if ($this->db->delete('type', array('typeid' => $typeid))) {
                $this->db->query('delete from ' . $this->db->dbprefix('type') . ' where ptypeid!=0 and  ptypeid not in (select typeid from (select typeid from ' . $this->db->dbprefix('type') . ') a)');
                $this->db->query('delete from ' . $this->db->dbprefix('type') . ' where ptypeid!=0 and  ptypeid not in (select typeid from (select typeid from ' . $this->db->dbprefix('type') . ') a)');
                $this->db->query('delete from ' . $this->db->dbprefix('type') . ' where ptypeid!=0 and  ptypeid not in (select typeid from (select typeid from ' . $this->db->dbprefix('type') . ') a)');
                $this->db->query('delete from ' . $this->db->dbprefix('type') . ' where ptypeid!=0 and  ptypeid not in (select typeid from (select typeid from ' . $this->db->dbprefix('type') . ') a)');
                $this->db->query('delete from ' . $this->db->dbprefix('type') . ' where ptypeid!=0 and  ptypeid not in (select typeid from (select typeid from ' . $this->db->dbprefix('type') . ') a)');
            }
        }
    }

    public function filter()
    {
        $data['filter'] = $this->getchildfilter('0');
        $this->load->view($this->template . 'admin/type/filter', $data);
    }

    public function getchildfilter($pid)
    {
        $rows = $this->db->select('id,pid,name,sort')->order_by('sort')->get_where('filter', array('pid' => $pid))->result();
        $sb = '';
        if ($rows) {
            $sb = '<ul>';
            foreach ($rows as $item) {
                $sb .= '<li data-id="' . $item->id . '"> ';
                $sb .= '<input type="text" class="ui-text h7" value="' . $item->sort . '" /> ';
                $sb .= '<input type="text" class="ui-text h6" value="' . $item->name . '" /> ';
                if ($pid) {
                    $sb .= '<span class="type-del"><i class="fa fa-trash-o fa-lg"></i></span> ';
                } else {
                    $sb .= '<span class="type-addchlid">添加筛选项目</span> ';
                    $sb .= '<span class="type-del"><i class="fa fa-trash-o fa-lg"></i></span> ';
                    $sb .= $this->getchildfilter($item->id);
                }
                $sb .= '</li>';
            }
            $sb .= '</ul>';
        }
        return $sb;
    }

    public function filter_edit()
    {
        if ($filter = $this->input->post('type')) {
            $filters = explode(',', $filter);
            foreach ($filters as $ty) {
                $tys = explode('|', $ty);
                if (count($tys) == 4) {
                    $id = $tys[0];
                    $data = array(
                        'pid' => $tys[1],
                        'name' => $tys[3],
                        'sort' => $tys[2],
                    );
                    if ($id == '-1') {
                        $this->db->insert('filter', $data);
                    } else {
                        $this->db->update('filter', $data, array('id' => $id));
                    }
                }
            }
        }
        echo 1;
    }

    public function filter_del($id)
    {
        if ($id) {
            if ($this->db->delete('filter', array('id' => $id))) {
                $this->db->query('delete from ' . $this->db->dbprefix('filter') . ' where pid!=0 and  pid not in (select id from (select id from ' . $this->db->dbprefix('filter') . ') a)');
            }
        }
    }

    public function type_filter($typeid)
    {
        if (IS_GET) {
            $row = $this->db->select('filter')->get_where('type', array('typeid' => $typeid))->row();
            if ($row) {
                $selects = explode(',', $row->filter);
            } else {
                $selects = array();
            }
            $data['selects'] = $selects;
            $data['filter'] = $this->db->order_by('sort')->get_where('filter', array('pid' => 0))->result();
            $data['typeid'] = $typeid;
            $this->load->view($this->template . 'admin/type/type_filter', $data);
        } elseif (IS_POST) {
            $data = array(
                'filter' => $this->input->post('selects') ? $this->input->post('selects') : '-1',
            );
            echo $this->db->where_in('typeid', explode(',', get_all_childtype_ids($typeid)))->update('type', $data);
        }
    }

}
