<?php

defined('BASEPATH') or exit('No direct script access allowed');

class Update extends Admin_Controller
{

    private $cversion;
    private $nversion;

    public function __construct()
    {
        parent::__construct();
        $this->cversion = $this->config->item('version');
        $this->nversion = $this->getnversion();
        $this->newzip = $this->cversion . '.zip';

        $menu = array(
            'title' => '在线升级',
            'menu' => array(
                'admin/update' => '在线升级',
                'admin/update/history' => '版本历史',
                'admin/update/log' => '升级日志',
            ));
        $this->load->vars('menu', $menu);
    }

    public function index()
    {
        $data['update'] = array(
            'cversion' => $this->cversion,
            'nversion' => $this->nversion,
        );
        $this->load->view($this->template . 'admin/update/index', $data);
    }

    public function doing()
    {
        set_time_limit(10 * 60 * 60);
        if (file_exists('data/' . $this->newzip)) {
            $data['zip'] = 'data/' . $this->newzip;
            $this->load->view($this->template . 'admin/update/doing', $data);
        } else {
            $this->load->view($this->template . 'admin/update/update');
        }
    }

    public function downdoc()
    {
        $file = @fopen('https://www.docswf.com/ds_wenku/' . $this->newzip, 'rb');
        if ($file) {
            $new = @fopen('data/' . $this->newzip, 'wb');
            if ($new) {
                while (!feof($file)) {
                    fwrite($new, fread($file, 1024 * 8), 1024 * 8);
                }
                fclose($new);
                echo 1;
            } else {
                echo 0;
            }
            fclose($file);
        } else {
            echo -1;
        }
    }

    public function unzip()
    {
        $zip = new ZipArchive;
        if ($zip->open('data/' . $this->newzip) === true) {
            $zip->extractTo('./');
            $zip->close();
            unlink('data/' . $this->newzip);
            echo 1;
        } else {
            echo 0;
        }
    }

    public function db()
    {
        $sql = file_get_contents($this->cversion . '.sql');
        $this->db->query('set names utf8;');
        if ($this->db->query($sql)) {
            echo 1;
        } else {
            echo -1;
        }
        unlink($this->cversion . '.sql');
    }

    public function history()
    {
        $this->load->view($this->template . 'admin/update/history');
    }

    public function log()
    {
        $data['log'] = $this->db->order_by('insertdate')->get('ds_update')->result();
        $this->load->view($this->template . 'admin/update/log', $data);
    }

    public function log_del($updateid)
    {
        if ($updateid) {
            echo $this->db->delete('ds_update', array('updateid' => $updateid));
        }
    }

    public function getnversion()
    {
        return file_get_contents('https://www.docswf.com/ds_wenku/version.txt');
    }

}
