<?php

defined('BASEPATH') or exit('No direct script access allowed');

class User extends Admin_Controller
{

    public function __construct()
    {
        parent::__construct();
        $menu = array(
            'title' => '用户管理',
            'menu' => array(
                'admin/user' => '用户',
                'admin/user/group' => '用户组',
                'admin/user/vgroup' => 'VIP用户组',
                'javascript:;" class="i' => '<span></span>',
                'admin/user/audit' => '认证审核',
                'admin/user/passed' => '认证通过',
                'admin/user/nopass' => '认证失败',
                'javascript:;;" class="i' => '<span></span>',
                'admin/user/glods' => '邀请奖励',
            ));
        $this->load->vars('menu', $menu);
    }

    public function index()
    {
        $this->load->view($this->template . 'admin/user/index');
    }

    public function userlist()
    {
        $searchcol = $this->input->post('searchcol');
        $searchtext = $this->input->post('searchtext');
        $sortcol = $this->input->post('sortcol');
        $sorttext = $this->input->post('sorttext');
        $pagesize = $this->input->post('pagesize');
        $pagecurrent = $this->input->post('pagecurrent');

        if ($searchcol == 'vip') {
            $this->db->where('vipdate >=', date("Y-m-d"));
            $this->db->where('vipdate <=', date("Y-m-d", strtotime("+$searchtext day")));
        } else if ($searchcol == 'vip_end') {
            $this->db->where('vipdate >=', date("Y-m-d", strtotime("-$searchtext day")));
            $this->db->where('vipdate <=', date("Y-m-d"));
        } elseif ($searchtext != '') {
            $this->db->like($searchcol, $searchtext);
        }

        $this->db->select('userid,username,nickname,photo,phone,isauth,groupid,groupname,vgroupid,vgroupname,points,glods,vipdate,regfrom,logindate,insertdate,state')
            ->where('state >=', 0);

        $total = $this->db->count_all_results('user_view', false);

        $users = $this->db->order_by($sortcol, $sorttext)->limit($pagesize, ($pagesize * $pagecurrent - $pagesize))->get()->result();

        foreach ($users as $user) {
            if ($user->regfrom == 3) {
                $user->username = $user->nickname . ' <span class="tip-bg bg-red">QQ用户</span>';
            }
            if ($user->regfrom == 4) {
                $user->username = $user->nickname . ' <span class="tip-bg bg-green">微信用户</span>';
            }
            if ($user->regfrom == 5) {
                $user->username = $user->nickname . ' <span class="tip-bg bg-blue">支付宝用户</span>';
            }
            if ($user->regfrom == 6) {
                $user->username = $user->username . ' <span class="tip-bg bg-yellow">论坛用户</span>';
            }
            if (!$user->phone) {
                $user->phone = '<span class="tip-bg bg-red">无</span>';
            }
            $user->isauth = $user->isauth ? '是' : '否';
            $user->docnum = $this->db->select('count(*) docnum')->get_where('doc', array('userid' => $user->userid, 'state' => 1, 'isdel' => 0))->row()->docnum;
            if ($user->vgroupname != '-') {
                $user->vip = strtotime($user->vipdate) < time() ? '<s>' . $user->vgroupname . '</s>' : $user->vgroupname;
            } else {
                $user->vip = '';
            }
            $user->insertdate = date('Y-m-d', strtotime($user->insertdate));
            $user->logindate = date('Y-m-d', strtotime($user->logindate));
            $user->state = $user->state ? '<span style="color:#129A5C">正常</span>' : '<span style="color:#f00">禁止</span>';
        }
        echo json_encode(array('total' => $total, 'data' => $users));
    }

    public function photo_del($userid)
    {
        if ($userid) {
            $png = "data/photo/$userid.png";
            file_exists($png) && unlink($png);
        }
    }

    public function photo_edit()
    {
        if (IS_GET) {
            $id = $this->uri->segment('4');
            $photo = 'data/photo/0.png';
            $png = 'data/photo/$id.png';
            if (file_exists($png)) {
                $photo = $png;
            }
            $data['id'] = $id;
            $data['photo'] = $photo;
            $this->load->view($this->template . 'admin/user/photo_edit', $data);
        } else {
            header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
            header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT');
            header('Cache-Control: no-store, no-cache, must-revalidate');
            header('Cache-Control: post-check=0, pre-check=0', false);
            header('Pragma: no-cache');

            @set_time_limit(300); //5分钟

            $id = $this->input->post('id');

            $config['upload_path'] = 'data/photo/';
            $config['file_name'] = $id;
            $config['allowed_types'] = 'gif|jpg|png';
            $config['max_size'] = 1024; //1M
            $config['max_width'] = 200;
            $config['max_height'] = 200;
            $this->load->library('upload', $config);

            if (!$this->upload->do_upload('file')) {
                echo $this->upload->display_errors();
            }
        }
    }

    public function user_edit($userid)
    {
        if (IS_GET) {
            if ($userid && $row = $this->db->get_where('user_view', array('userid' => $userid))->row()) {
                $data['user'] = $row;
            } else {
                $data['user'] = (object) array(
                    'userid' => '0',
                    'username' => '',
                    'nickname' => '',
                    'photo' => 'data/photo/0.png',
                    'sex' => '男',
                    'phone' => '',
                    'groupid' => '1',
                    'groupname' => '-',
                    'vgroupid' => '0',
                    'vgroupname' => '-',
                    'isauth' => '否',
                    'points' => '0',
                    'glods' => '0',
                    'vipdate' => '',
                    'state' => '1',
                );
            }
            $data['group'] = $this->db->order_by('sort')->get_where('group', array('groupid >' => 0))->result();
            $data['vgroup'] = $this->db->order_by('sort')->get_where('vgroup', ['state' => 1])->result();
            $this->load->view($this->template . 'admin/user/user_edit', $data);
        } elseif (IS_POST) {
            $data = array(
                'username' => $this->input->post('username'),
                'nickname' => $this->input->post('nickname'),
                'sex' => $this->input->post('sex'),
                'phone' => $this->input->post('phone'),
                'groupid' => $this->input->post('groupid'),
                'vgroupid' => $this->input->post('vgroupid'),
                'isauth' => $this->input->post('isauth'),
                'points' => $this->input->post('points') ? $this->input->post('points') : 0,
                'glods' => $this->input->post('glods') ? $this->input->post('glods') : 0,
                'vipdate' => $this->input->post('vipdate') ? $this->input->post('vipdate') : null,
                'state' => $this->input->post('state'),
            );
            if ($userid) {
                if ($this->input->post('password')) {
                    $data['password'] = md5($this->input->post('password'));
                }
                echo $this->db->update('user', $data, array('userid' => $userid));
            } else {
                echo $this->db->insert('user', $data);
            }
        }
    }

    public function user_del($userids)
    {
        if ($userids) {
            foreach (explode('_', $userids) as $userid) {
                if ($userid > 1) {
                    if ($this->db->delete('user', array('userid' => $userid))) {
                        $png = "data/photo/$userid.png";
                        file_exists($png) && unlink($png);
                    }
                    $ok = 1;
                } else {
                    $ok = -1;
                }
            }
        }
        echo $ok;
    }

    public function glodsinfo($userid)
    {
        if (IS_GET) {
            $this->load->view($this->template . 'admin/user/glodsinfo', ['userid' => $userid]);
        } elseif (IS_POST) {
            $this->glodsinfolist($userid);
        }
    }

    private function glodsinfolist($userid)
    {
        $searchcol = $this->input->post('searchcol');
        $searchtext = $this->input->post('searchtext');
        $sortcol = $this->input->post('sortcol');
        $sorttext = $this->input->post('sorttext');
        $pagesize = $this->input->post('pagesize');
        $pagecurrent = $this->input->post('pagecurrent');

        if ($searchtext != '') {
            $this->db->like($searchcol, $searchtext);
        }

        $this->db->where('userid', $userid);
        $this->db->where('glods !=', 0);

        $total = $this->db->count_all_results('glod_view', false);

        $invites = $this->db->order_by($sortcol, $sorttext)->limit($pagesize, ($pagesize * $pagecurrent - $pagesize))->get()->result();

        foreach ($invites as $invite) {

            switch ($invite->type) {
                case '10':
                    $invite->type = "充值";
                    break;
                case '-10':
                    $invite->type = "提现";
                    break;
                case '11':
                    $invite->type = "邀请奖励";
                    break;
                case '12':
                    $invite->type = "邀请分成";
                case '21':
                    $invite->type = "悬赏金币";
                    break;
                case '-21':
                    $invite->type = "悬赏扣除";
                    break;
                case '30':
                case '31':
                case '32':
                    $invite->type = "阅读收益";
                    break;
                case '-30':
                case '-31':
                case '-32':
                    $invite->type = "阅读扣除";
                    break;
                case '40':
                case '41':
                case '42':
                    $invite->type = "下载收益";
                    break;
                case '-40':
                case '-41':
                case '-42':
                    $invite->type = "下载扣除";
                    break;
                case '50':
                case '51':
                case '52':
                    $invite->type = "专题收益";
                    break;
                case '-50':
                case '-51':
                case '-52':
                    $invite->type = "专题扣除";
                    break;
            }
            $invite->insertdate = date('Y-m-d', strtotime($invite->insertdate));
        }
        echo json_encode(array('total' => $total, 'data' => $invites));
    }

    public function auth($which)
    {
        if (IS_GET) {
            $this->load->view($this->template . 'admin/user/auth');
        } elseif (IS_POST) {
            $this->authlist($which);
        }
    }

    public function authlist($which)
    {
        $searchcol = $this->input->post('searchcol');
        $searchtext = $this->input->post('searchtext');
        $sortcol = $this->input->post('sortcol');
        $sorttext = $this->input->post('sorttext');
        $pagesize = $this->input->post('pagesize');
        $pagecurrent = $this->input->post('pagecurrent');

        switch ($which) {
            case 'audit':
                $this->db->where('state', 0);
                break;
            case 'passed':
                $this->db->where('state >', 0);
                break;
            case 'nopass':
                $this->db->where('state', -1);
                break;
        }
        if ($searchtext != '') {
            $this->db->like($searchcol, $searchtext);
        }

        $total = $this->db->count_all_results('auth', false);

        $auths = $this->db->select('`userid`,`comname`,`comaddress`,`comcode`,`realname`,`cardid`,`phone`,`email`,`note`,`insertdate`,`model`,`state`')->order_by($sortcol, $sorttext)->limit($pagesize, ($pagesize * $pagecurrent - $pagesize))->get()->result();

        foreach ($auths as $auth) {
            $auth->smodel = $auth->model ? '<span class="block">企业认证</span>' : '<span class="block">个人认证</span>';
            $auth->pubdate = date('Y-m-d', strtotime($auth->insertdate));
            switch ($auth->state) {
                case '-1':
                    $auth->sshow = '审核失败';
                    break;
                case '0':
                    $auth->sshow = '未审核';
                    break;
                case '1':
                    $auth->sshow = '已审核';
                    break;
            }
        }
        echo json_encode(array('total' => $total, 'data' => $auths));
    }

    public function auth_audit($userids = 0)
    {
        if (IS_GET) {
            $data['userids'] = $userids;
            $this->load->view($this->template . 'admin/user/auth_audit', $data);
        } else {
            if ($userids) {
                $passed = $this->input->post('passed');
                $nopass = $this->input->post('nopass');
                $note = $this->input->post('note');

                $data['state'] = 0;
                if ($passed == '1') {
                    $data['state'] = 1;
                }
                if ($nopass == '1') {
                    $data['state'] = -1;
                }
                $data['note'] = $note;

                foreach (explode('_', $userids) as $userid) {
                    $this->db->set('isauth', $passed, false)->where('userid', $userid)->update('user');
                    echo $this->db->update('auth', $data, array('userid' => $userid));
                }
            }
        }
    }

    public function auth_del($userids = -1)
    {
        if ($userids) {
            foreach (explode('_', $userids) as $userid) {
                $this->db->delete('auth', array('userid' => $userid));
            }
        }
    }

    public function auth_info($userid)
    {
        if ($row = $this->db->get_where('auth', array('userid' => $userid))->row()) {
            $data['auth'] = $row;
        } else {
            $data['auth'] = (object) array(
                'userid' => '0',
                'comname' => '',
                'comaddress' => '',
                'comcode' => '',
                'realname' => '',
                'cardid' => '',
                'phone' => '',
                'email' => '',
                'note' => '',
                'model' => '0',
                'state' => '0',
                'authpic1' => 'data/img/nopic.png',
                'authpic2' => 'data/img/nopic.png',
                'authpic3' => 'data/img/nopic.png',
                'authpic4' => 'data/img/nopic.png',
                'authpic5' => 'data/img/nopic.png',
                'authpic6' => 'data/img/nopic.png',
                'authpic7' => 'data/img/nopic.png',
            );
        }

        $this->load->view($this->template . 'admin/user/auth_info', $data);
    }

    public function group()
    {
        $data['group'] = $this->db->order_by('sort')->get('group')->result();
        $this->load->view($this->template . 'admin/user/group', $data);
    }

    public function group_edit($groupid)
    {
        if (IS_GET) {
            if ($groupid > -1 && $row = $this->db->get_where('group', array('groupid' => $groupid))->row()) {
                $data['group'] = $row;
            } else {
                $data['group'] = (object) array(
                    'groupid' => -1,
                    'groupname' => '新用户组',
                    'groupicon' => '',
                    'docnum' => 10,
                    'isauth' => 0,
                    'divide' => 0.5,
                    'invite' => '0',
                    'invitedays' => 365,
                    'uploadcount' => 10,
                    'uploadsize' => 10,
                    'uploadexten' => 'doc,docx,ppt,pptx,xls,xlsx,csv,epub,vsd,pot,pps,rtf,wps,et,dps,pdf,txt,zip',
                    'downcount' => 10,
                    'sort' => '8',
                );
            }
            $this->load->view($this->template . 'admin/user/group_edit', $data);
        } elseif (IS_POST) {
            $data = array(
                'groupname' => $this->input->post('groupname'),
                'groupicon' => $this->input->post('groupicon'),
                'docnum' => $this->input->post('docnum'),
                'isauth' => $this->input->post('isauth'),
                'divide' => $this->input->post('divide'),
                'invite' => $this->input->post('invite'),
                'invitedays' => $this->input->post('invitedays'),
                'uploadcount' => $this->input->post('uploadcount'),
                'uploadsize' => $this->input->post('uploadsize'),
                'uploadexten' => $this->input->post('uploadexten'),
                'downcount' => $this->input->post('downcount'),
                'sort' => $this->input->post('sort'),
            );
            if ($groupid > -1) {
                echo $this->db->update('group', $data, array('groupid' => $groupid));
            } else {
                echo $this->db->insert('group', $data);
            }
        }
    }

    public function group_del($groupid)
    {
        if ($groupid && $groupid > 5) {
            echo $this->db->delete('group', array('groupid' => $groupid));
        }
    }

    public function right_edit()
    {
        if (IS_GET) {
            $groupid = $this->uri->segment('4');
            $data['groupid'] = $groupid;

            $right_row = $this->db->select('rights')->get_where('group', array('groupid' => $groupid))->row();
            if ($right_row) {
                $selects = explode(',', $right_row->rights);
            } else {
                $selects = array();
            }
            $data['selects'] = $selects;

            $rights = $this->db->select('rightid,rightname,note,righticon,model')->order_by('sort')->get('right')->result();
            foreach ($rights as $r) {
                $right[$r->model][] = $r;
            }
            $data['right'] = $right;

            $this->load->view($this->template . 'admin/user/right_edit', $data);
        } elseif (IS_POST) {
            $data = array(
                'rights' => $this->input->post('rights'),
            );
            echo $this->db->update('group', $data, array('groupid' => $this->input->post('groupid')));
        }
    }

    public function vgroup()
    {
        $data['vgroup'] = $this->db->order_by('sort')->get('vgroup')->result();
        $this->load->view($this->template . 'admin/user/vgroup', $data);
    }

    public function vgroup_edit($id)
    {
        if (IS_GET) {
            if ($id && $row = $this->db->get_where('vgroup', array('vgroupid' => $id))->row()) {
                $data['vgroup'] = $row;
            } else {
                $data['vgroup'] = (object) array(
                    'vgroupid' => '0',
                    'vgroupname' => '',
                    'vgroupicon' => '',
                    'vipdays' => '',
                    'discount' => '',
                    'discount2' => '',
                    'downcount' => '',
                    'downcount2' => '',
                    'docmoney' => '',
                    'cash' => '',
                    'cash2' => '',
                    'sort' => '1',
                    'state' => '1',
                );
            }
            $this->load->view($this->template . 'admin/user/vgroup_edit', $data);
        } elseif (IS_POST) {
            $data = array(
                'vgroupname' => $this->input->post('vgroupname'),
                'vgroupicon' => $this->input->post('vgroupicon'),
                'vipdays' => $this->input->post('vipdays'),
                'discount' => $this->input->post('discount'),
                'discount2' => $this->input->post('discount2'),
                'downcount' => $this->input->post('downcount'),
                'downcount2' => $this->input->post('downcount2'),
                'docmoney' => $this->input->post('docmoney'),
                'cash' => number_format($this->input->post('cash'), 2, '.', ''),
                'cash2' => number_format($this->input->post('cash2'), 2, '.', ''),
                'sort' => $this->input->post('sort'),
                'state' => $this->input->post('state'),
            );
            if ($id) {
                echo $this->db->update('vgroup', $data, array('vgroupid' => $id));
            } else {
                echo $this->db->insert('vgroup', $data);
            }
        }
    }

    public function vgroup_del($id)
    {
        if ($id) {
            echo $this->db->delete('vgroup', array('vgroupid' => $id));
        }
    }

    public function vgroup_suggest()
    {
        $data = array(
            'suggest' => $this->input->post('val'),
        );
        if ($id = $this->input->post('key')) {
            echo $this->db->update('vgroup', array('suggest' => 0)) && $this->db->update('vgroup', $data, array('vgroupid' => $id));
        }
    }

    public function vgroup_state()
    {
        $data = array(
            'state' => $this->input->post('val'),
        );
        if ($id = $this->input->post('key')) {
            echo $this->db->update('vgroup', $data, array('vgroupid' => $id));
        }
    }

    public function glods()
    {
        if (IS_GET) {
            $this->load->view($this->template . 'admin/user/glods');
        } elseif (IS_POST) {
            $this->glodslist();
        }
    }

    public function glodslist()
    {
        $searchcol = $this->input->post('searchcol');
        $searchtext = $this->input->post('searchtext');
        $sortcol = $this->input->post('sortcol');
        $sorttext = $this->input->post('sorttext');
        $pagesize = $this->input->post('pagesize');
        $pagecurrent = $this->input->post('pagecurrent');

        if ($searchtext != '') {
            $this->db->like($searchcol, $searchtext);
        }

        $this->db->where_in('type', [11, 12]);

        $total = $this->db->count_all_results('glod_invite_view', false);

        $invites = $this->db->order_by($sortcol, $sorttext)->limit($pagesize, ($pagesize * $pagecurrent - $pagesize))->get()->result();

        foreach ($invites as $invite) {
            if ($invite->type == 11) {
                $invite->type = "注册奖励";
                $invite->invite = $invite->invite . ' ' . $this->tradeset->glodunit;
                $invite->glods = $invite->glods . ' ' . $this->tradeset->glodunit;
            }
            if ($invite->type == 12) {
                $invite->type = "分红奖励";
                $invite->invite = $invite->invite;
                $invite->glods = ((int) $invite->glods * 100 / (float) $invite->invite) . '*' . $invite->invite . '=' . $invite->glods . ' ' . $this->tradeset->glodunit;
            }
            $invite->insertdate = date('Y-m-d', strtotime($invite->insertdate));
        }
        echo json_encode(array('total' => $total, 'data' => $invites));
    }

    public function glods_del($ids)
    {
        if ($ids) {
            foreach (explode('_', $ids) as $id) {
                $this->db->delete('glodpot', array('id' => $id));
            }
            echo 1;
        }
    }

}
