<?php

defined('BASEPATH') or exit('No direct script access allowed');

//2018.05.19
//获取所有分类对象数组,Key为typeid,得到一个array[]
function get_types()
{
    if (isset($GLOBALS['type'])) {
        $type_array = $GLOBALS['type'];
    } else {
        $instance = &get_instance();
        $types = $instance->db->order_by('sort')->get_where('type')->result();
        $type_array = [];
        foreach ($types as $type) {
            $type_array[$type->typeid] = $type;
        }
        $GLOBALS['type'] = $type_array;
    }
    return $type_array;
}

//2017.07.27
//获取所有分类对象数组，Key为pid,得到一个array[][]
function get_type_array()
{
    $types = get_types();
    $type_array = [];
    foreach ($types as $type) {
        $type_array[$type->ptypeid][] = $type;
    }
    return $type_array;
}

//2017.08.10
//根据分类ID，获取分类对象()
function get_type($tid)
{
    $types = get_types();
    return isset($types[$tid]) ? $types[$tid] : null;
}

//2017.08.10
//根据分类ID，获取子分类数组[]
function get_childtype($tid)
{
    $types = get_type_array();
    return isset($types[$tid]) ? $types[$tid] : [];
}

//2017.10.31
//获取分类的所有子分类,不包含当前分类
function get_all_childtype($tid)
{
    $types = get_childtype($tid);
    foreach ($types as $type) {
        $types = array_merge($types, get_all_childtype($type->typeid));
    }
    return $types;
}

//2017.10.31
//获取分类的所有子分类,包含当前分类
function get_all_childtype_ids($tid)
{
    $tids = $tid;
    foreach (get_childtype($tid) as $type) {
        $tids .= ',' . get_all_childtype_ids($type->typeid);
    }
    return $tids;
}

//2019.03.17
//获取所有父分类,包含当前分类
function get_ptypes($typeid)
{
    $temp = get_type($typeid);
    $type = array($temp);
    if (isset($temp->ptypeid) && $temp->ptypeid) {
        $type = array_merge($type, get_ptypes($temp->ptypeid));
    }
    return $type;
}

//2019.08.08
//根据分类ID获取分类链 ['1-2-3','初三数学-数学-中学教育']
function get_typelink($typeid)
{
    $like = array_reverse(get_ptypes($typeid));
    $l0 = '';
    $l1 = '';

    foreach ($like as $l) {
        $l0 .= $l->typeid . '-';
        $l1 .= $l->typename . ' > ';

    }
    return [substr($l0, 0, -1), substr($l1, 0, -1)];
}

//2017.08.10
//根据分类ID，获取此分类下文档
function get_docs_bytid($tid)
{
    $instance = &get_instance();
    $docs = $instance->db->order_by('docid', 'desc')->get_where('doc_view', array('typeid' => $tid, 'state' => 1, 'isdel' => 0))->result();
    return $docs;
}

//2017.08.10
//根据分类ID，获取此分类下所有文档，包含当前分类和子类文档
function get_all_docs_bytid($tid)
{
    $docs = get_docs_bytid($tid);
    foreach (get_childtype($tid) as $item) {
        $docs = array_merge($docs, get_all_docs_bytid($item->typeid));
    }
    return $docs;
}

//2017.10.31
//获取分类下所有最新文档
function get_new_docs($tid, $num = 12)
{
    $instance = &get_instance();
    $types_str = get_all_childtype_ids($tid);
    $docs = $instance->db->order_by('docid', 'desc')->where_in('typeid', explode(',', $types_str))->limit($num)->get_where('doc_view', array('state' => 1, 'isdel' => 0))->result();
    return $docs;
}

//2017.08.19
//根据分页信息获取文档  doc/list-45-1-1.html  分类-页数-排序
function get_docs_bypage($userid, $typeid, $filter, $keyword, $isred, $exten, $isimp, $isvip, $isall, $pagesize, $cpage, $order)
{
    $instance = &get_instance();

    if ($userid) {
        $instance->db->where('userid', $userid);
    }

    if ($typeid) {
        $instance->db->where_in('typeid', explode(',', get_all_childtype_ids($typeid)));
    }

    if ($filter) {
        $instance->db->where("(filter like '$filter' or filter='-1')");
    }

    if ($keyword) {
        $keywords = explode(',', fenci($keyword));
        $where1 = '(';
        $where2 = '(';
        $where3 = '(';
        foreach ($keywords as $k) {
            $where1 .= "SIGN(LOCATE('$k',`title`)) + ";
            $where2 .= "SIGN(LOCATE('$k',`word`)) + ";
            $where3 .= "SIGN(LOCATE('$k',`keyword`)) + ";
        }
        $where1 = substr($where1, 0, -3) . ')';
        $where2 = substr($where2, 0, -3) . ')';
        $where3 = substr($where3, 0, -3) . ')';

        $instance->db->where("($where1 > 0 or $where2 > 0 or $where3 > 0)");

        $instance->db->order_by("$where1 desc");
        $instance->db->order_by("$where2 desc");
        $instance->db->order_by("$where3 desc");
    }

    if ($exten) {
        $instance->db->like('exten', $exten, 'after');
    }

    if ($isimp) {
        $instance->db->where('isimp', $isimp);
    }

    if ($isvip) {
        $instance->db->where('isvip', $isvip);
    }

    if ($isall) {
        $instance->db->where(array('state <>' => -2));
    } else {
        $instance->db->where(array('state' => 1, 'isdel' => 0));
    }

    if ($order) {
        $instance->db->order_by($order);
    }

    $total = $instance->db->count_all_results('doc_view', false);

    if ($pagesize && $cpage) {
        $instance->db->limit($pagesize, $pagesize * $cpage - $pagesize);
    }

    $docs = $instance->db->get()->result();
    if ($isred) {
        foreach ($docs as $doc) {
            $doc->word = wordwd($doc->word, 1860);
            if (isset($keywords)) {
                foreach ($keywords as $k) {
                    $doc->title = str_replace($k, '<span style="color:#f00">' . $k . '</span>', $doc->title);
                    $doc->keyword = str_replace($k, '<span style="color:#f00">' . $k . '</span>', $doc->keyword);
                    $doc->word = str_replace($k, '<span style="color:#f66">' . $k . '</span>', $doc->word);
                }
            }
        }
    }

    return array('total' => $total, 'data' => $docs);
}

//2017.10.05
//根据用户名和密码获取用户，不存在返回null
function get_user($username, $password)
{
    $instance = &get_instance();
    $user1 = $instance->db->where(array('username' => $username, 'password' => $password))->get('user')->row();
    $user2 = $instance->db->where(array('phone' => $username, 'password' => $password))->get('user')->row();
    return $user1 ? $user1 : $user2;
}

//2017.08.19
//根据用户ID获取用户，不存在返回null
function get_user2($userid)
{
    $instance = &get_instance();
    $row = $instance->db->get_where('user', array('userid' => $userid))->row();
    return $row;
}

//2017.08.19
//根据用户ID获取用户，不存在返回null
function get_group($groupid)
{
    $instance = &get_instance();
    $row = $instance->db->get_where('group', array('groupid' => $groupid))->row();
    return $row;
}

//2017.07.26
//判断权限
function has_right($ugroup, $right)
{
    if ($ugroup && in_array($right, explode(',', $ugroup->rights))) {
        return true;
    } else {
        return false;
    }
}

//2017.08.21
//根据文档ID获取文档，不存在返回null
function get_doc($docid)
{
    $instance = &get_instance();
    $row = $instance->db->get_where('doc', array('docid' => $docid))->row();
    return $row;
}

//2017.11.28
//根据文档ID获取文档，不存在返回null
function get_docv($docid)
{
    $instance = &get_instance();
    $row = $instance->db->get_where('doc_view', array('docid' => $docid))->row();
    return $row;
}

//2017.08.21
//根据文档ID获取文档，不存在返回null
function get_topic($topicid)
{
    $instance = &get_instance();
    $row = $instance->db->get_where('topic', array('topicid' => $topicid))->row();
    return $row;
}

//2017.08.21
//根据文档ID获取文档，不存在返回null
function get_topicv($topicid)
{
    $instance = &get_instance();
    $row = $instance->db->get_where('topic_view', array('topicid' => $topicid))->row();
    return $row;
}

//2017.08.21
//根据文档ID获取文档，不存在返回null
function get_path($docid)
{
    $instance = &get_instance();
    $row = $instance->db->select('path')->get_where('doc', array('docid' => $docid))->row();
    return $row;
}

//2017.12.12
function get_tradeset()
{
    $instance = &get_instance();
    $row = $instance->db->get('tradeset')->row();
    return $row;
}

//2017.12.12
//根据文档ID获取文档，不存在返回null
function get_points($id)
{
    $instance = &get_instance();
    $row = $instance->db->get_where('points', array('id' => $id, 'state' => 1))->row();
    return $row;
}

function get_vipgroup($vgroupid)
{
    $instance = &get_instance();
    $row = $instance->db->get_where('vgroup', array('vgroupid' => $vgroupid))->row();
    return $row;
}

//2018.07.24
//记录积分日志
function pointpot($type, $userid, $docid = '0', $ip = '')
{
    if ($points = get_points($type)) {
        $instance = &get_instance();
        $has = $instance->db->get_where('pointpot', array('type' => $type, 'userid' => $userid, 'docid' => $docid, 'ip' => $ip));
        if ($has->num_rows() <= 0) {
            $instance->db->set('points', 'points+' . $points->points, false)->where('userid', $userid)->update('user');
            $potdata = array(
                'type' => $type,
                'userid' => $userid,
                'points' => $points->points,
                'docid' => $docid,
                'ip' => $ip,
            );
            $instance->db->insert('pointpot', $potdata);
        }
    }
}

//2017.08.19
//根据path，获取扩展名,不含 .
function get_exten($path)
{
    return strtolower(substr(strrchr($path, '.'), 1));
}

//2017.08.19
//根据path，获取文档目录,含 /
function get_dir($path)
{
    return substr($path, 0, strrpos($path, '.')) . '/';
}

function get_pcount($path)
{
    $count = 0;
    $file = null;
    if (is_dir($path) && $handle = opendir($path)) {
        while ($file = readdir($handle)) {
            if (get_exten($file) == 'view') {
                $count++;
            }
        }
        closedir($handle);
    }

    if (($instance = &get_instance()) && ($oss = $instance->db->get('ossset')->row()) && $oss->state && $instance->load->library('Oss/oss')) {
        $count = $count + $instance->oss->get_pcount($path) - 1;
    }

    return $count;
}

function delfile($file)
{
    if (is_file($file)) {
        @unlink($file);
    }

    if (($dir = get_dir($file)) && is_dir($dir) && $dh = opendir($dir)) {
        while ($filename = readdir($dh)) {
            if ($filename != '.' && $filename != '..') {
                $f = $dir . $filename;
                if (is_dir($f)) {
                    delfile($f);
                } else {
                    @unlink($f);
                }
            }
        }
        closedir($dh);
        rmdir($dir);
    }

    if (($instance = &get_instance()) && ($oss = $instance->db->get('ossset')->row()) && $oss->state && $instance->load->library('Oss/oss')) {
        $instance->oss->deletefile($file); //有目录删目录
    }
}

function synoss($file, $title = null)
{
    $instance = &get_instance();
    if (($oss = $instance->db->get('ossset')->row()) && $oss->state && $instance->load->library('Oss/oss')) {
        if (is_file($file)) {
            $instance->oss->uploadfile($file, $file, $title);
            if ($oss->delfile) {
                @unlink($file);
            }
        }
        if (($dir = get_dir($file)) && is_dir($dir) && $dh = opendir($dir)) {
            while ($filename = readdir($dh)) {
                if ($filename != '.' && $filename != '..') {
                    $instance->oss->uploadfile($dir . $filename, $dir . $filename, null);
                    if ($oss->delfile) {
                        @unlink($dir . $filename);
                    }
                }
            }
        }
    }
}

function downfile($file, $real = true)
{
    if (file_exists($file)) {
        $real && readfile2($file);
        return true;
    } else if (($instance = &get_instance()) && ($oss = $instance->db->get('ossset')->row()) && $oss->state && $instance->load->library('Oss/oss') && $instance->oss->objectexists($file)) {
        $url = $instance->oss->signUrl($file);
        if ($oss->fluxoss) {
            $real && header('Location:' . $url);
        } else {
            $real && readfile2($url);
        }
        return true;
    } else {
        return false;
    }
}

function readfile2($file)
{
    $handler = fopen($file, 'rb');

    while (!feof($handler)) {
        echo fread($handler, 10240);
        flush();
        ob_flush();
    }

    fclose($handler);
}

//删除文件夹下所有文件  deldir('/data/doc','/data/doc')
function deldir($path, $but)
{
    if (is_dir($path) && $dh = opendir($path)) {
        while ($filename = readdir($dh)) {
            if ($filename != '.' && $filename != '..' && $filename != 'index.html' && $filename != '.htaccess') {
                $file = $path . '/' . $filename;
                if (is_dir($file)) {
                    deldir($file, $but);
                } else {
                    @unlink($file);
                }
            }
        }
        if ($but != $path) {
            closedir($dh);
            rmdir($path);
        }
    }
}

//2017.10.03
//获取客户端IP
function getip()
{
    if (@$_SERVER['HTTP_X_FORWARDED_FOR']) {
        $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
    } else if (@$_SERVER['HTTP_CLIENT_IP']) {
        $ip = $_SERVER['HTTP_CLIENT_IP'];
    } else if (@$_SERVER['REMOTE_ADDR']) {
        $ip = $_SERVER['REMOTE_ADDR'];
    } else if (@getenv('HTTP_X_FORWARDED_FOR')) {
        $ip = getenv('HTTP_X_FORWARDED_FOR');
    } else if (@getenv('HTTP_CLIENT_IP')) {
        $ip = getenv('HTTP_CLIENT_IP');
    } else if (@getenv('REMOTE_ADDR')) {
        $ip = getenv('REMOTE_ADDR');
    } else {
        $ip = 'Unknown';
    }

    return $ip;
}

function iswap()
{
    if (isset($_SERVER['HTTP_X_WAP_PROFILE'])) {
        return true;
    }
    if (isset($_SERVER['HTTP_VIA'])) {
        return stristr($_SERVER['HTTP_VIA'], 'wap') ? true : false;
    }
    if (isset($_SERVER['HTTP_USER_AGENT'])) {
        $clientkeywords = array('nokia',
            'sony',
            'ericsson',
            'mot',
            'samsung',
            'htc',
            'sgh',
            'lg',
            'sharp',
            'sie-',
            'philips',
            'panasonic',
            'alcatel',
            'lenovo',
            'iphone',
            'ipod',
            'blackberry',
            'meizu',
            'android',
            'netfront',
            'symbian',
            'ucweb',
            'windowsce',
            'palm',
            'operamini',
            'operamobi',
            'openwave',
            'nexusone',
            'cldc',
            'midp',
            'wap',
            'mobile',
        );
        if (preg_match('/(' . implode('|', $clientkeywords) . ')/i', strtolower($_SERVER['HTTP_USER_AGENT']))) {
            return true;
        }
    }
    if (isset($_SERVER['HTTP_ACCEPT'])) {
        if ((strpos($_SERVER['HTTP_ACCEPT'], 'vnd.wap.wml') !== false) && (strpos($_SERVER['HTTP_ACCEPT'], 'text/html') === false || (strpos($_SERVER['HTTP_ACCEPT'], 'vnd.wap.wml') < strpos($_SERVER['HTTP_ACCEPT'], 'text/html')))) {
            return true;
        }
    }
    return false;
}

function iswx()
{
    if (strpos($_SERVER['HTTP_USER_AGENT'], 'MicroMessenger') !== false) {
        return true;
    }
    return false;
}

// 删除 "Custo", 因和iphone qq浏览器 mttcustomua 冲突
function isrobot()
{
    $agent = strtolower($_SERVER['HTTP_USER_AGENT']);
    if (!empty($agent)) {
        $spiderSite = array(
            "TencentTraveler",
            "Baiduspider+",
            "BaiduGame",
            "Googlebot",
            "msnbot",
            "Sosospider+",
            "Sogou web spider",
            "ia_archiver",
            "Yahoo! Slurp",
            "YoudaoBot",
            "Yahoo Slurp",
            "MSNBot",
            "Java (Often spam bot)",
            "BaiDuSpider",
            "Voila",
            "Yandex bot",
            "BSpider",
            "twiceler",
            "Sogou Spider",
            "Speedy Spider",
            "Google AdSense",
            "Heritrix",
            "Python-urllib",
            "Alexa (IA Archiver)",
            "Ask",
            "Exabot",
            "OutfoxBot/YodaoBot",
            "yacy",
            "SurveyBot",
            "legs",
            "lwp-trivial",
            "Nutch",
            "StackRambler",
            "The web archive (IA Archiver)",
            "Perl tool",
            "MJ12bot",
            "Netcraft",
            "MSIECrawler",
            "WGet tools",
            "larbin",
            "Fish search",
        );
        foreach ($spiderSite as $val) {
            $str = strtolower($val);
            if (strpos($agent, $str) !== false) {
                return true;
            }
        }
    } else {
        return false;
    }
}

//2017.10.12
//获取随机数包含数字，大小写字母
function random($length)
{
    $chars = '123456789abcdefghijklmnpqrstuvwxyzABCDEFGHIJKLMNPQRSTUVWXYZ';
    $hash = '';
    for ($i = 0; $i < $length; $i++) {
        $hash .= $chars[mt_rand(0, 58)];
    }
    return $hash;
}

function getsize2($size)
{
    $unit = ['Bytes', 'KB', 'MB', 'GB'];
    $i = round(log($size) / log(1024));
    return round($size / pow(1024, $i), 2) . ' ' . $unit[$i];
}

function bsize($size, $digits = 2)
{
    if ($size > 0) {
        $unit = array('', 'K', 'M', 'G', 'T', 'P');
        $i = floor(log($size, 1024));
        $n = count($unit);
        if ($i >= $n) {
            $i = $n - 1;
        }
        return round($size / pow(1024, $i), $digits) . ' ' . $unit[$i] . 'B';
    } else {
        return 0;
    }
}

function fnum($num)
{
    return $num >= 10000 ? round($num / 10000, 2) . '万' : $num;
}

function mb_sub($str, $len, $start = 0)
{
    $osLen = mb_strlen($str);
    if ($osLen <= $len) {
        return $str;
    }
    $string = mb_substr($str, $start, $len, 'utf8');
    $sLen = mb_strlen($string, 'utf8');
    $bLen = strlen($string);
    $sCharCount = (3 * $sLen - $bLen) / 2;
    if ($osLen <= $sCharCount + $len) {
        $arr = preg_split('/(?<!^)(?!$)/u', mb_substr($str, $len, $osLen, 'utf8'));
    } else {
        $arr = preg_split('/(?<!^)(?!$)/u', mb_substr($str, $len, $sCharCount, 'utf8'));
    }
    foreach ($arr as $value) {
        if (ord($value) < 128 && ord($value) > 0) {
            $sCharCount = $sCharCount - 1;
        } else {
            $sCharCount = $sCharCount - 2;
        }
        if ($sCharCount <= 0) {
            break;
        }
        $string .= $value;
    }
    return $string;
}

function dockey($str)
{
    $instance = &get_instance();
    $dockeys = $instance->db->order_by('sort')->get_where('dockey', array('state' => '1'))->result();
    foreach ($dockeys as $dockey) {
        return substr_replace($str, "<a href='$dockey->url' title='$dockey->key' >$dockey->key</a>", strpos($str, $dockey->key), strlen($dockey->key));
    }
    return $str;
}

//str 字符串 wh 宽度像素
function wordwd($str, $wh)
{
    if ($str == '') {
        return '';
    }

    //100个字符在雅黑字体的长度(px)
    $w = [32 => 0, 33 => 500, 34 => 697, 35 => 1021, 36 => 938, 37 => 1423, 38 => 1392, 39 => 410, 40 => 534, 41 => 534, 42 => 728, 43 => 1187, 44 => 385, 45 => 692, 46 => 385, 47 => 684, 48 => 938, 49 => 938, 50 => 938, 51 => 938, 52 => 938, 53 => 938, 54 => 938, 55 => 938, 56 => 938, 57 => 938, 58 => 385, 59 => 385, 60 => 1187, 61 => 1187, 62 => 1187, 63 => 773, 64 => 1650, 65 => 1126, 66 => 1004, 67 => 1070, 68 => 1219, 69 => 880, 70 => 850, 71 => 1190, 72 => 1238, 73 => 470, 74 => 634, 75 => 1016, 76 => 821, 77 => 1563, 78 => 1301, 79 => 1304, 80 => 979, 81 => 1304, 82 => 1045, 83 => 923, 84 => 917, 85 => 1195, 86 => 1082, 87 => 1628, 88 => 1032, 89 => 966, 90 => 992, 91 => 534, 92 => 666, 93 => 534, 94 => 1187, 95 => 717, 96 => 472, 97 => 884, 98 => 1022, 99 => 802, 100 => 1023, 101 => 908, 102 => 555, 103 => 1023, 104 => 985, 105 => 426, 106 => 427, 107 => 871, 108 => 426, 109 => 1499, 110 => 986, 111 => 1017, 112 => 1022, 113 => 1023, 114 => 611, 115 => 741, 116 => 596, 117 => 986, 118 => 840, 119 => 1263, 120 => 811, 121 => 847, 122 => 787, 123 => 534, 124 => 430, 125 => 534, 126 => 1187, 127 => 473];
    $l = 0;
    $s = '';
    $str = preg_split('/(?<!^)(?!$)/u', mb_substr($str, 0, $wh * 0.1));
    foreach ($str as $c) {
        $a = ord($c);
        if ($a >= 32 && $a <= 127) {
            $l += $w[$a];
        } else {
            $l += 1600;
        }
        $s .= $c;
        if ($l > $wh * 100) {
            return $s;
        }
    }
    return $s;
}

function createdir($dir)
{
    $yd = date('Ym') . '/';
    $d = date('d') . '/';
    $subdir0 = $dir;
    $subdir1 = $subdir0 . $yd;
    $subdir2 = $subdir1 . $d;
    if (!is_dir($subdir0)) {
        @mkdir($subdir0, 0777);
    }
    if (!is_dir($subdir1)) {
        @mkdir($subdir1, 0777);
    }
    if (!is_dir($subdir2)) {
        @mkdir($subdir2, 0777);
    }
    return $dir . $yd . $d;
}

function yun($docset, $from_url, $file_path, $title, $exten, $version)
{
    $tip = '上传成功';
    if ($exten == 'mp4') {
        $cmd = 'ffmpeg.exe -i ' . $file_path . ' -y -f image2 -t 0.001 ' . get_dir($file_path) . '1.png';
        exec($cmd);
    } else {
        if ($docset->isyun) {
            if (islocal($from_url)) {
                $tip = '内网用户如想在线阅读，请安装转换软件';
            } else {
                $from_dir = '/';
                $rtn = cpost($from_url, $from_dir, $file_path, $from_url . $from_dir . $file_path, $title . '.' . $exten, $docset->ypage, $docset->iscopy, $docset->ish5, $version);
                switch ($rtn) {
                    case '1':
                    case '2':
                        break;
                    case '-1':
                        $tip = '您的网站未开通VIP服务，且阅读次数已超';
                        break;
                    case '-2':
                        $tip = '您的网站VIP服务已过期，请续费';
                        break;
                    default:
                        $tip = '您的网站出现异常，请稍后访问';
                }
            }
        } else {
            $from_dir = '';
            if (file_exists($from_dir . $file_path)) {
                $file_jm_name = str_replace('/', '@', $file_path);
                fopen($from_dir . "data/temp/$docset->iscopy@$docset->ish5@$docset->ypage@" . $file_jm_name, 'w');
            } else {
                $tip = '文件不存在';
            }
        }
    }
    return $tip;
}

function cpost($from_host, $from_dir, $from_path, $from_aurl, $from_name, $from_page, $iscopy, $ish5, $ver)
{
    if ($from_host && $from_dir && $from_path && $from_aurl && $from_name) {
        $service = 'http://do.docswf.com/doc.do';
        $data = array(
            'from_host' => $from_host,
            'from_dir' => $from_dir,
            'from_path' => $from_path,
            'from_aurl' => $from_aurl,
            'from_name' => $from_name,
            'from_page' => $from_page,
            'from_h5' => $ish5,
            'from_copy' => $iscopy,
            'from_mode' => "ds/ci/$ver",
        );
        return gethttp($service, $data);
    } else {
        return '-12';
    }
}

function csee($id)
{
    if ($id) {
        $service = 'http://do.docswf.com/see.do';
        $data = array(
            'host' => $id,
            'mode' => 'ds/ci',
        );
        return gethttp($service, $data);
    } else {
        return '-12';
    }
}

function gethttp($url, $data = false)
{
    if (function_exists('curl_init') && function_exists('curl_exec')) {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($ch, CURLOPT_TIMEOUT, 60);
        if ($data) {
            curl_setopt($ch, CURLOPT_POST, 1);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
        }
        $result = curl_exec($ch);
        curl_close($ch);
        return $result;
    } else {
        if ($data) {
            $data = http_build_query($data);
            $cont = array(
                'http' => array(
                    'method' => 'POST',
                    'header' => 'Content-type: application/x-www-form-urlencoded ',
                    'content' => $data),
            );
            $context = stream_context_create($cont);
            $result = file_get_contents($url, false, $context);
        } else {
            $result = file_get_contents($url);
        }
        return $result;
    }
}

function fenci($word)
{
    $keys = '';
    $instance = &get_instance();

    $fencidatas = $instance->db->order_by('sort', 'desc')->get_where('fencidata')->result();
    foreach ($fencidatas as $fencidata) {
        if (stripos($word, $fencidata->word) !== false) {
            $word = str_ireplace($fencidata->word, '', $word);
            $keys .= $fencidata->word . ',';
        }
    }

    if ($fenci = $instance->db->get_where('fenciset', ['state' => 1])->row()) {
        $service = 'http://api.docswf.com/fc.do';
        $data = array(
            'appkey' => $fenci->appkey,
            'word' => $word,
        );
        $keys .= gethttp($service, $data);
    } else {
        $word = str_replace(' ', ',', $word);
        $keys .= $word;
    }
    return $keys;
}

function islocal($url)
{
    $regex0 = '/^http:\/\/((127.0.0.1)|(localhost))/';
    $regex1 = '/^http:\/\/10(\.([2][0-4]\d|[2][5][0-5]|[01]?\d?\d)){3}/';
    $regex2 = '/^http:\/\/172\.([1][6-9]|[2]\d|3[01])(\.([2][0-4]\d|[2][5][0-5]|[01]?\d?\d)){2}/';
    $regex3 = '/^http:\/\/192\.168(\.([2][0-4]\d|[2][5][0-5]|[01]?\d?\d)){2}/';
    if (preg_match($regex0, $url) || preg_match($regex1, $url) || preg_match($regex2, $url) || preg_match($regex3, $url)) {
        return true;
    } else {
        return false;
    }
}

function cashvip($orderid, $title, $from, $userid, $vipid, $cash, $trade_no, $state)
{
    $instance = &get_instance();
    if (($user = get_user2($userid)) && ($vipgroup = get_vipgroup($vipid)) && $vipgroup->cash2 == $cash) {
        $orderdata = array(
            'orderid' => $orderid,
            'title' => $title . $vipgroup->vgroupname,
            'userid' => $userid,
            'cash' => $cash,
            'from' => $from,
            'vgroupid' => $vipid,
            'tradeno' => $trade_no,
            'state' => $state,
        );
        if ($instance->db->get_where('viporder', array('orderid' => $orderid))->row()) {
            //Log::ERROR('order repeat:' . json_encode($data));
            return -2;
        } else {
            $instance->db->insert('viporder', $orderdata);
            addvipdays($user, $vipid, $vipgroup->vipdays);
            return 1;
        }
    } else {
        return -1;
        //Log::ERROR('order cash error:' . json_encode($data));
    }
}

function addvipdays($user, $vgroupid, $days)
{
    $instance = &get_instance();
    if ($user->vipdate && strtotime($user->vipdate) > time()) {
        $vipdate = strtotime("+$days day", strtotime($user->vipdate));
    } else {
        $vipdate = strtotime("+$days day");
    }
    $data = array(
        'vgroupid' => $vgroupid,
        'vipdate' => date('Y-m-d H:i:s', $vipdate),
    );
    $instance->db->update('user', $data, array('userid' => $user->userid));
}

function cashglod($orderid, $title, $from, $userid, $glods, $cash, $trade_no, $state)
{
    $instance = &get_instance();
    if (($user = get_user2($userid)) && ($tradeset = get_tradeset()) && $tradeset->glodrate * $glods == $cash) {
        $orderdata = array(
            'orderid' => $orderid,
            'title' => $title,
            'userid' => $userid,
            'cash' => $cash,
            'from' => $from,
            'glods' => $glods,
            'tradeno' => $trade_no,
            'state' => $state,
        );
        if ($instance->db->get_where('glodorder', array('orderid' => $orderid))->row()) {
            //Log::ERROR('order repeat:' . json_encode($data));
            return -2;
        } else {
            $instance->db->insert('glodorder', $orderdata);
            addglods($userid, $orderid, $glods);
            return 1;
        }
    } else {
        return -1;
        //Log::ERROR('order cash error:' . json_encode($data));
    }
}

function addglods($userid, $orderid, $glods)
{
    $instance = &get_instance();
    $glodpotdata2 = array(
        'userid' => $userid,
        'linkid' => $orderid,
        'type' => 10,
        'glods' => $glods,
    );
    $instance->db->insert('glodpot', $glodpotdata2);
    $instance->db->set('glods', 'glods+' . $glods, false)->where('userid', $userid)->update('user');
}

function cashdown($orderid, $title, $from, $userid, $docid, $cash, $trade_no, $state, $readdown)
{
    $instance = &get_instance();
    if (($doc = get_doc($docid)) && ($tradeset = get_tradeset()) && $tradeset->glodrate * $doc->$readdown == $cash) {
        $orderdata = array(
            'orderid' => $orderid,
            'title' => $title,
            'userid' => $userid,
            'cash' => $cash,
            'from' => $from,
            'docid' => $docid,
            'tradeno' => $trade_no,
            'readdown' => $readdown,
            'state' => $state,
        );
        if ($instance->db->get_where('downorder', array('orderid' => $orderid))->row()) {
            //Log::ERROR('order repeat:' . json_encode($data));
            return -2;
        } else {
            $instance->db->insert('downorder', $orderdata);
            adddown($userid, $doc, $readdown);
            return 1;
        }
    } else {
        return -1;
        //Log::ERROR('order cash error:' . json_encode($data));
    }
}

function adddown($userid, $doc, $readdown)
{
    $instance = &get_instance();
    if (($tradeset = get_tradeset()) && $tradeset->toauth2) {
        $glodpotdata = array(
            'userid' => $doc->userid,
            'linkid' => $doc->docid,
            'type' => $readdown == 'readpay' ? 32 : 42,
            'glods' => $doc->$readdown * (1 - $tradeset->rate),
        );
        $instance->db->insert('glodpot', $glodpotdata);
        $instance->db->set('glods', 'glods+' . $doc->$readdown * (1 - $tradeset->rate), false)->where('userid', $doc->userid)->update('user');
    }

    //匿名用户添加付费阅读和下载记录
    $glodpotdata2 = array(
        'userid' => $userid,
        'linkid' => $doc->docid,
        'type' => $readdown == 'readpay' ? -32 : -42,
        'glods' => 0 - $doc->$readdown,
    );
    $instance->db->insert('glodpot', $glodpotdata2);
}

function topicdown($orderid, $title, $from, $userid, $topicid, $cash, $trade_no, $state)
{
    $instance = &get_instance();
    if (($topic = get_topic($topicid)) && ($tradeset = get_tradeset()) && $tradeset->glodrate * $topic->downpay == $cash) {
        $orderdata = array(
            'orderid' => $orderid,
            'title' => $title,
            'userid' => $userid,
            'cash' => $cash,
            'from' => $from,
            'topicid' => $topicid,
            'tradeno' => $trade_no,
            'state' => $state,
        );
        if ($instance->db->get_where('topicorder', array('orderid' => $orderid))->row()) {
            //Log::ERROR('order repeat:' . json_encode($data));
            return -2;
        } else {
            $instance->db->insert('topicorder', $orderdata);
            addtopicdown($userid, $topic);
            return 1;
        }
    } else {
        return -1;
        //Log::ERROR('order cash error:' . json_encode($data));
    }
}

function addtopicdown($userid, $topic)
{
    $instance = &get_instance();
    if (($tradeset = get_tradeset()) && $tradeset->toauth2) {
        $glodpotdata = array(
            'userid' => $topic->userid,
            'linkid' => $topic->topicid,
            'type' => 52,
            'glods' => $topic->downpay * (1 - $tradeset->rate),
        );
        $instance->db->insert('glodpot', $glodpotdata);
        $instance->db->set('glods', 'glods+' . $topic->downpay * (1 - $tradeset->rate), false)->where('userid', $topic->userid)->update('user');
    }

    //匿名用户添加付费阅读和下载记录
    $glodpotdata2 = array(
        'userid' => $userid,
        'linkid' => $topic->topicid,
        'type' => -52,
        'glods' => 0 - $topic->$downpay,
    );
    $instance->db->insert('glodpot', $glodpotdata2);
}

//$path 不含扩展名的path
function savebase64($base64, $path)
{
    if (preg_match('/^(data:\s*image\/(\w+);base64,)/', $base64, $result)) {
        $type = $result[2];
        $file = $path . '.' . $type;
        if (file_put_contents($file, base64_decode(str_replace($result[1], '', $base64)))) {
            return true;
        } else {
            return false;
        }
    } else {
        return false;
    }
}

function deletehtml($str)
{
    $str = strip_tags($str, "");
    $str = str_replace("&nbsp;", '', $str);
    $str = str_replace("\t", '', $str);
    $str = str_replace("\r", '', $str);
    $str = str_replace("\n", '', $str);
    $str = str_replace(" ", '', $str);
    return trim($str);
}

function getfirstimg($html)
{
    $imgpreg = '/<img.+src=[\'"]([^\'"]+)[\'"].*>/i';
    preg_match($imgpreg, $html, $matches);

    if ($matches) {
        return $matches[1];
    } else {
        return null;
    }
}

function get_user_tip($userid, $loginid)
{
    $instance = &get_instance();
    $seo = $instance->db->get_where('seo')->row();
    $doc_count = $instance->db->select('count(*) as count')->get_where('doc', array('userid' => $userid, 'state' => 1, 'isdel' => 0))->row()->count;
    $user = $instance->db->get_where('user_view', array('userid' => $userid))->row();
    if ($user) {
        return '<div class="user-tip">
            <a href="' . $seo->user . $user->userid . '.html">
                <img src="' . $seo->user . $user->userid . '.pic"/>
                <span>' . ($user->vipuser ? '<i class="v"></i>' : '') . $user->nickname . '</span>
            </a>
            <ul>
                <li><p>' . $doc_count . '</p><span>文档</span></li>
                <li class="line"></li>
                <li><p>' . $user->glods . '</p><span>金币</span></li>
            </ul>
            <div>
                <a href="' . $seo->user . $user->userid . '.html" target="_blank" >Ta的主页</a> ' .
            ($user->userid == $loginid ?
            '<a tip="不能给自己发私信">发私信</a>' :
            $loginid > 0 ?
            '<a html="message/' . $user->userid . '.html">发私信</a>' :
            '<a href="javascript:login_f();">发私信</a>') .
            '</div>
        </div>';
    } else {
        return "";
    }

}

function writerouter()
{
    $instance = &get_instance();
    $seo = $instance->db->get_where('seo')->row();
    $navbar = $instance->db->select('id,href')->get('navbar')->result();
    $nav = [];
    foreach ($navbar as $n) {
        $nav[$n->id] = $n->href;
    }
    $router = <<<EOF
<?php
defined('BASEPATH') or exit('No direct script access allowed');

\$route['default_controller'] = 'home';
\$route['404_override'] = '';
\$route['translate_uri_dashes'] = false;

\$route['home.html'] = 'home/index';
\$route['login'] = 'login/index';
\$route['login.html'] = 'login/index';
\$route['login_f.html'] = 'login/login_f';
\$route['register'] = 'login/register';
\$route['register.html'] = 'login/register';
\$route['logout'] = 'login/logout';
\$route['logout.html'] = 'login/logout';
\$route['forget'] = 'forget/index';
\$route['forget.html'] = 'forget/index';
\$route['change'] = 'change/index';
\$route['change.html'] = 'change/index';
\$route['tip.html'] = 'tip/index';

\$route['qcback.html'] = 'login/qcback';
\$route['applogin_ewm.html'] = 'login/applogin_ewm';
\$route['applogin.html'] = 'login/applogin';
\$route['alilogin.html'] = 'login/alilogin';
\$route['weilogin.html'] = 'login/weilogin';
\$route['gzh.html'] = 'login/gzh';
\$route['gzh_pc.html'] = 'login/gzh_pc';
\$route['gzhlogin.html'] = 'login/gzhlogin';
\$route['api/uc.php'] = 'login/uclient';

\$route['fenci/(.*)'] = '/c/fenci/$1';
\$route['neditor'] = '/c/neditor';

\$route['message'] = '404';
\$route['message/(:num).html'] = 'message/index/$1';
\$route['message/get-(:num).html'] = 'message/getmsg/$1';
\$route['message/send-(:num).html'] = 'message/sendmsg/$1';

\$route['upload.html'] = 'upload/index';
\$route['upload/(:num).html'] = 'upload/reward/$1';
\$route['upload.file'] = 'upload/file';
\$route['upload.save'] = 'upload/save';

\$route['down'] = '404';
\$route['down.(doc|topic).(:num).html'] = 'down/$1/$2';

\$route['type'] = '404';
\$route['{$nav[2]}'] = 'type/index';

\$route['about'] = '404';
\$route['{$nav[9]}'] = 'about/index/help.html';
\$route['{$seo->about}(.*)'] = 'about/index/$1';
\$route['{$seo->notice}(:num).html'] = 'notice/index/$1';

\$route['user'] = '404';
\$route['{$seo->user}(:num).html'] = 'user/index/$1';
\$route['{$seo->user}(:num).pic'] = 'user/photo/$1';

\$route['lists'] = '404';
\$route['{$nav[3]}'] = 'lists/index/0/1/1/0';
\$route['{$seo->list}(:num).html'] = 'lists/index/$1/1/1/0';
\$route['{$seo->list}(:num)-(:num)-(:num).html'] = 'lists/index/$1/$2/$3/0';
\$route['{$seo->list}(:num)-(:num)-(:num)-([\d.]+).html'] = 'lists/index/$1/$2/$3/$4';
\$route['{$nav[5]}'] = 'lists/index/0/4/1/0';

\$route['doc'] = '404';
\$route['{$seo->doc}(:num).html'] = 'doc/index/$1/1';
\$route['{$seo->doc}(:num)-(:num).html'] = 'doc/index/$1/$2';
\$route['{$seo->doc}edit-(:num).html'] = 'edit/index/$1';
\$route['{$seo->doc}(:num).thum'] = 'thum/index/$1';

\$route['search'] = '404';
\$route['search.html'] = 'search/index/1/1/';
\$route['{$seo->search}(:num)-(:num).html'] = 'search/index/$1/$2/';
\$route['{$seo->search}(:num)-(:num)-(.*).html'] = 'search/index/$1/$2/$3';

\$route['topic'] = '404';
\$route['{$nav[4]}'] = 'topic/index/0/1/';
\$route['{$seo->topl}(:num).html'] = 'topic/index/$1/1/';
\$route['{$seo->topl}(:num)-(:num).html'] = 'topic/index/$1/$2/';
\$route['{$seo->topl}(:num)-(:num)-(.*).html'] = 'topic/index/$1/$2/$3';
\$route['{$seo->topic}(:num).html'] = 'topic/view/$1/1';
\$route['{$seo->topic}(:num)-(:num).html'] = 'topic/view/$1/$2';
\$route['{$seo->topic}pub.html'] = 'topic/publish/0';
\$route['{$seo->topic}edit-(:num).html'] = 'topic/publish/$1';
\$route['{$seo->topic}select.html'] = 'topic/select';
\$route['{$seo->topic}getdoc-(:num).html'] = 'topic/getdoc/$1';
\$route['{$seo->topic}cover-(:num).(.*)'] = 'topic/cover/$1/$2';
\$route['{$seo->topic}reply-(:num).html'] = 'topic/reply_add/$1';
\$route['{$seo->topic}reply-del-(:num).html'] = 'topic/reply_del/$1';
\$route['{$seo->topic}reply-edit-(:num).html'] = 'topic/reply_edit/$1';
\$route['{$seo->topic}reply-reply-(:num).html'] = 'topic/reply_reply/$1';
\$route['{$seo->topic}reply-report-(:num).html'] = 'topic/reply_report/$1';

\$route['reward'] = '404';
\$route['{$nav[6]}'] = 'reward/index/0/0/1/1/';
\$route['{$seo->rewl}(:num)-(:num)-(:num)-(:num).html'] = 'reward/index/$1/$2/$3/$4/';
\$route['{$seo->rewl}(:num)-(:num)-(:num)-(:num)-(.*).html'] = 'reward/index/$1/$2/$3/$4/$5';
\$route['{$seo->reward}(:num).html'] = 'reward/view/$1/1';
\$route['{$seo->reward}(:num)-(:num).html'] = 'reward/view/$1/$2';
\$route['{$seo->reward}pub.html'] = 'reward/publish';

\$route['article'] = '404';
\$route['{$nav[7]}'] = 'article/index/0/1/1/';
\$route['{$seo->artl}(:num)-(:num)-(:num).html'] = 'article/index/$1/$2/$3/';
\$route['{$seo->artl}(:num)-(:num)-(:num)-(.*).html'] = 'article/index/$1/$2/$3/$4';
\$route['{$seo->article}pub.html'] = 'article/pub/0';
\$route['{$seo->article}pub-(:num).html'] = 'article/pub/$1';
\$route['{$seo->article}edit-(:num).html'] = 'article/edit/$1';
\$route['{$seo->article}del-(:num).html'] = 'article/del/$1';
\$route['{$seo->article}(:num).html'] = 'article/view/$1/1';
\$route['{$seo->article}(:num)-(:num).html'] = 'article/view/$1/$2';
\$route['{$seo->article}reply-(:num).html'] = 'article/reply_add/$1';
\$route['{$seo->article}reply-del-(:num).html'] = 'article/reply_del/$1';
\$route['{$seo->article}reply-edit-(:num).html'] = 'article/reply_edit/$1';
\$route['{$seo->article}reply-reply-(:num).html'] = 'article/reply_reply/$1';
\$route['{$seo->article}reply-report-(:num).html'] = 'article/reply_report/$1';

\$route['ask'] = '404';
\$route['{$nav[8]}'] = 'ask/index/0/1/1/';
\$route['{$seo->askl}(:num)-(:num)-(:num).html'] = 'ask/index/$1/$2/$3/';
\$route['{$seo->askl}(:num)-(:num)-(:num)-(.*).html'] = 'ask/index/$1/$2/$3/$4';
\$route['{$seo->ask}pub.html'] = 'ask/pub/0';
\$route['{$seo->ask}pub-(:num).html'] = 'ask/pub/$1';
\$route['{$seo->ask}edit-(:num).html'] = 'ask/edit/$1';
\$route['{$seo->ask}del-(:num).html'] = 'ask/del/$1';
\$route['{$seo->ask}(:num).html'] = 'ask/view/$1/1';
\$route['{$seo->ask}(:num)-(:num).html'] = 'ask/view/$1/$2';
\$route['{$seo->ask}reply-(:num).html'] = 'ask/reply_add/$1';
\$route['{$seo->ask}reply-del-(:num).html'] = 'ask/reply_del/$1';
\$route['{$seo->ask}reply-edit-(:num).html'] = 'ask/reply_edit/$1';
\$route['{$seo->ask}reply-reply-(:num).html'] = 'ask/reply_reply/$1';
\$route['{$seo->ask}reply-report-(:num).html'] = 'ask/reply_report/$1';

\$route['menu.html'] = 'center/menu';
\$route['center.html'] = 'center/index';
\$route['center/income.html'] = 'center/income';
\$route['center/purchase.html'] = 'center/purchase';
\$route['center/down.html'] = 'center/down';
\$route['center/favorite.html'] = 'center/favorite';
\$route['center/topic.html'] = 'center/topic';
\$route['center/reward.html'] = 'center/reward';
\$route['center/ask.html'] = 'center/ask';
\$route['center/article.html'] = 'center/article';
\$route['center/task.html'] = 'center/task';
\$route['center/message.html'] = 'center/message';
\$route['center/order.html'] = 'center/order';
\$route['center/vip.html'] = 'center/vip';
\$route['center/glodpay.html'] = 'center/glodpay';
\$route['center/cash.html'] = 'center/cash';
\$route['center/change.html'] = 'center/change';
\$route['center/auth.html'] = 'center/auth';
\$route['center/auth/(person|company).html'] = 'center/auth/$1';
\$route['center/authpic/(:num).html'] = 'center/authpic/$1';
\$route['center/group.html'] = 'center/group';
\$route['center/ugroup.html'] = 'center/ugroup';
\$route['center/account.html'] = 'center/account';
\$route['center/photo'] = 'center/photo';

\$route['alipay.(:num).html'] = 'c/alipay/$1';
\$route['alipay2.(:num).html'] = 'c/alipay2/$1';
\$route['alipay3.(doc|topic).(readpay|downpay).(:num).html'] = 'c/alipay3/$1/$2/$3';
\$route['alipay.notify'] = '/c/alipaynotify';
\$route['weipay.(:num).html'] = 'c/weipay/$1';
\$route['weipay2.(:num).html'] = 'c/weipay2/$1';
\$route['weipay3.(doc|topic).(readpay|downpay).(:num).html'] = 'c/weipay3/$1/$2/$3';
\$route['weipay.notify'] = '/c/weipaynotify';
\$route['perpay.notify'] = '/c/perpaynotify';
\$route['glodpaystate.(:num)'] = '/c/glodpaystate/$1';
\$route['vippaystate.(:num)'] = '/c/vippaystate/$1';
\$route['docpaystate.(:num).(readpay|downpay)'] = 'c/docpaystate/$1/$2';
\$route['topicpaystate.(:num).downpay'] = 'c/topicpaystate/$1/$2';

\$route['pay.(doc|topic).(readpay|downpay).(:any)-(:any)-(:any)'] = 'pay/index/$1/$2/$3/$4/$5';

\$route['admin'] = 'admin/sys/index';
\$route['admin/doc/(audit|passed|nopass|online|free|vip|imp|unline|conver|clear)'] = 'admin/doc/index/$1';
\$route['admin/doc/comment/(audit|online)'] = 'admin/doc/comment/$1';
\$route['admin/topic/(audit|passed|nopass|online|free|vip|imp|unline)'] = 'admin/topic/index/$1';
\$route['admin/topic/comment/(audit|online)'] = 'admin/topic/comment/$1';
\$route['admin/user/(audit|passed|nopass)'] = 'admin/user/auth/$1';
\$route['admin/reward/(audit|passed|nopass)'] = 'admin/reward/index/$1';
\$route['admin/article/(audit|online|recycle)'] = 'admin/article/index/$1';
\$route['admin/article/comment/(audit|online)'] = 'admin/article/comment/$1';
\$route['admin/ask/(audit|online|recycle)'] = 'admin/ask/index/$1';
\$route['admin/ask/comment/(audit|online)'] = 'admin/ask/comment/$1';
\$route['admin/adv/(home|list|doc|search)'] = 'admin/adv/index/$1';
\$route['admin/pay'] = 'admin/pay/index';
EOF;
    file_put_contents('app/config/routes.php', $router);
}

function put_cache($key, $data)
{
    file_put_contents('data/cache/' . $key, $data);
}

function get_cache($key, $time)
{
    $cache = 'data/cache/' . $key;
    if (file_exists($cache) && time() - filemtime($cache) < $time) {
        return file_get_contents($cache);
    } else {
        return false;
    }
}

function writelog($text)
{
    file_put_contents('data/log/' . date('Ymd') . '.txt', date('Y-m-d H:i:s') . '-' . $text . "\r\n", FILE_APPEND);
}
