<?php

require_once 'pagepay/service/AlipayTradeService.php';

class Alinotify
{
    public function __construct()
    {
        $instance = &get_instance();
        $data = $instance->db->get('alipayset')->row();
        $config = array(
            'app_id' => $data->app_id,
            'merchant_private_key' => $data->private_key,
            'notify_url' => "",
            'return_url' => "",
            'charset' => "UTF-8",
            'sign_type' => $data->sign_type,
            'gatewayUrl' => "https://openapi.alipay.com/gateway.do",
            'alipay_public_key' => $data->public_key,
        );

        $arr = $_POST;
        $alipaySevice = new AlipayTradeService($config);
        //$alipaySevice->writeLog(var_export($_POST, true));
        $result = $alipaySevice->check($arr);
        //$alipaySevice->writeLog($result);
        /* 实际验证过程建议商户添加以下校验。
        1、商户需要验证该通知数据中的out_trade_no是否为商户系统中创建的订单号，
        2、判断total_amount是否确实为该订单的实际金额（即商户订单创建时的金额），
        3、校验通知中的seller_id（或者seller_email) 是否为out_trade_no这笔单据的对应的操作方（有的时候，一个商户可能有多个seller_id/seller_email）
        4、验证app_id是否为该商户本身。
         */
        if ($result) { //验证成功
            /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
            //请在这里加上商户的业务逻辑程序代
            //——请根据您的业务逻辑来编写程序（以下代码仅作参考）——
            //获取支付宝的通知返回参数，可参考技术文档中服务器异步通知参数列表
            //交易状态
            $trade_status = $_POST['trade_status'];
            if ($trade_status == 'TRADE_FINISHED') {
                //判断该笔订单是否在商户网站中已经做过处理
                //如果没有做过处理，根据订单号（out_trade_no）在商户网站的订单系统中查到该笔订单的详细，并执行商户的业务程序
                //请务必判断请求时的total_amount与通知时获取的total_fee为一致的
                //如果有做过处理，不执行商户的业务程序
                //注意：
                //退款日期超过可退款期限后（如三个月可退款），支付宝系统发送该交易状态通知
            } else if ($trade_status == 'TRADE_SUCCESS') {
                //判断该笔订单是否在商户网站中已经做过处理
                //如果没有做过处理，根据订单号（out_trade_no）在商户网站的订单系统中查到该笔订单的详细，并执行商户的业务程序
                //请务必判断请求时的total_amount与通知时获取的total_fee为一致的
                //如果有做过处理，不执行商户的业务程序
                //注意：
                //付款完成后，支付宝系统发送该交易状态通知
                //
                //商户订单号
                $out_trade_no = $_POST['out_trade_no'];
                $trade_no = $_POST['trade_no'];
                $cash = $_POST["total_amount"];
                $attach = explode('|', $_POST["body"]);
                if (count($attach) == 3) {
                    $which = $attach[0];
                    $userid = $attach[1];
                    $id = $attach[2];
                    if ($which == "vip") {
                        $state = cashvip($out_trade_no, '开通', 2, $userid, $id, $cash, $trade_no, 1);
                    } else if ($which == "glod") {
                        $state = cashglod($out_trade_no, '充值', 2, $userid, $id, $cash, $trade_no, 1);
                    } else if ($which == "docreadpay") {
                        $state = cashdown($out_trade_no, "文档阅读", 2, $userid, $id, $cash, $trade_no, 1, 'readpay');
                    } else if ($which == "docdownpay") {
                        $state = cashdown($out_trade_no, "文档下载", 2, $userid, $id, $cash, $trade_no, 1, 'downpay');
                    } else if ($which == "topicdownpay") {
                        $state = topicdown($out_trade_no, "专题下载", 2, $userid, $id, $cash, $trade_no, 1);
                    }

                    if ($state == 1) {

                    } elseif ($state == -1) {
                        $alipaySevice->writeLog("order cash error:" . $trade_no);
                    } else if ($state == -2) {
                        $alipaySevice->writeLog("order repeat:" . $trade_no);
                    }
                } else {
                    $alipaySevice->writeLog("order attach error:" . $trade_no);
                }
            }
            echo "success";
        } else {
            echo "fail";
        }
    }

}
