<?php

//2018.8.19  AlipayTradePagePayContentBuilder 增加设置和获取 qr_pay_mode 属性，用于只返回二维码

class Alipay
{

    public $set;
    public $isewm;
    public function __construct()
    {
        $instance = &get_instance();
        $data = $instance->db->get('alipayset')->row();
        $this->set = array(
            'app_id' => $data->app_id,
            'merchant_private_key' => $data->private_key,
            'notify_url' => "",
            'return_url' => "",
            'charset' => "UTF-8",
            'sign_type' => $data->sign_type,
            'gatewayUrl' => "https://openapi.alipay.com/gateway.do",
            'alipay_public_key' => $data->public_key,
        );
        $this->isewm = $data->isewm;
    }

    public function pcpay($subject, $body, $total_amount, $out_trade_no, $return, $notify, $isewm)
    {
        require_once dirname(__FILE__) . '/pagepay/service/AlipayTradeService.php';
        require_once dirname(__FILE__) . '/pagepay/buildermodel/AlipayTradePagePayContentBuilder.php';

        $payRequestBuilder = new AlipayTradePagePayContentBuilder();
        $payRequestBuilder->setSubject($subject);
        $payRequestBuilder->setBody($body);
        $payRequestBuilder->setTotalAmount($total_amount);
        $payRequestBuilder->setOutTradeNo($out_trade_no);
        if ($isewm) {
            $payRequestBuilder->setqr_pay_mode(4);
            $payRequestBuilder->setqrcode_width(135);
        }

        $aop = new AlipayTradeService($this->set);
        $response = $aop->pagePay($payRequestBuilder, $return, $notify);
        var_dump($response);
    }
    public function wappay($subject, $body, $total_amount, $out_trade_no, $return, $notify)
    {
        require_once dirname(__FILE__) . '/wappay/service/AlipayTradeService.php';
        require_once dirname(__FILE__) . '/wappay/buildermodel/AlipayTradeWapPayContentBuilder.php';

        $payRequestBuilder = new AlipayTradeWapPayContentBuilder();
        $payRequestBuilder->setSubject($subject);
        $payRequestBuilder->setBody($body);
        $payRequestBuilder->setTotalAmount($total_amount);
        $payRequestBuilder->setOutTradeNo($out_trade_no);
        $payRequestBuilder->setTimeExpress("1m");

        $aop = new AlipayTradeService($this->set);
        $result = $aop->wapPay($payRequestBuilder, $return, $notify);
        return;
    }

}
