<?php

//使用dysmsapi-lite-php 把SDK文件夹复制到libraries下
//新建Alisms.php 把原Test.php 和 demo/sendSms.php 内容整合到此文件中

require_once "SignatureHelper.php";

use Aliyun\DySDKLite\SignatureHelper;

class Alisms {

    private $accessKeyId = '';
    private $accessKeySecret = '';
    private $signname1 = '';
    private $template1 = '';
    private $signname2 = '';
    private $template2 = '';
    private $product = '';

    public function __construct() {
        $instance = & get_instance();
        $smsset = $instance->db->get('smsset')->row();

        if ($smsset) {
            $this->accessKeyId = $smsset->keyid;
            $this->accessKeySecret = $smsset->keysecret;
            $this->signname1 = $smsset->signname1;
            $this->template1 = $smsset->template1;
            $this->signname2 = $smsset->signname2;
            $this->template2 = $smsset->template2;
        }

        $site = $instance->db->get('site')->row();
        if ($site)
            $this->product = $site->name;
    }

    public function sms2reg($phone, $code) {
        return $this->sendSms($phone, $this->signname1, $this->template1, $code);
    }

    public function sms2forget($phone, $code) {
        return $this->sendSms($phone, $this->signname2, $this->template2, $code);
    }

    function sendSms($phone, $signname, $template, $code) {
        $params = array();
        // fixme 必填: 短信接收号码
        $params["PhoneNumbers"] = $phone;

        // fixme 必填: 短信签名，应严格按"签名名称"填写，请参考: https://dysms.console.aliyun.com/dysms.htm#/develop/sign
        $params["SignName"] = $signname;

        // fixme 必填: 短信模板Code，应严格按"模板CODE"填写, 请参考: https://dysms.console.aliyun.com/dysms.htm#/develop/template
        $params["TemplateCode"] = $template;

        // fixme 可选: 设置模板参数, 假如模板中存在变量需要替换则为必填项
        $params['TemplateParam'] = Array(
            "code" => $code
        );

        // fixme 可选: 设置发送短信流水号
        //$params['OutId'] = "12345";
        // fixme 可选: 上行短信扩展码, 扩展码字段控制在7位或以下，无特殊需求用户请忽略此字段
        //$params['SmsUpExtendCode'] = "1234567";
        // *** 需用户填写部分结束, 以下代码若无必要无需更改 ***
        if (!empty($params["TemplateParam"]) && is_array($params["TemplateParam"])) {
            $params["TemplateParam"] = json_encode($params["TemplateParam"], JSON_UNESCAPED_UNICODE);
        }

        // 初始化SignatureHelper实例用于设置参数，签名以及发送请求
        $helper = new SignatureHelper();

        // 此处可能会抛出异常，注意catch
        $content = $helper->request(
                $this->accessKeyId, $this->accessKeySecret, "dysmsapi.aliyuncs.com", array_merge($params, array(
            "RegionId" => "cn-hangzhou",
            "Action" => "SendSms",
            "Version" => "2017-05-25",
                ))
        );

        return $content;
    }

    function Test() {
        $info = array();
        if (preg_match("/^\d+\.\d+/", PHP_VERSION, $matches)) {
            $version = $matches[0];
            if ($version >= 5.3) {
                $info["PHP $version"] = 'OK';
            } else {
                $info["PHP $version"] = "需要PHP>=5.3版本";
            }
        }

        $depends = array(
            'json_encode' => '需要安装',
            'curl_init' => '需要安装',
            'hash_hmac' => '需要安装',
            'simplexml_load_string' => '如果是php7.x + ubuntu环境，请确认php7.x-libxml是否安装，x为子版本号',
        );

        foreach ($depends as $func => $desc) {
            if (!function_exists($func)) {
                $info[$func] = $desc;
            } else {
                $info[$func] = 'OK';
            }
        }
        return $info;
    }

}
