<?php

error_reporting(E_ERROR);

require_once "lib/WxPay.Api.php";
require_once 'lib/WxPay.Notify.php';
require_once 'pay/log.php';

//初始化日志
$logHandler = new CLogFileHandler("app/libraries/Weipay/logs/" . date('Y-m-d') . '.log');
$log = Log::Init($logHandler, 15);

class Weinotify extends WxPayNotify
{

    public function __construct()
    {
        $instance = &get_instance();
        $data = $instance->db->get('weipayset')->row_array();
        $set = "class WxPayConfig {
                    const APPID = '$data[APPID]';
                    const MCHID = '$data[MCHID]';
                    const KEY = '$data[KEY]';
                    const APPSECRET = '$data[APPSECRET]';
                    const SSLCERT_PATH = '../cert/apiclient_cert.pem';
                    const SSLKEY_PATH = '../cert/apiclient_key.pem';
                    const CURL_PROXY_HOST = '0.0.0.0';
                    const CURL_PROXY_PORT = 0;
                    const REPORT_LEVENL = 1;
                }";
        eval($set);
        //$this->NotifyProcess("", $set);
        //Log::DEBUG("begin notify:");
    }

    //查询订单
    public function Queryorder($transaction_id)
    {
        $input = new WxPayOrderQuery();
        $input->SetTransaction_id($transaction_id);
        $result = WxPayApi::orderQuery($input);
        //Log::DEBUG("query:" . json_encode($result));
        if (array_key_exists("return_code", $result) && array_key_exists("result_code", $result) && $result["return_code"] == "SUCCESS" && $result["result_code"] == "SUCCESS") {
            return true;
        }
        return false;
    }

    //重写回调处理函数
    public function NotifyProcess($data, &$msg)
    {

        //Log::DEBUG("call back:" . $data);
        //$notfiyOutput = array();

        if (!array_key_exists("transaction_id", $data)) {
            $msg = "输入参数不正确";
            return false;
        }
        //查询订单，判断订单真实性
        if (!$this->Queryorder($data["transaction_id"])) {
            $msg = "订单查询失败";
            return false;
        }

        $out_trade_no = $data['out_trade_no'];
        $trade_no = $data['transaction_id'];
        $cash = $data["total_fee"] / 100;
        $attach = explode('|', $data["attach"]);
        if (count($attach) == 3) {
            $which = $attach[0];
            $userid = $attach[1];
            $id = $attach[2];
            if ($which == "vip") {
                $state = cashvip($out_trade_no, '开通', 1, $userid, $id, $cash, $trade_no, 1);
            } else if ($which == "glod") {
                $state = cashglod($out_trade_no, '充值', 1, $userid, $id, $cash, $trade_no, 1);
            } else if ($which == "docreadpay") {
                $state = cashdown($out_trade_no, "文档阅读", 1, $userid, $id, $cash, $trade_no, 1, 'readpay');
            } else if ($which == "docdownpay") {
                $state = cashdown($out_trade_no, "文档下载", 1, $userid, $id, $cash, $trade_no, 1, 'downpay');
            } else if ($which == "topicdownpay") {
                $state = topicdown($out_trade_no, "专题下载", 1, $userid, $id, $cash, $trade_no, 1);
            }

            if ($state == 1) {

            } elseif ($state == -1) {
                Log::ERROR("order cash error:" . json_encode($data));
            } else if ($state == -2) {
                Log::ERROR("order repeat:" . json_encode($data));
            }
        } else {
            Log::ERROR("order attach error:" . json_encode($data));
        }
        return true;
    }

}
