<?php

//注释掉WxPay.NativePay文件 require_once "../lib/WxPay.Api.php";
//注释掉WxPay.JsApiPay文件 require_once "../lib/WxPay.Api.php";
//注释掉WxPayWxPay.Api文件  require_once "WxPay.Config.php";
//注释掉WxPay.Data文件  require_once "WxPay.Config.php";
//
//修改 WxPayWxPay.Api #537文件  curl_setopt($ch,CURLOPT_SSL_VERIFYPEER,TRUE) -> curl_setopt($ch,CURLOPT_SSL_VERIFYPEER,FALSE);
//修改 WxPayWxPay.Api #537文件  curl_setopt($ch,CURLOPT_SSL_VERIFYHOST,2);  -> curl_setopt($ch,CURLOPT_SSL_VERIFYHOST,FALSE);//严格校验

defined('BASEPATH') or exit('No direct script access allowed');
require_once "lib/WxPay.Api.php";
require_once "pay/WxPay.NativePay.php";
require_once "pay/WxPay.JsApiPay.php";
require_once 'pay/log.php';
require_once 'pay/phpqrcode/phpqrcode.php';

class Weipay
{

    public function __construct()
    {
        $instance = &get_instance();
        $data = $instance->db->get('weipayset')->row_array();
        $set = "class WxPayConfig {
                    const APPID = '$data[APPID]';
                    const MCHID = '$data[MCHID]';
                    const KEY = '$data[KEY]';
                    const APPSECRET = '$data[APPSECRET]';
                    const SSLCERT_PATH = '../cert/apiclient_cert.pem';
                    const SSLKEY_PATH = '../cert/apiclient_key.pem';
                    const CURL_PROXY_HOST = '0.0.0.0';
                    const CURL_PROXY_PORT = 0;
                    const REPORT_LEVENL = 1;
                }";
        eval($set);
    }

    public function pcpay($body, $attach, $total_fee, $out_trade_no, $tag, $product_id, $return, $notify)
    {
        $nativepay = new NativePay();
        $input = new WxPayUnifiedOrder();

        $input->SetBody($body);
        $input->SetAttach($attach);
        $input->SetTotal_fee($total_fee * 100);
        $input->SetOut_trade_no($out_trade_no);
        $input->SetTime_start(date('YmdHis'));
        $input->SetTime_expire(date('YmdHis', time() + 600));
        $input->SetGoods_tag($tag);
        $input->SetNotify_url($notify);
        $input->SetTrade_type('NATIVE');
        $input->SetProduct_id($product_id);
        $result = $nativepay->GetPayUrl($input);
        $url2 = isset($result['code_url']) ? $result['code_url'] : null;
        if ($url2) {
            QRcode::png(urldecode($url2));
        } else {
            var_dump($result);
        }
    }

    public function wxpay($body, $attach, $total_fee, $out_trade_no, $tag, $product_id, $return, $notify)
    {
        $tools = new JsApiPay();
        $openId = $tools->GetOpenid();

        $input = new WxPayUnifiedOrder();
        $input->SetBody($body);
        $input->SetAttach($attach);
        $input->SetOut_trade_no($out_trade_no);
        $input->SetTotal_fee($total_fee * 100);
        $input->SetTime_start(date("YmdHis"));
        $input->SetTime_expire(date("YmdHis", time() + 600));
        $input->SetGoods_tag($tag);
        $input->SetNotify_url($notify);
        $input->SetTrade_type("JSAPI");
        $input->SetOpenid($openId);
        $order = WxPayApi::unifiedOrder($input);
        $jsApiParameters = $tools->GetJsApiParameters($order);
echo <<<EOF
<html>
<head>
    <meta http-equiv="content-type" content="text/html;charset=utf-8"/>
    <meta name="viewport" content="width=device-width, initial-scale=1"/> 
    <title>微信支付</title>
    <script type="text/javascript">
	callpay();
	function jsApiCall()
	{
		WeixinJSBridge.invoke(
			'getBrandWCPayRequest',
			 $jsApiParameters,
			function(res){
				window.history.go(-1);
			}
		);
	}
	function callpay()
	{
		if (typeof WeixinJSBridge == "undefined"){
		    if( document.addEventListener ){
		        document.addEventListener('WeixinJSBridgeReady', jsApiCall, false);
		    }else if (document.attachEvent){
		        document.attachEvent('WeixinJSBridgeReady', jsApiCall); 
		        document.attachEvent('onWeixinJSBridgeReady', jsApiCall);
		    }
		}else{
		    jsApiCall();
		}
	}
    </script>
</head>
<body>
</body>
</html>
EOF;
    }
    
    public function wappay($body, $attach, $total_fee, $out_trade_no, $tag, $product_id, $return, $notify)
    {
        $appid = WxPayConfig::APPID;
        $mch_id = WxPayConfig::MCHID;
        $key = WxPayConfig::KEY;
        $nonce_str = $this->createNoncestr();
        $total_fee = $total_fee * 100;
        $spbill_create_ip = getip();
        $notify_url = $notify;
        $trade_type = 'MWEB';
        $scene_info = '{"h5_info":{"type":"Wap","wap_url":"' . $return . '","wap_name":"支付"}}';
        $signA = "appid=$appid&attach=$attach&body=$body&mch_id=$mch_id&nonce_str=$nonce_str&notify_url=$notify_url&out_trade_no=$out_trade_no&scene_info=$scene_info&spbill_create_ip=$spbill_create_ip&total_fee=$total_fee&trade_type=$trade_type";
        $strSignTmp = $signA . "&key=$key";
        $sign = strtoupper(MD5($strSignTmp));
        $post_data = "<xml>
                    <appid>$appid</appid>
                    <mch_id>$mch_id</mch_id>
                    <body>$body</body>
                    <out_trade_no>$out_trade_no</out_trade_no>
                    <total_fee>$total_fee</total_fee>
                    <spbill_create_ip>$spbill_create_ip</spbill_create_ip>
                    <notify_url>$notify_url</notify_url>
                    <trade_type>$trade_type</trade_type>
                    <scene_info>$scene_info</scene_info>
                    <attach>$attach</attach>
                    <nonce_str>$nonce_str</nonce_str>
                    <sign>$sign</sign>
            </xml>";
        $url = "https://api.mch.weixin.qq.com/pay/unifiedorder";
        $dataxml = $this->postXmlCurl($post_data, $url);
        $objectxml = (array) simplexml_load_string($dataxml, 'SimpleXMLElement', LIBXML_NOCDATA);

        if (isset($objectxml) && isset($objectxml['mweb_url'])) {
            header('Location: ' . $objectxml['mweb_url']);
        } else {
            echo $objectxml['return_msg'];
        }
    }
    public function createNoncestr($length = 32)
    {
        $chars = "abcdefghijklmnopqrstuvwxyz0123456789";
        $str = "";
        for ($i = 0; $i < $length; $i++) {
            $str .= substr($chars, mt_rand(0, strlen($chars) - 1), 1);
        }
        return $str;
    }
    public function postXmlCurl($xml, $url, $second = 30)
    {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_TIMEOUT, $second);
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
        curl_setopt($ch, CURLOPT_HEADER, false);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $xml);
        $data = curl_exec($ch);
        if ($data) {
            curl_close($ch);
            return $data;
        } else {
            $error = curl_errno($ch);
            curl_close($ch);
            echo "curl出错，错误码:$error" . "<br>";
        }
    }
}
